package composant_saisie.wCalendar;


import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class CellRendererTothWeek implements TableCellRenderer{
	private static final long serialVersionUID = 1L;
	JLabel jlToth=null;
	JLabel jlTots=null;
	JPanel jp=null;
	public CellRendererTothWeek(){
		super();
		jp=new JPanel(new BorderLayout());{
			jlToth=new JLabel();{
				jlToth.setOpaque(false);
				jlToth.setBackground(Gp.MOVE_BG_LVERT);
				jlToth.setHorizontalAlignment(JLabel.CENTER);
				jlToth.setForeground(Gp.VERTFONCE_FG);
				jlToth.setFont(Gp.FONTTEXT15);
			}
			jlTots=new JLabel();{
				jlTots.setOpaque(false);
				jlTots.setBackground(Gp.MOVE_BG_LVERT);
				jlTots.setHorizontalAlignment(JLabel.CENTER);
				jlTots.setForeground(Color.BLACK);
				jlTots.setFont(Gp.FONTTEXT11);
			}
			jp.setOpaque(true);
			jp.setBackground(Color.WHITE);
			jp.add(jlToth,BorderLayout.CENTER);
			jp.add(jlTots,BorderLayout.SOUTH);
		}
	}
	public Component getTableCellRendererComponent(JTable jt, Object cellule,boolean isSelected, boolean hasFocus, int row, int column) {
		JComponent ret=null;
		JTableCalendar jtc=(JTableCalendar) jt;
		CalendarValues cv=jtc.cv;

		jlToth.setText(((String[]) cv.getTotWeek(row))[0]);
		jlTots.setText(((String[]) cv.getTotWeek(row))[1]);

		ret=jp;
		return ret;
	}
}
