package composant_saisie.wComposant;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.border.Border;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.Document;
import javax.swing.text.JTextComponent;

import module_standard.wPointageHeure.S_pointageHeureSAISIE;
import persistance.wGlobalParam.Gp;
import persistance.wSql.Edit;
import persistance.wSql.Sql;
import template_applicatif.wVue.AbstractVue;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.Ccs;
import composant_saisie.wSaisieFormat.CcsFmt;
import composant_saisie.wSaisieFormat.Fmt;
import composant_saisie.wSaisieFormat.UserUpdate;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JPlageTimes extends JPanel implements DocumentListener,KeyListener, FocusListener, ActionListener, JPopupIClicked {
	private static final long serialVersionUID = 1L;
	Ccs ccs=null;
	JTextDbTime time=null;
	public JTextButton jbF4=null;
	String buttonbtn="F4";
	boolean updatableValue=true;
	Sql sql=null;
	private boolean jplagetimerequestfocusenter=false;
	private boolean jplagetimerequestfocuscancel=false;
	public AbstractVue jpVueF2=null;
	public Sql sqlF2=null;
	JPopup jpopup=null;
	UserUpdate userupdate=null;
	public JPlageTimes(Sql sql, String sdeb,AbstractVue vue){
		this.sql=sql;
		setVue(vue);
		adapte(sdeb);
	}
	public void setVue(AbstractVue vue){
		jpVueF2=vue;
		sqlF2=vue.sqlListe;
		sqlF2.t_PLAGETIMES=this;
		jpopup=new JPopup();{
			sqlF2.t_F2Popup=jpopup;
			S_pointageHeureSAISIE phs=(S_pointageHeureSAISIE) vue.dbFiche;{
				phs.timd.setComposentFocusTraversalPolicy(jpopup);
			}
			jpopup.addComposant(vue,this);
			jpopup.validateDebut();
		}
	}

	private void adapte(String stime) {
		userupdate=new UserUpdate(this);
		putClientProperty(Edit.TYPE_FIELD,Edit.PLAGETIMES);
		jbF4=new JTextButton("F4",KeyEvent.VK_F4);{
			jbF4.addActionListener(this);
			jbF4.setPreferredSize(new Dimension(Gp.HEIGHTTEXT,Gp.HEIGHTTEXT));
		}

		time=new JTextDbTime(sql);{
			time.setOrientation(SwingConstants.VERTICAL);
		}
		ccs=new Ccs(sql);
		ccs.adapteT(this,time,"time", Fmt.TIME);

		time.setSTime(stime);

		ccs.addEditListener(time,Ccs.TIME);
		this.setLayout(new FlowLayout(0,0,0));{
			this.add(time);
			this.add(jbF4);
		}
		this.setOpaque(false);
		this.setFocusable(false);{
			this.setRequestFocusEnabled(true);
			this.addFocusListener(this);
		}
	}
	public void setBorder(Border border){
		if (time!=null){
			time.setBorder(border);
			jbF4.setBorder(border);
		}
	}
	public void setBackground(Color color){
		super.setBackground(color);
		if (time!=null){
			time.setBackground(color);
			jbF4.setBackground(color);
		}
	}
	public void setForeground(Color color){
		super.setForeground(color);
		if (time!=null){
			time.setForeground(color);
			jbF4.setForeground(color);
		}
	}
	public void setFont(Font font){
		super.setFont(font);
		if (time!=null){
			time.setFont(font);
			jbF4.setFont(font);
		}
	}
	public void setEnabled(boolean enable){
		super.setEnabled(enable);
		if (time!=null){
			time.setEnabled(enable);
			jbF4.setEnabled(enable);
		}
	}	
	public void setOk(){
		if (time!=null){
			time.setForeground(Gp.LABEL_FG_BLACK);
			time.setBorder(Gp.getBorder(Gp.LABEL_BORDER));
		}
	}
	public void focusGained(FocusEvent e) {}
	public void focusLost(FocusEvent e) {
		setFocusable(false);
	}
	public void requestFocus(){
		if (jplagetimerequestfocusenter){
			jplagetimerequestfocusenter=false;
			setFocusable(true);
			super.requestFocus();
			setOk();
		}  else if (jplagetimerequestfocuscancel){
			jplagetimerequestfocuscancel=false;
			setFocusable(true);
			super.requestFocus();
			setOk();
		} else {
			time.requestFocus();
			time.selectAll();
		}
	}

	public void keyReleased(KeyEvent e) {}
	public void keyTyped(KeyEvent e) {}
	public void keyPressed(KeyEvent e) { // ATTENTION MEME RACCOURCI QUE ABSTRACTDBFICHE
		if (e.isControlDown()){
			switch (e.getKeyCode()) {
			case KeyEvent.VK_M:
				e.consume();
				setFocusable(true);
				super.requestFocus();
				Gp.dispatchEvent(this,e);
				break;
			default:
				break; }
		} else {
			switch (e.getKeyCode()) {
			case KeyEvent.VK_F5:
				e.consume();
				this.setFocusable(true);
				super.requestFocus();
				Gp.dispatchEvent(this,e);
				break;
			case KeyEvent.VK_F3:
				e.consume();
				this.setFocusable(true);
				super.requestFocus();
				Gp.dispatchEvent(this,e);
				break;
			case KeyEvent.VK_ESCAPE:
				e.consume();
				userActionCancelFocusSaisie();
				Gp.dispatchEvent(this,e);
				break;
			case KeyEvent.VK_ENTER:
				e.consume();
				userActionRecordFocusListe();
				Gp.dispatchEvent(this,e);
				break;
			default:
				break; }
		}
	}
	private void userActionCancelFocusSaisie() {
		jplagetimerequestfocuscancel=true;{
			this.requestFocus();
		}
	}
	private void userActionRecordFocusListe() {
		if (time.isFocusOwner()){
			String ancTime=time.getText();
			updatableValue=false;
			time.setSTime(CcsFmt.formatStrTime(time.getText(),true));
			ccs.fireT(time,Ccs.TIME);
			updatableValue=true;
			if (!ancTime.equals(time.getText()))
				userUpdateParent();
			jplagetimerequestfocusenter=true;{
				this.requestFocus();
			}
		}
	}
	public String getSTime() {
		return time.getSTime();
	}
	public void setSTime(String time){
		this.time.setSTime(time);
	}
	public void changedUpdate(DocumentEvent de) {}
	public void removeUpdate(DocumentEvent de) {
		userUpdateTextField(de.getDocument());
	}
	public void insertUpdate(DocumentEvent de) {
		userUpdateTextField(de.getDocument());
	}
	private void userUpdateTextField(Document jctd) {
		JTextComponent jc=(JTextComponent) jctd.getProperty(Ccs.JTPARENTDOC);
		if (jc.isValid()){
			if (this.isEnabled()){
				if (updatableValue) {
					updatableValue=false;
					if (jc==time){
						if (time.userUpdate){
							userUpdateParent();
							ccs.fireT(jc,Ccs.TIME);
						}
					}
					updatableValue=true;
				}
			}
		}
	}
	private void userUpdateParent(){
		userupdate.userUpdate();
	}
	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==jbF4){
			openPopup();
		}
	}

	public void openPopup(){
		jpopup.openPopup(); 
	}
	public JFrame getMainFrame() {
		return sql.getMf();
	}

	@Override
	public boolean clickedInFleche(Point point) {
		return false;
	}

	@Override
	public void setValueChild() {
		// la valeur total 
		// est dsacouple des valeurs dtails
	}

	public void setValueFromChild(Object obj) {
		String ancTime=time.getText();
		time.setSTime((String)obj);
		// Double la mise  jour de l'heure dclenche un UpdateValue
		time.setText((String)obj);
		if (!ancTime.equals(time.getText()))
			userUpdateParent();
	}
	public void dispose(){
		if (ccs!=null){
			ccs.dispose();
			ccs=null;
		}
		time=null;
		jbF4=null;
		if (jpVueF2!=null){
			jpVueF2.dispose();
			jpVueF2=null;
		}
//		jpVueF2=null;
//		if (sqlF2!=null){
//			sqlF2.dispose();
//			sqlF2=null;
//		}
		sqlF2=null;
		if (jpopup!=null){
			jpopup.disposePopup();
			jpopup=null;
		}
		userupdate=null;
		sql=null;
	}
	protected void finalize()  {
//		Gp.af("finalize : "+this.getName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
