package composant_saisie.wComposant;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class JStatusBar extends JPanel {
	private static final long serialVersionUID = 1L;
	private JLabel jlStatusWest = null;
	private JLabel jlStatusCenter = null;
	private JLabel jlStatusEast = null;
	private JPanel jpEast =null;
	private JLabel jlKeyboard = null;
	public JStatusBar(){
		setFocusable(false);
		setLayout(new BorderLayout(5,0));
		jlStatusWest = new JLabel(" ");{
			jlStatusWest.setFont(Gp.FONTMENU);
		}
		jlStatusCenter = new JLabel("");{
			jlStatusCenter.setFont(Gp.FONTMENU);
			jlStatusCenter.setHorizontalTextPosition(SwingConstants.CENTER);
			jlStatusCenter.setHorizontalAlignment(SwingConstants.CENTER);
		}
		jpEast = new JPanel();{
			jlStatusEast = new JLabel("");{
				jlStatusEast.setFont(Gp.FONTMENU);
			}
			jlKeyboard = new JLabel(" ");{
				jlKeyboard.setFont(Gp.FONTMENU);
				jlKeyboard.setForeground(Gp.VERTFONCE_FG);
			}
			jpEast.add(jlStatusEast);
			jpEast.add(jlKeyboard);
		}
		add(jlStatusWest,BorderLayout.WEST);
		add(jlStatusCenter,BorderLayout.CENTER);
		add(jpEast,BorderLayout.EAST);
		setBorder(BorderFactory.createCompoundBorder(BorderFactory.createMatteBorder(1,0,1,0,Color.GRAY),BorderFactory.createMatteBorder(0,0,1,0,Color.LIGHT_GRAY)));
	}
	public void adapte(){
		this.setPreferredSize(this.getSize());
		this.setMaximumSize(this.getSize());
	}
	public void setTextStatus(String west, String center, String east) {
		adapte();
		setTextStatusFiche(west,east);
		setTextStatusFicheEdit(center);
	}
	public void setTextStatusFiche(String west, String east) {
		adapte();
		jlStatusWest.setText(" "+west);
		jlStatusEast.setText(east+" ");
	}
	public void setTextStatusFicheEdit(String center) {
		adapte();
		if (center.length()==0){
			jlStatusCenter.setBorder(null);
		} else {
			jlStatusCenter.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createMatteBorder(0,1,0,1,Color.GRAY),BorderFactory.createMatteBorder(0,1,0,1,Color.LIGHT_GRAY)));
		}
		jlStatusCenter.setText(center);
	}
	public void setFontStatus(Font font) {
		jlStatusWest.setFont(font);
		jlStatusCenter.setFont(font);
		jlStatusEast.setFont(font);
	}
	public void setTextKeyboard(String value){
		jlKeyboard.setText(value);
	}
}
