package composant_saisie.wComposant;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Edit;
import persistance.wSql.Sql;
import template_applicatif.wVue.AbstractVue;
import template_applicatif.wVue.VueIMoveListener;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class JTextDbF2 extends JTextDb implements MouseListener,VueIMoveListener, MouseWheelListener,JPopupIClicked  {
	private static final long serialVersionUID = 1L;
	public JLabel espace=null;
	public JTextDb libe=null;
	public JPanel jpF2PlusLibe=null;

	public AbstractVue jpVueF2=null;
	String approche="";
	public Sql sqlF2=null;
	private String fieldLibe=null;
	Color colorfondfleche=null;
	Color colorfondflechesave=new Color(230,230,230);
	Color colortraitgauche=null;
	Color colorcadrefond=null;
	int x=LEFT;
	int y=CENTER;
	int width=0;
	int height=0;
	JPopup jpopup=null;
	public JTextDbF2() {
		// Rien pour le moment juste pour le cellRenderer de la table
		colortraitgauche=Color.GRAY;
		colorfondfleche=colorfondflechesave;
		colorcadrefond=Color.GRAY;
		this.setName("F2 CellEditor");
	}
	public JTextDbF2(AbstractVue vue) {
		setVue(vue);
		//this.addFocusListener(this);
	}
	public void setVue(AbstractVue vue){
		putClientProperty(Edit.TYPE_FIELD,Edit.F2);
		jpVueF2=vue;
		sqlF2=vue.sqlListe;
		sqlF2.t_F2=this;
		adapte();

		jpopup=new JPopup();{
			sqlF2.t_F2Popup=jpopup;
			vue.dbListe.setHeaderSouth();
			jpopup.addComposant(vue,this);
			jpopup.validateDebut();
		}
	}
	private void adapte(){
		addMouseListener(this);
		addMouseWheelListener(this);
		this.setDisabledTextColor(Gp.VERTFONCE_FG);
		setCursor(Cursor.getPredefinedCursor(Cursor.TEXT_CURSOR));
		colortraitgauche=Color.LIGHT_GRAY;
		colorfondfleche=colorfondflechesave;
		colorcadrefond=Color.DARK_GRAY;
		jpF2PlusLibe=new JPanel(new FlowLayout(0,0,0));{
			libe=new JTextDb(); {
				libe.adapteTextLibe();
			}
			espace=new JLabel();{
				espace.setText(" ");
			}
			jpF2PlusLibe.add(this);
			jpF2PlusLibe.add(espace);
			jpF2PlusLibe.add(libe);
		}
	}
	public void mouseClicked(MouseEvent arg0) {
		if ( SwingUtilities.isLeftMouseButton(arg0) ){ 
			if (arg0.getClickCount()==2) {
				jpopup.openPopup(); 
			} else if (arg0.getClickCount()==1){
				if (clickedInFleche(getMousePosition())){
					jpopup.openPopup(); 
				}
			}
		}
	}
	public void keyReleased(KeyEvent e) {}
	public void keyTyped(KeyEvent e) {}
	public void keyPressed(KeyEvent arg0) {
		if (arg0.isControlDown()){
			switch (arg0.getKeyCode()) {
			case KeyEvent.VK_UP: precedent(1);arg0.consume(); break; 
			case KeyEvent.VK_DOWN: suivant(1);arg0.consume(); break;
			case KeyEvent.VK_HOME: debut();arg0.consume(); break; 
			case KeyEvent.VK_END: dbFin();arg0.consume(); break; }
		} else {
			switch (arg0.getKeyCode()) {
			case KeyEvent.VK_UP:
			case KeyEvent.VK_DOWN:
			case KeyEvent.VK_ENTER: 
				arg0.consume(); break;
			case KeyEvent.VK_F2: 
				jpopup.isTrigger=false;
				jpopup.openPopup(); 
				arg0.consume(); break; }
		}
	}

	public void removeLibeEspace(){
		jpF2PlusLibe.remove(espace);
	}
	public void removeThis(){
		jpF2PlusLibe.remove(this);
		removeLibeEspace();
	}
	public JPanel getThisInPanelsetLibe(String fieldLibe, int libeLength){
		int height=2+Gp.HEIGHTCHAR+2;
		Dimension dim=new Dimension(((libeLength+2)*Gp.WIDTHCHAR),height);
		libe.setPreferredSize(dim);
		libe.setMaximumSize  (dim);
		libe.setMinimumSize  (dim);
		libe.validate();
		this.fieldLibe=fieldLibe;
		return jpF2PlusLibe;
	}
	// Interface JPopupIClicked
	public boolean clickedInFleche(Point point){
		boolean ret=false;
		int xmin=getWidth()-getHeight();
		int xmax=getWidth();
		int ymin=0;
		int ymax=getHeight()-1;
		if (point!=null){
			int x=point.x;
			int y=point.y;
			if ((xmin<x && x<xmax) && (ymin < y && y < ymax) )
				ret=true;
		}
		return ret;
	}
	public void setValueFromChild(Object obj) {
		setText((String)obj);
	}
	public void setText(String string){
		super.setText(string);
		userUpdate();
	}
	public void setValueChild() {
		sqlF2.v_index=getText();
		sqlF2.rsSoftSeek();
		sqlF2.taThis.validateDebut();
	}
	public JFrame getMainFrame() {
		return sqlF2.getMf();
	}
	// Interface JPopupIClicked

	/*/////////////////////////
	// INTERFACE UTILISATEUR //
	/////////////////////////*/
	/*/////////////////////////
	// INTERFACE UTILISATEUR //
	/////////////////////////*/
	public void mouseExited(MouseEvent arg0) {}
	public void mouseEntered(MouseEvent arg0) {}
	public void mousePressed(MouseEvent arg0) {
		if (this.isEnabled()){
			if (clickedInFleche(getMousePosition())){
				colorfondfleche=getSelectionColor();
				repaint();
			}
		}
	}
	public void mouseReleased(MouseEvent arg0) {
		if (this.isEnabled()){
			if (clickedInFleche(getMousePosition())){
				colorfondfleche=colorfondflechesave;
				repaint();
			}
		}
	}
	public boolean isMovable(){
		return sqlF2.isModeMovable();
	}
	public void debut() {
		if(!sqlF2.v_index.equals(sqlF2.t_F2Debut)){
			sqlF2.dBTopByIndex();
			setValueFromChild(sqlF2.v_index);
		}
	}
	public void dbFin() {
		if(!sqlF2.v_index.equals(sqlF2.t_F2Fin)){
			sqlF2.dBBottomByIndex();
			setValueFromChild(sqlF2.v_index);
		}
	}
	public void precedent(int nb) {
		sqlF2.v_index=getText();
		boolean skip=false;
		for (int i=0;i<nb;i++){
			if(!sqlF2.v_index.equals(sqlF2.t_F2Debut)){
				sqlF2.dBSkavantByIndex();
				skip=true;
			}
			if (skip){
				setValueFromChild(sqlF2.v_index);
			}
		}
	}
	public void suivant(int nb) {
		sqlF2.v_index=getText();
		boolean skip=false;
		for (int i=0;i<nb;i++){
			if(!sqlF2.v_index.equals(sqlF2.t_F2Fin)){
				sqlF2.dBSkapresByIndex();
				skip=true;
			}
			if (skip){
				setValueFromChild(sqlF2.v_index);
			}
		}
	}
	public void pagePrecedente() {}
	public void pageSuivante() {}
	public void mouseWheelMoved(MouseWheelEvent arg0) {
		if (this.isEnabled()){
			if (arg0.getWheelRotation()>0){
				suivant(arg0.getWheelRotation());
			} else { 
				precedent(arg0.getWheelRotation()*-1); }
		}
	}
	public void userUpdate(){
		if (fieldLibe!=null){
			approche();
			repaintLibe();
		}
	}
	public void userOpenF2(){
		jpopup.openPopup();
	}
	public void userOpenF3(){
		jpopup.openPopup();
		jpVueF2.jbF3.doClick();
	}
	public void updateLibe(){
		approche="";
		approche();
		repaintLibe();
	}
	public void approche(){
		reactivateLibeSeek();
		String approche=sqlF2.rsSoftSeekIndex(getText());
		if (getText().length()==0 || !getText().equals(approche)){
			sqlF2.t_eof=true;
			if (approche.contains(getText())) 
				this.approche=approche;
			else
				this.approche="";
			reactivateLibeSeek();
		} else {
			this.approche="";
		}
		repaint();
	}
	public void reactivateLibeSeek(){
		if (fieldLibe!=null)
			sqlF2.t_F2fieldLibe=fieldLibe;
	}
	public void repaintLibe(){
		if (fieldLibe!=null && sqlF2.t_F2fieldLibe!=null){
			String strlibe=sqlF2.getLibeF2();
			if (strlibe.equals(fieldLibe))
				libe.setText("?");
			else
				libe.setText(strlibe);
		}
	}
	public void paint(Graphics g){
		super.paint(g);
		String emptyHelp="F2 : ";{
			if (sqlF2!=null){
				emptyHelp=emptyHelp+sqlF2.t_table;
			}
			FontMetrics fontMetrics = g.getFontMetrics();
			int lenEmptyHelp=fontMetrics.stringWidth(emptyHelp);
			if (lenEmptyHelp>getWidth()-getHeight()) {
				emptyHelp="                 ";
			}
			surPaint(g,emptyHelp+"        ",JTextDb.RIGHT, JTextDb.CENTER, Gp.FILIGRANE_LGRAY);
		}
		if (!getText().equals(approche)&&!getText().isEmpty() && !approche.isEmpty()){
			approchePaint(g);
		}
		flechePaint(g);
		paintBorder(g); // le text deborde sur le cadre
	}
	private void approchePaint(Graphics g) {
		Color save=g.getColor();
		g.setColor(Gp.FILIGRANE_LGRAY);
		g.drawString(approche, getInsets().left+1, getInsets().top+g.getFont().getSize());
		g.setColor(save);
		g.drawString(getText(), getInsets().left+1, getInsets().top+g.getFont().getSize());
	}
	private void flechePaint(Graphics g) {
		int w=getWidth();
		int h=getHeight();
		int largF2=h;
		if(h>Gp.HEIGHTTEXT){
			largF2=h/(h/Gp.HEIGHTTEXT);
		}
		Color save=g.getColor();
		// Trait Verticale gauche
		g.setColor(colortraitgauche);
		x=w-(largF2+2);
		y=0;
		height=h;
		g.fillRect(x, y, 1,height );

		// carr gris
		if (isEnabled()){
			g.setColor(colorfondfleche);
		} else {
			g.setColor(Color.LIGHT_GRAY);
		}
		x=w-largF2;
		y=2;
		width=largF2-3;
		height=h-4;
		g.fillRect(x, y, width,height );

		// basse Ombre du Cadre du carr gris
		x=w-largF2;
		y=2;
		width=largF2-2;
		height=h-4;
		g.setColor(Color.GRAY);
		g.drawRect(x, y, width,height);

		// Cadre du carr gris
		x=w-largF2;
		y=2;
		width=largF2-3;
		height=h-5;
		g.setColor(Gp.VERTFONCE_FG);
		g.drawRect(x, y, width, height);

		// Dessine le triangle
		if(isEnabled()){
			g.setColor(Gp.VERTFONCE_FG);
		} else {
			g.setColor(Color.GRAY);
		}
		int y=6;
		y=y+((h-Gp.HEIGHTTEXT)/2);// Centre la flche pour les zones plus grande que la hauteur standard
		int flechewidth=6;
		Gp.paintTriangle(g, (w-largF2)+((largF2-flechewidth)/2),y,flechewidth, SOUTH,0);			
		g.setColor(save);
	}

	public void surPaint(Graphics g,String txt, int x,int y,Color color){
		if (this.getText().length()==0){
			super.surPaint(g, txt, x, y);{
				super.surPaintText(g, txt, color);
			}
		}
	}
	public void dispose(){
		espace=null;
		libe=null;
		jpF2PlusLibe=null;
		if (jpopup!=null){
			jpopup.disposePopup();
			jpopup=null;
		}
		if (jpVueF2!=null){
			jpVueF2.dispose();
			jpVueF2=null;
		}
		//		jpVueF2=null;
		//		if (sqlF2!=null){
		//			sqlF2.dispose();
		//			sqlF2=null;
		//		}
		sqlF2=null;
		super.dispose();
	}
	protected void finalize()  {
		//		Gp.af("finalize : "+this.getName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
