package composant_saisie.wComposant;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;

import javax.swing.JFrame;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Edit;
import persistance.wSql.Sql;
import a_doc.doc.Licence;

import composant_saisie.wPtime.Day;
import composant_saisie.wPtime.JPTime;
import composant_saisie.wPtime.Time;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JTextDbTime extends JTextDb implements MouseListener, JPopupIClicked, MouseWheelListener   {
	private static final long serialVersionUID = 1L;
	JPopup jpopup=null;
	Sql sql=null;
	Color colorfondfleche=null;
	Color colorfondflechesave=new Color(230,230,230);
	Color colortraitgauche=null;
	Color colorcadrefond=null;
	public boolean userUpdate=true;
	private JPTime jptime=null;
	int x=0;
	int y=0;
	int width=0;
	int height=0;
	public int calctable=0;
	public JTextDbTime() {
		// Rien pour le moment juste pour le cellRenderer de la table
		colortraitgauche=Color.GRAY;
		colorfondfleche=colorfondflechesave;
		colorcadrefond=Color.GRAY;
		calctable=0;
	}
	public JTextDbTime(Sql sql) {
		putClientProperty(Edit.TYPE_FIELD,Edit.TIME);
		this.sql=sql;
		calctable=1;
		adapte();
	}
	private void adapte(){
		addMouseListener(this);
		this.addMouseWheelListener(this);
		this.setDisabledTextColor(Gp.VERTFONCE_FG);
		//this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
		setCursor(Cursor.getPredefinedCursor(Cursor.TEXT_CURSOR));
		this.setWidthChar(5+3);
		this.setHorizontalAlignment(SwingConstants.RIGHT);
		colortraitgauche=Color.LIGHT_GRAY;
		colorfondfleche=colorfondflechesave;
		colorcadrefond=Color.DARK_GRAY;
		jpopup=new JPopup();{
			jptime =new JPTime();
			jpopup.addComposant(jptime,this);
			jpopup.validateDebut();
		}
	}
	public void setOrientation(int orientation){
		if (jptime!=null)
			jptime.setOrientation(orientation);
	}

	/*/////////////////////////
	// INTERFACE UTILISATEUR //
	/////////////////////////*/
	public void keyReleased(KeyEvent e) {}
	public void keyTyped(KeyEvent e) {}
	public void keyPressed(KeyEvent arg0) {
		if (arg0.isControlDown()){
			switch (arg0.getKeyCode()) {
			case KeyEvent.VK_UP: 
				jptime.incrValue();
				super.setText(jptime.getSTime());
				arg0.consume();
				break; 
			case KeyEvent.VK_DOWN: 
				jptime.decrValue();
				super.setText(jptime.getSTime());
				arg0.consume(); 
				break;
			}

		} else {
			switch (arg0.getKeyCode()) {
			case KeyEvent.VK_F2:
				jpopup.isTrigger=false;
				jpopup.openPopup();
				checkAndRoundText();
				arg0.consume();
				break;
			case KeyEvent.VK_ENTER:
				checkAndRoundText();
				break;
			}
		}
	}
	public void mouseClicked(MouseEvent arg0) {
		if ( SwingUtilities.isLeftMouseButton(arg0) ){ 
			if (arg0.getClickCount()==2) {
				if (isEnabled()){
					jpopup.openPopup();
					checkAndRoundText();
				}
			} else if (arg0.getClickCount()==1){ 				
				if (clickedInFleche(getMousePosition())){
					if (isEnabled()){
						jpopup.openPopup();
						checkAndRoundText();
					}
				}
			}
		} else if ( SwingUtilities.isRightMouseButton(arg0) ){
			if (arg0.getClickCount()==1){
				setText(Day.getCurrentSTime());
			}
			
		}
	}
	public void mouseWheelMoved(MouseWheelEvent e) {
		if (isEnabled()){
			if (e.getWheelRotation()>0){
				jptime.incrValue();
				super.setText(jptime.getSTime());
			} else {
				jptime.decrValue();
				super.setText(jptime.getSTime());
			}
		}
	}
	// Interface JPopupIClicked
	public boolean clickedInFleche(Point point){
		boolean ret=false;
		int xmin=0;
		int xmax=getHeight()-1;
		int ymin=0;
		int ymax=getHeight()-1;
		if (point!=null){
			int x=point.x;
			int y=point.y;
			if ((xmin<x && x<xmax) && (ymin < y && y < ymax) )
				ret=true;
		}
		return ret;
	}
	public void setDEA(String timedeb,String timefin) {
		userUpdate=false;
		jptime.setPlage(timedeb,timefin);
		super.setText(jptime.getSTime());
		userUpdate=true;
	}
	public void setPlage(String timetot) {
		userUpdate=false;
		jptime.setPlage(timetot);
		super.setText(jptime.getSTime());
		userUpdate=true;
	}
	public String getDebSTime(){
		return jptime.getDebSTime();
	}
	public String getSTime(){
		return jptime.getSTime();
	}
	public String getFinStime(){
		return jptime.getFinSTime();
	}
	public void setSTime(String time) {
		userUpdate=false;
		super.setText(time);
		checkAndRoundText();
		userUpdate=true;
	}
	public void setText(String str){
		setSTime(str);
	}
	private void checkAndRoundText(){
		userUpdate=false;
		setValueChild();
		super.setText(jptime.getSTime());
		userUpdate=true;
	}
	public void setValueChild() {
		jptime.setPTime(Day.parseTime(getText()));
	}

	public void setValueFromChild(Object obj) {
		super.setText(((Time) obj).getSTime());
		checkAndRoundText();
	}
	public String getTimeDelay() {
		return jptime.getTimeDelay();
	}
	public String getSTimeDelay() {
		return jptime.getSTimeDelay();
	}
	public int getTimeDelayMinutes() {
		return jptime.getTimeDelayMinutes();
	}
	public JFrame getMainFrame() {
		return sql.getMf();
	}
	// Interface JPopupIClicked

	/*/////////////////////////
	// INTERFACE UTILISATEUR //
	/////////////////////////*/
	public void mouseExited(MouseEvent arg0) {}
	public void mouseEntered(MouseEvent arg0) {}
	public void mousePressed(MouseEvent arg0) {
		if (this.isEnabled()){
			if (clickedInFleche(getMousePosition())){
				colorfondfleche=getSelectionColor();
				repaint();
			}
		}
	}
	public void mouseReleased(MouseEvent arg0) {
		if (this.isEnabled()){
			if (clickedInFleche(getMousePosition())){
				colorfondfleche=colorfondflechesave;
				repaint();
			}
		}
	}
	public void paint(Graphics g){
		super.paint(g);
		flechePaint(g);
		super.surPaint(g,getText(),JTextDb.RIGHT, JTextDb.CENTER);
		paintBorder(g); // le text deborde sur le cadre
	}
	private void flechePaint(Graphics g) {
		int xx=getWidth ()-(getHeight ());
		xx=2;
		Color saveColor=g.getColor();
		// Trait Verticale gauche
		g.setColor(colortraitgauche);
		x=xx;
		y=0;
		width=1;
		height=getHeight ();
		g.fillRect(x, y, width,height );

		// carr gris
		g.setColor(colorfondfleche);
		x=xx;
		y=2;
		width=getHeight ()-3;
		height=getHeight ()-4;
		g.fillRect(x, y, width,height );

		// Ombre Cadre du carr gris
		x=xx;
		y=2;
		width=getHeight ()-2;
		height=getHeight ()-4;
		g.setColor(Color.GRAY);
		g.drawRect(x, y, width,height );
		// Cadre du carr gris
		x=xx;
		y=2;
		width=getHeight ()-3;
		height=getHeight ()-5;
		//g.setColor(colorcadrefond);
		g.setColor(Gp.VERTFONCE_FG);
		g.drawRect(x, y, width,height );


		if (calctable==1) {
			g.setColor(Color.DARK_GRAY);
			if (jptime.isPlage()){
				g.drawLine(xx+2 , y+2 , xx+2, y+2+8 );
				g.drawLine(xx+4 , y+2 , xx+4 ,y+2+4 );
				g.drawLine(xx+6 , y+2 , xx+6 ,y+2+4 );
				g.drawLine(xx+8 , y+2 , xx+8 ,y+2+6 );
				g.drawLine(xx+10, y+2 , xx+10,y+2+4 );
				g.drawLine(xx+12, y+2 , xx+12,y+2+4 );
				g.drawLine(xx+14, y+2 , xx+14,y+2+8 );
			} else {
				g.drawLine(xx+2, y+3 , xx+2+9 ,y+3 );
				g.drawLine(xx+2, y+5 , xx+2+5 ,y+5 );
				g.drawLine(xx+2, y+7 , xx+2+7 ,y+7 );
				g.drawLine(xx+2, y+9 , xx+2+5 ,y+9 );
				g.drawLine(xx+2, y+11, xx+2+9 ,y+11);
			}
		} else {
		}
		g.setColor(saveColor);
	}
	public void dispose(){
		if (jptime!=null){
			jptime.dispose();
			jptime=null;
		}
		if (jpopup!=null){
			jpopup.disposePopup();
			jpopup=null;
		}
		sql=null;
		super.dispose();
	}
	protected void finalize()  {
		//Gp.af("finalize : "+this.getName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
