package fenetre_menu.wConteneur;

import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Window;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.JDialog;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public abstract class AbstractJDialogDb extends JDialog implements PropertyChangeListener  {
	private static final long serialVersionUID = 1L;
	public Sql sql=null;
	public static String action="action";
	public static String closedialog="closedialog";

	public AbstractJDialogDb(Window wdn, Sql sql){
		super(wdn);
		this.sql=sql;
		adapte();
	}
	private void adapte(){
		sql.setIcon(this);
	}
	public void setVisible(boolean enable){
		if (enable){
			Gp.setRelativeLocation(this, getLocation(), this.getSize());
		}
		super.setVisible(enable);
	}
	public void computeSizeLocation(float position,Dimension panelDim){
		this.setLocationRelativeTo(null);
		Dimension tailleEcran=Gp.getScreenSize(); 
		Insets insetsEcran=Gp.getScreenInsets();
		if (position==JDialog.TOP_ALIGNMENT){
			this.setLocation(insetsEcran.left,insetsEcran.top);
		} else if (position==JDialog.BOTTOM_ALIGNMENT){
			this.setLocation(tailleEcran.width-panelDim.width-insetsEcran.left,tailleEcran.height-panelDim.height-insetsEcran.bottom);
		} else if (position==JDialog.RIGHT_ALIGNMENT){
			this.setLocation(tailleEcran.width-panelDim.width-insetsEcran.left,(tailleEcran.height-panelDim.height)/2);
		} else if (position==JDialog.LEFT_ALIGNMENT){
			this.setLocation(insetsEcran.left,(tailleEcran.height-panelDim.height)/2);
		} else {
			this.setLocation((tailleEcran.width-panelDim.width)/2,(tailleEcran.height-panelDim.height)/2);
		}
	}
	public void propertyChange(PropertyChangeEvent arg0) {
		if (arg0.getPropertyName().equals(action)){
			if (arg0.getNewValue().equals(closedialog))
				dispose();
		}
	}
	public void dispose(){
		sql=null;
		super.dispose();		
	}
	protected void finalize()  {
//		Gp.af("finalize : "+this.getName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
