package fenetre_menu.wMenu;



import java.sql.ResultSet;
import java.sql.SQLException;

import javax.swing.JComponent;
import javax.swing.JMenuItem;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class DbMenu implements ChangeListener {
	Gp gpAbc=null;
	public DbMenu(Gp gpAbc){
		this.gpAbc=gpAbc;

		JComponent jc;
		String c_code;
		if (gpAbc.m_flagMenuMain==0){
			// passe la premiere fois seulement pour les option de la barre de menus
			gpAbc.m_flagMenuMain=1;
			jc=gpAbc.m_jmenubar;
			c_code=gpAbc.m_menuMain;
		} else {
			// reste du temps passe pour option des sous menus
			jc=gpAbc.m_jmemu;
			c_code=gpAbc.m_menu;
		}
		Sql sqlAbcMenu=new Sql(gpAbc.sqlAbc);
		sqlAbcMenu.setTable("s_menus");
		try {
			String where="";
			if (gpAbc.ISDEVFILE){
				where="c_code = '"+c_code+"'";
			} else {
				where="c_code = '"+c_code+"' AND substr(c_smen,1,4) <> substr('"+Gp.DEVNUMM+"',1,4)";
			}
			String query="SELECT c_code,c_cle2,c_smen,c_menu,c_racc,c_opt1,c_opt2,c_opt3,c_aide FROM s_menus WHERE "+where+" ORDER BY  c_cle2;";
			ResultSet rs=sqlAbcMenu.dBExecuteQueryOpen(query);
			while (rs.next()) {
				boolean sousmenu=false;
				if (rs.getString("c_smen")!=null){
					if (rs.getString("c_smen").trim().length()>0){
						sousmenu=true;
					}
				}
				if (sousmenu){
					// Ajoute un sous Menus
					gpAbc.m_menu=rs.getString("c_smen");
					gpAbc.m_option=rs.getString("c_menu");
					gpAbc.m_a=rs.getString("c_racc").charAt(0);
					jc.putClientProperty("Aide",rs.getString("c_aide"));
					jc.add(new Menu(gpAbc));
					// ajoute l'couteur sur le menu principal
					if(gpAbc.m_jmenubar.getComponentCount()-1>=0){
						if (gpAbc.m_jmenubar.getMenu(gpAbc.m_jmenubar.getComponentCount()-1)!=null){
							gpAbc.m_jmenubar.getMenu(gpAbc.m_jmenubar.getComponentCount()-1).addChangeListener(this);
							gpAbc.m_jmenubar.getMenu(gpAbc.m_jmenubar.getComponentCount()-1).putClientProperty("Aide",rs.getString("c_aide"));
						}
					}
				} else {
					String code=rs.getString("c_code");
					String smen=rs.getString("c_smen");
					String opt1=rs.getString("c_opt1");
					String opt2=rs.getString("c_opt2");
					JMenuItem jmi =new JMenuItem(rs.getString("c_menu"));
					jmi.putClientProperty("Aide",rs.getString("c_aide"));
					jmi.putClientProperty("Option",rs.getString("c_menu"));
					jmi.putClientProperty("c_opt2",rs.getString("c_opt2"));
					jmi.putClientProperty("c_opt3",rs.getString("c_opt3"));
					jmi.setMnemonic((rs.getString("c_racc")+"*").charAt(0));
					if (opt1!=null){
						jmi.setActionCommand(rs.getString("c_opt1"));
					} else {
						jmi.setName(rs.getString("c_menu"));
						jmi.setActionCommand("");
					}
					jmi.addActionListener(new ExecuteMenu(gpAbc));
					jmi.addChangeListener(this);
					if (!gpAbc.appliParam.VERSIONPRO){
						if (Gp.isSupOrEqual(code,gpAbc.appliParam.VERSIONPRONUM_DE) && Gp.isInfOrEqual(code, gpAbc.appliParam.VERSIONPRONUM_A)){
							jmi.setEnabled(false);
						} else if(opt1!=null){
							if (opt1.contains(gpAbc.appliParam.VERSIONPROOPT1))
								jmi.setEnabled(false);
						}
					}
					if (opt1.trim().length()==0 && smen.trim().length()==0){
						jmi.setEnabled(false);
					}
					if (opt2!=null){
						if (opt2.trim().length()==0){
							jc.add(jmi );
						}
					}
				}
			}
			sqlAbcMenu.dBExecuteQuerryClose(rs);
			rs=null;
			sqlAbcMenu=null;
		} catch (SQLException e) { e.printStackTrace(); }
	}

	public void stateChanged(ChangeEvent arg0) {
		String aide=(String)((JMenuItem) arg0.getSource()).getClientProperty("Aide");
		if (aide==null){
			aide=" ";
		}
		if (aide.length()==0){
			aide=" ";
		}
		if(((JMenuItem) arg0.getSource()).isShowing()){
			gpAbc.f_mjStatusBar.setTextStatus(aide,"","");
		}
	}
}

