package module_standard.wAide;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.io.IOException;
import java.net.URL;

import javax.swing.JEditorPane;
import javax.swing.JScrollPane;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.text.html.HTMLDocument;
import javax.swing.text.html.HTMLFrameHyperlinkEvent;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import a_doc.doc.Licence;
import fenetre_menu.wConteneur.AbstractJPanelDlg;
import fenetre_menu.wConteneur.JDialogDlg;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class Aide extends AbstractJPanelDlg implements HyperlinkListener {
	private static final long serialVersionUID = 1L;
	JEditorPane jeAide =null;
	public Aide(JDialogDlg jd){
		super(jd);
		adapte();
	}
	private void adapte(){
		JScrollPane jpaide = new JScrollPane ();{
			jeAide  = new JEditorPane ();{
				jeAide.setPreferredSize(new Dimension(800, 600));
				jeAide.setEditable (false);
				jeAide.addHyperlinkListener (this);
			}
			jpaide.setViewportView(jeAide);
			jd.getContentPane().add (jpaide, BorderLayout.CENTER);
		}
	}
	public void hyperlinkUpdate (HyperlinkEvent event) { 
		if (event.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
			if (event instanceof HTMLFrameHyperlinkEvent) { 
				HTMLDocument doc = (HTMLDocument)jeAide.getDocument ();
				doc.processHTMLFrameHyperlinkEvent ((HTMLFrameHyperlinkEvent)event);
			} else {
				loadPage ("",event.getURL ().toString (),"");
			}
		}
	}
	public void loadPage (String prefixe,String directory,String file){
		String urlText=prefixe+directory+file;
		try {
			jeAide.setPage (new URL (urlText));
			jd.jlSouth.setText(directory+file);
		} catch (IOException ex) {
			Gp.MB("Fichier introuvable : " + directory+file);
		}
	}

	public static boolean isAide(Sql sql){
		boolean ret=false;
		createDbAide(sql);
		String t_moduleIdAide=sql.t_moduleIdAide;
		Sql sqlAbc=new Sql(sql.getSqlAbc());
		if (t_moduleIdAide.trim().length()!=0){
			String html=sqlAbc.readStringValue("s_aide","c_code", t_moduleIdAide, "c_html");
			if (html.trim().length()!=0){
				ret=true;
			}
		}
		return ret;
	}
	public static String getHtml(Sql sql) {
		String ret="";
		createDbAide(sql);
		String t_moduleIdAide=sql.t_moduleIdAide;
		if (t_moduleIdAide.trim().length()!=0){
			Sql sqlAbc=new Sql(sql.getSqlAbc());
			ret=sqlAbc.readStringValue("s_aide","c_code", t_moduleIdAide, "c_html");
			if (!sqlAbc.readSeek("s_aide","c_code", t_moduleIdAide)){
				sqlAbc.dBExecuteUpdate("INSERT INTO s_aide (c_code,c_html) VALUES ('"+t_moduleIdAide+"','');");
			}
		}
		return ret;
	}

	private static void createDbAide(Sql sql){
		Sql sqlAbc=new Sql(sql.getSqlAbc());
		sqlAbc.setTable("s_aide");
		if (!sqlAbc.isTableExist()){
			String query="";
			switch (sqlAbc.getGpAbc().sqltype){
				case Gp.MYSQL:
					query="CREATE TABLE s_aide (c_code VARCHAR (60) NOT NULL,c_html VARCHAR (60) NOT NULL,ROWID int(10) unsigned NOT NULL AUTO_INCREMENT,  UNIQUE code (c_code), PRIMARY KEY (ROWID) );";
					break;
				case Gp.SQLITE:
					query="CREATE TABLE s_aide (c_code VARCHAR (60) NOT NULL,c_html VARCHAR (60) NOT NULL,  UNIQUE (c_code) );";
					break;
			}
			sqlAbc.dBExecuteUpdate(query);
		}
	}
}
