package module_standard.wBackup;

import java.awt.BorderLayout;
import java.awt.Component;
import java.beans.PropertyChangeListener;
import java.io.File;

import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import a_doc.doc.Licence;



/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class JFileChooserDb extends JFileChooser {
	private static final long serialVersionUID = 1L;
	JFileChooserExtensionFilter fef;
	public int type=0;
	public JFileChooserDb(int type){
		super();
		setSauvegarde(type);
	}
	public void setSauvegarde(int type){
		this.type=type;
		setFileSelectionMode(JFileChooser.FILES_ONLY);
		setMultiSelectionEnabled(false); 
		setAcceptAllFileFilterUsed(false);
	}
	public void addSelectedFileChanged(PropertyChangeListener pcl){
		this.addPropertyChangeListener(JFileChooser.SELECTED_FILE_CHANGED_PROPERTY, pcl);
	}
	public void addDirectoryChanged(PropertyChangeListener pcl){
		this.addPropertyChangeListener(JFileChooser.DIRECTORY_CHANGED_PROPERTY, pcl);
	}
	public void approveSelection(){
		fef=(JFileChooserExtensionFilter) this.getFileFilter();
		boolean acceptExt=false;
		if (getSelectedFile().getName().contains(".")){
			acceptExt=true; //Le nom de fichie contient une extension c'est ok 
		}
		if (!acceptExt){
			File file=new File(this.getSelectedFile().getPath()+fef.getExtension());
			this.setSelectedFile(file);			
		}

		if (type==JDialogBackup.BACKUP){
			if (!this.getSelectedFile().isFile()){
				super.approveSelection();
			} else {
				int retour=0;
				retour = JOptionPane.showConfirmDialog(null,
						"Le fichier existe dj \n\n "+
						" OUI remplacer ce fichier \n\n", 
						"Attention !!!",JOptionPane.YES_NO_OPTION);
				if (retour==JOptionPane.OK_OPTION){
					super.approveSelection();
				}
			}
		} else {
			if (this.getSelectedFile().isFile()){
				super.approveSelection();
			} else {
				String titre="";
				if (type==JDialogBackup.RESTORE){
					titre="Rcupration";
				} else {
					titre="Importation";
				}
				JOptionPane.showMessageDialog(null, "Ce fichier n'xiste pas \n\n Choisir un autre, Merci",titre, JOptionPane.INFORMATION_MESSAGE);
			}
		}
	}
	public void addSouth(JComponent jc) {
		JPanel jpsouth=new JPanel(new BorderLayout());
		jpsouth.add(new JLabel("      >>      "),BorderLayout.WEST);
		jpsouth.add(jc,BorderLayout.CENTER);
		jpsouth.add(new JLabel("      <<      "),BorderLayout.EAST);
		this.add(jpsouth,BorderLayout.SOUTH);
	}
	public void setNotChangeDirectory(PropertyChangeListener pcl) {
		addDirectoryChanged(pcl);
		this.add(new JLabel(),BorderLayout.NORTH);
		Component tc[]=this.getComponents();
		for (int i=0;i<tc.length;i++){
			if (tc[i].toString().contains("ToolBar")){
				tc[i].setVisible(false);
			}
		}
	}
}
