package module_standard.wBackup;

import java.io.File;

import javax.swing.filechooser.FileFilter;

import a_doc.doc.Licence;



/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JFileChooserExtensionFilter extends FileFilter{
	private final String description;
	private String extension;
	private String[] extensions;
	public JFileChooserExtensionFilter(String description, String extension){
		super();
		this.description = description;
		this.extension = extension;
	}
	public JFileChooserExtensionFilter(String description, String[] extensions) {
		super();
		this.description = description;
		this.extension = extensions[0];
		this.extensions = extensions;
	}
	public boolean accept(File file){
		boolean ret=false;
		if (file.isDirectory()){
			ret=true; 
		} else { 
			String fileName = file.getName().toLowerCase();
			if (extensions != null ){
				for (int i=0; i<extensions.length; i++){
					if (fileName.endsWith(extensions[i])){
						ret = true;
						i=extensions.length;
					}
				}
			} else {
				ret=fileName.endsWith(extension);
			}   
		}
		return ret;
	}
	public String getDescription(){
		return description;
	}
	public String getExtension(){
		return extension;
	}
	public String[] getExtensions() {
		return extensions;
	}
}
