package module_standard.wConnectPreference;


import java.awt.event.KeyEvent;

import javax.swing.JComponent;
import javax.swing.JPanel;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import table_standard.wS_prefs.S_prefsVUE;
import table_standard.wS_prefs.S_prefsSAISIE;
import template_applicatif.wFiche.FicheIEditableColumns;
import template_applicatif.wListe.ListeIEditableColumn;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextDb;
import composant_saisie.wComposant.JTextDbF2;
import composant_saisie.wComposant.JTextPassword;
import composant_saisie.wSaisieFormat.Ccs;

import fenetre_menu.wConteneur.MainFrame;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class S_prefsConnectSAISIE extends S_prefsSAISIE  {
	private static final long serialVersionUID = 1L;
	JTextDb luser,lword,ltent;
	JTextDbF2 	user=null;
	JTextPassword word=null;
	JTextDb 	tent=null;

	String optionQuit="Quitter le logiciel";			       
	String optionOk="Utiliser ce code utilisateur";			       
	int nbTent=0;
	int maxTent=3;
	public S_prefsConnectSAISIE(Sql sql) {
		super(sql);
	}
	public void initCreateLE() {
		luser	=new JTextDb("Utilisateur");
		lword	=new JTextDb("Mot de passe");
		ltent	=new JTextDb("Nombre de tentatives");
		Ccs.TexttoLibe(luser);
		Ccs.TexttoLibe(lword);
		Ccs.TexttoLibe(ltent);
	}
	public void initMapLE() {}

	public void initGuiLE(){
		initGuiLSimple();
		jpDbE=new JPanel(Gp.adaptePanelE());
	}
	public void initFocus() {
		setDefFocus(user);
	}
	public void setEditableColumns(FicheIEditableColumns fe,ListeIEditableColumn fl) {}
	public void fireEditableColumnUpdate(String nameField,Object value){}
	public void validateAdapteFicheCrud(){
		userOptionAdd(optionQuit,sql.getAppliParam().JBDELETE);
		userOptionAdd(optionOk,sql.getAppliParam().JBRECORD);
		setCrudOnlyOption();
		initT();

	}
	private void initT(){
		user	=new JTextDbF2(new S_prefsVUE(sql,"",Vue.F2));{
			user.setWidthChar(10+2);
			user.setText(sql.restoreLastUserFromSystem());
		}
		word=new JTextPassword("        ");
		tent	=new JTextDb(nbTent+"/"+maxTent);{
			tent.setFont(Gp.FONTTEXT16);
			tent.adapteTextLibe();
			tent.setWidthChar(3);		
		}
		user.addKeyListener(this);
		user.setName("c_code");
		ccs.addE(user);

		word.addKeyListener(this);
		word.setName("c_pass");
		ccs.addE(word);

		Gp.adaptePanelE();
		jpDbE.add(user,Gp.gety());
		jpDbE.add(word,Gp.gety());
		jpDbE.add(tent,Gp.gety());

	}
	public void loadEAdapteGuiLE() {}
	public void setBaseListener() {}
	public void fireBaseListener(JComponent jc){}
	public void userOptionDo(String actionCommandOption){
		if (actionCommandOption.equals(optionQuit)){
			userOptionQuit();
		} else if (actionCommandOption.equals(optionOk)){
			userOptionOk();
		} 
	}
	private void userOptionQuit() {
		((MainFrame)sql.getMf()).windowClosing(null);
	}
	private void userOptionOk() {
		boolean acces=true;
		nbTent++;
		tent.setText(nbTent+"/"+maxTent);
		if (nbTent>maxTent){
			userOptionQuit();
		}
		if (acces){
			acces=sql.readSeek("s_prefs", "c_code",user.getText());
		}
		if (acces){
			String pass=sql.readStringValue("s_prefs","c_code",user.getText(),"c_pass");
			if (pass.trim().length()==0){
				acces=true;
			} else {
				if (word.getText().trim().length()!=pass.trim().length()){
					acces=false;
				}
				if (!word.getText().trim().equals(pass.trim())){
					acces=false;
				}
			}
		}
		if (acces){
			reloadAppli();
		}
	}
	private void reloadAppli(){
		sql.setUser(user.getText().trim());
		sql.applyPreferences(sql.getUser());
		sql.getAppliParam().setUserParamFromDb(sql.getGpAbc());
		sql.loadMenu();
		sql.removeDbVue(true);
	}
	public void keyPressed(KeyEvent arg0) { // ATTENTION MEME RACCOURCI QUE JPLAGETIMES // JTIMEDELAY
		if (!arg0.isControlDown() && arg0.getKeyCode()==KeyEvent.VK_ENTER && arg0.getSource()==word){
			arg0.consume(); 
			userOptionOk();
		} else {
			super.keyPressed(arg0);
		}
	}
}
