package module_standard.wDebug;

import java.io.OutputStream;
import java.lang.management.ManagementFactory;
import java.lang.management.MemoryMXBean;

import javax.swing.JTextArea;

import a_doc.doc.Licence;



/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class Console extends OutputStream {
	private JTextArea ta=null;
	private String titre=null;
	JDebug debug=null;
	public Console(String titre, JTextArea ta) {
		this.ta = ta;
		this.titre=titre;
		
		boolean memory=false;
		if (memory){
			MemoryMXBean memoryBean = ManagementFactory.getMemoryMXBean();
			ta.append(""+memoryBean.getHeapMemoryUsage()+(char) 13+(char)10);
		}
	}
	public void write(int b) {
		String sb=new String(new byte[]{(byte)b});
		if (sb.charAt(0)==13){
			sb=sb+(char)10;
		}
		ta.append(sb);
		if (debug==null){
			debug=new JDebug(titre,ta);
			debug.pack();
		} else {
			if (!debug.isVisible())
				debug.setVisible(true);
		}
	}
}