package module_standard.wImprime;


import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Window;
import java.beans.PropertyChangeEvent;

import javax.swing.JDialog;
import javax.swing.JLabel;

import persistance.wGlobalParam.Gp;
import template_applicatif.wFiltre.JPdeA;
import template_applicatif.wVue.AbstractVue;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextDb;

import fenetre_menu.wConteneur.AbstractJDialogDb;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class JDialogPrint extends AbstractJDialogDb {
	private static final long serialVersionUID = 1L;
	AbstractVue vue=null;
	public static String apercu="Apercu";
	public static String apercunew="newApercu";
	JPanelPrint pp=null;
	JTextDb jlSouth=null;
	JPdeA jpdea=null;	
	JPEntete jpentete=null;

	public JDialogPrint(Window wdn, AbstractVue vue){
		super(wdn,vue.sqlListe);
		this.vue=vue;
		adapte();
		this.setVisible(true); // en dernier et sans le pack
		pp.jbImprime.requestFocusInWindow();
	}
	public void adapte(){
		this.setName(this.getClass().getSimpleName());
		this.setTitle("Impression : "+sql.getOptionText());
		jpdea=new JPdeA(vue);{
			jpentete=new JPEntete(vue,jpdea);
			pp=new JPanelPrint(vue,jpdea,jpentete); {
				pp.putClientProperty(action,"ok");
				pp.addPropertyChangeListener(action, this);
				this.getContentPane().add(pp,BorderLayout.CENTER);
			}
		}
		if (!sql.isTcetorp() && sql.t_table.equals(sql.getAppliParam().PROTECTTABLE)){
			jlSouth=new JTextDb("  ");{
				jlSouth.setText("   "+Gp.PROTECTDEMO+" :  Pour les ditions. Ceci vous permet de tester le logiciel et de conserver vos donnes.");
				jlSouth.adapteTextLibe();
				this.getContentPane().add(jlSouth,BorderLayout.SOUTH);
			}
		} else { 
			this.getContentPane().add(new JLabel("  "),BorderLayout.SOUTH);
		}

		this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		this.setResizable(true);{
			computeSizeLocation(pp);
		}
	}
	public void propertyChange(PropertyChangeEvent arg0) {
		if (arg0.getPropertyName().equals(action)){
			if (arg0.getNewValue().equals(closedialog)){
				dispose();
			}
			if (arg0.getNewValue().equals(apercu)||arg0.getNewValue().equals(apercunew)){
				this.getContentPane().remove(pp);
				pp.removeJPDea();
				pp=new JPanelPrint(vue,jpdea,jpentete);{
					pp.putClientProperty(action,"ok");
					pp.addPropertyChangeListener(action, this);
					this.getContentPane().add(pp,BorderLayout.CENTER);}
				computeSizeLocation(pp);
				this.getContentPane().validate();
				pp.jbImprime.requestFocusInWindow();
			}
		}
	}
	public void setVisible(boolean enable){
		super.setVisible(enable);
	}
	public void computeSizeLocation(JPanelPrint pp){
		this.setLocationRelativeTo(null);
		Dimension tailleEcran=Gp.getScreenSize();
		Point p=sql.getMf().getLocationOnScreen();
		int widthdecr=100;
		int heightdecr=20;
		p.x=p.x+(widthdecr/2);
		p.y=p.y+(heightdecr/2);
		int width=sql.getGpAbc().f_mfWidth-widthdecr;
		int height=sql.getGpAbc().f_mfHeight-heightdecr;
		int ppwidth=(int) (pp.jpImpListe.pageWidth*pp.jpImpListe.scale/100*110);
		if (ppwidth>width && ppwidth<tailleEcran.width)
			width=ppwidth;
		if (pp.getHeight()>height && pp.getHeight()<tailleEcran.height)
			height=pp.getHeight();
		this.setSize(width,height);
		this.setLocation((tailleEcran.width-width)/2,(tailleEcran.height-height)/2);
	}
	public void dispose(){
		vue=null;
		pp=null;
		jlSouth=null;
		jpdea=null;	
		jpentete=null;
		super.dispose();
	}
}
