package module_standard.wImprime;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.print.PageFormat;
import java.awt.print.Paper;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.File;
import java.util.prefs.Preferences;

import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.TitledBorder;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;

import module_standard.wBackup.JDialogBackup;
import module_standard.wBackup.JFileChooserDb;
import module_standard.wBackup.JFileChooserExtensionFilter;
import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import template_applicatif.wFiltre.JPdeA;
import template_applicatif.wVue.AbstractVue;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JRadio;
import composant_saisie.wComposant.JScrollPaneAuto;
import composant_saisie.wComposant.JTextButton;
import composant_saisie.wComposant.JTextDb;
import composant_saisie.wSaisieFormat.UserUpdate;

import fenetre_menu.wConteneur.AbstractJDialogDb;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class JPanelPrint extends JPanel implements Printable, ActionListener, CaretListener, KeyListener, PropertyChangeListener {
	private static final long serialVersionUID = 1L;
	Sql sql=null;
	AbstractVue vue=null;
	JPimpListe jpImpListe=null;
	JPdeA jpdea=null;
	JPEntete jpentete=null;
	JScrollPane jsp=null;
	JPanel jpNorth=null;
	JPanel jpUser=null;
	JPanel jpImprime=null;
	String imprime	="Lancer l'impression";
	String export	="Exportation";
	JTextButton jbImprime=null;
	JTextButton jbExport=null;
	String fermer="fermer";
	JTextButton jbApercu=null;
	JTextDb jtnbListe=null;
	JRadio jrb=null;
	JRadio jrbr=null;
	JLabel jl=null;
	PageFormat pf=null;
	boolean userprint=true;
	boolean printWithIndex=true;
	String indexDebut="";
	String indexFin="";
	//	String recnoDebut="";
	//	String recnoFin="";
	public JPanelPrint(AbstractVue vue,JPdeA jpdea,JPEntete jpentete) {
		this.jpentete=jpentete;
		this.vue=vue;
		this.sql=vue.sqlListe;
		this.jpdea=jpdea;
		adapte();
		jbImprime.requestFocusInWindow();
	}
	public void adapte(){
		this.setLayout(new BorderLayout());{
			jpNorth=new JPanel(Gp.adaptePanelP()); {
				jpNorth.add(sql.getPanelTitleMenuOptionText(),Gp.getGbcTitre());

				jpUser=new JPanel(new FlowLayout());{
					jpImprime=new JPanel(new BorderLayout());{
						jbImprime=appendButtonImprimer(imprime);
						JPanel jpExport=new JPanel();{
							JLabel jl1=new JLabel("     ");
							jbExport=appendButtonExport(export);
							JLabel jl2=new JLabel("     ");
							jpExport.add(jl1);
							jpExport.add(jbExport);
							jpExport.add(jl2);
						}
						jpImprime.add(jbImprime,BorderLayout.CENTER);
						jpImprime.add(jpExport,BorderLayout.SOUTH);
					}

					jl=new JLabel("Colonnes par Page : ");

					jrb=appendRadioOrientation();{
						jrb.addPropertyChangeListener(UserUpdate.UPDATE,this);
					}

					jrb.setKeyListener(this);
					if (sql.ruptures!=null){
						jrbr=appendRadioRupture();{
							jrbr.addPropertyChangeListener(UserUpdate.UPDATE,this);
						}
						jrb.jpGroup.setBorder(new TitledBorder("Orientation"));
						jrb.add(jrbr,BorderLayout.SOUTH);
						jrbr.setBorder(new TitledBorder(sql.g_optionRupture));
						jrbr.setKeyListener(this);
					}

					jtnbListe=new JTextDb(sql.g_nbList+"  "); {
						jtnbListe.setText(sql.g_nbList+"  ");
						jtnbListe.addCaretListener(this);
						jtnbListe.addKeyListener(this);
					}

					jbApercu=appendButtonApercu(JDialogPrint.apercu);

					jpUser.add(jpImprime);
					jpUser.add(jl);
					jpUser.add(jtnbListe);
					jpUser.add(jrb);
					jpUser.add(jbApercu);
				}
				jpNorth.add(jpUser,Gp.gety());{
					addJPDea();
				}
			}

			jsp=new JScrollPaneAuto();{
				jpImpListe = new JPimpListe(jpentete);{
					this.pf=PrinterJob.getPrinterJob().defaultPage();{
						pf.setOrientation(sql.g_orientation);
						Paper paper=pf.getPaper();
						int marge=Gp.MARGEMINI;
						paper.setImageableArea(marge,marge, paper.getWidth()-(marge*2), paper.getHeight()-(marge*2)); // ne pas descendre en dessous de ces marges minimum sinon pert une page blanche ???

						pf.setPaper(paper);
					}
					validateDebutFin();
					jpImpListe.validateDebut(sql, pf,indexDebut,indexFin,printWithIndex);
				}
				//jsp.setAutoscrolls(true);
				jsp.setViewportView(jpImpListe);
				//jsp.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			}
			this.add(jpNorth,BorderLayout.NORTH);
			this.add(jsp,BorderLayout.CENTER);
		}
	}
	private void validateDebutFin() {
		if (jpdea.isValid){
//			if (sql.t_index.length>1){
//				Gp.MB("Problme programmation, \n la table n'est pas une table simple, elle dispose d'un index compos");
//				indexDebut=Sql.t_top;
//				indexFin  =Sql.t_top;
//			} else {
				//			recnoDebut=jpdea.getRecnoDebut();
				indexDebut=jpdea.getIndexDebut();
				//			recnoFin=jpdea.getRecnoFin();
				indexFin=jpdea.getIndexFin();
//			}

		} else {
			boolean filtered=false;
			if (sql.clauseFilter!=null){
				if (sql.clauseFilter.trim().length()>0){
					indexDebut=Sql.t_top;
					indexFin=Sql.t_bottom;
					filtered=true;
				}
			}
			if (!filtered){
				sql.dBTopByIndex();
				//				recnoDebut=sql.t_Recno;
				indexDebut=sql.v_index;
				sql.dBBottomByIndex();
				//				recnoFin=sql.t_Recno;
				indexFin=sql.v_index;
			}
		}
	}
	public void addJPDea(){
		if (jpdea.isValid){
			jpNorth.add(jpdea,Gp.gety());
			jpdea.addPropertyChangeListener(UserUpdate.UPDATE,this);
		}
	}
	public void removeJPDea(){
		if (jpdea.isValid){
			jpNorth.remove(jpdea);
			jpdea.removePropertyChangeListener(UserUpdate.UPDATE,this);
		}
	}
	public JTextButton appendButtonImprimer(String ActionCommand){
		JTextButton jb=new JTextButton(ActionCommand);{
			jb.setFont(Gp.FONTTEXT14);
			jb.setPreferredSize(new Dimension(200,42));
			jb.setMinimumSize(new Dimension(200,42));
			jb.setMaximumSize(new Dimension(200,42));
			jb.setFocusable(true);
			jb.addActionListener(this);
			jb.addKeyListener(this);
		}
		return jb;
	}
	public JTextButton appendButtonExport(String ActionCommand){
		JTextButton jb=new JTextButton(ActionCommand);{
			jb.setFocusable(true);
			jb.addActionListener(this);
			jb.addKeyListener(this);
		}
		return jb;
	}
	private JTextButton appendButtonApercu(String ActionCommand) {
		JTextButton jb=new JTextButton(ActionCommand);{
			jb.addActionListener(this);
			jb.setEnabled(false);
			jb.addKeyListener(this);
		}
		return jb;
	}
	private JRadio appendRadioOrientation(){
		JRadio jrb=new JRadio(); {
			if (sql.g_orientation==Sql.LANDSCAPE){
				jrb.addButton("Portrait",false);
				jrb.addButton("Paysage",true);
			} else {
				jrb.addButton("Portrait",true);
				jrb.addButton("Paysage",false);
			}
		}
		return jrb;
	}
	private JRadio appendRadioRupture(){
		JRadio jrb=new JRadio(); {
			boolean tous=false;
			boolean detail=false;
			boolean total=false;
			switch (sql.g_rupture){
			case Sql.RUPTURE_TOUS:
				tous=true;
				break;
			case Sql.RUPTURE_DETAIL:
				detail=true;
				break;
			case Sql.RUPTURE_TOTAL:
				total=true;
				break;
			}
			jrb.addButton("Tous    ",tous);
			jrb.addButton("Dtail  ",detail);
			jrb.addButton("Total   ",total);
		}
		return jrb;
	}
	public void actionPerformed(ActionEvent arg0){
		if(arg0.getSource()==jbApercu){
			userprint=false;
			userApercu();
		} else if(arg0.getActionCommand().equals(imprime)) {
			userprint=true;
			userPrint();
		} else if(arg0.getActionCommand().equals(export)) {
			userprint=true;
			userExport();
		} else if(arg0.getActionCommand().equals(fermer)){
			userFermer();
		}
	}
	private void userFermer(){
		this.putClientProperty(AbstractJDialogDb.action,AbstractJDialogDb.closedialog);
	}
	private void userApercu() {
		int nbList=jtnbListe.getInt();
		if (nbList>0 && nbList<6){
			jbImprime.setEnabled(true);
			jbExport.setEnabled(true);
			sql.g_nbList=nbList;
			this.apercu();
		} else {
			jtnbListe.setText(sql.g_nbList+"");
		}
	}
	private void userPrint(){
		jbImprime.setEnabled(false);
		jbExport.setEnabled(false);
		jbImprime.setText("Impression Encours");
		this.print();
		jbImprime.setText("Impression Termine, Ok");
		jbImprime.setEnabled(true);
		jbImprime.setActionCommand(fermer);
		jbImprime.requestFocusInWindow();
	}
	private void userExport(){
		jbImprime.setEnabled(false);
		jbExport.setEnabled(false);
		boolean ret=export();
		if (ret){
			jbImprime.setText("Exportation Termine, Ok");
			jbImprime.setActionCommand(fermer);
		} else {
			jbExport.setEnabled(true);
		}
		jbImprime.setEnabled(true);
		jbImprime.requestFocusInWindow();
	}
	public void apercu(){
		if (this.getClientProperty(AbstractJDialogDb.action).equals(JDialogPrint.apercu)){
			this.putClientProperty(AbstractJDialogDb.action,JDialogPrint.apercunew);
		} else {
			this.putClientProperty(AbstractJDialogDb.action,JDialogPrint.apercu);
		}
	}
	public void caretUpdate(CaretEvent arg0) {
		userUpdate();
	}
	public void userUpdate(){
		if (!userprint){
			jbImprime.setEnabled(false);
			jbExport.setEnabled(false);
			jbApercu.setEnabled(true);
		}
	}
	public void keyReleased(KeyEvent arg0) {}
	public void keyTyped(KeyEvent arg0) {}
	public void keyPressed(KeyEvent arg0) {
		switch (arg0.getKeyCode()) {
		case KeyEvent.VK_ENTER: 
			if (jbApercu.isEnabled()){
				jbApercu.doClick();
			} else if (jbImprime.isEnabled()) {
				jbImprime.doClick();
			}
			arg0.consume(); break;
		case KeyEvent.VK_ESCAPE:
			userFermer();
			arg0.consume(); break;
		default:
			break; }
	}
	public void propertyChange(PropertyChangeEvent arg0) {
		if (arg0.getSource()==jpdea){
			jbImprime.setEnabled(false);
			jbExport.setEnabled(false);
			jbApercu.setEnabled(true);
			userprint=false;
		} else 	if (arg0.getSource()==jrb){
			int radiobutton=jrb.getButton();
			if (radiobutton==0){
				sql.g_orientation=Sql.PORTRAIT;
			} else if (radiobutton==1) {
				sql.g_orientation=Sql.LANDSCAPE;
			}
			jbImprime.setEnabled(false);
			jbExport.setEnabled(false);
			jbApercu.setEnabled(true);
			userprint=false;
		} else if (arg0.getSource()==jrbr){
			int radiobutton=jrbr.getButton();
			if (radiobutton==0){
				sql.g_rupture=Sql.RUPTURE_TOUS;
			} else if (radiobutton==1) {
				sql.g_rupture=Sql.RUPTURE_DETAIL;
			} else if (radiobutton==2) {
				sql.g_rupture=Sql.RUPTURE_TOTAL;
			}
			jbImprime.setEnabled(false);
			jbExport.setEnabled(false);
			jbApercu.setEnabled(true);
			userprint=false;
		}
	}
	public int print(Graphics g, PageFormat pf, int pageIndex) throws PrinterException {
		double hauteurPage =pf.getImageableHeight();
		if (pageIndex>jpImpListe.getHeight()/hauteurPage) {
			return 1;
		}
		double tsmoin=(pf.getImageableY()+2+(-pageIndex) * (hauteurPage));
		double tsplus=(pf.getImageableY()+2+( pageIndex) * (hauteurPage));
		Graphics2D g2d=(Graphics2D)g;
		g2d.translate(pf.getImageableX(),tsmoin);
		jpImpListe.paintComponent(g);
		g2d.translate(pf.getImageableX(),tsplus);
		return 0;
	}
	public void print() {
		//Paper paper = pf.getPaper();
		//System.out.println("Avant x : "+paper.getImageableX()+" y : "+paper.getImageableY()+" W : "+ paper.getWidth()+" H :"+paper.getHeight());
		PrinterJob printJob=PrinterJob.getPrinterJob();
		printJob.setPrintable(this, pf);
		try {
			boolean print=false;
			if (sql.g_choicePrinter==Sql.CHOICEPRINTER) {
				if(printJob.printDialog()) {
					print=true;
					//      Paper save = pf.getPaper();
					//      System.out.println("Avant x : "+paper.getImageableX()+" y : "+paper.getImageableY()+" W : "+ paper.getWidth()+" H :"+paper.getHeight());
					//      paper.setImageableArea(paper.getImageableX(), paper.getImageableY(), paper.getWidth(), paper.getHeight() );
					//      System.out.println("Apres x : "+paper.getImageableX()+" y : "+paper.getImageableY()+" W : "+ paper.getWidth()+" H :"+paper.getHeight());
					//      pf.setPaper(paper);
					//      printJob.setPrintable(this, pf);
					// printJob.print();
					//      pf.setPaper(save);
				}
			} else {
				print=true;
			}
			if (print){
				printJob.print();
			}
		}
		catch(PrinterException pe) { System.out.println("Erreur lors de l'impression du document: " + toString()); }
	}
	private boolean export(){
		boolean ret=false;
		String prefEdition=sql.getGpAbc().m_option; // Le nom du fichier reprends la Key l'option de menu
		Preferences pref=Preferences.userRoot();
		File fExport=null;

		JFileChooserDb jfc = new JFileChooserDb(JDialogBackup.BACKUP);{
			String path=pref.get(sql.getAppliParam().getNameBase()+prefEdition,"");
			if (path.equals("")){
				fExport=new File(prefEdition+".html");
			} else {
				fExport=new File(path);
			}
			jfc.setSelectedFile(fExport);
			jfc.addChoosableFileFilter(new JFileChooserExtensionFilter("Fichier Texte ("+"txt"+")", ".txt"));
			jfc.addChoosableFileFilter(new JFileChooserExtensionFilter("Fichier web ("+"html"+")", ".html"));
		}
		String choisir="Lancer l'exportation";
		int returnVal = jfc.showDialog(this,choisir);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			fExport = jfc.getSelectedFile();
			pref.put(sql.getAppliParam().getNameBase()+prefEdition, fExport.getPath());
			int typeExport=JPimpListe.TXT;
			if (fExport.getPath().contains(".html")) {
				typeExport=JPimpListe.HTML;
			}
			jpImpListe.exportDb(typeExport,fExport);
			fExport=null;
			ret=true;
		}
		return ret;	
	}
}
