package module_standard.wInfos;


import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import javax.swing.BorderFactory;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextButton;
import composant_saisie.wComposant.JTextDb;
import composant_saisie.wComposant.JTextLabel;
import composant_saisie.wSaisieFormat.Ccs;

import fenetre_menu.wConteneur.AbstractJDialogDb;
import fenetre_menu.wConteneur.AbstractJPanelDlg;
import fenetre_menu.wConteneur.JDialogDlg;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class Infos extends AbstractJPanelDlg implements ActionListener {
	private static final long serialVersionUID = 1L;
	JPanel jpText=null;
	JTextDb lsiteweb,lcontact,lforum,linfos,lversion,lcode,lkey;
	JTextDb siteweb,contact,forum,infos,version,code,key;

	JTextLabel lice=null;

	Sql sql=null;
	JTextButton jbCopy,jbValid;
	JTextDb jlSouth=null;

	public Infos(JDialogDlg jd,Sql sql){
		super(jd);
		this.jlSouth=jd.jlSouth;
		this.sql=sql;
		adapte();
	}
	private void adapte() {
		lice=new JTextLabel();{
			StringBuffer txt= new StringBuffer();
			try {
				String path=getClass().getPackage().getName().replace('.','/');
				InputStream is = getClass().getClassLoader().getResourceAsStream(path+"/"+Gp.LICENCE);
				if (is!=null){
					BufferedReader buffer	=new BufferedReader(new InputStreamReader(is));
					String ligne;
					while ((ligne = buffer.readLine()) != null){
						ligne=ligne.replace(Gp.ABCSOFT,sql.getAppliParam().TITRE_APPLI );
						txt.append(ligne);
					}
					is.close();
					buffer.close();
				}
			} catch (FileNotFoundException arg0) {
				Gp.af(arg0.getMessage());
				arg0.printStackTrace();
			} catch (IOException arg0) {
				Gp.af(arg0.getMessage());
				arg0.printStackTrace();
			}
			lice.setBorder(BorderFactory.createLoweredBevelBorder());
			lice.setSizeChar(120,24);
			lice.append(txt.toString());
			lice.setBackground(Color.WHITE);
			lice.setForeground(Color.GRAY);
			lice.setOpaque(true);
		}
		lsiteweb=new JTextDb("Site Web ");{
			Ccs.TexttoLibe(lsiteweb);
		}
		lcontact=new JTextDb("Nous crire ");{
			Ccs.TexttoLibe(lcontact);
		}
		lforum=new JTextDb("Participer au forum ");{
			Ccs.TexttoLibe(lforum);
		}
		linfos=new JTextDb("Logiciel ");{
			Ccs.TexttoLibe(linfos);
		}
		lversion=new JTextDb("Version ");{
			Ccs.TexttoLibe(lversion);
		}
		lcode=new JTextDb("Code ");{
			Ccs.TexttoLibe(lcode);
		}
		lkey=new JTextDb("Cl d'enregistrement");{
			Ccs.TexttoLibe(lkey);
		}
		/////////////////////
		siteweb=new JTextDb();{
			siteweb.setWebBrowse(sql.getAppliParam().SITEWEB,sql.getAppliParam().SITEWEB);
		}
		contact=new JTextDb();{
			contact.setWebMailto(sql.getAppliParam().CONTACT);
		}
		forum=new JTextDb();{
			forum.setWebBrowse(sql.getAppliParam().FORUM,sql.getAppliParam().FORUM);
		}
		infos=new JTextDb();{
			infos.setText(sql.getAppliParam().TITRE_APPLI);
			infos.adapteTextLibe();
		}
		version=new JTextDb();{
			version.setText(sql.getAppliParam().VERSION);
			version.adapteTextLibe();
		}

		code=new JTextDb();{
			if (!sql.isTcetorp()){
				code.setText(sql.geth());
				code.selectAll();
				code.copy();
			} else {
				code.setText("####-####-####-####-####");
				code.adapteTextLibe();
			}
		}
		key=new JTextDb();{
			key.setText("");
			key.setPreferredSize(code.getPreferredSize());
			if (!sql.isTcetorp() && sql.getAppliParam().VERSIONEVAL){
				key.adapteTextLibe();
			}
		}
		jbCopy=new JTextButton("Copier le code",'C');{
			if (!sql.isTcetorp()){
				jbCopy.addActionListener(this);
				if (!sql.isTcetorp() && !sql.getAppliParam().VERSIONEVAL){
					jbCopy.setEnabled(true);
				} else {
					jbCopy.setEnabled(false);
				}
			} else {
				jbCopy.setVisible(false);
			}
		}

		jbValid=new JTextButton("Enregistrer votre licence",'E');{
			if (!sql.isTcetorp()){
				jbValid.addActionListener(this);
				if (!sql.isTcetorp() && !sql.getAppliParam().VERSIONEVAL){
					jbValid.setEnabled(true);
				} else {
					jbValid.setEnabled(false);
				}
			} else {
				key.setText(" Vrifie. OK");
				key.setEnabled(false);
				jbValid.setText("Licence enregistre");
			}
		}			

		jpText=new JPanel(Gp.adaptePanelE());{
			Gp.gbc.anchor=GridBagConstraints.EAST;
			if (sql.getAppliParam().SITEWEB!=null){
				jpText.add(lsiteweb,Gp.gety());
				Gp.gbc.anchor=GridBagConstraints.WEST;
				jpText.add(siteweb,Gp.getx());
			}
			Gp.setx(0);
			if (sql.getAppliParam().CONTACT!=null){
				Gp.gbc.anchor=GridBagConstraints.EAST;
				jpText.add(lcontact,Gp.gety());
				Gp.gbc.anchor=GridBagConstraints.WEST;
				jpText.add(contact,Gp.getx());
			}
			Gp.setx(0);
			if (sql.getAppliParam().FORUM!=null){
				Gp.gbc.anchor=GridBagConstraints.EAST;
				jpText.add(lforum,Gp.gety());
				Gp.gbc.anchor=GridBagConstraints.WEST;
				jpText.add(forum,Gp.getx());
			}
			Gp.setx(0);
			Gp.gbc.anchor=GridBagConstraints.EAST;
			jpText.add(linfos,Gp.gety());
			Gp.gbc.anchor=GridBagConstraints.WEST;
			jpText.add(infos,Gp.getx());
			Gp.setx(0);
			Gp.gbc.anchor=GridBagConstraints.EAST;
			jpText.add(lversion,Gp.gety());
			Gp.gbc.anchor=GridBagConstraints.WEST;
			jpText.add(version,Gp.getx());
			Gp.setx(0);
			Gp.gbc.anchor=GridBagConstraints.EAST;
			jpText.add(lcode,Gp.gety());
			Gp.gbc.anchor=GridBagConstraints.WEST;
			jpText.add(code,Gp.getx());
			jpText.add(jbCopy,Gp.getx());
			Gp.setx(0);
			Gp.gbc.anchor=GridBagConstraints.EAST;
			jpText.add(lkey,Gp.gety());
			Gp.gbc.anchor=GridBagConstraints.WEST;
			jpText.add(key,Gp.getx());

			Gp.setx(0);
			Gp.setWidth(3);
			Gp.setFill(1);
			jpText.add(jbValid,Gp.gety());
			Gp.setWidth(1);

		}

		this.add(jpText,BorderLayout.CENTER);
		this.setBorder(null);
		//this.add(jbValid,BorderLayout.SOUTH);
		//this.add(lice,BorderLayout.SOUTH);
		JPanel jplice=new JPanel(new FlowLayout(0,10,10));
		jplice.add(lice);
		jd.getContentPane().add(jplice,BorderLayout.SOUTH);
	}
	public void actionPerformed(ActionEvent arg0) {
		if (arg0.getSource()==jbValid){
			String comp=code.getText();
			if (comp!=null){
				if (comp.length()>=3){
					String code=comp.substring(0,3);
					if (code.equals(Gp.PROTECTKEY) && sql.isDevFile()){
						code=comp.substring(3);
						String newcomp=sql.getdecah(code);
						key.setText(newcomp);
						key.selectAll();
						key.requestFocusInWindow();
					} else {
						String newcomp=sql.getdecah(comp);
						if (newcomp.equals(key.getText())){
							sql.setTcetorp();
							jbValid.setEnabled(false);
							JOptionPane.showMessageDialog(sql.getMf(), "Ce code est valide, Merci de votre achat","ABC vous remercie !!!", JOptionPane.INFORMATION_MESSAGE);
							this.putClientProperty(AbstractJDialogDb.action,AbstractJDialogDb.closedialog);
						} else {
							JOptionPane.showMessageDialog(sql.getMf(), "Ce code n'est pas valide, Procurez-vous un code correct","Attention !!!", JOptionPane.INFORMATION_MESSAGE);
						}
					}
				}
			}
		} else if (arg0.getSource()==jbCopy){
			this.code.copy();
			this.jbCopy.setEnabled(false);
			jlSouth.setText(code.getText()+" Taper Ctrl+V dans votre Mail de demande de n de licence");
			sql.setTextStatus(jlSouth.getText(),"","");
		}

	}
}
