package module_standard.wParamPreference;

import persistance.wSql.AbstractFieldsDef;
import persistance.wSql.Sql;
import table_standard.wS_prefs.S_prefsLISTE;
import table_standard.wS_prefs.S_prefsFICHE;
import template_applicatif.wFiche.AbstractDbFiche;
import template_applicatif.wListe.AbstractDbListe;
import template_applicatif.wListe.ListeRecno;
import template_applicatif.wVue.AbstractVue;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class S_prefsParamVUE extends AbstractVue {
	private static final long serialVersionUID = 1L;
	public S_prefsParamVUE(Sql sql, String t_seek, Vue vue) {
		super(sql.getSqlAbc(), t_seek, vue);
	}
	public AbstractDbListe getDbListe() {
		AbstractDbListe ret=null;
		adapteJoin(sqlListe);
		sqlListe.clauseFilter="c_code='"+sqlListe.getUser()+"'";
		ret=new ListeRecno(sqlListe);
		return ret;
	}
	public AbstractDbFiche getDbFiche(Vue vue) {
		AbstractDbFiche ret=null;
		sqlFiche.t_AccesMode=Sql.t_AccesModeRecno;
		adapteJoin(sqlFiche);
		sqlFiche.clauseFilter="c_code='"+sqlFiche.getUser()+"'";
		sqlFiche.dBTopByIndex();
		ret=new S_prefsParamSAISIE(sqlFiche);
		return ret;
	}
	
	public AbstractFieldsDef getFieldsDefEcran(Vue vue) {
		return new S_prefsFICHE(sqlFiche,vue);
	}
	public AbstractFieldsDef getFieldsDefListe(Vue vue) {
		AbstractFieldsDef ret=null;
		ret=new S_prefsLISTE(sqlListe,vue);
		return ret;
	}
	
	public AbstractFieldsDef getFieldsDefPrint(Vue vue) {
		AbstractFieldsDef ret=null;
		return ret;
	}
	public AbstractFieldsDef getFieldsDefRupture(Vue vue) {
		AbstractFieldsDef ret=null;
		return ret;
	}
	public void adapteJoin(Sql sql) {}
}
