package module_standard.wPointageHeure;

import persistance.wSql.AbstractFieldsDef;
import persistance.wSql.Edit;
import persistance.wSql.Sql;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.Fma;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class S_pointageHeureFICHE extends AbstractFieldsDef {
	public S_pointageHeureFICHE(Sql sql,Vue vue) {
		super(sql,vue);
	}
	public Object adapteField(Vue vue){
		t_table="pointage_heure";
		t_nbLigne=1;
		t_filtre=null;
		v_filtre=null;
		t_index=new String[]{"c_code","c_jour","c_timd"};
		if (vue==Vue.F3POINTAGE){
			t_index=new String[]{"c_timd"};
			t_filtre=new String[]{"c_code","c_jour"};
			v_filtre=new String[]{"",""};
		}

		switch (vue){
		default:{
			addSqlField("c_code" , 30,Fma.FIELD,"Code identifiant","",Edit.F2,"");
			addSqlField("c_jour" , 10,Fma.FIELD,"Jour","",Edit.TEXT,"");
			addSqlField("c_timd" , 15,Fma.TIMEDELAY,"Heures","",Edit.TIMEDELAY,"00:0000:0000:00");
			break;}
		}
		return this;
	}
}
