package module_standard.wPointageHeure;

import persistance.wSql.AbstractFieldsDef;
import persistance.wSql.Sql;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.Fma;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class S_pointageHeureLISTE extends AbstractFieldsDef {
	public S_pointageHeureLISTE(Sql sql,Vue vue) {
		super(sql,vue);
	}

	public Object adapteField(Vue vue){
		t_table="pointage_heure";
		t_nbLigne=15;
		t_filtre=null;
		v_filtre=null;
		t_index=new String[]{"c_code","c_jour","c_timd"};
		if (vue==Vue.F3POINTAGE){
			t_nbLigne=7;
			t_index=new String[]{"c_timd"};
			t_filtre=new String[]{"c_code","c_jour"};
			v_filtre=new String[]{"",""};
		}
		switch (vue){
		case F3:
		default:{
			addSqlField("c_timd" , 17,Fma.TIMEDELAY,"H.Db. H.Fin  H.total");
			break;}
		}
		return this;
	}
}
