package module_standard.wPointageHeure;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.SwingConstants;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import template_applicatif.wFiche.AbstractDbFiche;
import template_applicatif.wFiche.FicheIEditableColumns;
import template_applicatif.wListe.ListeIEditableColumn;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JPopup;
import composant_saisie.wComposant.JTextButton;
import composant_saisie.wComposant.JTextDb;
import composant_saisie.wComposant.JTextLabel;
import composant_saisie.wComposant.JTimeDelay;
import composant_saisie.wPtime.Day;
import composant_saisie.wPtime.JPTime;
import composant_saisie.wPtime.Time;
import composant_saisie.wSaisieFormat.Ccs;
import composant_saisie.wSaisieFormat.Fmt;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class S_pointageHeureSAISIE extends AbstractDbFiche implements ActionListener {
	private static final long serialVersionUID = 1L;
	JTextDb lcode,ljour,ltimd;
	JTextDb		code=null;
	JTextDb		jour=null;
	public JTimeDelay 	timd=null;
	/////////////////////////////
	int value;
	int nbPointage=0;
	JTextLabel jlTitreDetail=null;
	JTextButton jbF4=null;
	JTextButton jbEsc=null;
	JPTime jptime=null;
	JTextDb		toth=null;
	public void setArgValue(Object argValue) {
		vue.dbFiche.sql.v_index=vue.dbListe.sql.v_index="";
		vue.dbFiche.sql.v_filtre[0]=vue.dbListe.sql.v_filtre[0]=argValue.toString().substring(0,30);
		vue.dbFiche.sql.v_filtre[1]=vue.dbListe.sql.v_filtre[1]=argValue.toString().substring(30,40);
		this.load(Sql.t_LoadAllField);
		this.loadTwin(Sql.t_LoadAllField);
		vue.dbListe.loadTwin(Sql.t_LoadAllField);
		this.initFocus();
		this.sumRecord();
	}
	public Object getReturnValue() {
		return Day.parseMinTime(value);
	}
	public void dispose(){
		jlTitreDetail=null;
		jbF4=null;
		jbEsc=null;
		if (toth!=null){
			toth.dispose();
			toth=null;
		}
		if (jptime!=null){
			jptime.dispose();
			jptime=null;
		}
		super.dispose();
	}
	public S_pointageHeureSAISIE(Sql sql) {
		super(sql);
		initStart();
	}
	public void initCreateLE() {
		lcode=new JTextDb();
		ljour=new JTextDb();
		ltimd=new JTextDb();
		code	=new JTextDb();{
			code.adapteTextLibe();
		}
		jour	=new JTextDb();{
			jour.adapteTextLibe();
		}
		timd	=new JTimeDelay(sql,"","");
	}
	public void initMapLE() {
		ccs.mapL(this,lcode,0);
		ccs.mapL(this,ljour,1);
		ccs.mapL(this,ltimd,2);
		ccs.mapE(this,code,0);
		ccs.mapE(this,jour,"",10,"c_jour");// ne pas mettre de format date
		ccs.adapteE(this,timd,2,Fmt.TIMEDELAY);
	}
	public void initGuiLE(){
		ccs.alignL(SwingConstants.RIGHT);
		jpDbL=new JPanel(Gp.adaptePanelL());
		jpDbL.add(ltimd,Gp.gety());
		jpDbE=new JPanel(Gp.adaptePanelE());
		//		jpTextDb.add(code,Gp.gety());
		//		jpTextDb.add(jour,Gp.getGridxNext());
		jpDbE.add(timd,Gp.gety());

		toth=new JTextDb();{
			toth.adapteTextLibe();
			toth.setHorizontalAlignment(SwingConstants.CENTER);
			toth.setFont(Gp.FONTTEXT14);
		}
		jour.setFont(Gp.FONTTEXT12);
		jour.setHorizontalAlignment(SwingConstants.CENTER);
	}
	public void initFocus() {
		setDefFocus(timd);
	}
	public void setBaseListener() {
		// La cl d'index
		// La fiche
		ccs.addEditListener(timd,Ccs.TIMEDELAY);
	}
	public void setEditableColumns(FicheIEditableColumns fe, ListeIEditableColumn fl) {}
	public void fireEditableColumnUpdate(String nameField, Object value) {}
	public void validateAdapteFicheCrud(){
		setModeAutoAppend(true);
		Gp.adaptePanelButtonVertical();
		Gp.sety(20);
		jlTitreDetail=new JTextLabel();{
			jlTitreDetail.adapteTitre();
		}
		//jlTitreDetail.setText(jour.getText());
		vue.dbFiche.jpCrud.jpBoutonCenter.add(jlTitreDetail,Gp.gety());
		//vue.dbFiche.jpCrud.jpBoutonCenter.add(jour,Gp.gety());

		vue.dbListe.jpEntete.add(toth);
		JPanel jpButton=new JPanel(new FlowLayout(0,0,0));{
			jbEsc=new JTextButton("Esc ",27);{
				jbEsc.addActionListener(this);
				jbEsc.setImageIconPressed(sql.getImage(sql.getAppliParam().JBCANCEL,true),true);
			}
			jbF4=new JTextButton("F4 Enregistrer Total Heures",KeyEvent.VK_F4);{
				jbF4.addActionListener(this);
				jbF4.setImageIconPressed(sql.getImage(sql.getAppliParam().JBOPTIONDEF,true),true);
			}
			jpButton.add(jbF4);
			jpButton.add(jbEsc);
			jpButton.setBorder(Gp.getBorder(BorderFactory.createRaisedBevelBorder(),Gp.LABEL_FG_BLACK));
			vue.dbListe.add(jpButton,BorderLayout.SOUTH);
		}
		jptime=new JPTime();{
			jptime.setOrientation(SwingConstants.HORIZONTAL);
			jptime.setPlage("00:00","00:00");
			jptime.setClickable(false);
		}
		sumRecord();
		this.initFocus();

	}
	public void loadEAdapteGuiLE(){
		jlTitreDetail.setText(jour.getText());
	}
	public void fireBaseListener(JComponent jc){
		// La cl d'index
		// La fiche
		if (jc==timd){
			ccs.fireT(jc,Ccs.TIMEDELAY);
		}
	}
	protected void fireContextualRange(JComponent jc) {}
	protected void updateDependant(JComponent jc) {}
	protected void updateContextualRangeAndEnable(JComponent jc) {}
	public void setDependants() {}
	public JPanel getJTimeHours(){
		jptime.setBorder(null);
		return jptime;
	}
	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==jbF4){
			userF4();
		} else if (e.getSource()==jbEsc){
			userESCAPE();
		} 
	}
	private void userF4() {
		if (!sql.isModeMovable()){
			userRecord();
		}
		if (isModeAutoAppend()){
			userCancel();
		}
		vue.putClientProperty(JPopup.T_RETURN, getReturnValue());
	}
	private void userESCAPE() {
		if (isModeAutoAppend()){
			userCancel();
		}
		vue.putClientProperty(JPopup.ESCAPE, "ok");
	}
	public void setBufferDataBeforeSetEditsWithDatas(){
		sql.setDataString(code.getName(), sql.v_filtre[0]);
		sql.setDataString(jour.getName(), sql.v_filtre[1]);
	}
	public void dbDeleteAfterOtherTable() {
		sumRecord();	
	}
	public boolean dbUpdateAfterOtherTable(){
		sumRecord();	
		return true;
	}
	public void sumRecord(){
		nbPointage=0;
		value=0;
		String plag="";
		jptime.clearPlage();
		ResultSet rs=sql.dBExecuteQueryOpen("SELECT c_timd FROM "+sql.t_table+" WHERE c_code='"+sql.v_filtre[0]+"' AND c_jour ='"+sql.v_filtre[1]+"';");
		try {
			while (rs.next()) {
				plag=rs.getString("c_timd");
				jptime.addPlage(new Time(plag.substring(0, 5),plag.substring(5, 10)));
				value=value+Day.parseTimeMin(plag.substring(10, 15));
				nbPointage++;
			}
		} catch (SQLException e) { e.printStackTrace(); }
		sql.dBExecuteQuerryClose(rs);
		this.toth.setText("Total H = "+Day.parseMinTime(value));
	}
	public void userRecord(){
		if (!userPlageOk()){
			String ancPlag=timd.getTimeDelay();
			timd.setTimeDelay("");
			ccs.fireT(timd,Ccs.TIMEDELAY);
			timd.setTimeDelay(ancPlag);
		} else {
			timd.setOk();
		}
		if (timd.getTimeDelayMinutes()==0){
			super.userCancel();
			userF4();
		} else {
			super.userRecord();
		}
	}
	private boolean userPlageOk() {
		String recno="";
		if (sql.isModeAppendUpdated()||sql.isModeAppend()){
			recno="APPEND";
		} else {
			recno=sql.t_Recno;
		}
		boolean ret=true;
		int debplag=Day.parseTimeMin(this.timd.getTimeDelay().substring(0, 5));
		int finplag=Day.parseTimeMin(this.timd.getTimeDelay().substring(5,10));
		String plag="";
		String rowid="";
		int deb=0;
		int fin=0;
		ResultSet rs=sql.dBExecuteQueryOpen("SELECT rowid AS RECNO , c_timd FROM "+sql.t_table+" WHERE c_code='"+sql.v_filtre[0]+"' AND c_jour ='"+sql.v_filtre[1]+"';");
		try {
			while (rs.next() && ret) {
				plag=rs.getString("c_timd");
				rowid=rs.getString("RECNO");
				deb=Day.parseTimeMin(plag.substring(0,5));
				fin=Day.parseTimeMin(plag.substring(5,10));
				if (!recno.equals(rowid)){
					if (debplag>=deb && debplag<=fin){
						ret=false;
					}
					if (finplag>=deb && finplag<=fin){
						ret=false;
					}
					if (debplag<=deb && finplag>=fin){
						ret=false;
					}
				}
			}
		} catch (SQLException e) { e.printStackTrace(); }
		sql.dBExecuteQuerryClose(rs);
		return ret;
	}
	public int getNbPointage(){
		return nbPointage;
	}
	public int getTimeDelayMinutes(){
		return value;
	}
}
