package persistance.wGlobalParam;

import java.awt.AWTException;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GraphicsEnvironment;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.Insets;
import java.awt.KeyEventPostProcessor;
import java.awt.KeyboardFocusManager;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Robot;
import java.awt.Toolkit;
import java.awt.Window;
import java.awt.color.ColorSpace;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.awt.image.BufferedImage;
import java.awt.image.ColorConvertOp;
import java.awt.image.FilteredImageSource;
import java.awt.image.ImageFilter;
import java.awt.image.ImageProducer;
import java.awt.image.RGBImageFilter;
import java.awt.image.RescaleOp;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintStream;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.net.URL;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;
import java.util.prefs.Preferences;

import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.border.Border;

import module_standard.wDebug.Console;
import module_standard.wSerial.CodeBarre;
import module_standard.wSerial.ImpDot;
import module_standard.wSerial.Ms1204;
import module_standard.wSerial.Serial;
import persistance.wSql.Sql;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JButtonArrow;
import composant_saisie.wComposant.JPanelImage;
import composant_saisie.wComposant.JStatusBar;
import composant_saisie.wComposant.JTextDb;
import composant_saisie.wComposant.RoundBorder;
import composant_saisie.wPtime.Day;
import composant_saisie.wSaisieFormat.Ccs;

import fenetre_menu.wConteneur.MainFrame;
import fenetre_menu.wMenu.DbVue;
import fenetre_menu.wMenu.MainMenuBar;
/**
 Entretien les variables globales dynamiques de l'appli<br>
 Cet objet est le mapeur  la base de donnes<br>
 Il propose aussi des routines static usuelles transverses<br>
 <br>
 On y accde par le biais de {@link Sql} 
<br>
__________________________________________________________________________________
<br>{@link A_doc}
 <br>{@link Licence}.*/
public class Gp implements KeyEventPostProcessor{
	public static AbstractDefaultParam APPLIPARAM=null; // Pour debug
	public static String NAME		= "user.name";
	public static String HOME		= "user.home";
	public static String USERDIR    = "user.dir";
	public static String AIMAGES    = "/main/aImages/";
	public static String ABCSOFT    = "[ABCSOFT]";
	public static String LICENCE    = "LICENCE.htm";
	public static final Color	LABEL_BORDER	= Color.GRAY;
	public static final Color	LABEL_FG_BLACK	= Color.BLACK;
	public static final Color 	FILIGRANE_LGRAY = Color.LIGHT_GRAY;
	public static final Color 	UPDATE_BG_JAUNE	= new Color(255,255,200);
	public static final Color 	INVALIDE_FG_RED = Color.RED;

	// taille de caractere pour l'impression et l'affichage
	public static final int HEIGHTCHAR= 16;
	public static final int WIDTHCHAR =  6;
	public static final int MARGEMINI	= 34;
	public static final int INSETCHAR =2;
	public static final int HEIGHTTEXT=INSETCHAR+HEIGHTCHAR+INSETCHAR;
	public static final String LINEFEED = "\n\r";


	// Appli
	public boolean ISDEVFILE=false;
	public AbstractDefaultParam appliParam=null;
	public boolean sqlTrace		= false;
	public String sqlTraceFiche	= "";
	public boolean uiTrace		= false;
	public boolean dblisteTrace	= false;
	public boolean sllisteTrace	= false;
	
	// Keyboard
	public boolean ISCTRL_MASK=false;
	public boolean ISSHIFT_MASK=false;

	// Fenetre principale
	public JFrame 	f_mf		= null;
	public int 		f_mfWidth	= 1024;
	public int 		f_mfHeight	= 768;
	//	public int 		f_mfWidth	= 800;
	//	public int 		f_mfHeight	= 600;

	// Panel Principale de la Main Frame
	public JPanelImage 	f_mjpc	= null;
	public static final int      JPGCENTER	= 0;
	public static final int      JPGTEXTURE	= 1;
	public static final int      JPGFILL	= 2;
	public static final int 	JPGGRADIENT = 3;
	public static final int 	JPGNULL  	= 99;
	// Barre de status
	public JStatusBar f_mjStatusBar=null;
	//	public JLabel 	f_mjlStatusWest	 	= null;	
	//	public JLabel 	f_mjlStatusCenter 	= null;	
	//	public JLabel 	f_mjlStatusEast 	= null;

	// Menu Barre Principale
	public JMenuBar m_jmenubar		= null;
	public String 	m_menuMain		= "00000000";
	public String m_user = "Utilisateur";

	public int 		m_flagMenuMain	= 0;
	public static final String BEFOREMAINCHOICEMENU = "Identifier vous et acceder au logiciel";
	public static final String MAINCHOICEMENU = "Choisissez une option dans le menu, Merci";

	// Gestion d'une option de menu
	public JMenu 	m_jmemu			= null;
	public String 	m_menu			= null;
	public String 	m_option		= null;
	public String 	m_c_opt2		= null;
	public String 	m_c_opt3		= null;
	public String   m_optionText	= null;
	public char 	m_a;

	// Gestion des tables
	public Gp		gpAbc		= null;
	public Gp		gp			= null;
	public Sql      sqlAbc		= null;
	public Sql      sql			= null;
	ArrayList< Sql > sqls=null;

	// Valeur gnral de l'appli
	// PLacement des panels dans la Vue
	public static final int G_TITRE 		= 10;
	public static final int G_LISTEENTETE 	= 20;
	public static final int G_LISTE 		= 30;
	public static final int G_LISTEPIED 	= 40;
	public static final int G_FICHEENTETE 	= 50;
	public static final int G_FICHE 		= 60;
	public static final int G_FICHEPIED 	= 70;
	public static final int G_DETAILENTETE 	= 80;
	public static final int G_DETAIL 		= 90;
	public static final int G_DETAILPIED 	= 100;

	public static final String 	PROTECTFIELD 		= "code";
	public static final int 	PROTECTMAXLINE 		= 10;
	public static final String 	PROTECTDEMO 		= "V E R S I O N  LIMITEE";
	public static final int 	PROTECTDECALAGE		= 17;
	public static final int 	PROTECTDECALAGEKEY	= 23;
	public static final String 	PROTECTKEY 			= "KEY";
	public static final String  DEVFILE 			= "dev.rlw";
	public static final String  DEVNUMM 			= "9000DEVE";
	public static final String  DEFAULTUSER			= "Utilisateur";

	// Gestion code barre
	public CodeBarre codeBarres;
	// Pool des imprimantes Thermique/port srie
	public ImpDot impdots=null;

	// Console et message d'erreur
	private static PrintStream stderr=null;
	private static PrintStream stdout=null;
	public static String ConsoleErr="Log Error";
	public static String ConsoleOut="Console debug";

	public static GridBagConstraints gbc=new GridBagConstraints();
	//------------ Prfrence -----------
	// ToolTip d'aide
	public static boolean TOOLTIP			= true;
	public static double TOOLTIPINITIALDELAY	= 1.0;
	public static double TOOLTIPDELAY			= 12.0;
	public static int TITLESIZE 			= 22;
	public static boolean TITLE				= true;
	public static int TOTAUXSIZE 			= 24;

	public static final Font FONTNORMAL			= UIManager.getFont("Label.font").deriveFont(Font.PLAIN,UIManager.getFont("Label.font").getSize());
	public static final Font FONTBOLD			= FONTNORMAL.deriveFont(Font.BOLD);

	public static int  FONTTEXTTYPE 		= Font.PLAIN;  
	public static Font FONTTEXT 			= FONTNORMAL;  
	public static Font FONTTEXT9 			= FONTNORMAL;  
	public static Font FONTTEXT10 			= FONTNORMAL;  
	public static Font FONTTEXT11 			= FONTNORMAL;  
	public static Font FONTTEXT12 			= FONTNORMAL;  
	public static Font FONTTEXT13 			= FONTNORMAL;  
	public static Font FONTTEXT14 			= FONTNORMAL;  
	public static Font FONTTEXT15 			= FONTNORMAL;  
	public static Font FONTTEXT16 			= FONTNORMAL;  
	public static Font FONTTEXT18 			= FONTNORMAL;  
	public static Font FONTMENU				= FONTNORMAL; 

	public static boolean USEFRAMETEXTURE	=true;
	public static boolean USEBUTTONICONE	=true;
	// Couleur en rapport au thme de l'utilisateur
	public static Color 	BLEU_FG 		= Color.BLUE;
	public static Color 	ORANGE_FG 		= new Color(255,80,0);
	public static Color 	VERTFONCE_FG 	= new Color(0,80,0);
	public static Color 	MOVE_BG_LVERT 	= new Color(240,255,240);
	public static Color 	MOVE_BG_LRED 	= new Color(255,247,247);
	public static Color 	PANELVUE_BG = Color.LIGHT_GRAY;
	//------------ Prfrence -----------
	public static boolean   USEROUNDEDBORDER = true;
	public static boolean   USEPANELVUE = true;
	public static boolean   USEPANELGRADIENT = true;

	public DbVue lastDbVue=null;
	public static final int SQLITE=0;
	public static final int MYSQL=1;
	public static final int MAXFIELDS = 100;
	public int sqltype=SQLITE;
	public String base = "";
	public String url = "";

	public Gp(int sqltype,String url,String base){
		this.base=base;
		this.url=url;
		this.sqltype=sqltype;
		sqls=new ArrayList< Sql >();
	}
	// ICON IMAGE BUFFER STRING 
	public void setIcon(Window jw){
		if (appliParam.APPLIICON!=null)
			jw.setIconImage(getImage(appliParam.APPLIICON,true).getScaledInstance(Gp.HEIGHTCHAR*2,Gp.HEIGHTCHAR*2,Image.SCALE_AREA_AVERAGING));
	}
	public Image getImage(String name, boolean transp){
		Image ret=null;
		Image transparent=null;
		if (name!=null){
			URL url = this.getClass().getResource(AIMAGES +name);
			if (url==null){
				Toolkit toolkit = java.awt.Toolkit.getDefaultToolkit();
				ret=toolkit.getImage(name);
			}
			if (url!=null){
				ret = Toolkit.getDefaultToolkit().getImage(url);
				url=null;
			}
			if (ret!=null){
				if (transp)
					transparent=makeColorTransparent(ret,Color.WHITE);
				else
					transparent=ret;
				ret=null;
			}
		}
		return transparent;
	}
	public Image makeColorTransparent(Image im, final Color color) {
		ImageFilter filter = new RGBImageFilter() {
			// alpha red green blue
			int markerRGB = color.getRGB() | 0xFF000000;
			public final int filterRGB(int x, int y, int rgb) {
				if ( ( rgb | 0xFF000000 ) == markerRGB ) {
					// Mark the alpha bits as zero - transparent
					return 0x00FFFFFF & rgb;
				}
				else {
					// nothing to do
					return rgb;
				}
			}
		}; 
		ImageProducer ip = new FilteredImageSource(im.getSource(), filter);
		im=null;
		filter=null;
		return Toolkit.getDefaultToolkit().createImage(ip);
	}
	public Icon ImageIcon(Image img,int coef){
		Icon icon=null;
		if (img!=null){
			Image tmpIm=img.getScaledInstance(Gp.HEIGHTCHAR*coef,Gp.HEIGHTCHAR*coef,Image.SCALE_AREA_AVERAGING);
			if (tmpIm!=null){
				icon=new ImageIcon(tmpIm);
			}
			img=null;
			tmpIm=null;
		}
		return icon;
	}
	public BufferedImage toBufferedImage(Image imag) {
		BufferedImage ret=null;
		Image image = new ImageIcon(imag).getImage();
		ret = new BufferedImage( image.getWidth(null), image.getHeight(null), BufferedImage.TYPE_INT_RGB); 
		Graphics g = ret.createGraphics(); 
		g.setColor(Color.white); 
		g.drawImage(image, 0, 0, null); 
		g.dispose();
		image=null;
		imag=null;
		return ret;
	}
	public BufferedImage grayedImage(BufferedImage colorImage){
		/*
		 Les oprations rescale modifient les valeurs des composantes RGB de chaque pixel : c' = c*m+d Cette opration permet d'claircir ou d'assombrir une image, en gardant ou non le contraste.
		 * 0< m <1 : l'image est assombrie.
		 * m > 1 : l'image est claicie.
		 * 0<= d <256 : d>0 l'image est claircie et le contraste est diminu.
			RescaleOp scOp = new RescaleOp(m, d, null);
			scOp.filter(bimg, bimg);
		 */
		BufferedImage ret=null;
		ColorConvertOp op = new ColorConvertOp(ColorSpace.getInstance(ColorSpace.CS_GRAY),null);
		ret = op.filter(colorImage,null);
		op=null;
		colorImage=null;
		float m=1;
		int d=30;
		RescaleOp scOp = new RescaleOp(m, d, null);
		scOp.filter(ret,ret);
		scOp=null;
		return ret;
	}
	public static void setBackgroundGradient(Graphics g, Component component, int value,boolean sens){
		if (component.isOpaque()){
			Graphics2D g2d=(Graphics2D) g;
			int red=component.getBackground().getRed()-value;
			if (red<0){
				red=0;
			}
			int green=component.getBackground().getGreen()-value;
			if (green<0){
				green=0;
			}
			int blue=component.getBackground().getBlue()-value;
			if (blue<0){
				blue=0;
			}
			Color color=new Color(red,green,blue);
			if (sens){
				g2d.setPaint(new GradientPaint(0,0,color,component.getWidth(),component.getHeight(),component.getBackground()));
			} else {
				g2d.setPaint(new GradientPaint(0,0,component.getBackground(),component.getWidth(),component.getHeight(),color));
			}
			g2d.fillRect(0,0,component.getWidth()-1,component.getHeight()-1);
		}
	}
	public static void paintTriangle(Graphics g, int x, int y, int size, int direction,int type) {
		int mid, i, j;
		j = 0;
		size = Math.max(size, 2);
		mid = (size / 2) - 1;

		g.translate(x, y);

		switch(direction)       {
			case SwingConstants.NORTH:
				if (type==JButtonArrow.PAGE){
					g.translate(0,3);
				}
				if (type==JButtonArrow.END){
					g.translate(0,2);
				}
				if (type==JButtonArrow.NEXT||type==JButtonArrow.PAGE||type==JButtonArrow.END){
					for(i = 0; i < size; i++)      {
						g.drawLine(mid-i, i, mid+i, i);
					}
				}
				if (type==JButtonArrow.PAGE){
					g.translate(0,-4);
					for(i = 0; i < size; i++)      {
						g.drawLine(mid-i, i, mid+i, i);
					}
					g.translate(0,1);
				}
				if (type==JButtonArrow.END){
					g.translate(0,-3);
					g.translate(0,1);
					i = size-1;
					g.drawLine(mid-i, 0, mid+i, 0);
					g.drawLine(mid-i, 0+1, mid+i, 0+1);
					g.translate(0,-1);
				}
				break;
			case SwingConstants.SOUTH:
				if (type==JButtonArrow.PAGE){
					g.translate(0,-1);
				}	
				if (type==JButtonArrow.NEXT||type==JButtonArrow.PAGE||type==JButtonArrow.END){
					j = 0;
					for(i = size-1; i >= 0; i--)   {
						g.drawLine(mid-i, j, mid+i, j);
						j++;
					}
				}
				if (type==JButtonArrow.PAGE){
					g.translate(0,1);
					g.translate(0,3);
					j = 0;
					for(i = size-1; i >= 0; i--)   {
						g.drawLine(mid-i, j, mid+i, j);
						j++;
					}
					g.translate(0,-3);
				}
				if (type==JButtonArrow.END){
					i = size-1;
					g.drawLine(mid-i, j, mid+i, j);
					g.drawLine(mid-i, j+1, mid+i, j+1);
				}
				break;
			case SwingConstants.WEST:
				for(i = 0; i < size; i++)      {
					g.drawLine(i, mid-i, i, mid+i);
				}
				break;
			case SwingConstants.EAST:
				j = 0;
				for(i = size-1; i >= 0; i--)   {
					g.drawLine(j, mid-i, j, mid+i);
					j++;
				}
				break;
		}
		g.translate(-x, -y);	
	}
	public void setColorFonce(){
		Color color=(Color) UIManager.get("Menu.selectionBackground");
		if (color==null){
			color=(Color) UIManager.get("Tree.selectionBackground");
		}
		if (color!=null){
			int vfGreen=color.getGreen();
			int vfRed=color.getRed();
			int vfBlue=color.getBlue();
			int mbGreen=240;
			int mbRed=240;
			int mbBlue=240;
			if (vfGreen>vfBlue){
				if (vfGreen>vfRed){ // Theme tire sur le vert
					vfGreen=80;
					vfRed=0;
					vfBlue=0;
					mbGreen=255;
				} else { // Theme tire sur le rouge
					vfRed=80;
					vfGreen=0;
					vfBlue=0;
					mbRed=255;
				}
			} else if (vfBlue>vfRed){ // Theme tire sur le bleu
				vfBlue=80;
				vfRed=0;
				vfGreen=0;
				mbBlue=255;
			} else { // Theme tire sur le rouge
				vfRed=80;
				vfBlue=0;
				vfGreen=0;
				mbRed=255;
			}
			Gp.VERTFONCE_FG = new Color(vfRed,vfGreen,vfBlue);
			Gp.MOVE_BG_LVERT = new Color(mbRed,mbGreen,mbBlue);
			Gp.MOVE_BG_LRED = new Color(255,240,240);

			color=(Color) UIManager.get("Panel.background");
			Gp.PANELVUE_BG = new Color(
					Math.min(color.getRed()+8,255),
					Math.min(color.getGreen()+8,255),
					Math.min(color.getBlue()+8,255)
			); 
		}
	}
	public void applyPreferences(String user) {
		saveLastUserToSystem(user);
		// take the menu bar off the jframe Mac OsX
		//System.setProperty("apple.laf.useScreenMenuBar", "true");
		// set the name of the application menu item Mac OsX
		//System.setProperty("com.apple.mrj.application.apple.menu.about.name", appliParam.SOC+" "+appliParam.APPLI+" "+appliParam.PRO);
		applyPreferencesUser(user);
		if (appliParam.SQL_DRIVER_ABC==SQLITE){
			if (!isFileExists(appliParam.getNameBaseABC())){
				if (ISDEVFILE){
					JOptionPane.showMessageDialog(null, "\n\n Le fichier :   '"+appliParam.getNameBaseABC()+"'   est introuvable,\n IL faut crer les bases .ABC & .DATA, Merci.","ATTENTION !!!", JOptionPane.INFORMATION_MESSAGE);
				} else {
					JOptionPane.showMessageDialog(null, "\n\n Le fichier :   '"+appliParam.getNameBaseABC()+"'   est introuvable, Copier tous les fichiers dans un dossier, Merci.","ATTENTION !!!", JOptionPane.INFORMATION_MESSAGE);
				}
				System.exit(0);
			}
		}
	}
	// PREFERENCE UTILISATEUR

	public static Gp mainDebut(String namePackage) {
		AbstractDefaultParam appliParam=Gp.getAppliParam(namePackage);
		Gp gpAbc = new Gp(appliParam.SQL_DRIVER_ABC,appliParam.URL_BASE_ABC,appliParam.getNameBaseABC());
		gpAbc.gpAbc = gpAbc;{
			gpAbc.appliParam=appliParam;
			gpAbc.m_user=gpAbc.restoreLastUserFromSystem();
		}
		Gp gp = new Gp(appliParam.SQL_DRIVER_DATA,appliParam.URL_BASE_DATA,appliParam.getNameBaseDATA());

		gp.gpAbc = gpAbc;
		gp.gp = gp;
		gpAbc.gp = gp;
		Sql sqlAbc = new Sql(gpAbc);

		gpAbc.gp.sqlAbc = sqlAbc;
		gpAbc.sqlAbc = sqlAbc;

		// Lance la Fenetre Principale
		new MainFrame(gpAbc);
		return gpAbc;
	}
	public static AbstractDefaultParam getAppliParam(String namePackage){
		AbstractDefaultParam ret=null;
		Class<?> classe;
		Constructor<?> cons;
		try {
			URL ress=ClassLoader.getSystemResource(namePackage.replace('.','/')+"/AppliParam.class");
			if (ress!=null){
				classe = Class.forName(namePackage+".AppliParam");
				cons = classe.getConstructor();
				classe=null;
				ret=(AbstractDefaultParam) cons.newInstance();
				cons=null;
			} else {
				System.out.println("ress est null Pb de path :"+namePackage.replace('/','.')+"/AppliParam.class"+" Introuvable");
			}
			ress=null;
		} catch (ClassNotFoundException e) {e.printStackTrace(); 
		} catch (SecurityException e) { e.printStackTrace();
		} catch (NoSuchMethodException e) { e.printStackTrace();
		} catch (IllegalArgumentException e) { e.printStackTrace();
		} catch (InstantiationException e) { e.printStackTrace();
		} catch (IllegalAccessException e) { e.printStackTrace();
		} catch (InvocationTargetException e) { e.printStackTrace(); }
		APPLIPARAM=ret;
		APPLIPARAM.setBaseParamFromFileRLW();
		APPLIPARAM.setExtraParam();
		return ret;
	}
	public void mapUser() {
		appliParam.setAppliParamFromDb(this);
		if (ISDEVFILE){	
			appliParam.setUserParamFromDb(this);
			f_mjStatusBar.setTextStatus(Gp.MAINCHOICEMENU,"","");
			loadMenu();
		} else {
			f_mjStatusBar.setTextStatus(Gp.BEFOREMAINCHOICEMENU,"","");
			m_option="ChangeUser";
			m_optionText="Identification Utilisateur";
			addDbVue();
		}
	}
	public void loadMenu() {
		f_mf.setJMenuBar(new MainMenuBar(gpAbc));
		f_mjStatusBar.setFontStatus(Gp.FONTMENU);
		f_mf.validate();
		setMainTitle();
	}
	public void setMainTitle(){
		String titre=appliParam.TITRE_APPLI;
		if (appliParam.TITRE_VERSIONABLE){
			titre=titre+" "+appliParam.VERSION;
		}
		if (ISDEVFILE){
			titre=titre+" ["+m_user+"] ["+appliParam.URL_BASE_ABC+""+appliParam.getNameBaseABC()+"] ["+appliParam.URL_BASE_DATA+""+appliParam.getNameBase()+"]";
		} else {
			if (appliParam.TITRE_USERABLE){
				titre=titre+" "+m_user;
			}
		} 
		f_mf.setTitle(titre);
	}
	private void applyPreferencesUser(String user){
		setLookAndFeel(getLookAndFeel(getPreferencesUserFromDb(user)));
		setPreferenceOptionPane();
		setPreferenceMenu();
		setColorFonce();
		setFrameTexture();
	}
	public String restoreLastUserFromSystem() {
		return Preferences.userRoot().get(appliParam.getNameBase()+appliParam.PREF,Gp.DEFAULTUSER);
	}
	public void saveLastUserToSystem(String user) {
		Preferences.userRoot().put(appliParam.getNameBase()+appliParam.PREF,user.trim());
	}
	private String getPreferencesUserFromDb(String user){
		String ret="";
		Sql sqlAbcPref=new Sql(sqlAbc);
		sqlAbcPref.setTable("s_prefs");
		if (sqlAbcPref.isTableExist()){
			String fields="c_tool,c_dela,c_time,c_titr,c_atit,c_tota,c_gras,c_mgra,c_fond,c_butt,c_vpro,c_them";
			try {
				ResultSet rs=sqlAbcPref.dBExecuteQueryOpen("SELECT "+fields+" FROM "+sqlAbcPref.t_table+" WHERE c_code='"+user+"' LIMIT 1;");
				if (rs.next() && rs!=null) {
				} else {
					rs=sqlAbcPref.dBExecuteQueryOpen("SELECT "+fields+" FROM "+sqlAbcPref.t_table+" WHERE c_code='"+Gp.DEFAULTUSER+"' LIMIT 1;");
					if (rs.next()&& rs!=null) {
					} else {
						rs=sqlAbcPref.dBExecuteQueryOpen("SELECT "+fields+" FROM "+sqlAbcPref.t_table+" LIMIT 1;");
						rs.next();
					}
				}
				int value=0;
				value=rs.getInt("c_tool");
				if (value==0){
					Gp.TOOLTIP=false;
				} else {
					Gp.TOOLTIP=true;
				}
				value=rs.getInt("c_dela");
				Gp.TOOLTIPINITIALDELAY=value;
				value=rs.getInt("c_time");
				Gp.TOOLTIPDELAY=value;
				value=rs.getInt("c_titr");
				if (value>4 && value<40)
					Gp.TITLESIZE = value;
				value=rs.getInt("c_atit");
				if (value==0){
					Gp.TITLE	= false;
				} else {
					Gp.TITLE	= true;
				}
				value=rs.getInt("c_tota");
				if (value>4 && value<40)
					Gp.TOTAUXSIZE = value;
				value=rs.getInt("c_gras");
				if (value==0){
					Gp.FONTTEXTTYPE=Font.PLAIN;
					Gp.FONTTEXT	= FONTNORMAL;
				} else {
					Gp.FONTTEXTTYPE=Font.BOLD;
					Gp.FONTTEXT	= FONTBOLD;
				}
				Gp.FONTTEXT9	= FONTTEXT.deriveFont(Gp.FONTTEXTTYPE,9f);
				Gp.FONTTEXT10	= FONTTEXT.deriveFont(Gp.FONTTEXTTYPE,10f);
				Gp.FONTTEXT11	= FONTTEXT.deriveFont(Gp.FONTTEXTTYPE,11f);
				Gp.FONTTEXT12	= FONTTEXT.deriveFont(Gp.FONTTEXTTYPE,12f);
				Gp.FONTTEXT13	= FONTTEXT.deriveFont(Gp.FONTTEXTTYPE,13f);
				Gp.FONTTEXT14	= FONTTEXT.deriveFont(Gp.FONTTEXTTYPE,14f);
				Gp.FONTTEXT15	= FONTTEXT.deriveFont(Gp.FONTTEXTTYPE,15f);
				Gp.FONTTEXT16	= FONTTEXT.deriveFont(Gp.FONTTEXTTYPE,16f);
				Gp.FONTTEXT18	= FONTTEXT.deriveFont(Gp.FONTTEXTTYPE,18f);

				value=rs.getInt("c_mgra");
				if (value==0){
					Gp.FONTMENU	= FONTNORMAL;
				} else {
					Gp.FONTMENU	= FONTBOLD;
				}
				value=rs.getInt("c_fond");
				if (value==0){
					Gp.USEFRAMETEXTURE=false;
				} else {
					Gp.USEFRAMETEXTURE=true;
				}
				value=rs.getInt("c_butt");
				if (value==0){
					Gp.USEBUTTONICONE=false;
				} else {
					Gp.USEBUTTONICONE=true;
				}
				value=rs.getInt("c_vpro");
				if (value==0){
					appliParam.VERSIONPRO=false;
				} else {
					appliParam.VERSIONPRO=true;
				}
				ret=rs.getString("c_them");
				sqlAbcPref.dBExecuteQuerryClose(rs);
			} catch (SQLException e) { e.printStackTrace(); }
		} else {
			JOptionPane.showMessageDialog(null, "\n\n Le fichier :     '"+appliParam.getNameBaseABC()+"\\"+sqlAbcPref.t_table+"'     est introuvable, Copier tous les fichiers dans un dossier, Merci","ATTENTION !!!", JOptionPane.INFORMATION_MESSAGE);
			System.exit(0);
		}
		return ret;
	}
	public void setFrameTexture(){
		if (f_mjpc!=null){
			String frametexture=null;
			if (Gp.USEFRAMETEXTURE){
				frametexture=appliParam.FRAMETEXTURE;
			}
			f_mjpc.setImage(this,frametexture,Gp.JPGTEXTURE);
			f_mjpc.repaint();
		}
	}
	private String getLookAndFeel(String look){
		//  1. UIDefaults uiDefaults = UIManager.getDefaults();
		//  2. Enumeration enum = uiDefaults.keys();
		//  3. while (enum.hasMoreElements()) {
		//  4.     Object key = enum.nextElement();
		//  5.     Object val = uiDefaults.get(key);
		//  6.     System.out.println("[" + key.toString() + "]:[" +
		//  7.         (null != val ? val.toString() : "(null)" ) +
		//  8.         "]" );
		//  9.     }

		int nlook=0;
		String ret=null;
		UIManager.LookAndFeelInfo[] info = UIManager.getInstalledLookAndFeels();
		Sql sqlAbcTheme=new Sql(sqlAbc);
		ret=sqlAbcTheme.readStringValue("s_themes","c_code",look, "c_code");
		nlook=info.length;
		for (int i=0;i<info.length;i++){
			if (info[i].getName().equals(ret)){
				nlook=i;
				break;
			}
		}
		sqlAbcTheme.closeT_stat();
		if (nlook>=info.length)
			ret=UIManager.getSystemLookAndFeelClassName();
		else
			ret=info[nlook].getClassName();
		return ret;
	}
	private void setLookAndFeel(String lookandfeel) {
		try {
			/*if (lookandfeel.equals("CDE/Motif")){
				lookandfeel="Metal";
				UIManager.setLookAndFeel(lookandfeel);
				MetalLookAndFeel.setCurrentTheme(new DefaultMetalTheme());
			} else*/
			UIManager.setLookAndFeel(lookandfeel);
			SwingUtilities.updateComponentTreeUI(gpAbc.f_mf);

			//force chaque composant de la fentre  appeler sa mthode updateUI
		} catch (InstantiationException e) {
		} catch (ClassNotFoundException e) {
		} catch (UnsupportedLookAndFeelException e) {
		} catch (IllegalAccessException e) {}
	}
	private void setPreferenceOptionPane(){
		setFontUIManager("OptionPane.font",Gp.FONTTEXT13);
		setFontUIManager("OptionPane.messageFont",Gp.FONTTEXT13);
		setFontUIManager("OptionPane.buttonFont",Gp.FONTTEXT13);
	}
	private void setPreferenceMenu(){
		setFontUIManager("Menu.font",Gp.FONTMENU);
		setFontUIManager("MenuItem.font",Gp.FONTMENU);
		setFontUIManager("MenuBar.font",Gp.FONTMENU);
	}
	private void setFontUIManager(String strfont,Font font){
		if (UIManager.getFont(strfont)!=null)
			UIManager.put(strfont,font);
	}
	public static void listKeyUiManager(String strkey){
		//		UIDefaults defaults = UIManager.getDefaults();
		//		System.out.println(defaults.size()+ " properties deffined !");
		//		String[ ][ ] rowData = new String[ defaults.size() ][ 2 ];
		//		int i = 0;
		//		for(Enumeration< Object > e = defaults.keys(); e.hasMoreElements(); i++){
		//			Object key = e.nextElement();
		//			rowData[ i ] [ 0 ] = key.toString();
		//			rowData[ i ] [ 1 ] = ""+defaults.get(key);
		//			if (rowData[i][0].contains(strkey) || key==null)
		//				System.out.println(rowData[i][0]+" ,, "+rowData[i][1]);
		//		}
	}
	public static Dimension getScreenSize(){
		return java.awt.Toolkit.getDefaultToolkit().getScreenSize();
	}
	public static Insets getScreenInsets(){
		return java.awt.Toolkit.getDefaultToolkit().getScreenInsets(GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getDefaultConfiguration());
	}
	public static void setRelativeLocation(Container cont,Point p,Dimension dim){
		Insets insets = getScreenInsets(); 
		Dimension tailleEcran = getScreenSize(); 
		tailleEcran.width=tailleEcran.width-insets.right;
		tailleEcran.height=tailleEcran.height-insets.bottom;
		if (p.x+p.y==0){ // centrer  l'ecran le popup
			p.x=(tailleEcran.width-dim.width)/2;
			p.y=(tailleEcran.height-dim.height)/2;
		}
		if (p.x+dim.width>tailleEcran.width){ // perte sur la largeur
			p.x=(tailleEcran.width-dim.width); // recalcule x  pour coller  droite
		}
		if (p.y+dim.height>tailleEcran.height){ // perte en hauteur
			p.y=(tailleEcran.height-dim.height); // recalcule y  pour coller en bas
		}
		cont.setLocation(p.x,p.y);
		insets=null;
		tailleEcran=null;
	}
	public static Color getPanelBackground() {
		return UIManager.getColor("Panel.background");
	} 
	//	public void fixeSizePanel(JPanel jp){
	//		Dimension dim=new Dimension(f_mfWidth,f_mfHeight);
	//		jp.setSize(dim);
	//		jp.setMinimumSize(dim);
	//		jp.setMaximumSize(dim);
	//		jp.setPreferredSize(dim);
	//		jp.setFocusable(false);
	//	}
	public void setSizePanel(JPanel jp,int width,int height){
		Dimension dim=new Dimension(width,height);
		jp.setSize(dim);
		jp.setMinimumSize(dim);
		jp.setMaximumSize(dim);
		jp.setPreferredSize(dim);
		jp.setFocusable(false);
	}
	public JPanel getPanelTitleMenuOptionText(){
		JLabel jlNorth=new JLabel(" ");{
			jlNorth.setFont(FONTTEXT.deriveFont(Gp.FONTTEXTTYPE,Gp.TITLESIZE/6));
		}
		JLabel jlSouth=new JLabel(" ");{
			jlSouth.setFont(FONTTEXT.deriveFont(Gp.FONTTEXTTYPE,Gp.TITLESIZE/3));
		}
		JLabel jlWest=new JLabel("    ");
		JLabel jlEast=new JLabel("    ");
		JLabel jlTitre=new JLabel();{
			jlTitre.setFont(FONTTEXT.deriveFont(Gp.FONTTEXTTYPE,Gp.TITLESIZE));
			jlTitre.setHorizontalAlignment(0);
			jlTitre.setVerticalAlignment(0);
			jlTitre.setForeground(Gp.VERTFONCE_FG);
			jlTitre.setText(m_optionText);
		}

		JPanelImage jpTitre=new JPanelImage(new BorderLayout(0,0));{
			jpTitre.add(jlNorth,BorderLayout.NORTH);
			jpTitre.add(jlWest,BorderLayout.WEST);
			jpTitre.add(jlTitre,BorderLayout.CENTER);
			jpTitre.add(jlEast,BorderLayout.EAST);
			jpTitre.add(jlSouth,BorderLayout.SOUTH);
			if (Gp.USEROUNDEDBORDER){
				jpTitre.setBorder(new RoundBorder());
			} else {
				jpTitre.setBorder(Gp.getBorder(Color.LIGHT_GRAY));
			}
			jpTitre.setBackground(Gp.MOVE_BG_LVERT);
			if (appliParam.TITRETEXTETURE==null){
				jpTitre.setImage(gp,null,Gp.JPGGRADIENT);
				jpTitre.setModeGradient(45,true);
			} else {
				jpTitre.setImage(gp,appliParam.TITRETEXTETURE,Gp.JPGTEXTURE);
			}
		}
		jpTitre.setVisible(Gp.TITLE);
		return jpTitre;
	}
	public void clearMainFrame(boolean clearAide) {
		if (clearAide){
			gpAbc.f_mjStatusBar.setTextStatus(Gp.MAINCHOICEMENU,"","");
		}
		gpAbc.f_mf.repaint();
		//clearContainer(gpAbc.f_mjpc,true);
		closeSql();
	}
	private void closeSql(){
		Sql sql=null;
		for (int i=0;i<sqls.size();i++){
			sql=sqls.get(i);
			sql.closeT_stat();
			if (sql.sqlTwin!=null){
				sql.closeT_stat();
				sql.sqlTwin=null;
			}
			sql=null;
			sqls.set(i, null);
		}
		sqls.clear();
	}
	public void addSql(Sql sql){
		sqls.add(sql);
	}
	public void clearContainer(Container container,boolean racine){
		if (container!=null){
			for (int i=0;i<container.getComponentCount();i++){
				if (container.getComponent(i) instanceof Container){
					clearContainer( (Container) container.getComponent(i),false);
				}
				container.getComponent(i).invalidate();
				container.remove(i);
				container.validate();
			}	
			container=null;
		}
	}
	//////////////////////////////////////////////////////
	// Gestion des layout LIBELLES ET CHAMPS DES TABLES //
	//////////////////////////////////////////////////////
	public static GridBagLayout adaptePanelC(){
		gbc.insets=new Insets(0,0,0,0);
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.weightx=0;
		gbc.weighty=0;
		gbc.gridwidth=1;
		gbc.gridheight=1;
		gbc.gridx=0;
		gbc.gridy=-1;
		gbc.fill=0;
		return new GridBagLayout();
	}
	public static GridBagLayout adaptePanelButtonVertical(){
		gbc.insets=new Insets(5,5,5,5);
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.weightx=0;
		gbc.weighty=0;
		gbc.gridwidth=1;
		gbc.gridheight=1;
		gbc.gridx=0;
		gbc.gridy=-1;
		gbc.fill=1;
		return new GridBagLayout();
	}
	//////////////////////////////////////////////////////
	// Gestion des layout LIBELLES ET CHAMPS DES TABLES //
	//////////////////////////////////////////////////////
	public static GridBagLayout adaptePanelL(){
		gbc.insets=new Insets(3,2,1,3);
		gbc.anchor = GridBagConstraints.EAST;
		gbc.weightx=1;
		gbc.weighty=1;
		gbc.gridwidth=1;
		gbc.gridheight=1;

		gbc.gridx=0;
		gbc.gridy=-1;
		gbc.fill=0;
		return new GridBagLayout();
	}
	public static GridBagLayout adaptePanelP(){
		gbc.insets=new Insets(3,2,1,3);
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.weightx=0;
		gbc.weighty=0;
		gbc.gridwidth=1;
		gbc.gridheight=1;

		gbc.gridx=0;
		gbc.gridy=-1;
		gbc.fill=0;
		return new GridBagLayout();
	}
	public static GridBagLayout adaptePanelE(){
		gbc.insets=new Insets(3,2,1,3);
		gbc.anchor = GridBagConstraints.NORTHWEST;
		gbc.weightx=0;
		gbc.weighty=0;
		gbc.gridwidth=1;
		gbc.gridheight=1;

		gbc.gridx=0;
		gbc.gridy=-1;
		gbc.fill=0;
		return new GridBagLayout();
	}
	public static void setLabelTitre(JLabel jl){
		jl.setOpaque(true);
		jl.setBackground(UIManager.getColor("Panel.background"));
		jl.setFont(Gp.FONTTEXT13);
		jl.setHorizontalAlignment(JLabel.CENTER);
		jl.setForeground(Gp.VERTFONCE_FG);
	}
	public static Border getBorder (Color color){
		Border ret=BorderFactory.createEmptyBorder(2,2,2,2);
		ret=getBorder(ret,color);
		return ret;
	}
	public static Border getBorder (Border bd,Color color) {
		Border ret=BorderFactory.createCompoundBorder(BorderFactory.createLineBorder(color),bd);
		return ret;
	}

	public static JTextDb getEmptyLabel(String str){
		JTextDb ret=null;
		ret=new JTextDb(str);
		Ccs.TexttoLibe(ret);
		return ret;
	}
	// LES GBC DES VUES
	// Les TITRES
	public static GridBagConstraints getGbcTitre() {
		setGbc();
		gbc.gridy=G_TITRE;
		gbc.fill=1;
		return gbc;
	}
	// Les LISTES
	public static GridBagConstraints getGbcListe() {
		setGbc();
		gbc.gridy=G_LISTE;
		return gbc;
	}	
	public static GridBagConstraints getGbcListeEntete() {
		setGbc();
		gbc.gridy=G_LISTEENTETE;
		gbc.fill=1;
		return gbc;
	}
	public static GridBagConstraints getGbcListePied() {
		setGbc();
		gbc.gridy=G_LISTEPIED;
		gbc.fill=1;
		return gbc;
	}
	// Les FICHES
	public static GridBagConstraints getGbcFiche() {
		setGbc();
		gbc.insets=new Insets(1,0,0,0);
		gbc.gridy=G_FICHE;
		return gbc;
	}
	public static GridBagConstraints getGbcFicheEntete() {
		setGbc();
		gbc.insets=new Insets(1,0,0,0);
		gbc.gridy=G_FICHEENTETE;
		return gbc;
	}
	public static GridBagConstraints getGbcFichePied() {
		setGbc();
		gbc.insets=new Insets(1,0,0,0);
		gbc.gridy=G_FICHEPIED;
		return gbc;
	}
	// Les DETAILS
	public static GridBagConstraints getGbcDetail() {
		setGbc();
		gbc.insets=new Insets(1,0,0,0);
		gbc.gridy=G_DETAIL;
		return gbc;
	}
	public static GridBagConstraints getGbcDetailEntete() {
		setGbc();
		gbc.insets=new Insets(1,0,0,0);
		gbc.gridy=G_DETAILENTETE;
		return gbc;
	}
	public static GridBagConstraints getGbcDetailPied(int indice) {
		setGbc();
		gbc.insets=new Insets(1,0,0,0);
		gbc.gridy=G_DETAILPIED+indice;
		return gbc;
	}
	// le GBC 
	private static void  setGbc(){
		gbc.insets=new Insets(0,0,0,0);
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.weightx=0;
		gbc.weighty=0;
		gbc.gridwidth=1;
		gbc.gridheight=1;
		gbc.gridx=0;
		gbc.fill=0;
	}
	public static void setxy(int gridx, int gridy) {
		gbc.gridx=gridx;
		gbc.gridy=gridy;
	}
	public static void sety(int gridy) {
		gbc.gridy=gridy;
	}
	public static GridBagConstraints gety(){
		gbc.gridy++;
		return gbc;
	}
	public static void setx(int gridx) {
		gbc.gridx=gridx;
	}
	public static void setWidth(int width) {
		gbc.gridwidth=width;
	}
	public static void setHeight(int height) {
		gbc.gridheight=height;
	}
	public static GridBagConstraints getx(){
		gbc.gridx++;
		return gbc;
	}
	public static void setFill(int fill) {
		gbc.fill=fill;
	}
	/**
	 * Ajout d'un sparateur horizonthal dans le panel principal de saisie
	 * @param jpDbE panel principal de saisie 
	 * @param titre [Titre] align  gauche  
	 */
	public static void addSeparator(JPanel jpDbE,String titre) {
		JPanel jp=new JPanel(new BorderLayout(0,0));
		if (titre.length()!=0){
			JLabel jl=new JLabel("[ "+titre+" ] ");
			jl.setVerticalAlignment(JLabel.TOP);
			jl.setForeground(Gp.VERTFONCE_FG);
			jp.add(jl,BorderLayout.WEST);
			jp.setName(titre);
		}
		jp.add(new JSeparator(),BorderLayout.CENTER);

		//////
		gety();
		setx(0);
		setWidth(99);
		setFill(GridBagConstraints.HORIZONTAL);
		jpDbE.add(jp,gbc);
		setFill(GridBagConstraints.NONE);  
		setWidth(1);	
	}
	public static void setSeparatorVisible(JPanel jpDbT,String titre,boolean enable) {
		for (int i=0;i<jpDbT.getComponents().length;i++){
			if (jpDbT.getComponent(i).getName()!=null){
				if (jpDbT.getComponent(i).getName().equals(titre)){
					jpDbT.getComponent(i).setVisible(enable);
					break;
				}
			}
		}
	}
	public static void addSeparator2(JPanel jpDbT) {
		setWidth(99);
		setx(0);
		gety();
		setFill(GridBagConstraints.HORIZONTAL);
		jpDbT.add(new JSeparator(),gbc);
		setFill(GridBagConstraints.NONE);  
		setWidth(1);	
	}
	// SECURITE LOGICIEL
	public void setTcetorp(){
		try {
			File cfgFile=getFCfg();
			FileWriter out = new FileWriter(cfgFile);
			cfgFile=null;
			String namehex="";
			namehex=stringtoh(getTcetorpName());
			String decanamehex="";
			decanamehex=decah(namehex,PROTECTDECALAGE,false);
			String record="";
			record=decah(decanamehex,0,true);
			out.write(record,0,record.length());
			out.close();
		} catch (Exception e) { e.printStackTrace(); } 
	}
	public boolean isTcetorp(){
		boolean ret=false;
		File cfgFile=getFCfg();
		if (cfgFile.exists()) {
			try {
				FileReader in = new FileReader(cfgFile);
				cfgFile=null;
				String namehex="";
				namehex=stringtoh(getTcetorpName()); // Traduit une String en StingH
				//System.out.println("name en hex :"+namehex+":");

				String decanamehex="";
				decanamehex=decah(namehex,PROTECTDECALAGE,false); // Decale une StringH
				//System.out.println("decaname en hex :"+decanamehex+":");

				String record="";
				record=decah(decanamehex,0,true); // Repasse une StringH en String
				//System.out.println("decaname en hex to string :"+record+":");

				char[] readIn=new char[getTcetorpName().length()];
				in.read(readIn,0,record.length()); // Lit un fichier dans un char[]

				String comp = new String(readIn); // Converti un char[] en String
				//System.out.println("comp string :"+comp+":");

				String comphex="";
				comphex=stringtoh(comp); // Traduit une String en StringH
				//System.out.println("comp string :"+comphex+":");

				String recanamehex="";
				recanamehex=decah(comphex,PROTECTDECALAGE,true); // Recale une StringH
				//System.out.println("recacomp string to hex :"+recanamehex+":");

				record="";
				record=decah(recanamehex,0,true); // Repasse une StringH en String
				//System.out.println("recacomp string :"+record+":");
				in.close();

				if (record.equals(getTcetorpName()))
					ret=true;
			} catch (Exception e) { e.printStackTrace(); }
		}
		return ret;
	}
	private String getTcetorpName(){
		return appliParam.getNameBase()+System.getProperty(NAME);
	}
	private File getFCfg(){
		File ret=null;
		String flag=System.getProperty(HOME); // Rpertoire principal de l'utilisateur
		String fileSeparator=System.getProperty("file.separator"); // Sparateur li au system d'exploitation
		ret=new File(flag+fileSeparator+appliParam.getNameBase()+".cfg"); // Mouchard de l'aplication 
		return ret;
	}
	public String geth(){
		String ret="";
		String namehex="";
		namehex=stringtoh(getTcetorpName());
		if (gpAbc.ISDEVFILE)
			System.out.println("PassWord en hex :"+namehex+":");
		String decanamehex="";
		decanamehex=decah(namehex,PROTECTDECALAGEKEY,false);
		if (gpAbc.ISDEVFILE)
			System.out.println("PassWord en hex decal :"+decanamehex+":");
		ret=decanamehex;
		return ret;
	}
	public String getdecah(String decamehex){
		String ret="";
		ret=decah(decamehex,PROTECTDECALAGEKEY,false);
		if (gpAbc.ISDEVFILE)
			System.out.println("PassWord en hex redecal :"+ret+":");
		return ret;
	}
	private String decah(String passwordhex,int deca,boolean sens) {
		String ret="";
		String htos="";
		for (int pos = 0; pos<passwordhex.length(); pos+=2) {
			String substring = passwordhex.substring(pos, pos+2);
			char c;
			if (sens)
				c = (char) (Integer.parseInt(substring, 16)+deca);
			else
				c = (char) (Integer.parseInt(substring, 16)-deca);
			htos=htos+c;
		}
		if (deca!=0)
			ret=(stringtoh(htos));
		else
			ret=htos;
		return ret;
	}
	private String stringtoh(String password){
		String ret="";
		for (int i=0;i<password.length();i++)
			ret=ret+Integer.toHexString(password.charAt(i)).toUpperCase();
		return ret;
	}
	// ZOOM IN OUT FRAME
	public void zoomIn(Container cont, int step) {
		Rectangle bounds=cont.getBounds();
		while(bounds.height>100){
			bounds.height=bounds.height-step*2;
			bounds.width=bounds.width-step*2;
			bounds.x=bounds.x+step;
			bounds.y=bounds.y+step;
			cont.setBounds(bounds);
		}

	}
	public void zoomOut(Container cont, int step) {
		Rectangle bounds=cont.getBounds();
		while(bounds.height<this.gpAbc.f_mfHeight){
			bounds.height=bounds.height+step*2;
			bounds.width=bounds.width+step*2;
			bounds.x=bounds.x-step;
			bounds.y=bounds.y-step;
			cont.setBounds(bounds);
		}

	}
	public int notify(String titre, String mess, Object[] option,String nameImage,int defOption) {
		int reponse = JOptionPane.showOptionDialog(f_mf 
				,mess
				,titre 
				,JOptionPane.YES_NO_OPTION
				,JOptionPane.QUESTION_MESSAGE
				,ImageIcon(getImage(nameImage,true),6)
				,option
				,option[defOption]);
		return reponse;
	}
	// DBFICHIER
	public void removeDbVue(boolean enable) {
		if (lastDbVue!=null){
			f_mjpc.remove(lastDbVue);
			lastDbVue.dispose();
		}
		clearMainFrame(enable);
	}
	public void addDbVue() {
		if (sql==null) {
			sql=new Sql(gp);
		}
		lastDbVue=new DbVue(sql);
		f_mjpc.add(lastDbVue);
		f_mjpc.validate();
	}
	// CHAINE & COMPARAISON
	public static boolean isSup(String s1,String s2){
		boolean ret=false;
		ArrayList < String > arrayliste = new  ArrayList < String > ();
		arrayliste.add(s1);
		arrayliste.add(s2);
		Collections.sort(arrayliste);
		if (s1.equals(arrayliste.get(1)) && !s1.equals(s2))
			ret=true;
		arrayliste.clear();
		arrayliste=null;
		return ret;
	}
	public static boolean isSupOrEqual(String s1,String s2){
		boolean ret=false;
		if (s1.equals(s2)){
			ret=true;
		} else {
			ret=isSup(s1,s2);
		}
		//Gp.afficherTrace(1, s1+">="+s2+"!"+ret);
		return ret;
	}
	public static boolean isInf(String s1,String s2){
		return !isSupOrEqual(s1,s2);
	}
	public static boolean isInfOrEqual(String s1,String s2){
		boolean ret=false;
		if (s1.equals(s2)){
			ret=true;
		} else {
			ret=isInf(s1,s2);
		}
		return ret;
	}
	// PARSER ET ROUND
	public static double parseDouble(String value) {
		if (value==null){
			value="0";
		} else if (value.isEmpty()) {
			value="0";
		} else if (value.equals("-")){
			value="-0";
		}

		return Double.parseDouble(value);
	}
	public static int parseInt(String value) {

		if (value==null){
			value="0";
		} else if (value.isEmpty()){
			value="0";
		} else if (value.equals("-")){
			value="-0";
		}

		return Integer.parseInt(value);
	}
	public static double doubleRound(double value, int n) {
		double r = (Math.round(value * Math.pow(10, n))) / (Math.pow(10, n));
		return r;
	}	
	// CONSOLE ERROR
	public static void setConsoleErr(boolean enable) {
		if (enable){
			stderr=System.err;
			System.setErr(new PrintStream(new Console(ConsoleErr,new JTextArea())));
		} else {
			PrintStream tmpstd=System.err;
			tmpstd.close();
			System.setErr(stderr);
		}
	}
	public static void setConsoleDebug(boolean enable) {
		if (enable){
			stdout=System.out;
			System.setOut(new PrintStream(new Console(ConsoleOut,new JTextArea()))); 
		} else {
			PrintStream tmpstd=System.out;
			tmpstd.close();
			System.setOut(stdout); 
		}
	}
	// CONSOLE DEBUG/NOTIFICATION
	public static StackTraceElement[] getTrace()
	{
		//On rcupre la pile d'excution
		Throwable throwable = new Throwable();
		StackTraceElement[] trace = throwable.getStackTrace();
		throwable=null;
		//On enlve le premier lment qui est l'appel de cette mthode
		StackTraceElement[] reponse = new StackTraceElement[trace.length - 1];
		System.arraycopy(trace, 1, reponse, 0, reponse.length);
		trace=null;
		//On envoie la pile d'excution
		return reponse;
	}
	public static void af()
	{
		//On rcupre la pile d'cution
		StackTraceElement[] trace = getTrace();
		//On affiche la pile, sauf le premier lment qui est l'appel de cette
		// mthode
		for(int i = 1; i < trace.length; i++)
		{
			System.out.println(trace[i]);
		}
		trace=null;
	}
	public static void af(int nbTrace,Object strDebug)
	{
		//On rcupre la pile d'cution
		StackTraceElement[] trace = getTrace();
		//On affiche la pile, sauf le premier lment qui est l'appel de cette
		// mthode
		for(int i = nbTrace; i < trace.length && i <=nbTrace; i++)
		{
			System.out.println(trace[i]+"\n "+strDebug);
		}
		trace=null;
	}
	public static void af(Object o)
	{
		af(2,o);
	}
	public static void ad(Object o)
	{
		System.out.print(""+o);
	}
	public static void ad(char a)
	{
		System.out.print(a);
	}
	static Object o=null;
	static Sql Ssql=null;
	public static void MB(Object o){
		Gp.o=o;
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				JOptionPane.showMessageDialog(null,""+Gp.o,"MessageBox",JOptionPane.INFORMATION_MESSAGE);
			}
		});
	}
	public static void MB(Sql sql,Object o){
		Gp.o=o;
		Gp.Ssql=sql;
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				JOptionPane.showMessageDialog(Ssql.getMf(),""+Gp.o,"MessageBox",JOptionPane.INFORMATION_MESSAGE);
			}
		});
	}
	/**
	 *  Initialise le Codes Barre <br>
	 *  a) paramtre le port com <br>
	 *  b) reprogramme le CB <br>
	 *  c) teint le faisceau <br>  
	 *  e) Reste en disponibilit <br>
	 * @param ms1204_port Nom du Port com
	 * @param num numro interne
	 * @param beepInit
	 */
	public void initCbParamUser(String ms1204_port, int num, boolean beepInit) {
		if (ms1204_port.trim().length()>0){
			if (codeBarres==null){
				codeBarres=new CodeBarre(gpAbc);
			}
			codeBarres.setLecteur(ms1204_port, num, beepInit);
		}
	}
	public Ms1204 getCodeBarreMs1204(int num) {
		Ms1204 ret=null;
		if (codeBarres!=null){
			ret=codeBarres.getMs1204(num);
		}
		return ret;
	}
	/**
	 *  Code barre sur port com prsent
	 */
	public boolean isCodeBarre(int num) {
		boolean ret=false;
		if (codeBarres!=null){
			ret=codeBarres.isPort(num);
		}
		return ret;
	}
	/**
	 *  Ferme les codes barres sur port com
	 */
	public void closeCodeBarre(){
		if (codeBarres!=null){
			codeBarres.close();
		}
	}
	/**
	 * Init Imprimantes thermiques sur port com
	 * @param impdot_port Nom du port com
	 * @param num numro interne
	 * @param impdot_driver nom du driver 8 ou 12 Dots
	 */
	public void initImpDotParamUser(String impdot_port, int num, String impdot_driver) {
		if (impdot_port.trim().length()>0){
			if (impdots==null){
				impdots=new ImpDot(gpAbc);
			}
			impdots.setPrinter(impdot_port, num, impdot_driver);
		}
	}
	/**
	 *  Imprimantes thermiques sur port com prsentes
	 */
	public boolean isImpDot(int num) {
		boolean ret=false;
		if (impdots!=null){
			ret=impdots.isPort(num);
		}
		return ret;
	}
	public String getImpDotDriver(int num) {
		String ret=null;
		if (impdots!=null){
			ret=impdots.getDriver(num);
		}
		return ret;
	}
	public Serial getImpDotSerial(int num) {
		Serial ret=null;
		if (impdots!=null){
			ret=impdots.getSerial(num);
		}
		return ret;
	}
	/**
	 *  Ferme les imprimantes thermiques sur port com
	 */
	public void closeImpdot(){
		if (impdots!=null){
			impdots.close();
		}
	}
	// FILE
	public static boolean isFileExists(String path){
		boolean ret=false;
		File file=new File(path);
		ret=file.exists();
		file=null;
		return ret;
	}
	public static long getFileLastModified(String path){
		long ret=-1;
		File file=new File(path);
		ret=file.lastModified();
		file=null;
		return ret;
	}
	public static String[] readParamFromFile(String file,int nbParam){
		String [] ret=new String [nbParam];
		if (Gp.isFileExists(file)){
			try {
				Scanner scanner = new Scanner(new File(file));
				for (int i=0;i<nbParam;i++){
					if (scanner.hasNextLine()){
						ret[i]=scanner.nextLine();
					} else {
						ret[i]="";
					}
				}
				scanner.close();
				scanner=null;
			} catch (FileNotFoundException arg0) { arg0.printStackTrace(); }
		} else {
			ret=null;
		}
		return ret;
	}

	// CURSOR
	public void setCursorWait(boolean enabled) {
		if (f_mf!=null){
			if (enabled){
				f_mf.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR) ) ;
			} else {
				f_mf.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
			}
		}
	}
	// ROBOT KEY
	public static void quit() {
		int[] quit={KeyEvent.VK_ALT,KeyEvent.VK_F4};
		keybAlt(quit);
	}
	public static int []  arrayStringToInt(String str){
		int [] ret=null;
		ret=new int [str.length()];
		for (int i=0;i<str.length();i++){
			ret[i]=str.charAt(i);
		}
		return ret;
	}
	public static void keyb(int[] keyb) {
		try {
			Robot robot = new Robot();
			robot.delay(10);
			for(int i=0;i<keyb.length;i++){
				robot.keyPress(keyb[i]);
				robot.delay(10);
				robot.keyRelease(keyb[i]);
				robot.delay(10);
			}
		} catch (AWTException arg0) { arg0.printStackTrace(); }

	}
	public static void keybAlt(int[] keyb) {
		try {
			Robot robot = new Robot();
			robot.delay(10);
			for(int i=0;i<keyb.length;i++){
				robot.keyPress(keyb[i]);
			}
			robot.delay(10);
			for(int i=keyb.length;i>0;i--){
				robot.keyRelease(keyb[i-1]);
			}
		} catch (AWTException arg0) { arg0.printStackTrace(); }

	}

	//--- A   C L A S S E R --//
	public static void debugSpyFocus(){
		KeyboardFocusManager focusManager = KeyboardFocusManager.getCurrentKeyboardFocusManager();
		focusManager.addPropertyChangeListener(
				new PropertyChangeListener() {
					public void propertyChange(PropertyChangeEvent e) {
						String properties = e.getPropertyName();
						if (("focusOwner".equals(properties)) && (e.getNewValue() != null)) {
							//Component component = (Component)e.getNewValue();
							//String name = component.getName();
							//component = (Component)e.getOldValue();
							//String name2 = component.getName();
							//System.out.println("!"+name2 + "!==> passe le focus  ==>!"+name + "!");
						}
					}
				}
		);
	}

	public static void dispatchEvent(Component c, KeyEvent e) {
		c.dispatchEvent(new KeyEvent(c,e.getID(), new Day().getTime(),e.getModifiers(),e.getKeyCode(),e.getKeyChar()));
	}
	public void catchKeyboard() {
		KeyboardFocusManager kbm = KeyboardFocusManager.getCurrentKeyboardFocusManager();
		kbm.addKeyEventPostProcessor(this);
	}
	public boolean postProcessKeyEvent(KeyEvent e) {
		if(e.getID() == KeyEvent.KEY_PRESSED) {
			if(e.getModifiers() == InputEvent.CTRL_MASK) {
				ISCTRL_MASK=true;
//				f_mjStatusBar.setTextKeyboard("C");
			}
			if(e.getModifiers() == InputEvent.SHIFT_MASK) {
//				f_mjStatusBar.setTextKeyboard("S");
				ISSHIFT_MASK=true;
			}
		}
		//
		if(e.getID() == KeyEvent.KEY_RELEASED) {
//			f_mjStatusBar.setTextKeyboard(" ");
				ISCTRL_MASK=false;
				ISSHIFT_MASK=false;
		}
		return false;
	}
	public boolean isCtrlMask() {
		return ISCTRL_MASK;
	}
	public boolean isShiftMask() {
		return ISSHIFT_MASK;
	}
}
