package persistance.wSql;

import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.Fma;

/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class Field {
	public String t_field=null; // Nom du champs de la table c_xxxx
	public Edit t_EditType=null; // Type du champs de la table F_xxxx
	public String t_fieldDefaultValue=null; // Valeur par default "xx"
	public String t_fieldFormat=null; //Format de saisie
	public int t_fieldLength=-1;
	public String t_lib="";
	public String t_libHelp="";
	public Fma t_Fma=null;

	
	public Field(){
	}
	public Field(String t_field){
		this.t_field=t_field;
	}
	public Field(String t_field, int t_fieldLength, Fma t_Fma, String t_lib){
		set(t_field, t_fieldLength, t_Fma, t_lib,"");
	}
	public Field(String t_field, int t_fieldLength, Fma t_Fma, String t_lib,String t_libHelp) {
		set(t_field, t_fieldLength, t_Fma, t_lib,t_libHelp);
	}
	private void set(String t_field, int t_fieldLength, Fma t_Fma, String t_lib,String t_libHelp){
		this.t_field=t_field;
		this.t_lib=t_lib;
		this.t_fieldLength=t_fieldLength;
		this.t_Fma=t_Fma;
		this.t_libHelp=t_libHelp;
	}
	public void setStruct(Edit fieldType, String fieldDefaultValue){
		this.t_EditType=fieldType;
		this.t_fieldDefaultValue=fieldDefaultValue;
	}
	public void setFormat(String format){
		this.t_fieldFormat=format;
	}
	public void set(Field field){
		t_field=field.t_field;
		t_EditType=field.t_EditType; 
		t_fieldDefaultValue=field.t_fieldDefaultValue; 
		t_fieldFormat=field.t_fieldFormat; 
		t_fieldLength=field.t_fieldLength;
		t_lib=field.t_lib;
		t_libHelp=field.t_libHelp;
		t_Fma=field.t_Fma;
	}
}
