package persistance.wSql;

import java.awt.Image;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

import javax.swing.Icon;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import module_standard.wSerial.Ms1204;
import persistance.wGlobalParam.AbstractDefaultParam;
import persistance.wGlobalParam.Gp;
import template_applicatif.wVue.VueIAcces;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JPlageTimes;
import composant_saisie.wComposant.JPopup;
import composant_saisie.wComposant.JTextDbF2;
import composant_saisie.wSaisieFormat.Fma;

import fenetre_menu.wConteneur.AbstractJDialogDb;
/**
 Sql est un objet path que tous les composants connaissent<br> 
 <br>
 il est le noeud principal de l'appli<br>
 <br>
 Cet objet est un requeteur sql, il s'appuie sur le mappage des tables et par les appels d'interface,<br> 
 calcule les requtes et met des "Records"  disposition des "Vue"<br>
 <br>
 Sql gre deux types de SGBDR sql : un type embarqu (SqlLite) et un type adressable (Mysql)<br>
<br>
__________________________________________________________________________________
<br>{@link A_doc}
 <br>{@link Licence}.*/
public class Sql  {
	// Gestion des parametre globaux a l'appli
	Gp gp=null;
	// Connexion  une base
	Connection cx=null;
	public ResultSet rs=null;
	ResultSet rsTmp=null;
	Statement statTmp=null;
	String sqlPipe="||";
	String t_select="SELECT ";
	boolean sqlconcat=false;
	public static final String CONCAT="CONCAT(";
	public static final int STR_BUILD=80;
	public static final int SQL_ERROR_HARD=0;
	public static final int SQL_ERROR_SOFT=1;

	// acces au composant Liste et Table
	public VueIAcces 	taThis=null;
	public VueIAcces   	taTwin=null;
	public VueIAcces   taParent=null;

	public Sql sqlTwin=null;

	// Gestion des Bases
	public Statement 	t_stat=null;
	public String 		t_table=null;
	public String 		baseTable=null;
	public String 		t_moduleIdAide=null;

	// Table
	public ArrayList <Field> fields =null;
	// Fiche
	public ArrayList< Object[] > datas=null;
	// Liste Impression
	public ArrayList <Field> prints=null;
	// Rupture liste d'impression
	public ArrayList <Field> ruptures=null;

	// Gestion des Jointures
	public static final String 	JoinTableName = ".";
	public ArrayList< FieldsJoin >  joins=null;

	public String[]     v_filtre		= null;
	public String[] 		t_filtre		= null;
	public String		clauseFilter	= null;
	public String		clauseGroupBy	= null;

	public int[] 			t_indexOrder	= null;
	public String[] 		t_index			= null;
	public String       v_index			= null;
	public String	 	t_seek			= null;
	private boolean	t_desc 			= false;
	public String		superieur       = ">";
	public String		inferieur       = "<";
	public boolean		t_showSearch	= true;
	public static String 		t_bottom		= "յ"; // 255 255 255 231 229 230 228
	public static String 		t_top			= ""; // Vide 

	public String       t_Recno						= "";
	public int 			t_nbFieldWithRowidForData	= 0;
	public int 			t_recnoCol					= 0;
	public boolean 		t_eof						= true;
	public int 			t_FirstFieldInSelectForRsGet= 1;
	public int			t_nbLigne					= 0;

	public String       t_TmpRecno					= "";
	public boolean 		t_TmpEof					= true;
	public String       v_TmpIndex					= null;
	public boolean 		t_saveRecno					= false;

	// Gestion des listes
	//	public JFrame		t_frame			= null;
	public JTextDbF2 		t_F2			= null;
	public JPlageTimes  	t_PLAGETIMES	= null;
	public JPopup       	t_F2Popup		= null;
	public String       		t_F2fieldLibe	= null;
	public String       		t_F2Debut		= null;
	public String       		t_F2Fin			= null;
	public String 			t_moduleIdF2Color		="";
	public static final int 	t_F2DebutFin	= 99;
	public static final int		t_LoadAllField	= 0;
	public static final int 	t_LoadRowid = 2;
	public static String 		FIELDENTER 		= "fieldenter";
	public int 			t_height; // Hauteur d'une ligne de la JTable

	// Gestion des fiches
	//public static final int 	t_LoadFieldWithoutIndex=1;
	private int[] Mode=null;

	// gestion du mode d'acces 
	public int UPDATED					= 0; // indice gestion du record 
	public static int MODE				= 1; // indice gestion du mode
	public static int MODE_MOVABLE 		= 0;
	public static int MODE_UPDATED 		= 1;
	public static int MODE_APPEND 		= 2;
	public static int MODE_APPENDUPDATED= 3;
	public static int MODE_SAUVE 		= 9999;

	public int		t_AccesMode;
	public static int		t_AccesModeIndex= 0;
	public static int		t_AccesModeRecno= 1;
	public static String	t_insert		= "INSERT";
	public Vue		vue	= Vue.VUEINDEFINIE;

	// Imprimante nombre de colonne par page
	public int 				g_nbList		= 1;
	public int 				g_orientation	= 1;
	public int				g_choicePrinter = 0;
	public static int 		DEFPRINTER		= 0;
	public static int 		CHOICEPRINTER	= 1;
	public AbstractFieldsDef printsFilter;
	public static int 		LANDSCAPE		= 0;
	public static int 		PORTRAIT 		= 1;
	public String 			g_optionRupture	= "Rupture";
	public  int 			g_rupture 		= 0;
	public final static int 		RUPTURE_TOUS 	= 0;
	public final static int 		RUPTURE_DETAIL 	= 1;
	public final static int 		RUPTURE_TOTAL 	= 2;
	public boolean 		debugPrint			= false;
	public boolean 		debugF2			= false;
	private String 		debugReadTable	= "";
	public boolean 		t_debugQuery=false;
	// APPLICATION
	/**
	 * Connexion  la base
	 */
	public Sql(Gp gp){
		// ne passe qu'une fois ici lors du lancement des menus
		this.gp=gp;
		gp.addSql(this);
		setCx();
	}
	/**
	 * Cration du statement d'une table
	 * On conserve le statement ouvert
	 * @param sql une connexion
	 */
	public Sql(Sql sql){
		this.gp=sql.gp;
		gp.addSql(this);
		cx=sql.cx;
		sqlPipe=sql.sqlPipe;
		sqlconcat=sql.sqlconcat;
		try {
			if (cx.isClosed()){
				setCx();
			}
			t_stat=cx.createStatement();
			statTmp=cx.createStatement();
		} catch (SQLException e1) { e1.printStackTrace(); }

		joins = new ArrayList< FieldsJoin >(10);
		fields=new ArrayList < Field >(Gp.MAXFIELDS);
		Mode=new int[2];
		//getMode[UPDATED]=0; // 0=Fiche non Modifie  1=l'utilisateur a fait un saisie
		setMode(MODE_MOVABLE); 
		//0=Fiche en affichage 
		//1=Fiche en modification 
		//2=Ajout (vide la fiche) 
		//3=Fiche ajoutee encours de modification
	}
	/**
	 * Cration du statement d'une table
	 * @param sql une connexion
	 * @param t_seek fiche par dfaut
	 * @param vue type de vue
	 */
	public Sql(Sql sql,String t_seek, Vue vue){
		this(sql);
		this.t_seek=t_seek;
		this.vue=vue;
	}
	/**
	 * Cration du statement d'une table
	 * @param sql une connexion
	 * @param t_table nom de la table
	 */
	public Sql(Sql sql,String t_table){
		this(sql);
		setTable(t_table);
	}

	private void setCx(){
		String driver="";
		String urlbase="";
		gp.gpAbc.setCursorWait(true);
		try {
			switch (gp.sqltype){
			case Gp.MYSQL:
				driver	= "com.mysql.jdbc.Driver";
				urlbase="jdbc:mysql:"+gp.url+gp.base+"?retainStatementAfterResultSetClose=true";
				break;
			case Gp.SQLITE:
				driver	= "org.sqlite.JDBC";
				urlbase="jdbc:sqlite:"+gp.url+gp.base;
				break;
			}
			Class.forName(driver);
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}

		try {
			switch (gp.sqltype){
			case Gp.MYSQL:
				sqlPipe=",";
				t_select="SELECT STRAIGHT_JOIN ";
				sqlconcat=true;
				break;
			case Gp.SQLITE:
				sqlPipe="||";
				t_select="SELECT ";
				sqlconcat=false;
				break;
			}
			if (gp.gpAbc.appliParam.USER_BASE.length()==0){
				cx = DriverManager.getConnection(urlbase);
			} else {
				cx = DriverManager.getConnection(urlbase,gp.gpAbc.appliParam.USER_BASE,gp.gpAbc.appliParam.PASSWORD);
				//				System.out.println(urlbase);
				//				System.out.println(gp.gpAbc.appliParam.USER_BASE);
				//				System.out.println(gp.gpAbc.appliParam.PASSWORD);
			}

			gp.gpAbc.setCursorWait(false);

			if (!isValid(cx))
				System.out.println("base introuvable : "+urlbase);
		} catch (SQLException e) {
			System.out.println("base introuvable : "+urlbase);
			e.printStackTrace();
		}
	}
	private boolean isValid(Connection cx){
		boolean ret=true;
		if(cx==null){
			ret=false;
		}
		ResultSet ping = null;
		try{
			if(cx.isClosed()){ret=false;}
			ping = cx.createStatement().executeQuery("SELECT 1");
			ret=ping.next();
		}catch(SQLException sqle){
			ret=false;
		}
		finally{
			if(ping!=null){try{ping.close();}catch(Exception e){}}
		}  
		return ret;
	}
	/**
	 * On libere la connexion
	 */
	public void closeCx() {
		try {
			if (joins!=null){
				joins.clear();
				joins=null;
			}
			if (fields!=null){
				fields.clear();
				fields=null;
			}
			if (datas!=null){
				datas.clear();
				datas=null;
			}
			if (prints!=null){
				prints.clear();
				prints=null;
			}
			if (ruptures!=null){
				ruptures.clear();
				ruptures=null;
			}
			closeT_stat();
			if (cx!=null)
				if (!cx.isClosed())
					cx.close();

		} catch (SQLException e) { e.printStackTrace(); }
	}
	/**
	 * On libere les tables
	 */
	public void closeT_stat() {
		try {

			if (rs!=null) {
				rs.close();
			}
			if (rsTmp!=null) {
				rsTmp.close();
			}

			if(t_stat!=null) {
				t_stat.close();
			}
			if(statTmp!=null) {
				statTmp.close();
			}
		} catch (SQLException e) { e.printStackTrace(); }
	}

	public void addJoin(FieldsJoin join){
		joins.add(join);
		initWar ();
	}
	////////////
	// INIT 
	////////////
	public void initFields() {
		if (fields.size()==0){
			String query="SELECT *, rowid AS RECNO FROM "+getQueryFrom()+getQueryLimit()+"1;";
			ResultSet rs = executeQuery(query);
			try {
				// valorise les champs
				for (int field=0;field<rs.getMetaData().getColumnCount();field++){
					fields.add(new Field(rs.getMetaData().getColumnLabel(field+1)));
				}
				rs.close();
			} catch (SQLException e) {
				System.out.println(getQueryFrom()+" : initField : " + query);
				e.printStackTrace(); }
		}
		initWar();
		initNameTextField();
	}

	private void initWar (){
		// tableau de correspondance Champ de cl et position du champ dans la fiche
		t_indexOrder=new int[t_index.length];
		for (int index=0;index<t_index.length;index++){ // champs de l'index ex: code,clef,cle2
			for (int field=0;field<fields.size();field++){
				if (t_index[index].equals(fields.get(field).t_field)){
					t_indexOrder[index]=field;
				}
			}
		}
	}

	private void initNameTextField() {
		if (fields.get(0).t_lib.length()==0){
			for (int field=0;field<fields.size();field++)
				// pas de nom de colonne
				fields.get(field).t_lib=fields.get(field).t_field;
		}
		if (fields.get(0).t_fieldLength==-1){
			// pas de taille de colonne
			for (int field=0;field<fields.size();field++)
				fields.get(field).t_fieldLength=fields.get(field).t_lib.length();
		}
		if (fields.get(0).t_Fma==null){
			// pas de type
			for (int field=0;field<fields.size();field++)
				fields.get(field).t_Fma=Fma.FIELD;
		}
	}

	public void initData() {
		t_nbFieldWithRowidForData=fields.size()+1;
		t_recnoCol=t_nbFieldWithRowidForData-1;
		// TABLEAU MEMOIRE DE LA TABLE
		datas = new ArrayList<Object[]>(Gp.MAXFIELDS);
		for (int lig=0;lig<t_nbLigne;lig++){
			datas.add(new Object [t_nbFieldWithRowidForData]);
		}
	}
	public String getDataString(String sfield){
		String ret=getData(sfield);
		return ret;
	}
	public double getDataDouble(String sfield){
		double ret=Gp.parseDouble((String)getData(sfield));
		return ret;
	}
	public int getDataInt(String sfield){
		int ret=Gp.parseInt((String)getData(sfield));
		return ret;
	}
	private String getData(String sfield){
		String ret=null;
		for (int field=0;field<fields.size();field++){
			if (fields.get(field).t_field.equals(sfield)){
				ret=(String) datas.get(0)[field];
				break;
			}
		}
		if (ret==null){
			Gp.af("Nom de champs Intouvable : ["+sfield+"]");
		}
		return ret;
	}
	public void setDataString(String sfield,String value){
		setData(sfield,value);
	}
	public void setDataDouble(String sfield,double value){
		setData(sfield,""+value);
	}
	public void setDataInt(String sfield,int value){
		setData(sfield,""+value);
	}
	private void setData(String sfield,String value){
		boolean ok=false;
		for (int field=0;field<fields.size();field++){
			if (fields.get(field).t_field.equals(sfield)){
				datas.get(0)[field]=value;
				ok=true;
				break;
			}
		}
		if (!ok){
			Gp.af("Nom de champs Intouvable : ["+sfield+"]["+value+"]");
		}
	}

	public int getNumField(String sfield){
		int ret=-1;
		for (int field=0;field<fields.size();field++){
			if (fields.get(field).t_field.equals(sfield)){
				ret=field;
				break;
			}
		}
		if (ret==-1){
			Gp.af("Nom de champs Intouvable : ["+sfield+"]");
		}
		return ret;
	}

	public Field getFieldDef(String nameField) {
		Field ret=null;
		if (fields!=null){
			for (int field=0;field<fields.size();field++){
				if (fields.get(field).t_field.equals(nameField)){
					ret=fields.get(field);
					break;
				}
			}
		}
		return ret;
	}
	public Field getFieldDef(int field) {
		Field ret=null;
		if (field<fields.size()){
			ret=fields.get(field);
		}
		return ret;
	}

	//////////////////
	// outils TABLE //
	//////////////////
	public ResultSet dBExecuteQueryOpen(String query){
		ResultSet ret=null;
		Statement stat=null;
		try {
			stat=cx.createStatement();
			if (t_debugQuery){
				if ( debugReadTable.equals(t_table)){
					System.out.println("Open : "+getQueryFrom()+query);
				}
			}
			ret=stat.executeQuery(query);
		} catch (SQLException e) { 
			System.out.println(getQueryFrom()+query);
			e.printStackTrace(); }
		return ret;
	}
	public ResultSet dBExecuteQueryTmp(String query){
		try {
			if (t_debugQuery){
				if ( debugReadTable.equals(t_table)){
					System.out.println("Open : "+getQueryFrom()+query);
				}
			}
			rsTmp=statTmp.executeQuery(query);
		} catch (SQLException e) { 
			System.out.println(getQueryFrom()+query);
			e.printStackTrace(); }
		return rsTmp;
	}
	public void dBExecuteQuerryClose(ResultSet rs) {
		try {
			rs.close();
			rs.getStatement().close();
		} catch (SQLException e) { e.printStackTrace(); }
	}
	//////////////////
	// outils RECNO //
	//////////////////
	public void saveRecno(){
		t_TmpRecno	= t_Recno;
		t_TmpEof	= t_eof;
		v_TmpIndex	= v_index;
		t_saveRecno = true;
	}
	public boolean restoreRecno(){
		boolean ret=false;
		if (t_saveRecno){
			t_Recno	= t_TmpRecno;
			t_eof	= t_TmpEof;
			v_index	= v_TmpIndex;
			t_saveRecno = false;
			ret=true;
		} else {
			//"Attention, Manque un saveRecno"
			Gp.af();			
		}
		return ret;
	}
	//////////////////
	// outils FIELD //
	//////////////////
	public boolean v_indexEqualData(int row) {
		StringBuilder tmp=new StringBuilder();
		String ancV_index=v_index;
		//valorise le t_varia sur la premiere ligne trouve
		if (!datas.isEmpty()){
			for (int index=0;index<t_index.length;index++){
				tmp.append(datas.get(row)[t_indexOrder[index]].toString());
			}
			v_index=tmp.toString();
		}
		if (ancV_index.equals(v_index)) {
			return true;
		} else {
			return false;
		}
	}
	public boolean isV_indexUpdated(int row) {
		StringBuilder tmp=new StringBuilder();
		if (!datas.isEmpty()){
			for (int index=0;index<t_index.length;index++){
				tmp.append(datas.get(row)[t_indexOrder[index]].toString());
			}
		}
		if (tmp.toString().equals(v_index)) {
			return false;
		} else {
			return true;
		}
	}
	public boolean isEmptyV_indexUpdated(int row) {
		boolean ret=false;
		if (!datas.isEmpty()){
			for (int index=0;index<t_index.length;index++){
				if (!datas.get(row)[t_indexOrder[index]].toString().equals("")){
					ret=true;
					break;
				}
			}
		}
		return ret;
	}

	public String getLibeF2(){
		String ret=t_F2fieldLibe;
		t_F2fieldLibe=null;
		return ret;
	}
	public boolean isFieldInIndex(int numfield){
		boolean ret=false;
		for (int index=0;index<t_indexOrder.length;index++){
			if (t_indexOrder[index]==numfield){
				ret=true;
				break;
			}
		}
		return ret;
	}
	public String getField(int numField){
		String ret="";
		try {
			ret=rs.getString(numField+1+t_FirstFieldInSelectForRsGet);
		} catch (SQLException e) {
			System.out.println(getQueryFrom()+" : getField : " +"numField "+numField);
			e.printStackTrace(); }
		return ret;
	}
	public String getField(String t_field) {
		String ret="";
		try {
			ret=rs.getString(t_field);
		} catch (SQLException e) {
			System.out.println(getQueryFrom()+" : getField : " +"t_field "+t_field);
			e.printStackTrace(); }
		return ret;
	}
	////////////////////////
	// GESTION DES MODES  //
	////////////////////////
	public void setMode(int mode) {
		Mode[MODE]=mode;
	}
	public boolean isModeUpdated(){
		boolean ret=false;
		if (Mode[MODE]==MODE_UPDATED)
			ret=true;
		return ret;
	}
	public boolean isModeAppend(){
		boolean ret=false;
		if (Mode[MODE]==MODE_APPEND)
			ret=true;
		return ret;
	}
	public boolean isModeAppendUpdated(){
		boolean ret=false;
		if (Mode[MODE]==MODE_APPENDUPDATED)
			ret=true;
		return ret;
	}
	public boolean isModeMovable(){
		boolean ret=false;
		if (Mode[MODE]==MODE_MOVABLE)
			ret=true;
		return ret;
	}
	public boolean isModeSauve(){
		boolean ret=false;
		if (Mode[MODE]==MODE_SAUVE)
			ret=true;
		return ret;
	}

	//////////////////////
	// MACROS DE QUERRY //
	//////////////////////
	private String getQuerySelect(ArrayList <Field> alField) {
		String[] field=new String[alField.size()];
		for (int i=0;i<field.length;i++){
			field[i]=alField.get(i).t_field;
		}
		return getQuerySelectField(field);
	}
	private String getQuerySelect() {
		String[] field=new String[fields.size()];
		for (int i=0;i<field.length;i++){
			field[i]=fields.get(i).t_field;
		}
		return getQuerySelect(field);
	}
	private String getQuerySelect(String[] t_champ) {
		StringBuilder values=new StringBuilder(STR_BUILD);
		String parantheseouvrante="(";
		String paranthesefermente=")";
		String virgule="";

		values.append(parantheseouvrante);
		for (int i=0;i<t_champ.length;i++){
			if (!t_champ[i].contains(JoinTableName)){
				values.append(virgule+t_champ[i]);
				virgule=",";
			}
		}
		values.append(paranthesefermente);
		return values.toString();
	}	
	private String getQuerySelectIndex() {
		return getQuerySelectField(t_index);
	}
	private String getQuerySelectField(String[]field) {
		// POUR PASSER LA LISTE DE CHAMPS A RECUPERER
		// Liste des champs d'un select
		// c_ordr,c_code

		StringBuilder select=new StringBuilder(STR_BUILD);
		select.append(t_table);
		select.append(".rowid AS RECNO, ");
		String virgule="";
		for (int i = 0;i<field.length;i++){
			select.append(virgule);
			if (!field[i].contains(JoinTableName)){
				select.append(t_table);
				select.append(".");
			}
			select.append(field[i]);
			virgule=",";
		}
		if (t_F2fieldLibe!=null){
			select.append(virgule);
			if (!t_F2fieldLibe.contains(JoinTableName)) {
				select.append(t_table);
				select.append(".");
			}
			select.append(t_F2fieldLibe);
		} 
		return select.toString();
	}	
	private String getQueryFrom(){
		return baseTable;
	}
	private String getOptimisedQueryJoin(String select){
		StringBuilder ret=new StringBuilder(STR_BUILD);
		if (!joins.isEmpty())
			for (int i=0;i<joins.size();i++) {
				if (select.contains(     joins.get(i).aliasTable+JoinTableName     ) || joins.get(i).isNotSpeedable()    ){  
					ret.append(" LEFT JOIN ");
					ret.append(joins.get(i).getJoin());
					ret.append(" ON ");
					ret.append(joins.get(i).getOnjoin(t_table,sqlPipe,sqlconcat));
				} else {
					if (t_debugQuery){
						System.out.println("Sql.getQueryJoin() exclude : "+joins.get(i).joinTable+"/"+t_table+" "+select );
					}
				}
			}
		return ret.toString();
	}
	public String getQueryWhereCurrentRowid(){
		return getQueryWhereRowid(t_Recno);
	}
	private String getQueryWhereRowid(String recno) {
		String whereRowid="";
		if (joins.isEmpty()) {
			whereRowid="rowid="+recno;
		} else {
			whereRowid=t_table+"."+"rowid="+recno;
		}
		return whereRowid;
	}
	private String getIndexPipe(){
		String pipe="";
		StringBuilder wherepipe=new StringBuilder(STR_BUILD*2);
		if (sqlconcat){
			if (t_index.length>1){
				wherepipe.append(CONCAT);
			} else {
				wherepipe.append("(");
			}
		}
		for (int i=0;i<t_index.length;i++){
			wherepipe.append(pipe);
			if (!t_index[i].contains(JoinTableName)) {
				wherepipe.append(t_table);
				wherepipe.append(".");
			}
			wherepipe.append(t_index[i]);
			pipe=sqlPipe;
		}
		if (sqlconcat){
			wherepipe.append(")");
		}
		return wherepipe.toString();
	}
	private String getOrderBy(){
		String pipe="";
		StringBuilder wherepipe=new StringBuilder(STR_BUILD*2);
		if (sqlconcat){
			int nbOrderField=0;
			if (t_filtre!=null){
				nbOrderField=nbOrderField+t_filtre.length;
			}
			nbOrderField=nbOrderField+t_index.length;
			if (nbOrderField>1){
				wherepipe.append(CONCAT);
			} else {
				wherepipe.append("(");
			}
		}
		if (t_filtre!=null){
			for (int i=0;i<t_filtre.length;i++){
				wherepipe.append(pipe);
				if (!t_filtre[i].contains(JoinTableName)) {
					wherepipe.append(t_table);
					wherepipe.append(".");
				}
				wherepipe.append(t_filtre[i]);
				pipe=sqlPipe;
			}
		}
		for (int i=0;i<t_index.length;i++){
			wherepipe.append(pipe);
			if (!t_index[i].contains(JoinTableName)) {
				wherepipe.append(t_table);
				wherepipe.append(".");
			}
			wherepipe.append(t_index[i]);
			pipe=sqlPipe;
		}
		if (sqlconcat){
			wherepipe.append(")");
		}
		return wherepipe.toString();
	}
	private String getQueryWhereIndexFilter(String vv_index) {
		// POUR METTRE A JOUR UN RECORD PARTICULIER
		// Liste des champs d'une clause where de FILTRE
		// c_ordr||c_code = '99"+t_dos+"'
		String cote="'";
		String wherefilter=getIndexPipe()+" = "+cote+setQuerydoubleCote(vv_index)+cote;
		return wherefilter;
	}
	private String getQueryFilter(String[] vt_index,String[] vv_index) {
		// POUR METTRE A JOUR UN RECORD PARTICULIER
		// Liste des champs d'une clause where de FILTRE
		// c_ordr='99' and c_code = 'code'
		String and="";
		String cote="'";
		StringBuilder filter=new StringBuilder(STR_BUILD*2);
		for (int i=0;i<vt_index.length;i++){
			filter.append(and);
			if (!vt_index[i].contains(JoinTableName)) {
				filter.append(t_table);
				filter.append(".");
			}
			filter.append(vt_index[i]);
			filter.append("=");
			filter.append(cote);
			filter.append(setQuerydoubleCote(vv_index[i]));
			filter.append(cote);
			and=" and ";
		}
		if (clauseFilter!=null){
			if (filter.length()>0) {
				filter.insert(0,clauseFilter+and);
			} else {
				filter.setLength(0);
				filter.append(clauseFilter);
			}
		}
		return filter.toString();
	}
	private String getQueryWhereFilter() {
		String whereFilter="";
		if (t_filtre!=null){
			whereFilter="WHERE "+getQueryFilter(t_filtre,v_filtre);
		} else if (clauseFilter!=null){
			whereFilter="WHERE "+clauseFilter;
		}
		return whereFilter;
	}
	private String getQueryAndFilter() {
		String andFiltre="";
		if (t_filtre!=null){
			andFiltre=" AND "+getQueryFilter(t_filtre,v_filtre);
		} else if (clauseFilter!=null){
			andFiltre=" AND "+clauseFilter;
		}

		return andFiltre;
	}

	private String getQuerySet(ArrayList < Field > t_champ,String[] v_champ) {
		//public String getQuerrySet(String[] t_champ,String[] v_champ) {
		// METTRE A JOUR LES CHAMPS D'UN RECORD
		// Liste des champs d'une clause Set
		//c_code = 'v_var1' , c_ordr='v_var2'

		// bug du code vide
		if (v_champ[0].trim().length()==0)
			v_champ[0]=" ";		
		// bug du code vide

		StringBuilder set=new StringBuilder(STR_BUILD*2);
		String cote="'";
		String virgule="";
		for (int i=0;i<t_champ.size();i++){
			if (!t_champ.get(i).t_field.contains(JoinTableName)){
				set.append(virgule);
				set.append(t_champ.get(i).t_field);
				set.append("=");
				set.append(cote);
				set.append(setQuerydoubleCote(v_champ[i]));
				set.append(cote);
				virgule=" , ";
			}
		}
		return set.toString();
	}

	private String getQueryWhereReste(String v_index) {
		// POUR CHARGER UNE LISTE DEPUIS UN RECORD PARTICULIER
		// Liste des champs d'une clause where de POSITION depuis une valeur
		// c_ordr||c_code >= '99"+t_dos+"'
		String cote="'";
		String wherereste=getIndexPipe()+" "+superieur+"= "+cote+setQuerydoubleCote(v_index)+cote;
		return wherereste;
	}
	private String getQueryLike(){
		StringBuilder wherelike=new StringBuilder(STR_BUILD*2);
		StringBuilder whereBeforelike=new StringBuilder(STR_BUILD*2);
		String cote="'";
		char speeder='@';
		StringBuilder textspeed=new StringBuilder(setQuerydoubleCote(v_index));
		StringBuilder value=new StringBuilder("");
		boolean speed=true;
		for (int i=0;i<textspeed.length();i++){
			if (textspeed.charAt(i)==speeder){
				speed=false;
			} else {
				value.append(textspeed.charAt(i));
			}
		}
		String values[]=value.toString().split(" ");
		boolean bval=false;
		for (int i=0;i<values.length;i++){
			if (values[i].trim().length()>0){
				bval=true;
				break;
			}
		}
		if (bval){
			whereBeforelike.append(getQueryBeforeLike(speed));
			String and="";
			wherelike.append("(");
			for (int i=0;i<values.length;i++){
				if (values[i].trim().length()>0){
					wherelike.append(and);
					wherelike.append(whereBeforelike);
					wherelike.append(" like ");
					wherelike.append(cote+"%");
					wherelike.append(values[i]);
					wherelike.append("%"+cote);
					and=" AND ";
				}
			}
			wherelike.append(")");
		}
		return wherelike.toString();
	}
	private String getQueryBeforeLike(boolean speed) {
		// c_ordr||c_code like '%99CODE%'
		String pipe="";
		StringBuilder wherelikereste=new StringBuilder(STR_BUILD*2);
		if (sqlconcat){
			if ((t_index.length+fields.size())>1){
				wherelikereste.append(CONCAT);
			} else {
				wherelikereste.append("(");
			}
		}
		for (int i=0;i<t_index.length;i++){
			wherelikereste.append(pipe);
			if (!t_index[i].contains(JoinTableName)){
				wherelikereste.append(t_table);
				wherelikereste.append(".");
			}
			wherelikereste.append(t_index[i]);
			pipe=sqlPipe;
		}
		boolean isfieldlikable=true;
		for (int i=0;i<fields.size();i++){
			isfieldlikable=true;
			if (fields.get(i).t_field.contains(JoinTableName) && fields.get(i).t_field.contains(" AS ")){
				isfieldlikable=false;
				// Bug sur requete incluant un Join + un calcul + Alias de champs
			}  
			if (fields.get(i).t_field.contains("MAX(")){
				isfieldlikable=false;
				// Bug sur requete incluant un Join + un calcul + Alias de champs
			} 
			if (fields.get(i).t_field.contains("MIN(")){
				isfieldlikable=false;
				// Bug sur requete incluant un Join + un calcul + Alias de champs
			} 
			if (fields.get(i).t_field.contains("COUNT(")){
				isfieldlikable=false;
				// Bug sur requete incluant un Join + un calcul + Alias de champs
			} 
			if (fields.get(i).t_field.contains(JoinTableName) && speed){ // Mode rapide ne prends pas les alias de table jointes
				isfieldlikable=false;
				// Bug sur requete incluant un Join 
			} 
			if (isfieldlikable) {
				wherelikereste.append(pipe);
				if (!fields.get(i).t_field.contains(JoinTableName)){
					wherelikereste.append(t_table);
					wherelikereste.append(".");
				}
				wherelikereste.append(fields.get(i).t_field);
				pipe=sqlPipe;
			}
		}
		if (sqlconcat){
			wherelikereste.append(")");
		}
		return wherelikereste.toString();
	}
	private String getQueryWhereNext() {
		// POUR FAIRE UN SUIVANT
		// Liste des champs d'une clause where de POSITION aprs une valeur
		// c_ordr||c_code > '99"+t_dos+"'
		String cote="'";
		String wherenext=getIndexPipe()+" "+superieur+" "+cote+setQuerydoubleCote(v_index)+cote;
		return wherenext;
	}
	private String getQueryWherePrevious() {
		// POUR FAIRE UN PRECEDENT
		// Liste des champs d'une clause where de POSITION avant une valeur
		// c_ordr||c_code < '99"+t_dos+"'
		String cote="'";
		String whereprevious=getIndexPipe()+" "+inferieur+" "+cote+setQuerydoubleCote(v_index)+cote;
		return whereprevious;
	}
	public String getQueryGroupOrderby() {
		// Liste des champs d'un order by concaten
		// c_ordr||c_code
		String orderby=" ORDER BY "+getOrderBy();
		if (clauseGroupBy!=null){
			orderby=" GROUP BY "+clauseGroupBy+orderby;
		}
		return orderby;
	}
	public void setDesc(boolean desc){
		this.t_desc=desc;
		if (t_desc){
			inferieur=">";
			superieur="<";
		} else {
			inferieur="<";
			superieur=">";
		}

	}
	private String getQueryLimit(){
		if (t_desc)
			return " DESC LIMIT ";
		else
			return " LIMIT ";
	}
	private String getQueryDescLimit(){
		if (t_desc)
			return " LIMIT ";
		else
			return " DESC LIMIT ";
	}
	private String getQueryDefField(ArrayList < Field > t_champ) {
		//SQLLITE c_code VARCHAR NOT NULL ,c_libe VARCHAR NOT NULL";		
		//MYSQL ROWID int(10) unsigned NOT NULL AUTO_INCREMENT,c_code VARCHAR(10) NOT NULL ,c_libe VARCHAR(30) NOT NULL";		
		String virgule="";
		String fieldType="";
		String def="";
		StringBuilder defField=new StringBuilder(STR_BUILD);
		defField.append(" ");
		switch (gp.sqltype){
		case Gp.MYSQL:
			defField.append("ROWID int(10) unsigned NOT NULL AUTO_INCREMENT");
			virgule=" , ";
			break;
		case Gp.SQLITE:
			break;
		}

		for (int i=0;i<t_champ.size();i++){
			Field field= t_champ.get(i);

			if (!field.t_field.contains(JoinTableName)){
				if (fieldType!=null){
					def=getTypeField(field);
					defField.append(virgule+def);
					virgule=" , ";
				} else {
					i=t_champ.size();
					defField.setLength(0);
				}
			}
		}
		return defField.toString();
	}
	private String getTypeField(Field field) {
		//SQLLITE VARCHAR NOT NULL;		
		//MYSQL  VARCHAR(10) NOT NULL;		
		String def="";
		String fieldDefaultValue=field.t_fieldDefaultValue;
		String dvalue="";
		Edit fieldType=field.t_EditType;
		switch (fieldType){
		case F2:
			def="VARCHAR";
			dvalue=" NOT NULL DEFAULT ''";
			break;
		case TEXT:
			def="VARCHAR";
			dvalue=" NOT NULL DEFAULT ''";
			break;
		case DATE:
			def="VARCHAR";
			dvalue=" NOT NULL DEFAULT '  /  /    '";
			break;
		case MONTH:
			def="VARCHAR";
			dvalue=" NOT NULL DEFAULT '  /    '";
			break;
		case YEAR:
			def="VARCHAR";
			dvalue=" NOT NULL DEFAULT '    '";
			break;
		case LIBE:
			def="VARCHAR";
			dvalue=" NOT NULL DEFAULT ''";
			break;
		case TIME:
			def="VARCHAR";
			dvalue=" NOT NULL DEFAULT '00:00'";
			break;
		case PLAGETIMES:
			def="VARCHAR";
			dvalue=" NOT NULL DEFAULT '00:00'";
			break;
		case TIMEDELAY:
			def="VARCHAR";
			dvalue=" NOT NULL DEFAULT '00:0000:0000:00'";
			break;
		case PHONE:
			def="VARCHAR";
			dvalue=" NOT NULL DEFAULT '  -  -  -  -  '";
			break;
		case SECU:
			def="VARCHAR";
			dvalue=" NOT NULL DEFAULT ' -  -  -  -   -   -  '";
			break;
		case URSS:
			def="VARCHAR";
			dvalue=" NOT NULL DEFAULT '   -               '";
			break;
		case POSTAL:
			def="VARCHAR";
			dvalue=" NOT NULL DEFAULT ''";
			break;
		case DOUBLE:
			def="DOUBLE";
			dvalue=" NOT NULL DEFAULT 0.0";
			break;
		case INT:
			def="INTEGER";
			dvalue=" NOT NULL DEFAULT 0";
			break;
		case CHECK:
			def="INTEGER";
			dvalue=" NOT NULL DEFAULT 0";
			break;
		case RADIO:
			def="INTEGER";
			dvalue=" NOT NULL DEFAULT 0";
			break;
		case AREA:
			def="BLOB";
			dvalue=" NOT NULL DEFAULT ''";
			break;
		}
		switch (gp.sqltype){
		case Gp.MYSQL:
			if (def.equals("VARCHAR")){
				def=def+"("+field.t_fieldLength+")";
			}
			break;
		case Gp.SQLITE:
			break;
		}

		if (fieldDefaultValue.length()==0)
			def=def+dvalue;
		else
			def=def+" NOT NULL DEFAULT '"+fieldDefaultValue+"'";
		return field.t_field+" "+def;
	}
	public String getReverseSubstDate(String table,String date){
		StringBuilder ret=new StringBuilder();
		String anne="substr("+table+"."+date+",7,4)";
		String mois="substr("+table+"."+date+",3,4)";
		String jour="substr("+table+"."+date+",1,2)";
		if (sqlconcat){
			ret.append(CONCAT);
		}
		ret.append(anne);
		ret.append(sqlPipe);
		ret.append(mois);
		ret.append(sqlPipe);
		ret.append(jour);
		if (sqlconcat){
			ret.append(")");
		}
		return ret.toString();
	}
	// DB execute Update
	private String getQueryValues(String[] t_champ, String[] v_champ) {
		// APPEND Clause values 
		// ("+t_cham+",c_ordr) values ('"+t_dos+"','"+v_var[1]+"'
		StringBuilder values=new StringBuilder(STR_BUILD);
		String parantheseouvrante="(";
		String paranthesefermente=")";
		values.append(getQuerySelect(t_champ) );
		//		String virgule="";
		//		values.append(parantheseouvrante);
		//		for (int i=0;i<t_champ.length;i++){
		//			if (!t_champ[i].contains(JoinTableName)){
		//				values.append(virgule+t_champ[i]);
		//				virgule=",";
		//			}
		//		}
		//		values.append(paranthesefermente);
		values.append(" VALUES ");
		values.append(parantheseouvrante);

		String cote="'";
		String cotevirgulecote="";
		values.append(cote);
		for (int i=0;i<t_champ.length;i++){
			if (!t_champ[i].contains(JoinTableName)){
				values.append(cotevirgulecote+setQuerydoubleCote(v_champ[i]));
				cotevirgulecote="','";
			}
		}
		values.append(cote);
		values.append(paranthesefermente);
		return values.toString();
	}	
	public String setQuerydoubleCote(String string) {
		StringBuilder tmp=new StringBuilder(STR_BUILD);
		String quot="'";
		char a=quot.charAt(0);
		String antislash="\\";
		char b=antislash.charAt(0);

		for(int len=0;len<string.length();len++)
			if (string.charAt(len)==a) {
				tmp.append("''");
			} else if (string.charAt(len)==';'){
				tmp.append(".");
			} else if (string.charAt(len)==b){
				tmp.append(b+b);
			} else {
				tmp.append(string.charAt(len));
			}

		return tmp.toString();
	}
	///////////////////////////////
	// EXECUTE DE QUERRY D'INDEX //
	///////////////////////////////
	public void dbSetDebutFinByIndex() {
		String sauve_index=v_index;
		t_F2Fin="";
		dBBottomByIndex();
		t_F2Debut="";
		dBTopByIndex();
		v_index=sauve_index;
	}
	private ResultSet executeQuery(String query){
		ResultSet ret=null;
		if (t_debugQuery){
			if ( debugReadTable.equals(t_table)){
				Gp.af();
				System.out.println(this.t_nbLigne+" "+getQueryFrom()+" ==> "+query);
			}
		}
		try {
			ret=t_stat.executeQuery(query);
		} catch (SQLException arg0) { 
			System.out.println(getQueryFrom()+query);
			arg0.printStackTrace(); }
		return ret;
	}
	public void dBTopByIndex(){
		String select=getQuerySelectIndex();
		String whereFilter=getQueryWhereFilter();
		String orderby=getQueryGroupOrderby();
		String query;
		query=t_select+select+" FROM "+getQueryFrom()+" "+getOptimisedQueryJoin(select+whereFilter+orderby)+" "+whereFilter+orderby+getQueryLimit()+"1;";
		rs = executeQuery(query);
		try {
			// recupere son index
			if (rs!=null){
				if (rs.next()) {
					v_index=rsReadIndexByIndex(false);
					t_F2Debut=v_index;
				} else {
					v_index=dbSetIndexEof();
				}
			}
			if (t_debugQuery){
				System.out.println("dbTopByIndex, v_index =!"+v_index+"!");
			}
		} catch (SQLException e) { 
			System.out.println(getQueryFrom()+" : indexTopDb : " + query);
			e.printStackTrace(); }
	}
	public void dBBottomByIndex(){
		String select=getQuerySelectIndex();
		String whereFilter=getQueryWhereFilter();
		String orderby=getQueryGroupOrderby();
		String query;
		query=t_select+select+" FROM "+getQueryFrom()+" "+getOptimisedQueryJoin(select+whereFilter+orderby)+" "+whereFilter+orderby+getQueryDescLimit()+"1;";
		rs = executeQuery(query);
		try {
			// recupere son index
			if (rs.next()) {
				v_index=rsReadIndexByIndex(false);
				t_F2Fin=v_index;
			} else {
				v_index=dbSetIndexEof();
			}
		} catch (SQLException e) { 
			System.out.println(getQueryFrom()+" : indexBottomDb : "+query);
			e.printStackTrace(); 
		}
	}

	public void dBSkapresByIndex(){
		// Fait un next
		String select=getQuerySelectIndex();
		String whereNext=getQueryWhereNext();
		String andFiltre=getQueryAndFilter();
		String orderby=getQueryGroupOrderby();
		String query;
		query=t_select+select+" FROM "+getQueryFrom()+" "+getOptimisedQueryJoin(select+whereNext+andFiltre+orderby)+" WHERE "+whereNext+andFiltre+orderby+getQueryLimit()+"1;";	
		rs = executeQuery(query);
		try {
			// recupere son index
			if (rs.next()) {
				v_index=rsReadIndexByIndex(true);
			} else {
				t_F2Fin=v_index;
				dbSetIndexEof();
			}
		} catch (SQLException e) { 
			System.out.println(getQueryFrom()+" : SeekNextDb : " +query);
			e.printStackTrace(); }
	}
	public void dBSkavantByIndex(){
		// Fait un next-1
		String select=getQuerySelectIndex();
		String wherePrevious=getQueryWherePrevious();
		String andFiltre=getQueryAndFilter();
		String orderby=getQueryGroupOrderby();
		String query;
		query=t_select+select+" FROM "+getQueryFrom()+" "+getOptimisedQueryJoin(select+wherePrevious+andFiltre+orderby)+" WHERE "+wherePrevious+andFiltre+orderby+getQueryDescLimit()+"1;";
		rs =executeQuery(query);
		try {
			// recupere son index
			if (rs.next()) {
				v_index=rsReadIndexByIndex(true);
			} else {
				t_F2Debut=v_index;
				dbSetIndexEof();
			}
		} catch (SQLException e) { 
			System.out.println(getQueryFrom()+" : SeekPreviousDb : " + query);
			e.printStackTrace(); }
	}
	public void dBGoRecnoByRecno(String recno)  {
		if (!recno.equals("")){
			String select=getQuerySelectIndex();
			String whereRowid=getQueryWhereRowid(recno);
			String query;
			query=t_select+select+" FROM "+getQueryFrom()+" "+getOptimisedQueryJoin(select)+" WHERE "+whereRowid+";";
			executeQueryIndexSeek(query);
		}
	}
	public void dBSeekByIndex(String v_seek){
		// Fait un next-1
		String select=getQuerySelectIndex();
		String whereFilter=getQueryWhereIndexFilter(v_seek);
		String andFiltre=getQueryAndFilter();
		String orderby=getQueryGroupOrderby();
		String query;
		query=t_select+select+" FROM "+getQueryFrom()+" "+getOptimisedQueryJoin(select+whereFilter+andFiltre+orderby)+" WHERE "+whereFilter+andFiltre+orderby+getQueryLimit()+"1;";	
		executeQueryIndexSeek(query);
	}
	public void dBSoftSeekByIndex(String v_seek){
		// Fait un next-1
		String select=getQuerySelectIndex();
		String whereFilter=getQueryWhereReste(v_seek);
		String andFiltre=getQueryAndFilter();
		String orderby=getQueryGroupOrderby();
		String query;
		query=t_select+select+" FROM "+getQueryFrom()+" "+getOptimisedQueryJoin(select+whereFilter+andFiltre+orderby)+" WHERE "+whereFilter+andFiltre+orderby+getQueryLimit()+"1;";
		executeQueryIndexSeek(query);
	}
	private void executeQueryIndexSeek(String query){
		rs =executeQuery(query);
		try {
			// recupere son index
			if (rs!=null){
				if (rs.next()) {
					v_index=rsReadIndexByIndex(true);
				} else {
					v_index=dbSetIndexEof();
				}
			} else {
				v_index=dbSetIndexEof();
			}
		} catch (SQLException e) { 
			System.out.println(getQueryFrom()+" : indexSeekDb : " +query);
			e.printStackTrace(); }
	}
	public void dBUpPageByIndex() {
		String select=getQuerySelectIndex();
		String wherePrevious=getQueryWherePrevious();
		String andFiltre=getQueryAndFilter();
		String orderby=getQueryGroupOrderby();
		String query;
		query=t_select+select+" FROM "+getQueryFrom()+" "+getOptimisedQueryJoin(select+wherePrevious+andFiltre+orderby)+" WHERE "+wherePrevious+andFiltre+orderby+getQueryDescLimit()+t_nbLigne+";";
		rs =executeQuery(query);
		try {
			// Trouve le Precedent de l'index
			// et charge a l'envers une page de la table
			// le dernier record correspondra au premier index de la page lors du chargemment 
			//  l'endroit de la page
			//select * from (select rowid from article order by rowid limit 8 )  order by rowid  desc 
			// parcours la liste 
			// le dernier index correspond au dbut page
			while (rs.next()) {
				v_index=rsReadIndexByIndex(false);
			}
			rs.close();
		} catch (SQLException e) { 
			System.out.println(getQueryFrom()+query);
			e.printStackTrace(); }
	}
	public void dBNextPageByIndex() {
		// Trouve le suivant de l'index
		String select=getQuerySelectIndex();
		String whereNext=getQueryWhereNext();
		String andFiltre=getQueryAndFilter();
		String orderby=getQueryGroupOrderby();
		String query;
		query=t_select+select+" FROM "+getQueryFrom()+" "+getOptimisedQueryJoin(select+whereNext+andFiltre+orderby)+" WHERE "+whereNext+andFiltre+orderby+getQueryLimit()+"1;";
		executeQueryIndexSeek(query);
	}
	public void rsSkip(boolean close){
		v_index=rsReadIndex(close);
	}
	private String dbSetIndexEof(){
		t_eof=true;
		t_Recno="";
		return "";
	}
	private String rsReadIndex(boolean close) {
		StringBuilder ret=new StringBuilder(STR_BUILD);
		try {
			rs.next();
			if (rs==null||rs.isAfterLast()||rs.isBeforeFirst()||rs.getRow()==0){
				v_index=dbSetIndexEof();
			} else {
				for (int i=0;i<t_index.length;i++){
					//System.out.println(getQuerryFrom()+":"+t_index[i]);
					// Bug du org.sqlite.RS.findColumn
					// v_index=v_index+rs.getString(t_index[i]);
					// Rs commence  1 plutot que 0
					//System.out.println(getQueryFrom()+"dbReadIndex : "+t_index[i]+":"+t_indexOrder[i]+":");
					if (t_index[i].contains(JoinTableName)){ // READ UN CHAMP PAR SON INDICE DANS LE RS
						ret.append(rs.getString(t_indexOrder[i]+1+t_FirstFieldInSelectForRsGet));
						//ret.append(rs.getString(i+1+t_FirstFieldInSelectForRsGet));
						//System.out.println(t_index[i]+" dbreadindexJ : <"+(t_indexOrder[i])+">: "+rs.getString((t_indexOrder[i]+2)));

					} else { // READ UN CHAMP PAR LE NOM DU CHAMPS
						ret.append(rs.getString(t_index[i]));
					}
				}

				// Valorise le t_recno
				t_eof=false;
				t_Recno=rs.getString("RECNO");
				if (t_F2fieldLibe!=null){
					t_F2fieldLibe=rs.getString(t_F2fieldLibe);
				}
			}
			if (close){
				rs.close();
			}
		} catch (SQLException e) { System.out.println(getQueryFrom()+" rsReadIndex :"+ret+":"); e.printStackTrace(); }
		return  ret.toString();
	}
	public String rsReadIndexByIndex(boolean close) {
		StringBuilder ret=new StringBuilder(STR_BUILD);
		try {
			if (rs==null||rs.isAfterLast()||rs.isBeforeFirst()||rs.getRow()==0){
				v_index=dbSetIndexEof();
			} else {
				for (int i=0;i<t_index.length;i++){
					ret.append(rs.getString(1+i+t_FirstFieldInSelectForRsGet));
				}

				// Valorise le t_recno
				t_eof=false;
				t_Recno=rs.getString("RECNO");
				if (t_F2fieldLibe!=null){
					t_F2fieldLibe=rs.getString(t_F2fieldLibe);
				}
			}
			if (close){
				rs.close();
			}
		} catch (SQLException e) { System.out.println(getQueryFrom()+" rsReadIndex :"+ret+":"); e.printStackTrace(); }
		return  ret.toString();
	}
	public boolean isRs(){
		boolean ret=false;
		try {
			if (rs!=null && rs.next()){
				ret=true;
			}
		} catch (SQLException arg0) {}
		return ret;
	}



	///////////////////////////////////////////////////////
	// CHARGE UN RESULTSET FAIRE UNE OPERATION DB APPRES //
	///////////////////////////////////////////////////////
	public String  rsSoftSeekIndex(String index){
		String ret="";
		String select=getQuerySelectIndex();
		String whereReste=getQueryWhereReste(index);
		String andFiltre=getQueryAndFilter();
		String orderby=getQueryGroupOrderby();
		rsSeek(select,  whereReste, andFiltre, orderby);
		ret=rsReadIndex(true);
		return ret;
	}
	public void rsSoftSeek(){
		String select=getQuerySelect(fields);
		String whereReste=getQueryWhereReste(v_index);
		String andFiltre=getQueryAndFilter();
		String orderby=getQueryGroupOrderby();
		rsSeek(select,  whereReste, andFiltre, orderby);
	}
	public void rsLoadRecno(){
		String select=getQuerySelect(fields);
		String whereRowid=getQueryWhereRowid(t_Recno);
		String whereReste=getQueryWhereReste(v_index);
		String andFiltre=getQueryAndFilter();
		String orderby=getQueryGroupOrderby();
		if (t_Recno.equals("")){
			rsSeek(select,  whereReste, andFiltre, orderby);
		} else {
			rsSeek(select,  whereRowid, andFiltre, orderby);
		}		 
	}

	public void rsSeekByLike(){
		String select=getQuerySelect(fields);
		String likeReste=getQueryLike();
		String andFiltre=getQueryAndFilter();
		String orderby=getQueryGroupOrderby();
		rsSeek(select,  likeReste, andFiltre, orderby);
	}
	private void rsSeek(String select, String likeReste, String andFiltre, String orderby){
		StringBuilder query=new StringBuilder();
		query.append(t_select);
		query.append(select);
		query.append(" FROM ");
		query.append(getQueryFrom());
		query.append(" ");
		query.append(getOptimisedQueryJoin(select+likeReste+andFiltre+orderby));
		if (likeReste.trim().length()==0) {
			likeReste="TRUE";
		}
		query.append(" WHERE ");
		query.append(likeReste);
		query.append(andFiltre);

		query.append(orderby);
		query.append(getQueryLimit());
		query.append(t_nbLigne);
		query.append(";");
		rs = executeQuery(query.toString());
	}
	/////////////////////////////////
	// EXECUTE DE QUERRY DE RECORD //
	/////////////////////////////////
	public boolean rsSetDatas(){
		int nbrecords=0;
		datas.clear();
		// 2) parcours le rs et ajoute une ligne dans la liste pour chaque record
		try {
			while (rs.next()) {
				datas.add(new Object [t_nbFieldWithRowidForData]);
				for (int field=0;field<fields.size();field++){
					// Bug du org.sqlite.RS.findColumn
					//data.get(nbrecords)[field]=rs.getString(nameField[field]);
					// Rs commence  1 plutot que 0
					//System.out.println("Liste loaddb : "+rs.getString(nameField[field]));
					datas.get(nbrecords)[field]=rs.getString(field+1+t_FirstFieldInSelectForRsGet);
					if(datas.get(nbrecords)[field]==null)
						datas.get(nbrecords)[field]="";
				}
				datas.get(nbrecords)[t_recnoCol]=rs.getString("RECNO");
				nbrecords++;
			}
			rs.close();
		} catch (SQLException e) { e.printStackTrace(); }
		if (nbrecords==0){
			//System.out.println(getQueryFrom()+" : dbload : ");
			v_index=dbSetIndexEof();
			t_showSearch=false; // Table vide ne montre pas l'option search
			return false;
		} else {
			if (nbrecords<t_nbLigne) {
				t_showSearch=false; // moins de ligne trouv que prvu;
			} else {
				t_showSearch=true;
			}
			t_eof=false;
			t_Recno=(String) datas.get(0)[t_recnoCol];
			return true;
		}
	}
	public boolean rsSetDatas(int lastSelectRow) {
		int nbrecords=0;
		try {
			if (!t_Recno.equals("")){
				if (rs.next()) {
					for (int field=0;field<fields.size();field++){
						datas.get(lastSelectRow)[field]=rs.getString(field+1+t_FirstFieldInSelectForRsGet);
						if(datas.get(lastSelectRow)[field]==null)
							datas.get(lastSelectRow)[field]="";
						//Gp.afficherTrace(2, (String)data.get(lastSelectRow)[field]);
					}
					datas.get(lastSelectRow)[t_recnoCol]=rs.getString("RECNO");
					//System.out.println("Liste loaddb : "+trace);
					nbrecords++;
				}
			}
			rs.close();
		} catch (SQLException e) { e.printStackTrace(); }
		if (nbrecords==0){
			v_index=dbSetIndexEof();
			return false;
		} else {
			t_eof=false;
			t_Recno=(String) datas.get(lastSelectRow)[t_recnoCol];
			return true;
		}
	}

	public boolean dBInsert() {
		boolean ret=true;
		String v_champ[]=null;
		v_champ=new String[fields.size()];
		boolean filtre=false;
		for (int i=0;i<fields.size();i++){
			if (t_filtre!=null){
				filtre=false;
				for (int j=0;j<t_filtre.length;j++){
					if (fields.get(i).t_field.equals(t_filtre[j])){
						v_champ[i]=v_filtre[j];
						filtre=true;
						break;
					}
				}
			}
			if (!filtre){
				v_champ[i]=(String) datas.get(0)[i];
			}
		}
		ret=dBInsert(v_champ);
		return ret;
	}
	public boolean dBInsert(String[] v_champ) {
		boolean ret=true;
		String[] t_champ=null;
		t_champ=new String[fields.size()];
		for (int i=0;i<fields.size();i++){
			t_champ[i]=fields.get(i).t_field;
		}
		String values=getQueryValues(t_champ,v_champ);
		String query="INSERT INTO "+getQueryFrom()+" "+values+";";
		try {
			t_stat.executeUpdate(query);
			if (t_AccesMode==t_AccesModeRecno)
				t_Recno=t_insert;
		} catch (SQLException e) {
			StringBuilder mess=new StringBuilder("\n "+getQueryFrom()+" CLE UNIQUE : "+v_index+"\n\n");
			String plus="";
			for (int i=0;i<t_index.length;i++){
				mess.append(plus+t_index[i].toUpperCase());
				plus="+";
			}
			mess.append("\n");
			for (int i=0;i<t_champ.length;i++){
				mess.append("\n"+t_champ[i]+"="+v_champ[i].toString());
			}
			mess.append("\n");
			dBMessNotInsert(SQL_ERROR_HARD,mess.toString());
			ret=false;
		}
		return ret;
	}
	public boolean dBUpdateByRecno(String[] v_champ){
		boolean ret=true;
		if (t_Recno.trim().length()==0){
			ret=dBInsert(v_champ);
		} else {
			String set=getQuerySet(fields, v_champ);
			String whereRowid=getQueryWhereRowid(t_Recno);
			String query="UPDATE "+getQueryFrom()+" SET "+set+" WHERE "+whereRowid+";";
			if (t_debugQuery){
				System.out.println(query);
			}
			try {
				t_stat.executeUpdate(query);
			} catch (SQLException e) { 
				dBMessNotUpdate(SQL_ERROR_HARD,query);
				ret=false;
				e.printStackTrace(); }
		}
		return ret;
	}
	public boolean dBDeleteByRecno()  {
		boolean ret=true;
		String whereRowid=getQueryWhereRowid(t_Recno);
		String query="DELETE FROM "+getQueryFrom()+" WHERE "+whereRowid+";";
		// 1) delete
		try {
			t_stat.executeUpdate(query);
		} catch (SQLException e) {
			dBMessNotDelete(SQL_ERROR_HARD,query);
			ret=false;
			e.printStackTrace(); }
		return ret;
	}
	public void dBMessNotInsert(int type,String mess){
		switch (type){
		case SQL_ERROR_HARD:
			JOptionPane.showMessageDialog(getMf(), "Cration impossible, (existe dj) :\n"+mess,"Attention !!!", JOptionPane.INFORMATION_MESSAGE);
			break;
		case SQL_ERROR_SOFT:
			JOptionPane.showMessageDialog(getMf(), "Cette fiche : ["+v_index+"] est dj cre, Il convient de la modifier, ou de changer de code","Attention !!!", JOptionPane.INFORMATION_MESSAGE);
			break;
		}
	}
	public void dBMessNotUpdate(int type,String mess){
		switch (type){
		case SQL_ERROR_HARD:
			JOptionPane.showMessageDialog(getMf(), "Mise  jour impossible :\n["+mess+"]","Attention !!!", JOptionPane.INFORMATION_MESSAGE);
			break;
		case SQL_ERROR_SOFT:
			JOptionPane.showMessageDialog(getMf(), "Cette fiche : ["+v_index+"] est dj cre, Il convient de la modifier, ou de changer de code","Attention !!!", JOptionPane.INFORMATION_MESSAGE);
			break;
		}
	}
	public void dBMessNotDelete(int type,String mess){
		switch (type){
		case SQL_ERROR_HARD:
			JOptionPane.showMessageDialog(getMf(), "Effacement impossible :\n["+mess+"]","Attention !!!", JOptionPane.INFORMATION_MESSAGE);
			break;
		case SQL_ERROR_SOFT:
			JOptionPane.showMessageDialog(getMf(), "Cette fiche : ["+v_index+"] n'existe pas, Il convient de la modifier, ou de changer de code","Attention !!!", JOptionPane.INFORMATION_MESSAGE);
			break;
		}
	}
	public boolean dBExecuteUpdate(String query){
		boolean ret=true;
		try {
			if (t_stat==null){
				Gp.MB("Opration impossible t_stat est Null");
			} else {
				t_stat.executeUpdate(query);
			}
		} catch (SQLException e) { 
			System.out.println(getQueryFrom()+query);
			ret=false;
			e.printStackTrace(); }
		return ret;
	}
	public boolean dBExecuteSeekEof(String query){
		boolean ret=false;
		try {
			ResultSet rs=t_stat.executeQuery(query);
			if (!rs.next())
				ret=true;
			rs.close();
		} catch (SQLException arg0) {
			arg0.printStackTrace();
		}
		return ret;
	}

	//////////////////////// 
	// Outils Autre table //
	//////////////////////// 
	// String
	public String readFOStringValue(String table, String where, String index,String filter,String order,String value){
		return (String) readValue(table,where,index,filter,order,0,value);
	}
	public String readFStringValue(String table, String where, String index,String filter,String value){
		return (String) readValue(table,where,index,filter,null,0,value);
	}
	public String readOStringValue(String table, String where, String index,String order,String value){
		return (String) readValue(table,where,index,null,order,0,value);
	}
	public String readStringValue(String table, String where, String index,String value){
		return (String) readValue(table,where,index,null,null,0,value);
	}
	// Int
	public int readFOIntValue(String table, String where, String index,String filter,String order,String value){
		return (Integer) readValue(table,where,index,filter,order,1,value);
	}
	public int readFIntValue(String table, String where, String index,String filter,String value){
		return (Integer) readValue(table,where,index,filter,null,1,value);
	}
	public int readOIntValue(String table, String where, String index,String order,String value){
		return (Integer) readValue(table,where,index,null,order,1,value);
	}
	public int readIntValue(String table, String where, String index,String value){
		return (Integer) readValue(table,where,index,null,null,1,value);
	}
	// Double
	public double readFODoubleValue(String table, String where, String index,String filter,String order,String value){
		return (Double) readValue(table,where,index,filter,order,2,value);
	}
	public double readFDoubleValue(String table, String where, String index,String filter,String value){
		return (Double) readValue(table,where,index,filter,null,2,value);
	}
	public double readODoubleValue(String table, String where, String index,String order,String value){
		return (Double) readValue(table,where,index,null,order,2,value);
	}
	public double readDoubleValue(String table, String where, String index,String value){
		return (Double) readValue(table,where,index,null,null,2,value);
	}
	// boolean
	public boolean readFOBooleanValue(String table, String where, String index,String filter,String order,String value){
		return (Boolean) readValue(table,where,index,filter,order,3,value);
	}
	public boolean readFBooleanValue(String table, String where, String index,String filter,String value){
		return (Boolean) readValue(table,where,index,filter,null,3,value);
	}
	public boolean readOBooleanValue(String table, String where, String index,String order,String value){
		return (Boolean) readValue(table,where,index,null,order,3,value);
	}
	public boolean readBooleanValue(String table, String where, String index,String value){
		return (Boolean) readValue(table,where,index,null,null,3,value);
	}
	// les seek
	public boolean readFOSeek(String table, String where, String index,String filter,String order){
		return (Boolean) readValue(table,where,index,filter,order,9,null);
	}
	public boolean readFSeek(String table, String where, String index,String filter){
		return (Boolean) readValue(table,where,index,filter,null,9,null);
	}
	public boolean readOSeek(String table, String where, String index,String order){
		return (Boolean) readValue(table,where,index,null,order,9,null);
	}
	public boolean readSeek(String table, String where, String index){
		return (Boolean) readValue(table,where,index,null,null,9,null);
	}
	private Object readValue(String table, String where, String index,String filter,String order,int type,String value){
		Object ret=null;
		StringBuilder squery=new StringBuilder(STR_BUILD);
		try {
			squery.append(t_select+value+" FROM  "+table+" WHERE "+getKey(where)+"='"+index+"'");
			if (filter!=null){
				squery.append(" AND ("+filter+")");
			}
			if (order!=null){
				squery.append(" ORDER BY "+order);
			}
			squery.append(" LIMIT 1;");
			if (t_debugQuery){
				if ( debugReadTable.equals(t_table)){
					System.out.println("Open : "+getQueryFrom()+squery.toString());
				}
			}
			rsTmp=statTmp.executeQuery(squery.toString());
			if (rsTmp.next()){
				switch (type){
				case 0:
					ret=rsTmp.getString(value);
					break;
				case 1:
					ret=rsTmp.getInt(value);
					break;
				case 2:
					ret=rsTmp.getDouble(value);
					break;
				case 3:
					ret=rsTmp.getBoolean(value);
					break;
				case 9:
					ret=true;
					break;
				}
			} else {
				switch (type){
				case 0:
					ret="";
					break;
				case 1:
					ret=0;
					break;
				case 2:
					ret=0.0;
					break;
				case 3:
					ret=false;
					break;
				case 9:
					ret=false;
					break;
				}
			}
		} catch (SQLException e) { 
			ret="";
			System.out.println(getQueryFrom()+squery.toString());
			e.printStackTrace(); }
		return ret;
	}
	public void writeValue(String table,String values,String where){
		String query="UPDATE "+table+" SET "+values+" WHERE "+where+";";
		try {
			t_stat.executeUpdate(query);
		} catch (SQLException e) { 
			System.out.println(query);
			e.printStackTrace(); }
	}
	public void writeValueAll(String table,String values){
		String query="UPDATE "+table+" SET "+values+";";
		try {
			t_stat.executeUpdate(query);
		} catch (SQLException e) { 
			System.out.println(query);
			e.printStackTrace(); }
	}

	private String getKey(String key){
		StringBuilder ret= new StringBuilder(STR_BUILD);
		String tmpkey[]=key.split("\\+");
		if (sqlconcat){
			if (tmpkey.length>1){
				ret.append(CONCAT);
			} else {
				ret.append("(");
			}
		}
		String pipe="";
		for (int i=0;i<tmpkey.length;i++){
			ret.append(pipe+tmpkey[i]);
			pipe=sqlPipe;
		}
		if (sqlconcat){
			ret.append(")");
		}
		return ret.toString();
	}
	///////////////////////////////////////
	// Interface de maintenance de table //
	///////////////////////////////////////
	public boolean isTableExist() {
		boolean ret=false;
		ret=isTable(t_table);
		return ret;
	}
	public boolean isTable(String name){
		boolean ret=false;
		try {
			DatabaseMetaData dbmd=cx.getMetaData();
			ResultSet rs = dbmd.getTables(null, null, null,new String[] {"TABLE"});
			while (rs.next()){
				if (rs.getString("TABLE_NAME").toUpperCase().equals(name.toUpperCase()))
					ret=true;
			}
			rs.close();
		} catch (SQLException e) {
			System.out.println(getQueryFrom()+" isT_table "+ret);
			e.printStackTrace(); }
		return ret;
	}
	public void createTable() {
		createTable(false);
	}
	public void createTable(boolean confirm) {
		if (!isTableExist()){
			int retour=JOptionPane.NO_OPTION;
			if (confirm){
				retour = JOptionPane.showConfirmDialog(getMf(),"Crer cette table :'"+t_table+"'", "Attention la table n'xiste pas !!!",JOptionPane.YES_NO_OPTION);
			} else {
				retour=JOptionPane.OK_OPTION;
			}
			if (retour==JOptionPane.OK_OPTION){
				String defField=getQueryDefField(fields);
				if (defField!=null){
					String query="";
					String uniquekey=getUniqueKey();
					String primarykey=getPrimaryKey();
					switch (gp.sqltype){
					case Gp.MYSQL:
						query="CREATE TABLE "+getQueryFrom()+"("+defField+","+uniquekey+","+primarykey+");";
						break;
					case Gp.SQLITE:
						query="CREATE TABLE "+getQueryFrom()+"("+defField+","+uniquekey+");";
						break;
					}
					try {
						t_stat.executeUpdate(query);
					} catch (SQLException e) { 
						System.out.println(query);
						e.printStackTrace(); }
				}
			}
		}
	}
	public void createTemporarySinceTable() {
		createTemporaryTable(false);
	}
	public void createTemporaryTable(boolean confirm) {
		String tmptable=t_table+"_tmp";
		if (!isTable(tmptable)){
			int retour=JOptionPane.NO_OPTION;
			if (confirm){
				retour = JOptionPane.showConfirmDialog(getMf(),"Crer cette table temporaire :'"+tmptable+"'", "Attention la table n'xiste pas !!!",JOptionPane.YES_NO_OPTION);
			} else {
				retour=JOptionPane.OK_OPTION;
			}
			if (retour==JOptionPane.OK_OPTION){
				String defField=getQueryDefField(fields);
				if (defField!=null){
					String query="";
					String uniquekey=getUniqueKey();
					String primarykey=getPrimaryKey();
					switch (gp.sqltype){
					case Gp.MYSQL:
						query="CREATE TEMPORARY TABLE "+getQueryFrom()+"_tmp "+"("+defField+","+uniquekey+","+primarykey+");";
						break;
					case Gp.SQLITE:
						query="CREATE TEMPORARY TABLE "+getQueryFrom()+"_tmp "+"("+defField+","+uniquekey+");";
						break;
					}
					try {
						t_stat.executeUpdate(query);
					} catch (SQLException e) { 
						System.out.println(query);
						e.printStackTrace(); }
				}
			}
		}
	}
	public void dropTemporaryTable() {
		dropTemporaryTable(false);
	}
	public void dropTemporaryTable(boolean confirm) {
		String tmptable=t_table+"_tmp";
		if (!isTable(tmptable)){
			int retour=JOptionPane.NO_OPTION;
			if (confirm){
				retour = JOptionPane.showConfirmDialog(getMf(),"Supprimer cette table :'"+tmptable+"'", "Attention cette table va tre supprimer !!!",JOptionPane.YES_NO_OPTION);
			} else {
				retour=JOptionPane.OK_OPTION;
			}
			if (retour==JOptionPane.OK_OPTION){
				dBExecuteUpdate("DROP TABLE "+getQueryFrom()+"_tmp"+";");
			}
		}
	}
	public void insertTemporarySinceTable(String where){
		String select=getQuerySelect();
		String selectCol=select.substring(1, select.length()-1);
		String query;
		query="INSERT INTO "+getQueryFrom()+"_tmp  "+select+" SELECT "+selectCol+" FROM "+getQueryFrom()+" WHERE "+where+";";
		try {
			t_stat.executeUpdate(query);
		} catch (SQLException e) { 
			System.out.println(query);
			e.printStackTrace(); }
	}
	public void insertFromTemporaryTable(String where){
		String select=getQuerySelect();
		String selectCol=select.substring(1, select.length()-1);
		String query;
		query="INSERT INTO "+getQueryFrom()+select+" SELECT "+selectCol+" FROM "+getQueryFrom()+"_tmp  WHERE "+where+";";
		try {
			t_stat.executeUpdate(query);
		} catch (SQLException e) { 
			System.out.println(query);
			e.printStackTrace(); }
	}
	public void updateTemporarySinceTable(String values,String where){
		String query="UPDATE "+getQueryFrom()+"_tmp SET "+values+" WHERE "+where+";";
		try {
			t_stat.executeUpdate(query);
		} catch (SQLException e) { 
			System.out.println(query);
			e.printStackTrace(); }
	}
	public boolean isNewTableField() {
		boolean ret=false;
		ret=isOrAltertable(false);
		return ret;
	}
	public void alterNewTableField() {
		alterNewTableField(false);
	}
	public void alterNewTableField(boolean confirm) {
		if (isNewTableField()){
			int retour=JOptionPane.NO_OPTION;
			if (confirm){
				retour = JOptionPane.showConfirmDialog(getMf(),"Modifier cette table :'"+t_table+"'", "Attention cette table va tre modifier !!!",JOptionPane.YES_NO_OPTION);
			} else {
				retour=JOptionPane.OK_OPTION;
			}
			if (retour==JOptionPane.OK_OPTION){
				isOrAltertable(true);
			}
		}
	}
	private boolean isOrAltertable(boolean alterTable){
		boolean ret=false;
		ResultSet rs;
		ResultSetMetaData rsmd;
		ArrayList < String[] > tablefield=new ArrayList < String[] >(Gp.MAXFIELDS);
		String query=t_select+" * FROM "+getQueryFrom()+getQueryLimit()+"1;";
		rs = executeQuery(query);
		try {
			rsmd = rs.getMetaData();
			for (int i=0;i<rsmd.getColumnCount();i++){
				tablefield.add(new String[3]);
				tablefield.get(i)[0]=rsmd.getColumnName(i+1);
				tablefield.get(i)[1]=rsmd.getColumnTypeName(i+1);
			}
			rs.close();
		} catch (SQLException e) { e.printStackTrace();}

		// Structure Field VS Struture table 
		boolean newfield=false;
		for (int field=0;field<fields.size();field++){ // parcours la liste des champs Prvu au programme
			//System.out.println(fields.get(field).t_field);
			boolean fieldexist=false;
			if (!fields.get(field).t_field.contains(JoinTableName)){
				for (int table=0;table<tablefield.size();table++){ // parcours la liste des champs de la table
					if (fields.get(field).t_field.equals(tablefield.get(table)[0])){
						fieldexist=true;
						table=tablefield.size();
					}
				}
				if (!fieldexist){
					newfield=true;
					//System.out.println("!le champs : "+fields.get(field).t_field+"!"+" n'xiste pas");
					if (alterTable){
						String defField=getTypeField(fields.get(field));
						try {
							//System.out.println("ALTER TABLE "+getQueryFrom()+" ADD "+defField+";");
							t_stat.executeUpdate("ALTER TABLE "+getQueryFrom()+" ADD "+defField+";");
						} catch (SQLException e) { e.printStackTrace(); }
					} else {
						field=fields.size();
					}
				}
			}
		}

		if (newfield){
			ret=true;
		}

		return ret;
	}
	public void dropTable() {
		dropTable(false);
	}
	public void dropTable(boolean confirm) {
		if (isTableExist()){
			int retour=JOptionPane.NO_OPTION;
			if (confirm){
				retour = JOptionPane.showConfirmDialog(getMf(),"Supprimer cette table :'"+t_table+"'", "Attention cette table va tre supprimer !!!",JOptionPane.YES_NO_OPTION);
			} else {
				retour=JOptionPane.OK_OPTION;
			}
			if (retour==JOptionPane.OK_OPTION){
				dBExecuteUpdate("DROP TABLE "+t_table);
			}
		}
	}
	public void renameTable(String name) {
		renameTable(name,false);
	}
	public void renameTable(String name,boolean confirm) {
		boolean rename=true;
		if (rename){
			if (!isTableExist()){
				if (confirm){
					Gp.MB("La table "+t_table+" n'existe pas !");
				}
				rename=false;
			}
		}
		if (rename){
			if (name.trim().length()==0){
				if (confirm){
					Gp.MB("Mettre un nom conforme, merci");
				}
				rename=false;
			}
		}
		if (rename){
			if (t_table.equals(name)){
				if (confirm){
					Gp.MB("Les noms doivent-tre diffrent, merci");
				}
				rename=false;
			}
		}
		if (rename){
			int retour=JOptionPane.NO_OPTION;
			if (confirm){
				retour = JOptionPane.showConfirmDialog(getMf(),"Renommer cette table :'"+t_table+"' en :'"+name+"'", "Attention cette table va tre renommer !!!",JOptionPane.YES_NO_OPTION);
			} else {
				retour=JOptionPane.OK_OPTION;
			}
			if (retour==JOptionPane.OK_OPTION){
				boolean notify=false;
				notify=dBExecuteUpdate("ALTER TABLE "+t_table+" RENAME TO "+name+";");
				if (confirm){
					if (notify){
						Gp.MB("La table  t renomme");
					} else {
						Gp.MB("La table n'a pas t renomme");
					}
				}
			}
		}
	}
	///////////////////////////////////////
	// Interface de maintenance de table //
	///////////////////////////////////////
	private String getUniqueKey() {
		StringBuilder uniquekey=new StringBuilder(STR_BUILD);
		switch (gp.sqltype){
		case Gp.MYSQL:
			uniquekey.append(" UNIQUE code (");
			break;
		case Gp.SQLITE:
			uniquekey.append(" UNIQUE (");
			break;
		}
		String virgule="";
		if (t_filtre!=null){
			for (int i = 0;i<t_filtre.length;i++){
				if (!t_filtre[i].contains(JoinTableName)){
					uniquekey.append(virgule+t_filtre[i]);
					virgule=",";
				}
			}
		}
		for (int i = 0;i<t_index.length;i++){
			if (!t_index[i].contains(JoinTableName)){
				uniquekey.append(virgule+t_index[i]);
				virgule=",";
			}
		}
		uniquekey.append(")");
		return uniquekey.toString();
	}
	private String getPrimaryKey() {
		String primary=" PRIMARY KEY (ROWID)";
		return primary;
	}
	public void dBTruncate() {
		try {
			t_stat.executeUpdate("DELETE FROM "+getQueryFrom()+";");
		} catch (SQLException e) { 
			System.out.println(getQueryFrom()+" : Dbtruncate : " + "DELETE FROM "+getQueryFrom()+";");
			e.printStackTrace(); }
	}
	/*	public void dBexportData(String filename, String seek, int nbLigne) {
	String select=getQuerySelect(t_index);
	String whereReste=getQueryWhereReste(seek);
	String andFiltre=getQueryAndFilter();
	String orderby=getQueryGroupOrderby();
	String query=t_select+select+"  into OUTFILE  '"+filename+"' FIELDS TERMINATED BY ','  FROM "+getQueryFrom()+" "+getQueryJoin()+" WHERE "+whereReste+andFiltre+orderby+getQueryLimit()+nbLigne+";";
	try {
		rs=t_stat.executeQuery(query);
	} catch (SQLException e) { 
		System.out.println(query);
		e.printStackTrace(); }
}*/

	public String getCodeFiche(){
		StringBuilder ret=new StringBuilder(STR_BUILD);
		if (v_filtre!=null){
			for (int i=0;i<v_filtre.length;i++){
				ret.append(v_filtre[i]);
			}
			if (v_filtre.length>0){
				ret.append("."+v_index);
			} else {
				ret.setLength(0);
				ret.append(v_index);
			}

		} else {
			ret.setLength(0);
			ret.append(v_index);
		}
		return ret.toString();
	}
	public String debugSql() {
		String ret="\n";
		if (clauseFilter!=null)
			ret=ret+"\n ClauseFilter->"+clauseFilter+"<-";
		if (clauseGroupBy!=null)
			ret=ret+"\n clauseGroupBy->"+clauseGroupBy+"<-";

		if (t_index!=null){
			ret=ret+"\n t_index->"+"<-->";
			for (int i=0;i<t_index.length;i++)
				ret="!"+t_index[i];
			ret=ret+"!";
		}
		if (v_index!=null)
			ret=ret+"\n v_index->"+v_index+"<-";
		if (t_F2Debut!=null)
			ret=ret+"\n t_F2Debut->"+t_F2Debut+"<-";
		if (t_F2Fin!=null)
			ret=ret+"\n t_F2Fin->"+t_F2Fin+"<-";
		if (t_Recno!=null)
			ret=ret+"\n t_Recno->"+t_Recno+"<-";

		ret=ret+"\n t_eof->"+t_eof+"<-";
		return ret;
	}

	public void setDebugQuery(boolean enable) {
		t_debugQuery=enable;
		if (t_debugQuery){
			debugReadTable=t_table;
		} else {
			debugReadTable="";
		}
	}
	public void dispose() {
		gp=null;
		cx=null;
		rs=null;
		rsTmp=null;
		statTmp=null;
		taThis=null;
		taTwin=null;
		taParent=null;
		sqlTwin=null;
		t_stat=null;
		if (fields!=null){
			fields.clear();
			fields=null;
		}
		if (datas!=null){
			datas.clear();
			datas=null;
		}
		if (prints!=null){
			prints.clear();
			prints=null;
		}
		if (ruptures!=null){
			ruptures.clear();
			ruptures=null;
		}
		if (printsFilter!=null){
			printsFilter=null;
		}
		if (joins!=null){
			joins.clear();
			joins=null;
		}
		t_F2			= null;
		t_PLAGETIMES	= null;
		t_F2Popup		= null;
	}
	protected void finalize()  {
		//Gp.af("finalize : "+this.getClass().getName()+" "+t_table);
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
	public void debugDatas() {
		for (int field=0;field<fields.size();field++){
			Gp.af(fields.get(field).t_field+" ["+datas.get(0)[field]+"]");
		}
	}
	// Liaison avec GP
	public Gp getGp() {
		return gp;
	}
	public Gp getGpAbc(){
		return gp.gpAbc;
	}
	public JFrame getMf(){
		return gp.gpAbc.f_mf;
	}
	public boolean isDevFile(){
		return gp.gpAbc.ISDEVFILE;
	}
	public Sql getSqlAbc(){
		return gp.gpAbc.sqlAbc;
	}
	public String getUser(){
		return gp.gpAbc.m_user;
	}
	public String getOption(){
		return gp.gpAbc.m_option;
	}
	public String getOptionText(){
		return gp.gpAbc.m_optionText;
	}
	public String getMenu(){
		return gp.gpAbc.m_menu;
	}
	public void setUser(String m_user){
		gp.gpAbc.m_user=m_user;
	}
	public void setCursorWait(boolean enabled){
		gp.gpAbc.setCursorWait(enabled);
	}
	public void setTextStatusFiche(String west, String east) {
		if (isDevFile()){
			gp.gpAbc.f_mjStatusBar.setTextStatusFiche(gp.gpAbc.m_option+"|"+west, east);
		} else {
			gp.gpAbc.f_mjStatusBar.setTextStatusFiche(west, east);
		}
	}
	public void setTextStatusFicheEdit(String txt) {
		gp.gpAbc.f_mjStatusBar.setTextStatusFicheEdit(txt);
	}
	public void setTextStatus(String west, String center, String east) {
		gp.gpAbc.f_mjStatusBar.setTextStatus(west, center, east);
	}
	public void setIcon(AbstractJDialogDb abstractJDialogDb) {
		gp.gpAbc.setIcon(abstractJDialogDb);
	}
	public void clearMainFrame(boolean enable) {
		gp.gpAbc.clearMainFrame(enable);
	}
	public void loadMenu() {
		gp.gpAbc.loadMenu();
	}
	public void applyPreferences(String user) {
		gp.gpAbc.applyPreferences(user);
	}
	public AbstractDefaultParam getAppliParam() {
		return gp.gpAbc.appliParam;
	}
	public boolean isTcetorp() {
		return gp.gpAbc.isTcetorp();
	}
	public Image getImage(String name, boolean transp) {
		return gp.gpAbc.getImage(name, transp);
	}
	public Icon ImageIcon(Image img, int coef) {
		return gp.gpAbc.ImageIcon(img, coef);
	}
	public int notify(String titre, String mess, Object[] option, String nameImage, int defOption) {
		return gp.gpAbc.notify(titre, mess, option, nameImage, defOption);
	}
	public void removeDbVue(boolean enable) {
		gp.gpAbc.removeDbVue(enable);
	}
	public JPanel getPanelTitleMenuOptionText() {
		return gp.gpAbc.getPanelTitleMenuOptionText();
	}
	public String restoreLastUserFromSystem() {
		return gp.gpAbc.restoreLastUserFromSystem();
	}
	public Sql getSql() {
		return gp.gpAbc.sql;
	}
	public String geth() {
		return gp.gpAbc.geth();
	}
	public String getdecah(String decamehex) {
		return gp.gpAbc.getdecah(decamehex);
	}
	public void setTcetorp() {
		gp.gpAbc.setTcetorp();
	}
	public JPanel getMjpc() {
		return gp.gpAbc.f_mjpc;
	}
	public String getOpt2() {
		return gp.gpAbc.m_c_opt2;
	}
	public String getOpt3() {
		return gp.gpAbc.m_c_opt3;
	}
	public boolean isCodeBarre(int num) {
		return gp.gpAbc.isCodeBarre(num);
	}
	public Ms1204 getCbMS1204(int num) {
		return gp.gpAbc.getCodeBarreMs1204(num);
	}
	public boolean isImpDot(int num) {
		return gp.gpAbc.isImpDot(num);
	}
	// Clavier
	public boolean isCtrlMask() {
		return gp.gpAbc.isCtrlMask();
	}
	public boolean isShiftMask() {
		return gp.gpAbc.isShiftMask();
	}
	public void setTable(String t_table) {
		this.t_table=t_table;
		switch (gp.sqltype){
		case Gp.MYSQL:
			baseTable=gp.base+JoinTableName+t_table;
			break;
		case Gp.SQLITE:
			baseTable=t_table;
			break;
		}
	}
}
