package table_standard.wS_field;

import persistance.wSql.AbstractFieldsDef;
import persistance.wSql.Edit;
import persistance.wSql.Sql;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.Fma;
/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class S_fieldFICHE extends AbstractFieldsDef {
	public S_fieldFICHE(Sql sql,Vue vue) {
		super(sql,vue);
	}
	public Object adapteField(Vue vue){
		t_table="s_field";
		t_nbLigne=1;
		t_filtre=null;
		v_filtre=null;
		t_index=new String[]{"c_code","c_tvue","c_ordr"};
		switch (vue){
		default:{
			addSqlField("c_code" ,30,Fma.F2	,"Fichier"			,"",Edit.F2,"");
			addSqlField("c_tvue" , 3,Fma.F2  	,"Type de Vue"		,"",Edit.F2,"");
			addSqlField("c_ordr" , 2,Fma.NUM 	,"Ordre"			,"",Edit.F2,"");
			
			addSqlField("c_fiel" ,35,Fma.F2	,"Nom du champs"		,"",Edit.F2,"");
			addSqlField("c_lenf" , 2,Fma.NUM 	,"Longueur de la saisie","",Edit.F2,"");
			addSqlField("c_taff" , 3,Fma.F2  	,"Type d'affichage du champs","",Edit.F2,"");
			addSqlField("c_libe" ,35,Fma.FIELD,"Libelle sur la fiche"		,"",Edit.TEXT,"");
			
			addSqlField("c_aide" ,120,Fma.FIELD,"Aide tooltip","",Edit.TEXT,"");
			addSqlField("c_tfie" ,10,Fma.F2  	,"Type FIELD"	,"",Edit.F2,"");
			addSqlField("c_defa" ,10,Fma.FIELD,"Valeur par Default"		,"",Edit.TEXT,"");
			break;}
		}
		return this;
	}
}
