package table_standard.wS_field;


import javax.swing.JComponent;
import javax.swing.JPanel;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import table_standard.wS_files.S_filesVUE;
import template_applicatif.wFiche.AbstractDbFiche;
import template_applicatif.wFiche.FicheIEditableColumns;
import template_applicatif.wListe.ListeIEditableColumn;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextDb;
import composant_saisie.wComposant.JTextDbF2;
import composant_saisie.wSaisieFormat.Ccs;
/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class S_fieldSAISIE extends AbstractDbFiche {
	private static final long serialVersionUID = 1L;
	JTextDb lcode,ltvue,lordr,lfiel,llenf,ltaff,llibe,laide,ltfie,ldefa;
	JTextDbF2 	code=null;
	JTextDbF2 	tvue=null;
	JTextDb 	ordr=null;
	JTextDb 	fiel=null;
	JTextDb 	lenf=null;
	JTextDbF2 	taff=null;
	JTextDb 	libe=null;
	JTextDb 	aide=null;
	JTextDbF2 	tfie=null;
	JTextDb 	defa=null;
	public S_fieldSAISIE(Sql sql) {
		super(sql);
		initStart();
	}
	public void initCreateLE() {
		lcode=new JTextDb();
		ltvue=new JTextDb();
		lordr=new JTextDb();
		lfiel=new JTextDb();
		llenf=new JTextDb();
		ltaff=new JTextDb();
		llibe=new JTextDb();
		laide=new JTextDb();
		ltfie=new JTextDb();
		ldefa=new JTextDb();
		code	=new JTextDbF2(new S_filesVUE(sql,"",Vue.F2F3));
		tvue	=new JTextDbF2(new S_fieldTvueVUE(sql,"",Vue.F2F3));
		ordr	=new JTextDb();
		//fiel	=new JTextF2Db(new S_filesfieldVUE(sql,"",Vue.F2F3));
		fiel	=new JTextDb();
		lenf	=new JTextDb();
		taff	=new JTextDbF2(new S_fieldTaffVUE(sql,"",Vue.F2F3));
		libe	=new JTextDb();
		aide	=new JTextDb();
		tfie	=new JTextDbF2(new S_fieldTypeVUE(sql,"",Vue.F2F3));
		defa	=new JTextDb();
	}
	public void initMapLE() {
		ccs.mapL(this,lcode,0);
		ccs.mapL(this,ltvue,1);
		ccs.mapL(this,lordr,2);
		ccs.mapL(this,lfiel,3);
		ccs.mapL(this,llenf,4);
		ccs.mapL(this,ltaff,5);
		ccs.mapL(this,llibe,6);
		ccs.mapL(this,laide,7);
		ccs.mapL(this,ltfie,8);
		ccs.mapL(this,ldefa,9);
		ccs.mapE(this,code,0);
		ccs.mapE(this,tvue,1);
		ccs.mapE(this,ordr,2);
		ccs.mapE(this,fiel,3);
		ccs.mapE(this,lenf,4);
		ccs.mapE(this,taff,5);
		ccs.mapE(this,libe,6);
		ccs.mapE(this,aide,7);
		ccs.mapE(this,tfie,8);
		ccs.mapE(this,defa,9);
	}
	public void initGuiLE(){
		initGuiLSimple();
		jpDbE=new JPanel(Gp.adaptePanelE());
		jpDbE.add(code,Gp.gety());
		jpDbE.add(tvue.getThisInPanelsetLibe("c_libe",30),Gp.gety());
		jpDbE.add(ordr,Gp.gety());
		jpDbE.add(fiel,Gp.gety());
		jpDbE.add(lenf,Gp.gety());
		jpDbE.add(taff.getThisInPanelsetLibe("c_libe",30),Gp.gety());
		jpDbE.add(libe,Gp.gety());
		jpDbE.add(aide,Gp.gety());
		jpDbE.add(tfie.getThisInPanelsetLibe("c_libe",30),Gp.gety());
		jpDbE.add(defa,Gp.gety());
	}
	public void initFocus() {
		setDefFocus(code);
	}
	public void setBaseListener() {
		ccs.addF2Listener(code,Ccs.CONSULTF2);
		ccs.addF2Listener(tvue,Ccs.CODEINF2);
		ccs.addF2Listener(taff,Ccs.CODEINF2);
		ccs.addF2Listener(tfie,Ccs.CODEINF2);
	}
	public void setEditableColumns(FicheIEditableColumns fe, ListeIEditableColumn fl) {
		tvue.setEditableColumns(fe,fl);
	}
	public void fireEditableColumnUpdate(String nameField, Object value) {
		tvue.fireEditableColumnUpdate(nameField,value);
	}
	public void fireBaseListener(JComponent jc){
		// La cl d'index
		// La fiche
		if (jc==code){
			ccs.fireT(jc,Ccs.CONSULTF2);
		}
		if (jc==tvue){
			ccs.fireT(jc,Ccs.CODEINF2);
		}
		if (jc==taff){
			ccs.fireT(jc,Ccs.CODEINF2);
		}
		if (jc==tfie){
			ccs.fireT(jc,Ccs.CODEINF2);
		}
	}
	public void loadEAdapteGuiLE() {}
	protected void fireContextualRange(JComponent jc) {}
	protected void updateDependant(JComponent jc) {}
	protected void updateContextualRangeAndEnable(JComponent jc) {}
	public void setDependants() {}
}
