package table_standard.wS_intero;


import javax.swing.JComponent;

import persistance.wSql.Sql;
import template_applicatif.wFiche.AbstractDbFiche;
import template_applicatif.wFiche.FicheIEditableColumns;
import template_applicatif.wListe.ListeIEditableColumn;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextDb;
import composant_saisie.wComposant.JTextDbF2;
import composant_saisie.wSaisieFormat.Ccs;
/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class S_interoSAISIE extends AbstractDbFiche {
	private static final long serialVersionUID = 1L;
	JTextDb lcode,lrepo,lmess;
	JTextDbF2 	code=null;
	JTextDbF2 	repo=null;
	JTextDb 	mess=null;
	public S_interoSAISIE(Sql sql) {
		super(sql);
		initStart();
	}
	public void initCreateLE() {
		lcode	=new JTextDb();
		lrepo	=new JTextDb();
		lmess	=new JTextDb();
		code	=new JTextDbF2(new S_interoVUE(sql,"",Vue.F2UNIQUE1));
		repo	=new JTextDbF2(new S_interoVUE(sql,"",Vue.F2));
		mess	=new JTextDb();
	}
	public void initMapLE() {
		ccs.mapL(this,lcode,0);
		ccs.mapL(this,lrepo,1);
		ccs.mapL(this,lmess,2);
		ccs.mapE(this,code,0);
		ccs.mapE(this,repo,1);
		ccs.mapE(this,mess,2);
	}
	public void initFocus() {
		setDefFocus(code);
	}
	public void setBaseListener() {
		ccs.addF2Listener(code,Ccs.CONSULTF2);
		ccs.addF2Listener(repo,Ccs.CONSULTF2);
		ccs.addF2Listener(repo,Ccs.NEWCODEF2);
	}
	public void setEditableColumns(FicheIEditableColumns fe, ListeIEditableColumn fl) {}
	public void fireEditableColumnUpdate(String nameField, Object value) {}
	public void loadEAdapteGuiLE() {
		updateContextualRangeAndEnable(code);
	}
	public void updateContextualRangeAndEnable(JComponent jc) {
		if (jc==code){
			repo.sqlF2.v_filtre[0]=code.getText();
		}
	}
	public void fireBaseListener(JComponent jc){
		// La cl d'index
		// La fiche
		if (jc==code){
			ccs.fireT(jc,Ccs.CONSULTF2);
			updateContextualRangeAndEnable(code);
		}
		if (jc==repo){
			if (sql.isModeAppendUpdated()||sql.isModeAppend()){
				ccs.fireT(jc,Ccs.NEWCODEF2);
			} else {
				ccs.fireT(jc,Ccs.CONSULTF2);
			}
		}
	}
	protected void fireContextualRange(JComponent jc) {}
	protected void updateDependant(JComponent jc) {}
	public void setDependants() {}
	public boolean dbUpdateBeforeOtherTable(){
		dbReplaceCode();
		return true;
	}
	private void dbReplaceCode() {
		String ancCode=sql.getDataString(code.getName());
		String newCode=code.getText();
		if (!ancCode.equals(newCode)){
			sql.writeValue(sql.t_table, " c_code='"+newCode+"'","c_code='"+ancCode+"'");
		}
	}
}
