package table_standard.wS_menus;

import persistance.wSql.AbstractFieldsDef;
import persistance.wSql.Edit;
import persistance.wSql.Sql;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.Fma;
/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class S_menusFICHE extends AbstractFieldsDef {
	public S_menusFICHE(Sql sql,Vue vue) {
		super(sql,vue);
	}
	public Object adapteField(Vue vue){
		t_table="s_menus";
		t_nbLigne=1;
		t_filtre=null;
		v_filtre=null;
		t_index=new String[]{"c_code","c_cle2"};
		switch (vue){
		default:{
			addSqlField("c_code", 10,Fma.F2,"Option Menus"        ,"",Edit.F2  ,"");
			addSqlField("c_cle2",  2,Fma.F2,"Cle 2"               ,"",Edit.F2,"");
			addSqlField("c_smen", 10,Fma.F2   ,"Sous menus"       ,"",Edit.F2  ,"");
			addSqlField("c_opt1", 10,Fma.FIELD,"Fichier"           ,"",Edit.TEXT,"");
			addSqlField("c_menu", 50,Fma.FIELD,"Titre du menu"    ,"",Edit.TEXT,"");
			addSqlField("c_racc",  1,Fma.FIELD,"Raccourci"        ,"",Edit.TEXT,"");
			addSqlField("c_aide",120,Fma.FIELD,"Aide barre de Status","",Edit.TEXT,"");
			//
			addSqlField("c_opt2", 10,Fma.INVISIBLE,"Detail"                ,"",Edit.TEXT,"");
			addSqlField("c_opt3", 10,Fma.INVISIBLE,"    "                ,"",Edit.TEXT,"");
			break;}
		}
		return this;
	}
}
