package table_standard.wS_menusDetail;
import javax.swing.JComponent;
import javax.swing.JPanel;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import template_applicatif.wFiche.AbstractDbFiche;
import template_applicatif.wFiche.FicheIEditableColumns;
import template_applicatif.wListe.ListeIEditableColumn;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JArea;
import composant_saisie.wComposant.JTextDb;
import composant_saisie.wComposant.JTextDbF2;
import composant_saisie.wSaisieFormat.Ccs;
/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class S_menusDetailSAISIE extends AbstractDbFiche {
	private static final long serialVersionUID = 1L;
	JTextDbF2	code=null;
	//JTextDb   	cle2=null;
	JTextDbF2	cle2=null;
	JTextDb		menu=null;
	JTextDb   	racc=null;
	JTextDb   	opt1=null;
	JArea		aide=null;
	JTextDb  	smen=null;
	JTextDb   	opt2=null;
	JTextDb   	opt3=null;
	public S_menusDetailSAISIE(Sql sql) {
		super(sql);
		initStart();
	}
	public void initCreateLE() {
		code	=new JTextDbF2(new S_menusDetailVUE(sql,"",Vue.F2UNIQUE1));
		//cle2	=new JTextDb();
		cle2	=new JTextDbF2(new S_menusDetailVUE(sql,"",Vue.F2));
		menu	=new JTextDb();
		racc	=new JTextDb();
		opt1	=new JTextDb();
		aide	=new JArea();
		smen	=new JTextDb();
		opt2	=new JTextDb();
		opt3	=new JTextDb();
	}
	public void initMapLE() {
		ccs.mapE(this,code,0);
		ccs.mapE(this,cle2,1);
		ccs.mapE(this,menu,2);
		ccs.mapE(this,racc,3);
		ccs.mapE(this,opt1,4);
		ccs.mapE(this,aide,5);{
			aide.setDimChar(sql.fields.get(5).t_fieldLength/2,3);
		}
		ccs.mapE(this,smen,6);
		ccs.mapE(this,opt2,7);
		ccs.mapE(this,opt3,8);
	}
	public void initGuiLE(){
		jpDbE=new JPanel(Gp.adaptePanelC());
		//jpDbT.add(code,Gp.getx());
		jpDbE.add(cle2,Gp.getx());
		jpDbE.add(menu,Gp.getx());
		jpDbE.add(racc,Gp.getx());
		jpDbE.add(opt1,Gp.getx());
		jpDbE.add(smen,Gp.getx());
		jpDbE.add(opt2,Gp.getx());
		jpDbE.add(opt3,Gp.getx());
		Gp.setWidth(10);
		Gp.setx(0);
		jpDbE.add(aide,Gp.gety());
	}
	public void setRemoveForParam() {
		if (setCrudOnlyUpdate()){
			code.setEnabled(false);
			smen.setEnabled(false);
		}
		jpDbE.remove(opt1);
		jpDbE.remove(smen);
		jpDbE.remove(opt2);
		jpDbE.remove(opt3);

		smen.removeEditableColumn();
		opt1.enableEditableColumn(false);
		opt2.enableEditableColumn(false);
		opt3.enableEditableColumn(false);
	}
	public void initFocus() {
		setDefFocus(code);
	}
	public void setBaseListener() {
		ccs.addF2Listener(code,Ccs.CONSULTF2);
		ccs.addF2Listener(cle2,Ccs.CONSULTF2);
		ccs.addF2Listener(cle2,Ccs.NEWCODEF2);
	}
	public void setEditableColumns(FicheIEditableColumns fe,ListeIEditableColumn fl) {
		//cle2.validateFastEditAdd(fe,fl);
		menu.setEditableColumns(fe,fl);
		racc.setEditableColumns(fe,fl);
		opt1.setEditableColumns(fe,fl);
		aide.setEditableColumns(fe,fl);
		smen.setEditableColumns(fe,fl);
	}
	public void fireEditableColumnUpdate(String nameField,Object value){
		//cle2.validateFastEditRecord(nameField,value);
		menu.fireEditableColumnUpdate(nameField,value);
		racc.fireEditableColumnUpdate(nameField,value);
		opt1.fireEditableColumnUpdate(nameField,value);
		aide.fireEditableColumnUpdate(nameField,value);
		smen.fireEditableColumnUpdate(nameField,value);
	}
	public void loadEAdapteGuiLE() {
		updateContextualRangeAndEnable(code);
	}
	public void fireBaseListener(JComponent jc){
		// La cl d'index
		// La fiche
		if (jc==code){
			ccs.fireT(jc,Ccs.CONSULTF2);
			updateContextualRangeAndEnable(code);
		}
		if (jc==cle2){
			if (sql.isModeAppendUpdated()||sql.isModeAppend()){
				ccs.fireT(jc,Ccs.NEWCODEF2);
			} else {
				ccs.fireT(jc,Ccs.CONSULTF2);
			}
		}
	}
	public void updateContextualRangeAndEnable(JComponent jc) {
		if (jc==code){
			cle2.sqlF2.v_filtre[0]=code.getText();
		}
	}
	public boolean dbUpdateBeforeOtherTable(){
		dbReplaceCode();
		dbReplaceSmen();
		return true;
	}
	public boolean dbUpdateAfterOtherTable(){
		updateMenu();
		return true;
	}

	private void dbReplaceCode() {
		String ancCode=sql.getDataString(code.getName());
		String newCode=code.getText();
		if (!ancCode.equals(newCode) && ancCode.trim().length()>0 && newCode.trim().length()>0){
			sql.writeValue(sql.t_table, " c_code='"+newCode+"'","c_code='"+ancCode+"'");
			sql.writeValue(sql.t_table, " c_smen='"+newCode+"'","c_smen='"+ancCode+"'");
		}

	}
	private void dbReplaceSmen() {
		String ancSmen=sql.getDataString(smen.getName());
		String newSmen=smen.getText();
		if (!ancSmen.equals(newSmen) && ancSmen.trim().length()>0 && newSmen.trim().length()>0){
			sql.writeValue(sql.t_table, " c_code='"+newSmen+"'","c_code='"+ancSmen+"'");
		}
	}
	private void updateMenu(){
		sql.loadMenu();
	}
	protected void fireContextualRange(JComponent jc) {}
	protected void updateDependant(JComponent jc) {}
	public void setDependants() {}
}
