package table_standard.wS_prefs;

import persistance.wSql.AbstractFieldsDef;
import persistance.wSql.Edit;
import persistance.wSql.Sql;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.Fma;
/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class S_prefsFICHE extends AbstractFieldsDef {
	public S_prefsFICHE(Sql sql,Vue vue) {
		super(sql,vue);
	}
	public Object adapteField(Vue vue){
		t_table="s_prefs";
		t_nbLigne=1;
		t_filtre=null;
		v_filtre=null;
		t_index=new String[]{"c_code"};
		switch (vue){
		default:{
			addSqlField("c_code" , 30,Fma.F2		,"Utilisateur","",Edit.F2,"");
			addSqlField("c_them" , 30,Fma.F2		,"Thme","",Edit.F2,"");
			addSqlField("c_atit" ,  1,Fma.CHECK	,"Affichage des titres","",Edit.CHECK,"1");
			addSqlField("c_titr" ,  2,Fma.NUM		,"Taille des titres","",Edit.INT,"22");
			addSqlField("c_tota" ,  2,Fma.NUM		,"Taille des totaux","",Edit.INT,"24");
			addSqlField("c_gras" ,  1,Fma.CHECK	,"Police de caractre Textes & Boutons en GRAS","",Edit.CHECK,"1");
			addSqlField("c_mgra" ,  1,Fma.CHECK	,"Police de caractre Menus en GRAS","",Edit.CHECK,"0");
			addSqlField("c_tool" ,1,Fma.CHECK	,"ToolTip","",Edit.CHECK,"0");
			addSqlField("c_dela" , 6,Fma.NUM,"Dlais d'apparition","Dlais avant apparition des bulles d'aide, en seconde",Edit.DOUBLE,"1.0");
			addSqlField("c_time" , 6,Fma.NUM,"Temps d'affichage","Temps d'affichage des bulles d'aide, en seconde",Edit.DOUBLE,"12.0");
			addSqlField("c_fond" ,1,Fma.CHECK	,"Fond d'cran","",Edit.CHECK,"1");
			addSqlField("c_butt" ,1,Fma.CHECK	,"Icones des boutons","",Edit.CHECK,"1");
			addSqlField("c_vpro" ,1,Fma.CHECK	,"Version Pro","",Edit.CHECK,"1");
			addSqlField("c_pass" , 10,Fma.FIELD,"Mot de passe","",Edit.TEXT,"");
			addSqlField("c_idot" , 8,Fma.FIELD,"Etiquette","",Edit.TEXT,"");
			addSqlField("c_driv" , 8,Fma.FIELD,"Driver Etiquette","",Edit.TEXT,"");
			addSqlField("c_1204" , 8,Fma.FIELD,"Lecteur code barre","",Edit.TEXT,"");
			break;}
		}
		return this;
	}
}
