package table_standard.wS_prefs;


import javax.swing.JComponent;
import javax.swing.JPanel;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import table_standard.wS_themes.S_themesVUE;
import template_applicatif.wFiche.AbstractDbFiche;
import template_applicatif.wFiche.FicheIEditableColumns;
import template_applicatif.wListe.ListeIEditableColumn;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextCheck;
import composant_saisie.wComposant.JTextDb;
import composant_saisie.wComposant.JTextDbF2;
import composant_saisie.wSaisieFormat.Ccs;
/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class S_prefsSAISIE extends AbstractDbFiche {
	private static final long serialVersionUID = 1L;
	JTextDb lcode,lthem,latit,ltitr,ltota,lgras,lmgra,ltool,ldela,ltime,lfond,lbutt,lvpro,lpass,lidot,ldriv,l1204;
	JTextDbF2 	code=null;
	JTextDbF2 	them=null;
	JTextCheck 	atit=null;
	JTextDb 	titr=null;
	JTextDb 	tota=null;
	JTextCheck 	gras=null;
	JTextCheck 	mgra=null;
	JTextCheck 	tool=null;
	JTextDb 	dela=null;
	JTextDb 	time=null; 
	JTextCheck 	fond=null;
	JTextCheck 	butt=null;
	JTextCheck 	vpro=null;
	JTextDb 	pass=null;
	JTextDb 	idot=null;
	JTextDb 	driv=null;
	JTextDb 	ms1204=null;
	public S_prefsSAISIE(Sql sql) {
		super(sql);
		initStart();
	}
	public void initCreateLE() {
		lcode	=new JTextDb();
		lthem	=new JTextDb();
		latit	=new JTextDb();
		ltitr	=new JTextDb();
		ltota	=new JTextDb();
		lgras	=new JTextDb();
		lmgra	=new JTextDb();
		ltool	=new JTextDb();
		ldela	=new JTextDb();
		ltime	=new JTextDb();
		lfond	=new JTextDb();
		lbutt	=new JTextDb();
		lvpro	=new JTextDb();
		lpass	=new JTextDb();
		lidot	=new JTextDb();
		ldriv	=new JTextDb();
		l1204	=new JTextDb();
		code	=new JTextDbF2(new S_prefsVUE(sql,"",Vue.F2));
		them	=new JTextDbF2(new S_themesVUE(sql,"",Vue.F2));
		atit	=new JTextCheck("Afficher","Masquer");
		titr	=new JTextDb();
		tota	=new JTextDb();
		gras	=new JTextCheck("Gras","Fin");
		mgra	=new JTextCheck("Gras","Fin");
		tool	=new JTextCheck("ToolTips","Sans");
		dela	=new JTextDb();
		time	=new JTextDb();
		fond	=new JTextCheck("Actif","Sans fond");
		butt	=new JTextCheck("Actives","Texte");
		vpro	=new JTextCheck("Active","Basic");
		pass	=new JTextDb();
		idot	=new JTextDb();
		driv	=new JTextDb();
		ms1204	=new JTextDb();
	}
	public void initMapLE() {
		ccs.mapL(this,lcode,0);
		ccs.mapL(this,lthem,1);
		ccs.mapL(this,latit,2);
		ccs.mapL(this,ltitr,3);
		ccs.mapL(this,ltota,4);
		ccs.mapL(this,lgras,5);
		ccs.mapL(this,lmgra,6);
		ccs.mapL(this,ltool,7);
		ccs.mapL(this,ldela,8);
		ccs.mapL(this,ltime,9);
		ccs.mapL(this,lfond,10);
		ccs.mapL(this,lbutt,11);
		ccs.mapL(this,lvpro,12);
		ccs.mapL(this,lpass,13);
		ccs.mapL(this,lidot,14);
		ccs.mapL(this,ldriv,15);
		ccs.mapL(this,l1204,16);

		ccs.mapE(this,code,0);
		ccs.mapE(this,them,1);
		ccs.mapE(this,atit,2 ,"1");
		ccs.mapE(this,titr,3,"##");
		ccs.mapE(this,tota,4,"##");
		ccs.mapE(this,gras,5,"1");
		ccs.mapE(this,mgra,6,"1");
		ccs.mapE(this,tool,7,"1");
		ccs.mapE(this,dela,8,"1.00"	,"##.##");
		ccs.mapE(this,time,9,"12.00"	,"##.##");
		ccs.mapE(this,fond,10,"1");
		ccs.mapE(this,butt,11,"1");
		ccs.mapE(this,vpro,12,"1");
		ccs.mapE(this,pass,13);
		ccs.mapE(this,idot,14);
		ccs.mapE(this,driv,15);
		ccs.mapE(this,ms1204,16);
	}
	public void initGuiLE(){
		jpDbL=new JPanel(Gp.adaptePanelL());
		jpDbL.add(lcode,Gp.gety());
		jpDbL.add(lthem,Gp.gety());
		Gp.addSeparator(jpDbL,"");
		jpDbL.add(latit,Gp.gety());
		jpDbL.add(ltitr,Gp.gety());
		Gp.addSeparator(jpDbL,"");
		jpDbL.add(ltota,Gp.gety());
		jpDbL.add(lgras,Gp.gety());
		jpDbL.add(lmgra,Gp.gety());
		Gp.gety();
		Gp.addSeparator(jpDbL,"");
		jpDbL.add(ltool,Gp.gety());
		jpDbL.add(ldela,Gp.gety());
		jpDbL.add(ltime,Gp.gety());
		Gp.addSeparator(jpDbL,"");
		jpDbL.add(lfond,Gp.gety());
		jpDbL.add(lbutt,Gp.gety());
		jpDbL.add(lvpro,Gp.gety());
		jpDbL.add(lpass,Gp.gety());
		jpDbL.add(lidot,Gp.gety());
		jpDbL.add(ldriv,Gp.gety());
		jpDbL.add(l1204,Gp.gety());

		jpDbE=new JPanel(Gp.adaptePanelE());
		jpDbE.add(code,Gp.gety());
		jpDbE.add(them,Gp.gety());
		Gp.addSeparator(jpDbE,"");
		jpDbE.add(atit,Gp.gety());
		jpDbE.add(titr,Gp.gety());
		Gp.addSeparator(jpDbE,"");
		jpDbE.add(tota,Gp.gety());
		jpDbE.add(gras,Gp.gety());
		jpDbE.add(mgra,Gp.gety());
		Gp.addSeparator(jpDbE,"");
		jpDbE.add(tool,Gp.gety());
		jpDbE.add(dela,Gp.gety());
		jpDbE.add(time,Gp.gety());
		Gp.addSeparator(jpDbE,"");
		jpDbE.add(fond,Gp.gety());
		jpDbE.add(butt,Gp.gety());
		jpDbE.add(vpro,Gp.gety());
		jpDbE.add(pass,Gp.gety());
		jpDbE.add(idot,Gp.gety());
		jpDbE.add(driv,Gp.gety());
		jpDbE.add(ms1204,Gp.gety());
	}
	public void setRemoveForParam() {
		if (setCrudOnlyUpdate()){
			code.setEnabled(false);
		}
	}
	public void initFocus() {
		setDefFocus(code);
	}
	public void setBaseListener() {
		// La cl d'index
		ccs.addF2Listener(code,Ccs.NEWCODEF2);
		ccs.addF2Listener(code,Ccs.CODEINF2);

		// La fiche
		ccs.addF2Listener(them,Ccs.CODEINF2);
		ccs.addTextCheckListener(atit);
		ccs.addTextCheckListener(tool);
		ccs.addTextCheckListener(gras);
		ccs.addTextCheckListener(mgra);
		ccs.addTextCheckListener(fond);
		ccs.addTextCheckListener(butt);
		ccs.addTextCheckListener(vpro);
	}
	public void setEditableColumns(FicheIEditableColumns fe,ListeIEditableColumn fl) {
	}
	public void fireEditableColumnUpdate(String nameField,Object value){
	}
	public void loadEAdapteGuiLE() {
		if (atit.isSelected()){
			titr.setEditable(true);
		} else {
			titr.setEditable(false);
		}
		if (tool.isSelected()){
			dela.setEditable(true);
			time.setEditable(true);
		} else {
			dela.setEditable(false);
			time.setEditable(false);
		}
	}
	public void fireBaseListener(JComponent jc){
		// La cl d'index
		if (jc==code){
			if (sql.isModeAppendUpdated()||sql.isModeAppend()){
				ccs.fireT(jc,Ccs.NEWCODEF2);
			} else {
				ccs.fireT(jc,Ccs.CODEINF2);
			}
		}
		// La fiche
		if (jc==atit){
			if (atit.isSelected()){
				titr.adapteTextField();
			} else {
				titr.adapteTextLibe();
			}
		}
		if (jc==them){
			ccs.fireT(jc,Ccs.CODEINF2);
		}
		if (jc==tool){
			if (tool.isSelected()){
				dela.adapteTextField();
				time.adapteTextField();
			} else {
				dela.adapteTextLibe();
				time.adapteTextLibe();
			}
		}
	}
	protected void fireContextualRange(JComponent jc) {}
	protected void updateDependant(JComponent jc) {}
	protected void updateContextualRangeAndEnable(JComponent jc) {}
	public void setDependants() {}
	public boolean dbUpdateAfterOtherTable(){
		sql.applyPreferences(sql.getUser());
		sql.loadMenu();
		return true;
	}
}
