package template_applicatif.wFiche;


import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import template_applicatif.wVue.VueButtonSLBascule;
import template_applicatif.wVue.VueIAide;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JPanelImage;
import composant_saisie.wComposant.JTextButton;
import composant_saisie.wComposant.JTextLabel;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class FicheButton extends JPanel implements FicheIAction,ActionListener, MouseListener,VueIAide {
	private static final long serialVersionUID = 1L;
	public ArrayList <VueButtonSLBascule> bBascule=null;
	public JPanelImage jpBoutonCenter;

	private JTextButton jbAppend=null;
	private JTextButton jbCancel=null;
	private JTextButton jbDelete=null;
	private JTextButton jbRecord=null;
	private JTextButton jbAide=null;
	private FicheIAction fa=null;
	public  ArrayList <JComponent> bOptions=null;
	private Sql sql=null;
	private boolean isOnlyVisible=false;
	private boolean isOnlyOption=false;
	private boolean isOnlyAppend=false;
	private boolean isOnlyUpdate=false;
	public FicheButton(FicheIAction fa, Sql sql){
		super();
		this.setName(this.getClass().getSimpleName());
		this.fa=fa;
		this.sql=sql;
		this.setLayout(new BorderLayout()); {
			jpBoutonCenter= new JPanelImage(sql.getGp(),null, Gp.JPGGRADIENT);{
				jpBoutonCenter.setModeGradient(45,false);
				jbCancel=new JTextButton("Annuler"); {
					jbCancel.setFocusable(false);
					jbCancel.setMnemonic('A');
					jbCancel.addActionListener(this);
					jbCancel.setForeground(Gp.LABEL_FG_BLACK);
					jbCancel.setImageIconPressed(sql.getImage(sql.getAppliParam().JBCANCEL,true),true);
				}
				jbAppend=new JTextButton("Nouveau"); {
					jbAppend.setFocusable(false);
					jbAppend.setMnemonic('N');
					jbAppend.addActionListener(this);
					jbAppend.setImageIconPressed(sql.getImage(sql.getAppliParam().JBAPPEND,true),true);
				}
				jbDelete=new JTextButton("Effacer");{
					jbDelete.setFocusable(false);
					jbDelete.setMnemonic('E');
					jbDelete.addActionListener(this);
					jbDelete.setImageIconPressed(sql.getImage(sql.getAppliParam().JBDELETE,true),true);
				}
				jbRecord=new JTextButton("Enregistrer"); {
					jbRecord.setFocusable(false);
					jbRecord.setMnemonic('E');
					jbRecord.addActionListener(this);
					jbRecord.setImageIconPressed(sql.getImage(sql.getAppliParam().JBRECORD,true),true);
				}
				jbAide=new JTextButton("Aide"); {
					jbAide.setVisible(false);
					//		
					jbAide.setFocusable(false);
					jbAide.setMnemonic('?');
					jbAide.addActionListener(this);
					jbAide.setImageIconPressed(sql.getImage(sql.getAppliParam().JBAIDE,true),true);
				}
				jpBoutonCenter.add(jbAppend);
				jpBoutonCenter.add(jbDelete);
				jpBoutonCenter.add(jbRecord);
				jpBoutonCenter.add(jbCancel);
				//
				jpBoutonCenter.add(jbAide);
				bOptions=new ArrayList <JComponent> ();
				bBascule=new ArrayList <VueButtonSLBascule>();
				this.setBorder(Gp.getBorder(BorderFactory.createRaisedBevelBorder(),Gp.LABEL_FG_BLACK));
				this.add(jpBoutonCenter,BorderLayout.CENTER);
				this.addMouseListener(this);
			}
		}
	}
	public void setVertical(){
		jpBoutonCenter.setLayout(Gp.adaptePanelButtonVertical());
		Gp.sety(10);
		jpBoutonCenter.add(jbAppend,Gp.gety());
		jpBoutonCenter.add(jbDelete,Gp.gety());
		jpBoutonCenter.add(jbRecord,Gp.gety());
		jpBoutonCenter.add(jbCancel,Gp.gety());
		for (int i=0;i<bOptions.size();i++){
			jpBoutonCenter.add(bOptions.get(i),Gp.gety());
		}
		jpBoutonCenter.add(jbAide,Gp.gety());
		this.setBorder(Gp.getBorder(Gp.LABEL_BORDER));
	}
	public void addTitre(JTextLabel head) {
		Gp.adaptePanelButtonVertical();		
		Gp.sety(2);
		jpBoutonCenter.add(head,Gp.gety());
	}
	public void addFB(JTextButton jbBascule) {
		Gp.adaptePanelButtonVertical();		
		Gp.sety(1);
		jpBoutonCenter.add(jbBascule,Gp.gety());
	}
	public void addFicheBascule(VueButtonSLBascule fb){
		this.bBascule.add(fb);
	}
	public void userOptionAdd(String option,String fileIcon) {
		JTextButton jbOption=new JTextButton(option);{
			jbOption.setFocusable(false);
			jbOption.setMnemonic('O');
			jbOption.addActionListener(this);
			if (fileIcon==null)
				jbOption.setImageIconPressed(sql.getImage(sql.getAppliParam().JBOPTIONDEF,true),true);
			else
				jbOption.setImageIconPressed(sql.getImage(fileIcon,true),true);
		}
		optionAdd(jbOption);
	}
	public void userOptionAdd(JComponent  jcOption) {
		optionAdd(jcOption);
	}
	private void optionAdd(JComponent jcOption){
		bOptions.add(jcOption);
		jpBoutonCenter.remove(jbRecord);
		jpBoutonCenter.remove(jbCancel);
		jpBoutonCenter.remove(jbAide);
		jpBoutonCenter.add(jcOption);
		jpBoutonCenter.add(jbRecord);
		jpBoutonCenter.add(jbCancel);
		jpBoutonCenter.add(jbAide);
	}
	public void basculeAdd(JTextButton jbBascule) {
		jpBoutonCenter.remove(jbAide);
		jpBoutonCenter.add(jbBascule);
		jpBoutonCenter.add(jbAide);
	}
	public void setOptionEnabled(String actionCommandOption, boolean enable){
		for (int i=0;i<bOptions.size();i++)
			if (actionCommandOption==null){
				bOptions.get(i).setEnabled(enable);
			} else {
				if (actionCommandOption.equals(((JTextButton)bOptions.get(i)).getActionCommand()))
					bOptions.get(i).setEnabled(enable);
			}
	}
	public void setBasculeEnabled(String actionCommandBascule, boolean enable){
		for (int i=0;i<bBascule.size();i++)
			if (actionCommandBascule==null){
				bBascule.get(i).setEnabled(enable);
			} else {
				if (actionCommandBascule.equals(((JTextButton)bBascule.get(i).jbBascule).getActionCommand()))
					bBascule.get(i).jbBascule.setEnabled(enable);
			}
	}
	public void setVisible(boolean enable){
		super.setVisible(enable);
		jbAppend.setVisible(enable);
		jbDelete.setVisible(enable);
		for (int i=0;i<bOptions.size();i++){
			bOptions.get(i).setVisible(enable);
		}
		for (int i=0;i<bBascule.size();i++) {
			bBascule.get(i).jbBascule.setVisible(enable);
		}
		if (enable){
			restoreOnly();
		}
	}

	public void setRecordVisible(boolean enable) {
		jbRecord.setEnabled(enable);
		jbRecord.setVisible(enable);
	}
	public boolean isRecordable(){
		boolean ret=false;
		if (jbRecord.isVisible() && jbRecord.isEnabled()){
			ret=true;
		}
		return ret;
	}
	public void setAideVisible(boolean enable) {
		jbAide.setEnabled(enable);
		jbAide.setVisible(enable);
	}
	public boolean isAidable(){
		boolean ret=false;
		if (jbAide.isVisible() && jbAide.isEnabled()){
			ret=true;
		}
		return ret;
	}
	public boolean isAppendable(){
		boolean ret=false;
		if (jbAppend.isVisible() && jbAppend.isEnabled()){
			ret=true;
		}
		return ret;
	}
	public void doRecordClick() {
		jbRecord.doClick();
	}

	public void setEnabled(boolean enable){
		super.setEnabled(enable);
		jpBoutonCenter.setEnabled(enable);
		jbAppend.setEnabled(enable);
		jbDelete.setEnabled(enable);
		for (int i=0;i<bOptions.size();i++)
			bOptions.get(i).setEnabled(enable);
		for (int i=0;i<bBascule.size();i++)
			bBascule.get(i).jbBascule.setEnabled(enable);

		if (enable){
			this.setBorder(Gp.getBorder(BorderFactory.createRaisedBevelBorder(),Gp.LABEL_FG_BLACK));
		} else {
			this.setBorder(Gp.getBorder(BorderFactory.createLoweredBevelBorder(),Gp.FILIGRANE_LGRAY));
		}
	}

	public void disableGradient(){
		jpBoutonCenter.setMode(Gp.JPGNULL);
	}
	public void setModeMovable(){
		jbDelete.setEnabled(true);
		jbDelete.setVisible(true);
		for (int i=0;i<bOptions.size();i++){
			bOptions.get(i).setEnabled(true);
			bOptions.get(i).setVisible(true);
		}
		jbCancel.setVisible(false);
		jbCancel.setEnabled(false);

		jbAppend.setEnabled(true);
		jbAppend.setVisible(true);

		jbRecord.setEnabled(false);
		for (int i=0;i<bBascule.size();i++)
			bBascule.get(i).jbBascule.setEnabled(true);
	}
	public void setModeUpdated(){
		jbAppend.setVisible(false);
		jbAppend.setEnabled(false);

		jbCancel.setVisible(true);
		jbCancel.setEnabled(true);

		jbDelete.setEnabled(false);
		for (int i=0;i<bOptions.size();i++)
			bOptions.get(i).setEnabled(false);

		jbRecord.setEnabled(true);
		for (int i=0;i<bBascule.size();i++)
			bBascule.get(i).jbBascule.setEnabled(false);
	}
	public void setModeAppend(){
		jbCancel.setVisible(true);
		jbCancel.setEnabled(true);

		jbAppend.setEnabled(false);
		jbAppend.setVisible(false);

		jbDelete.setEnabled(false);
		for (int i=0;i<bOptions.size();i++)
			bOptions.get(i).setEnabled(false);

		jbRecord.setEnabled(false);
		for (int i=0;i<bBascule.size();i++)
			bBascule.get(i).jbBascule.setEnabled(false);
	}
	public void setModeAppendUpdated(){
		jbCancel.setVisible(true);
		jbCancel.setEnabled(true);

		jbAppend.setEnabled(false);
		jbAppend.setVisible(false);

		jbDelete.setEnabled(false);
		for (int i=0;i<bOptions.size();i++)
			bOptions.get(i).setEnabled(false);

		jbRecord.setEnabled(true);
		for (int i=0;i<bBascule.size();i++)
			bBascule.get(i).jbBascule.setEnabled(false);
	}
	public void userAppend() {
		fa.userAppend();
	}
	public void userCancel() {
		fa.userCancel();
	}
	public void userDelete() {
		fa.userDelete();
	}
	public void userRecord() {
		fa.userRecord();
	}
	public void userOption(String actionCommand) {
		fa.userOption(actionCommand);
	}
	public void userAide() {
		fa.userAide();
	}
	public void userSetAide() {
		fa.userSetAide();
	}
	public void adapteAide() {
		fa.adapteAide();
	}
	public void actionPerformed(ActionEvent arg0) {
		if (arg0.getActionCommand().contains(JTextButton.CLICK_RIGHT)){
			userSetAide();
		} else
			if (arg0.getSource()==jbDelete){
				userDelete();
			} else if (arg0.getSource()==jbAppend){
				userAppend();
			} else if (arg0.getSource()==jbCancel){
				userCancel();
			} else if (arg0.getSource()==jbRecord){
				userRecord();
			} else if (arg0.getSource()==jbAide){
				userAide();
			} else {
				for (int i=0;i<bOptions.size();i++){
					if(bOptions.get(i)==arg0.getSource()){
						userOption(((JTextButton)bOptions.get(i)).getActionCommand());
						break;
					}
				}
			}
	}
	public boolean setOnlyUpdate() {
		boolean ret=false;
		if (!sql.isDevFile()){
			jpBoutonCenter.remove(jbAppend);
			jpBoutonCenter.remove(jbDelete);
			ret=true;
			setOnlyFalse();
			isOnlyUpdate=ret;
		}
		return ret;
	}
	public boolean setOnlyAppend() {
		boolean ret=false;
		if (!sql.isDevFile()){
			jpBoutonCenter.remove(jbDelete);
			ret=true;
			setOnlyFalse();
			isOnlyAppend=ret;
		}
		return ret;
	}
	public boolean setOnlyOption() {
		boolean ret=false;
		jpBoutonCenter.remove(jbAppend);
		jpBoutonCenter.remove(jbDelete);
		jpBoutonCenter.remove(jbRecord);
		ret=true;
		setOnlyFalse();
		isOnlyOption=ret;
		return ret;
	}
	public boolean setOnlyVisible() {
		boolean ret=false;
		if (!sql.isDevFile()){
			jpBoutonCenter.remove(jbAppend);
			jpBoutonCenter.remove(jbDelete);
			jpBoutonCenter.remove(jbRecord);
			super.setVisible(false);
			ret=true;
			setOnlyFalse();
			isOnlyVisible=ret;
		}
		return ret;
	}
	private void restoreOnly(){
		if (isOnlyVisible){
			setOnlyVisible();
		}
		if (isOnlyOption){
			setOnlyOption();
		}
		if (isOnlyAppend){
			setOnlyAppend();
		}
		if (isOnlyUpdate){
			setOnlyUpdate();
		}
	}
	private void setOnlyFalse(){
		isOnlyVisible=false;
		isOnlyOption=false;
		isOnlyAppend=false;
		isOnlyUpdate=false;
	}
	public void dispose(){
		if (jpBoutonCenter!=null){
			jpBoutonCenter.removeAll();
			jpBoutonCenter=null;
		}
		jbAppend=null;
		jbCancel=null;
		jbDelete=null;
		jbRecord=null;
		jbAide=null;
		fa=null;
		if (bBascule!=null){
			for (int i=0;i<bBascule.size();i++){
				bBascule.get(i).dispose();
				bBascule.set(i, null);
			}
			bBascule.clear();
			bBascule=null;
		}
		if (bOptions!=null){
			bOptions.clear();
			bOptions=null;
		}
		sql=null;
	}
	//	protected void finalize()  {
	//		//		Gp.af("finalize : "+this.getClass().getSimpleName());
	//		try {
	//			super.finalize();
	//		} catch (Throwable arg0) {
	//			arg0.printStackTrace();
	//		}
	//	}
	public void mousePressed(MouseEvent arg0) {}
	public void mouseReleased(MouseEvent arg0) {}
	public void mouseEntered(MouseEvent arg0) {}
	public void mouseExited(MouseEvent arg0) {}
	public void mouseClicked(MouseEvent arg0) {
		if(SwingUtilities.isRightMouseButton(arg0)) {
			userSetAide();
		} 
	}
}
