package template_applicatif.wFiltre;

import java.awt.FlowLayout;
import java.awt.Insets;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextDb;
import composant_saisie.wSaisieFormat.Ccs;
import composant_saisie.wSaisieFormat.UserUpdate;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JPDeAText extends JPanel implements DocumentListener  {
	private static final long serialVersionUID = 1L;
	UserUpdate userupdate=null;
	JTextDb jlspace=null;
	public JTextDb jlDebut=null;
	public JTextDb jlFin=null;
	JPanel jpDebutFin=null;
	public JTextDb debut=null;
	public JTextDb fin=null;
	public JPDeAText (){
		super(new FlowLayout(0,0,0));
		userupdate=new UserUpdate(this);
		adapte();
	}
	public void adapte(){
		initLT();
		initFiche();
		this.add(jpDebutFin);
		this.setBorder(BorderFactory.createEtchedBorder());
	}
	public void initLT() {
		jlspace=new JTextDb("  ");{
			Ccs.TexttoLibe(jlspace);
			jlspace.setHorizontalAlignment(JTextDb.LEFT);
		}
		jlDebut=new JTextDb("Du ");{
			Ccs.TexttoLibe(jlDebut);
			jlDebut.setHorizontalAlignment(JTextDb.LEFT);
		}
		jlFin=new JTextDb("Au ");{
			Ccs.TexttoLibe(jlFin);
			jlFin.setHorizontalAlignment(JTextDb.LEFT);
		}
		
		debut =new JTextDb("");{
			debut.getDocument().addDocumentListener(this);
			debut.setFont(Gp.FONTTEXT12);
			debut.setBorder(Gp.getBorder(Gp.LABEL_BORDER));
			debut.setBackground(Gp.UPDATE_BG_JAUNE);

		}
		fin =new JTextDb("");{
			fin.getDocument().addDocumentListener(this);
			fin.setFont(Gp.FONTTEXT12);
			fin.setBorder(Gp.getBorder(Gp.LABEL_BORDER));
			fin.setBackground(Gp.UPDATE_BG_JAUNE);
		}
	}
	public void initFiche(){
		jpDebutFin=new JPanel(Gp.adaptePanelE());
		Gp.gbc.insets=new Insets(3,3,3,3);
		jpDebutFin.add(jlDebut,Gp.gety());
		jpDebutFin.add(jlspace,Gp.getx());
		jpDebutFin.add(jlFin,Gp.getx());		
		
		Gp.setx(0);
		Gp.gbc.insets=new Insets(1,3,1,3);
		jpDebutFin.add(debut,Gp.gety());
		Gp.getx();
		jpDebutFin.add(fin,Gp.getx());
	}
	public void setDe(boolean enable){
		jlspace.setVisible(!enable);
		jlFin.setVisible(!enable);
		fin.setVisible(!enable);
	}
	public void changedUpdate(DocumentEvent e) {}
	public void insertUpdate(DocumentEvent e) {
		userUpdate();
	}
	public void removeUpdate(DocumentEvent e) {
		userUpdate();
	}
	private void userUpdate() {
		userupdate.userUpdate();
	}
	public void setTextDe(String string) {
		debut.setWidthChar(string.length());
		debut.setText(string);
	}
	public void setTextA(String string) {
		fin.setWidthChar(string.length());
		fin.setText(string);
	}
	public void setTextLibeDe(String string) {
		jlDebut.setWidthChar(string.length());
		jlDebut.setText(string);
	}
	public void setTextLibeA(String string) {
		jlFin.setWidthChar(string.length());
		jlFin.setText(string);
	}
	public void dispose(){
		fin.dispose();
		fin=null;
		debut.dispose();
		debut=null;
		userupdate=null;
	}
}
