package template_applicatif.wListe;

import java.awt.Color;

import persistance.wTmp.Tmp;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class ListeColorCol {
	private Tmp tmpColbg=null;
	private Tmp tmpColfg=null;
	private Tmp tmpRowbg=null;
	private Tmp tmpRowfg=null;
	public ListeColorCol(){
		tmpColbg=new Tmp(new String[]{"col"});{
			tmpColbg.setColor(new String[]{"color"});
		}
		tmpColfg=new Tmp(new String[]{"col"});{
			tmpColfg.setColor(new String[]{"color"});
		}
		tmpRowbg=new Tmp(new String[]{"col","value"});{
			tmpRowbg.setColor(new String[]{"color"});
			tmpRowbg.setInteger(new String[]{"index"});
		}
		tmpRowfg=new Tmp(new String[]{"col","value"});{
			tmpRowfg.setColor(new String[]{"color"});
			tmpRowfg.setInteger(new String[]{"index"});
		}
	}
	public void setColBackground(int numcol, boolean setBackground,Color color) {
		if (setBackground){
			if (!tmpColbg.seek("col",""+ numcol)){
				tmpColbg.appendBlank();
			}
			tmpColbg.repl("col",""+ numcol);
			tmpColbg.repl("color",color);
		} else {
			tmpColbg.remove("col",""+ numcol);
		}
	}
	public void setColForeground(int numcol, boolean setForeground, Color color) {
		if (setForeground){
			if (!tmpColfg.seek("col",""+ numcol)){
				tmpColfg.appendBlank();
			}
			tmpColfg.repl("col",""+ numcol);
			tmpColfg.repl("color",color);
		} else {
			tmpColfg.remove("col",""+ numcol);
		}
	}
	public void setRowBackground(int numcol, boolean setBackground, Color color, String value) {
		if (setBackground){
			if (!tmpRowbg.seek("col",""+ numcol+"!"+value)){
				tmpRowbg.appendBlank();
			}
			tmpRowbg.repl("col",""+ numcol+"!"+value);
			tmpRowbg.repl("color",color);
			tmpRowbg.repl("value",value);
			tmpRowbg.repl("index",numcol);
		} else {
			tmpRowbg.remove("col",""+ numcol+"!"+value);
		}
	}
	public void setRowForeground(int numcol, boolean setForeground, Color color, String value) {
		if (setForeground){
			if (!tmpRowfg.seek("col",""+ numcol+"!"+value)){
				tmpRowfg.appendBlank();
			}
			tmpRowfg.repl("col",""+ numcol+"!"+value);
			tmpRowfg.repl("color",color);
			tmpRowfg.repl("value",value);
			tmpRowfg.repl("index",numcol);
		} else {
			tmpRowfg.remove("col",""+ numcol+"!"+value);
		}
	}
	public Color getColBackground(int numcol){
		Color ret=null;
		if (tmpColbg.seek("col",""+ numcol)){
			ret=tmpColbg.readC("color");
		}
		return ret;
	}
	public Color getRowBackground(int numcol, String value){
		Color ret=null;
		if (tmpRowbg.seek("col",""+ numcol+"!"+value)){
			ret=tmpRowbg.readC("color");
		}
		return ret;
	}
	public Color getColForeground(int numcol){
		Color ret=null;
		if (tmpColfg.seek("col",""+ numcol)){
			ret=tmpColfg.readC("color");
		}
		return ret;
	}
	public Color getRowForeground(int numcol, String value){
		Color ret=null;
		if (tmpRowfg.seek("col",""+ numcol+"!"+value)){
			ret=tmpRowfg.readC("color");
		}
		return ret;
	}
	public Color getRowForeground(Object[] record) {
		Color ret=null;
		// rcupre le numro de champs
		tmpRowfg.goTop();
		int numcol=tmpRowfg.readI("index");
		String data=(String) record[numcol];
		if (tmpRowfg.seek("col",""+numcol+"!"+data)){
			ret=tmpRowfg.readC("color");
		}
		return ret;
	}
	public Color getRowBackground(Object[] record) {
		Color ret=null;
		// rcupre le numro de champs
		tmpRowbg.goTop();
		int numcol=tmpRowbg.readI("index");
		String data=(String) record[numcol];
		if (tmpRowbg.seek("col",""+numcol+"!"+data)){
			ret=tmpRowbg.readC("color");
		}
		return ret;
	}
	//
	public boolean isColor(){
		boolean ret=false;
		if (tmpColfg.size()>0){
			ret=true;
		} else if (tmpColbg.size()>0){
			ret=true;
		} else if (tmpRowfg.size()>0){
			ret=true;
		} else if (tmpRowbg.size()>0){
			ret=true;
		}
		return ret;
	}
	public boolean isRowFg(){
		boolean ret=false;
		if (tmpRowfg.size()>0){
			ret=true;
		}
		return ret;
	}
	public boolean isRowBg(){
		boolean ret=false;
		if (tmpRowbg.size()>0){
			ret=true;
		}
		return ret;
	}
	public boolean isColFg(){
		boolean ret=false;
		if (tmpColfg.size()>0){
			ret=true;
		}
		return ret;
	}
	public boolean isColBg(){
		boolean ret=false;
		if (tmpColbg.size()>0){
			ret=true;
		}
		return ret;
	}
	public void dispose() {
		if (tmpColbg!=null){
			tmpColbg.close();
			tmpColbg=null;
		}
		if (tmpColfg!=null){
			tmpColfg.close();
			tmpColfg=null;
		}
		if (tmpRowbg!=null){
			tmpRowbg.close();
			tmpRowbg=null;
		}
		if (tmpRowfg!=null){
			tmpRowfg.close();
			tmpRowfg=null;
		}
	}
	
	protected void finalize()  {
		//		Gp.af("finalize : "+this.getClass().getSimpleName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
