package template_applicatif.wListe;

import java.util.ArrayList;

import javax.swing.JComponent;

import persistance.wSql.Edit;
import persistance.wSql.Sql;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class ListeFastEdit implements ListeIEditableColumn {
	private ArrayList < JComponent > fastEdit=null;
	private Sql sql=null;
	public static String FASTEDIT="fastedit";
	public ListeFastEdit (Sql sql){
		this.sql=sql;
		this.fastEdit=new ArrayList < JComponent >();
	}
	public void addEditableColumn(JComponent jc) {
		jc.putClientProperty(FASTEDIT, true);
		fastEdit.add(jc);
	}
	public boolean isFastListe(int column){
		boolean ret=false;
		if (column>-1) {
			for (int i=0;i<fastEdit.size();i++)
				if (fastEdit.get(i).getName().equals(sql.fields.get(column).t_field)){
					ret=true;
					break;
				} 
		} 
		return ret;
	}
	public boolean isFastListeEnable(int column) {
		boolean ret=false;
		if (column>-1) {
			for (int i=0;i<fastEdit.size();i++)
				if (fastEdit.get(i).getName().equals(sql.fields.get(column).t_field)){
					if ((Boolean) fastEdit.get(i).getClientProperty(FASTEDIT)){
						ret=true;
					} else {
						ret=false;
					}
					break;
				} 
		} 
		return ret;
	}
	public String getName(int column) {
		String ret=null;
		if (column>-1) {
			ret=sql.fields.get(column).t_field;
		}
		return ret;
	}
	public int size() {
		return fastEdit.size();
	}
	public Edit getTypeEdit(int column) {
		Edit ret=null;
		if (column>-1) {
			if (sql.sqlTwin==null){
				for (int i=0;i<fastEdit.size();i++) {
					if (fastEdit.get(i).getName().equals(sql.fields.get(column).t_field)){
						ret=(Edit) fastEdit.get(i).getClientProperty(Edit.TYPE_FIELD);
						break;
					} 
				}
			} else {
				for (int i=0;i<sql.sqlTwin.fields.size();i++){
					if(getName(column).equals(sql.sqlTwin.fields.get(i).t_field)){
						ret=sql.sqlTwin.fields.get(i).t_EditType;
					}
				}
			}
		}
		return ret;
	}
	public JComponent getComponent(int column){
		JComponent ret=null;
		if (column>-1) {
			for (int i=0;i<fastEdit.size();i++)
				if (fastEdit.get(i).getName().equals(sql.fields.get(column).t_field)){
					ret=fastEdit.get(i);
					break;
				} 
		} 
		return ret;
	}
	public void enableEditableColumn(String name, boolean enable) {
		for (int i=0;i<fastEdit.size();i++)
			if (fastEdit.get(i).getName().equals(name)){
				fastEdit.get(i).putClientProperty(FASTEDIT, enable);
				break;
			} 
	}
	public boolean isEmpty() {
		return fastEdit.isEmpty();
	}
	public void removeEditableColumn(String name) {
		for (int i=0;i<fastEdit.size();i++)
			if (fastEdit.get(i).getName().equals(name)){
				fastEdit.remove(i);
				break;
			} 
	}
	public void dispose() {
		fastEdit=null;
		sql=null;
	}
	protected void finalize()  {
		//Gp.af("finalize : "+this.getClass().getSimpleName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
