package template_applicatif.wListe;

import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Graphics;

import javax.swing.JTable;
import javax.swing.table.TableColumnModel;

import a_doc.doc.Licence;

import composant_saisie.wComposant.JPanelImage;

/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class ListeGridTable extends JPanelImage  {
	private static final long serialVersionUID = 1L;
	private JTable jt=null;
	public ListeGridTable(){
		super(new FlowLayout(0,0,0));
		adapte();
	}
	private void adapte() {
		setModeGradient(60, false);
		//this.setBackground(new Color(245,245,245));
	}

	public void add(JTable jt){
		this.jt=jt;
		super.add(jt);		
	}
	public void paintComponent(Graphics g) {	
		super.paintComponent(g);
		if (jt!=null){
			Color savecol=g.getColor();
			g.setColor(jt.getGridColor());
			int posx=-1;
			TableColumnModel tcm = jt.getTableHeader().getColumnModel();
			for (int i=0;i<tcm.getColumnCount();i++){
				posx=posx+(tcm.getColumn(i).getWidth());
				g.drawLine(posx, 0, posx, this.getHeight());
			}
			g.setColor(savecol);
		}
	}
	public void dispose() {
		jt=null;
	}
}
