package template_applicatif.wVue;

import java.awt.BorderLayout;

import javax.swing.BorderFactory;
import javax.swing.JPanel;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;

import composant_saisie.wComposant.JTextLabel;

public abstract class AbstractVueDetail extends AbstractVue {
	private static final long serialVersionUID = 1L;
	public AbstractVueDetail(Sql sql, String t_seek, Vue vue) {
		super(sql, t_seek, vue);
	}
	public AbstractVueDetail(Sql sql, String t_seek, Vue vue,String c_opt2) {
		super(sql, t_seek, vue,c_opt2);
	}
	public AbstractVueDetail(Sql sql, String t_seek, Vue vue,String c_opt2,String c_opt3) {
		super(sql, t_seek, vue,c_opt2,c_opt3);
	}
	public void validateInitSaisieEnLigneDetail(AbstractVue vue,String parentOption, String childOption){
		// Saisie en ligne Mono dtail
		validateInitSaisieEnLigneDetail(vue,parentOption, childOption,false,0);
	}
	public void validateInitSaisieEnLigneDetail(AbstractVue vue,String parentOption, String childOption,boolean defChildVisible,int indice){
		// Saisie en ligne Multi dtail
		if (defChildVisible){
			setDefaultBasculeChild(true);
		}
		vueParent=vue;
		dbFiche.sql.taParent=vue.dbFiche;
		dbListe.setForcedFocus(false);

		dbFiche.jpBascule=new VueButtonSLBascule(this,parentOption,"",false);{
			dbFiche.jpCrud.addFicheBascule(dbFiche.jpBascule);
			dbFiche.jpBascule.jbBascule.setImageIconPressed(sql.getImage(sql.getAppliParam().JBBASCULE,true),true);

			dbFiche.jpCrud.setVertical();{
				jlTitreDetail=new JTextLabel();{
					jlTitreDetail.adapteTitre();
					dbFiche.jpCrud.addTitre(jlTitreDetail);
				}
				dbFiche.jpCrud.addFB(dbFiche.jpBascule.jbBascule);
			}
		}

		setBorder(null);
		dbFicheNoBorder();
		dbFiche.setBorder(BorderFactory.createEtchedBorder());
		dbListe.add(dbFiche,BorderLayout.SOUTH);


		jpDetail=new JPanel(new BorderLayout(0,0)); {
			vue.dbFiche.jpBascule=new VueButtonSLBascule(this,childOption,"",true);{
				vue.dbFiche.jpCrud.addFicheBascule(vue.dbFiche.jpBascule);
				//vue.dbFiche.jpCrud.jpBoutonCenter.add(vue.dbFiche.jpBascule.jbBascule);
				vue.dbFiche.jpCrud.basculeAdd(vue.dbFiche.jpBascule.jbBascule);
				vue.dbFiche.jpBascule.jbBascule.setImageIconPressed(sql.getImage(sql.getAppliParam().JBBASCULE,true),true);
			}
			jpDetail.add(this.dbFiche.jpCrud,BorderLayout.WEST);
			jpDetail.add(this,BorderLayout.CENTER);
		}
		vue.add(jpDetail,Gp.getGbcDetailPied(indice));
	}
	public void loadfAdapteSaisieEnLigneDetail(String titreDetail) {
		jlTitreDetail.setText(titreDetail);
		dbListe.sql.v_index="";
		dbListe.load(Sql.t_F2DebutFin);
		dbListe.load(Sql.t_LoadAllField);
		dbListe.loadTwin(dbListe.sql.t_Recno);
		addEscBascule();
	}

}
