package template_applicatif.wVue;

import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.A_doc;

/**
 * Identifiant du type de Vue
 * @author William
 *
 <br>{@link A_doc}
 <br>{@link Licence}.
*/
public enum Vue {
	// Double Fiche et Liste
	F3 								(0), // Liste & fiche Dans Frame Principale
	F2F3 							(1), // Liste & fiche Dans DlgPopup	  
	F3DETAIL 					(2), // Liste & fiche dans fiche pour saisie en ligne
	F3DETAILHIDDEN 	(3), // Liste & fiche dans fiche pour saisie en ligne liste & Fiche caches
	F3HIGHTDETAIL		(4), // Liste & fiche dans fiche pour saisie en ligne
	F3POINTAGE 			(5), // Liste & fiche dans fiche pour saisie en ligne
	F2RECHERCHER 		(6), // Liste & fiche libelle	  
	// Liste simple
	F2 								(7), // Liste dans DlgPopup spcial saisie sans Modification
	F2UNIQUE1 				(8), // Liste dans DlgPopup Spcial saisie code unique
	F2UNIQUE2 				(9), // Liste dans DlgPopup Spcial saisie code unique
	// Fiche Modif simple 
	FICHEDETAIL			(10), // Fiche unique 
	// Fiche libelle simple d'affichage
	FICHE 						(11), // Fiche spcial sans modification 
	// spcial double code
	FICHEDEA 				(12), // Liste borne  borne spcial dition
	//
	VUEINDEFINIE 		(99),
	TABLESTRUCT 			(999),
	PRINTLISTESPE0 	(80),
	PRINTLISTESPE1 	(81),
	PRINTLISTESPE2 	(82),
	PRINTLISTESPE3 	(83);
	int vue;
	Vue(int vue){
		this.vue=vue;
	}
	public int value(){
		return vue;
	}
}
