package composant_saisie.wCalculator;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.math.BigDecimal;
import java.math.MathContext;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.KeyStroke;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;

import module_standard.wListChooser.A_doc;
import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JPopup;
import composant_saisie.wComposant.JTextButton;
import composant_saisie.wComposant.JTextDb;
import composant_saisie.wSaisieFormat.CcsFmt;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class Calculator extends JPanel implements ActionListener, MouseListener {
	private static final long serialVersionUID = 1L;
	JPanel jptotal=null;
	JPanel jptouch=null;
	Dimension dim=null;
	JLabel jlespace=null;
	JTextDb operande=null;
	JTextDb affiche=null;
	public JTextDb ttotal=null;
	JTextDb toperation=null;
	JLabel jloperation=null;

	String format="########0.0##";
	boolean isTotal=true;
	private static final String UN="1";
	private static final String DEUX="2";
	private static final String TROIS="3";
	private static final String QUATRE="4";
	private static final String CINQ="5";
	private static final String SIX="6";
	private static final String SEPT="7";
	private static final String HUIT="8";
	private static final String NEUF="9";
	private static final String ZERO="0";
	//	private static final String PLUSMOINS="+/-";
	private static final String POINT=".";
	private static final String CE="CE";
	private static final String C="C";
	private static final String SUPPR="SUPPR";
	private static final String BACKSPACE="<-";
	private static final String PLUS="+";
	private static final String MOINS="-";
	private static final String FOIS="*";
	private static final String EGALE="=";
	private static final String ESCAPE="Esc";
	private static final String DIVIDE="/";
	private static final String F2="F2";
	int size=7;
	public Calculator(){
		adapte();
		this.ttotal.setText("0.0");
		this.afficheTotal();
		this.addMouseListener(this);
	}
	private void adapte(){
		dim=new Dimension(Gp.WIDTHCHAR*size,Gp.WIDTHCHAR*size);
		this.setLayout(new BorderLayout(0,0));{
			affiche=new JTextDb("0");{
				affiche.setFont(Gp.FONTTEXT18);
				affiche.setBackground(Color.WHITE);
				affiche.setEditable(false);
				affiche.setHorizontalAlignment(SwingConstants.RIGHT);
				affiche.requestFocusInWindow();
				affiche.requestFocus();
				affiche.addMouseListener(this);
			}
			jptouch=new JPanel(Gp.adaptePanelC());{
				Gp.setx(0);
				JTextButton jb7=new JTextButton(SEPT,'7');{
					setSizeButton(jb7);
					jptouch.add(jb7,Gp.gety());
					JTextButton jb8=new JTextButton(HUIT,'8');{
						setSizeButton(jb8);
						jptouch.add(jb8,Gp.getx());
						JTextButton jb9=new JTextButton(NEUF,'9');{
							setSizeButton(jb9);
							jptouch.add(jb9,Gp.getx());
						}
					}
				}


				Gp.setx(0);
				JTextButton jb4=new JTextButton(QUATRE,'4');{
					setSizeButton(jb4);
					jptouch.add(jb4,Gp.gety());
					JTextButton jb5=new JTextButton(CINQ,'5');{
						setSizeButton(jb5);
						jptouch.add(jb5,Gp.getx());
						JTextButton jb6=new JTextButton(SIX,'6');{
							setSizeButton(jb6);
							jptouch.add(jb6,Gp.getx());
						}
					}
				}
				Gp.setx(0);
				JTextButton jb1=new JTextButton(UN,'1');{
					setSizeButton(jb1);
					jptouch.add(jb1,Gp.gety());
					JTextButton jb2=new JTextButton(DEUX,'2');{
						setSizeButton(jb2);
						jptouch.add(jb2,Gp.getx());
						JTextButton jb3=new JTextButton(TROIS,'3');{
							setSizeButton(jb3);
							jptouch.add(jb3,Gp.getx());
						}
					}
				}
				Gp.setx(0);
				JTextButton jb0=new JTextButton(ZERO,'0');{
					setSizeButton(jb0);
					jptouch.add(jb0,Gp.gety());
					//					JTextButton jba=new JTextButton(PLUSMOINS);{
					//						setSizeButton(jba);
					//						jptouch.add(jba,Gp.getGridxNext());
					//					}
					Gp.getx();
					JTextButton jbpoint=new JTextButton(POINT,'.');{
						setSizeButton(jbpoint);
						jptouch.add(jbpoint,Gp.getx());
					}
				}

				jlespace=new JLabel("     ");{
					jlespace.setFocusable(false);
					jlespace.addMouseListener(this);
					Gp.setxy(4,-1);
					jptouch.add(jlespace,Gp.gety());
				}

				jptotal=new JPanel(Gp.adaptePanelC());{
					jloperation=new JLabel("Dernire opration");{
						jloperation.setForeground(Gp.FILIGRANE_LGRAY);
						jloperation.setOpaque(false);
						jloperation.addMouseListener(this);
					}
					toperation=new JTextDb(" ");{
						toperation.setWidthChar(3);
						toperation.setFont(Gp.FONTTEXT14);
						toperation.setBackground(Gp.PANELVUE_BG);
						toperation.setEditable(false);
						toperation.setHorizontalAlignment(SwingConstants.CENTER);
						toperation.addMouseListener(this);
					}
					ttotal=new JTextDb();{
						ttotal.setWidthChar((3*size)-2);
						ttotal.setFont(Gp.FONTTEXT12);
						ttotal.setBackground(Color.WHITE);
						ttotal.setEditable(false);
						ttotal.setHorizontalAlignment(SwingConstants.RIGHT);
						ttotal.addMouseListener(this);
					}
					operande=new JTextDb();{
						operande.setWidthChar((3*size)-2);
						operande.setFont(Gp.FONTTEXT12);
						operande.setBackground(Color.WHITE);
						operande.setEditable(false);
						operande.setHorizontalAlignment(SwingConstants.RIGHT);
						operande.addMouseListener(this);
					}
					Gp.gbc.insets=new Insets(1,1,1,1);
					Gp.setxy(0,-1);
					Gp.setWidth(2);
					jptotal.add(jloperation,Gp.gety());
					Gp.setx(1);
					Gp.setWidth(1);
					jptotal.add(toperation,Gp.getx());
					Gp.setx(0);
					Gp.setWidth(3);
					jptotal.add(operande,Gp.gety());
				}

				Gp.setxy(5,-1);
				Gp.setWidth(3);
				jptouch.add(jptotal,Gp.gety());
				Gp.setWidth(1);

				Gp.setxy(5,0);
				JTextButton jbp=new JTextButton(PLUS,'+');{
					setSizeButton(jbp);
					jptouch.add(jbp,Gp.gety());
					JTextButton jbm=new JTextButton(MOINS,'-');{
						setSizeButton(jbm);
						jptouch.add(jbm,Gp.getx());
					}
					JTextButton jbf2=new JTextButton(F2,KeyEvent.VK_F2);{
						setSizeButton(jbf2);
						jbf2.setForeground(Gp.BLEU_FG);
						jbf2.setColor();
						jptouch.add(jbf2,Gp.getx());
					}
				}

				Gp.setx(5);
				JTextButton jbs=new JTextButton(FOIS,'*');{
					setSizeButton(jbs);
					jptouch.add(jbs,Gp.gety());
					JTextButton jbd=new JTextButton(DIVIDE,'/');{
						setSizeButton(jbd);
						jptouch.add(jbd,Gp.getx());
					}
					JTextButton jbesc=new JTextButton(ESCAPE,27);{
						setSizeButton(jbesc);
						jbesc.setForeground(Gp.ORANGE_FG);
						jbesc.setColor();
						jptouch.add(jbesc,Gp.getx());
					}
				}
				Gp.setx(5);
				JTextButton jbg=new JTextButton(EGALE,'=');{
					jbg.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER,0), EGALE);
					setSizeButton(jbg);
					jptouch.add(jbg,Gp.gety());
					JTextButton jbcbs=new JTextButton(BACKSPACE,KeyEvent.VK_BACK_SPACE);{
						setSizeButton(jbcbs);
						jptouch.add(jbcbs,Gp.getx());
					}
					JTextButton jbc=new JTextButton(C,KeyEvent.VK_DELETE);{
						jbc.setForeground(Gp.INVALIDE_FG_RED);
						jbc.setColor();
						setSizeButton(jbc);
						jptouch.add(jbc,Gp.getx());
					}
				}
				this.add(affiche,BorderLayout.NORTH);
				this.add(jptouch,BorderLayout.SOUTH);
			}
			this.setBorder(Gp.getBorder(BorderFactory.createRaisedBevelBorder(),Color.BLACK));
		}
	}
	public void actionPerformed(ActionEvent arg0) {
		String ac=arg0.getActionCommand();
		if (isVisible()){
			if (ac.equals(UN))
				setUN();
			else if (ac.equals(DEUX))
				setDEUX();
			else if (ac.equals(TROIS))
				setTROIS();
			else if (ac.equals(QUATRE))
				setQUATRE();
			else if (ac.equals(CINQ))
				setCINQ();
			else if (ac.equals(SIX))
				setSIX();
			else if (ac.equals(SEPT))
				setSEPT();
			else if (ac.equals(HUIT))
				setHUIT();
			else if (ac.equals(NEUF))
				setNEUF();
			else if (ac.equals(ZERO))
				setZERO();
			//----------------------
			//			else if (ac.equals(PLUSMOINS))
			//				setPLUSMOINS();
			else if (ac.equals(POINT))
				setPOINT();
			else if (ac.equals(CE))
				setCE();
			else if (ac.equals(C))
				setC();
			else if (ac.equals(SUPPR))
				setC();
			else if (ac.equals(BACKSPACE))
				setBACKSPACE();
			else if (ac.equals(PLUS))
				setPLUS();
			else if (ac.equals(MOINS))
				setMOINS();
			else if (ac.equals(FOIS))
				setFOIS();
			else if (ac.equals(EGALE))
				setEGALE();
			else if (ac.equals(DIVIDE))
				setDIVIDE();
			else if (ac.equals(F2))
				setF2();
			else if (ac.equals(ESCAPE))
				setESCAPE();
		}
	}
	//------------------------// Enregistre ou effectue l'opration
	private void setDIVIDE() { 
		computeValue();
		toperation.setText("/");{
			jloperation.setForeground(Gp.VERTFONCE_FG);
			operande.setText(ttotal.getText());
		}
	}
	private void setFOIS() {
		computeValue();
		toperation.setText("*");{
			jloperation.setForeground(Gp.VERTFONCE_FG);
			operande.setText(ttotal.getText());
		}
	}
	private void setMOINS() {
		computeValue();
		toperation.setText("-");{
			jloperation.setForeground(Gp.VERTFONCE_FG);
			operande.setText(ttotal.getText());
		}
	}
	private void setPLUS() {
		computeValue();
		toperation.setText("+");{
			jloperation.setForeground(Gp.VERTFONCE_FG);
			operande.setText(ttotal.getText());
		}
	}
	private void computeValue(){
		if (toperation.getText().isEmpty()){
			ttotal.setText(affiche.getText());
		} else {
			setEGALE();
		}
		isTotal=true;
	}
	//------------------------// Effectue la derniere opration enregistre
	private boolean isValidOperation=true;
	private void setEGALE() {
		if ("+-*/".contains(toperation.getText())&& !toperation.getText().isEmpty()){
			ttotal.setText(egale());
		} else {
			ttotal.setText(affiche.getText());
		}
		if (isValidOperation){
			afficheTotal();
			ttotal.setText(affiche.getText());
			clearDerniereOperation();
		} else {
			toperation.setText("??");
			operande.setText("ERREUR");
		}
	}
	private void clearDerniereOperation(){
		toperation.setText("");{
			jloperation.setForeground(Gp.FILIGRANE_LGRAY);
			operande.setText("");
		}
	}
	private String egale(){
		String ret=ttotal.getText();
		String futurvalue="";
		BigDecimal total = new BigDecimal(ttotal.getText()); 
		BigDecimal opera = new BigDecimal(affiche.getText()); 

		if (toperation.getText().equals("/")){
			if (opera.doubleValue()!=0.0)
				futurvalue=total.divide(opera, MathContext.DECIMAL128).toPlainString();
		} else if (toperation.getText().equals("*")){
			futurvalue=total.multiply(opera).toPlainString();
		} else if (toperation.getText().equals("+")){
			futurvalue=total.add(opera).toPlainString();
		} else if (toperation.getText().equals("-")){
			futurvalue=total.subtract(opera).toPlainString();
		}

		ret=futurvalue;
		String intvalue=CcsFmt.keepMaxInt(ret, "9"+format);
		String intformat=CcsFmt.keepMaxInt(format, format);
		if ( intvalue.length()>intformat.length() )
			isValidOperation=false;
		else
			isValidOperation=true;
		return ret;
	}
	//------------------------// Ajoute un chiffre
	private void setPOINT() {
		if (!affiche.getText().contains(".")){
			replaceZero();
			if (affiche.getText().isEmpty())
				affiche.setText("0.");
			else
				affiche.setText(affiche.getText()+".");
		}
	}
	private void setUN() {		
		replaceZero();
		affiche.setText(formatValue(affiche.getText(),"1"));
	}
	private void setDEUX() {		
		replaceZero();
		affiche.setText(formatValue(affiche.getText(),"2"));
	}
	private void setTROIS() {		
		replaceZero();
		affiche.setText(formatValue(affiche.getText(),"3"));
	}
	private void setQUATRE() {		
		replaceZero();
		affiche.setText(formatValue(affiche.getText(),"4"));
	}
	private void setCINQ() {		
		replaceZero();
		affiche.setText(formatValue(affiche.getText(),"5"));
	}
	private void setSIX() {		
		replaceZero();
		affiche.setText(formatValue(affiche.getText(),"6"));
	}
	private void setSEPT() {
		replaceZero();
		affiche.setText(formatValue(affiche.getText(),"7"));
	}
	private void setHUIT() {
		replaceZero();
		affiche.setText(formatValue(affiche.getText(),"8"));
	}
	private void setNEUF() {
		replaceZero();
		affiche.setText(formatValue(affiche.getText(),"9"));
	}
	private void setZERO() {
		if (!affiche.getText().equals("0")){
			replaceZero();
			affiche.setText(formatValue(affiche.getText(),"0"));
		}
	}

	//--------------------// Fonction spciale ok
	//	private void setPLUSMOINS() {
	//		total=total*-1;
	//		afficheTotal();
	//		ttotal.setText(affiche.getText());
	//	}
	private void setC() {
		if (affiche.getDouble()==0.0)
			setCE();
		else
			affiche.setText("0");
		if (!isValidOperation){
			clearDerniereOperation();
			isValidOperation=true;
		}
	}
	private void setCE() {
		affiche.setText("0");
		ttotal.setText(affiche.getText());
	}
	private void setBACKSPACE() {
		if (affiche.getText().length()>0){
			affiche.setText(affiche.getText().substring(0, affiche.getText().length()-1));
			isTotal=false;
		}
		if (affiche.getText().isEmpty())
			setCE();
	}
	// Methode priv
	public void afficheTotal() {
		String stmp=CcsFmt.formatStrDecimal(ttotal.getText(),format,false);
		affiche.setText(""+stmp);
		isTotal=true;
	}
	private void replaceZero(){
		if (affiche.getText().equals("0") || isTotal){
			if (!isValidOperation){
				isValidOperation=true;
			}
			isTotal=false;
			affiche.setText("");
		}
	}
	private void setSizeButton(JTextButton jb){
		jb.setPreferredSize(dim);
		jb.setSize(dim);
		jb.setMaximumSize(dim);
		jb.setMinimumSize(dim);
		jb.addActionListener(this);
	}

	//--------------------// Fonction spciale  developper
	private void setF2() {
		computeValue();
		if (this.isValidOperation)
			this.putClientProperty(JPopup.T_RETURN, ttotal.getText());
		else
			this.putClientProperty(JPopup.ESCAPE, "ok");
	}
	private void setESCAPE() {
		computeValue();
		this.putClientProperty(JPopup.ESCAPE, "ok");
	}
	//----------------------// Ajoute un chiffre CAS PARTICULIER DU POINT ET DU ZERO
	private String formatValue(String nombre,String chiffre) {
		String ret=nombre;
		String futurvalue=nombre+chiffre;
		if (Gp.parseDouble(CcsFmt.formatStrDecimal(futurvalue,format,false))==Gp.parseDouble(futurvalue))
			ret=CcsFmt.formatStrDecimal(futurvalue,format,false);
		return ret;
	}
	public void mouseEntered(MouseEvent arg0) {}
	public void mouseExited(MouseEvent arg0) {}
	public void mousePressed(MouseEvent arg0) {}
	public void mouseReleased(MouseEvent arg0) {}
	public void mouseClicked(MouseEvent arg0) {
		if ( SwingUtilities.isLeftMouseButton(arg0) ){ 
			if (arg0.getClickCount()==2) {
				setF2();
			}
		}
	}
}
