package composant_saisie.wCalendar;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;

import composant_saisie.wPtime.Day;
import composant_saisie.wPtime.ListDate;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class CellRendererDate implements TableCellRenderer{
	private static final long serialVersionUID = 1L;
	ListDate listDate=null;
	JLabel jl1=null;
	JLabel jl2=null;
	JLabel jl3=null;
	JLabel jl4=null;
	JPanel jp=null;
	JPanel jpl3l4=null;
	public CellRendererDate(){
		super();
		jp=new JPanel(new BorderLayout(0,0));{
			jl1=new JLabel("");{
				jl1.setHorizontalAlignment(JLabel.CENTER);
			}
			jl2=new JLabel("");{
				jl2.setHorizontalAlignment(JLabel.CENTER);
			}
			jl3=new JLabel("");{
				jl3.setHorizontalAlignment(JLabel.CENTER);
			}
			jl4=new JLabel("");{
				jl3.setHorizontalAlignment(JLabel.CENTER);
			}
			jp.setOpaque(true);
		}
		jpl3l4=new JPanel(new BorderLayout(0,0));{
			jpl3l4.setOpaque(false);
		}

	}
	public void setListDate(ListDate listDate){
		this.listDate=listDate;
	}
	public Component getTableCellRendererComponent(JTable jt, Object cellule,boolean isSelected, boolean hasFocus, int row, int column) {
		JTableCalendar jtc=(JTableCalendar) jt;
		CalendarValues cv=jtc.cv;
		Day dayHere =cv.getCalendarDay((row*jtc.nbDayofWeek)+column-jtc.dispWeek);
		jl1.setOpaque(false);
		jl2.setOpaque(jl1.isOpaque());
		jl3.setOpaque(jl1.isOpaque());
		jl4.setOpaque(jl1.isOpaque());

		jl1.setForeground(Gp.VERTFONCE_FG);
		jl2.setForeground(Gp.VERTFONCE_FG);
		jl3.setForeground(Color.BLACK);
		jl4.setForeground(Color.DARK_GRAY);

		jl1.setFont(Gp.FONTTEXT12);
		jl2.setFont(jl1.getFont());
		jl3.setFont(Gp.FONTTEXT13);
		jl4.setFont(Gp.FONTTEXT9);

		jp.setBackground(Gp.MOVE_BG_LVERT);


		// cas standard
		switch (jtc.type){
		case JPCalendar.DAY:
			switch (jtc.attribut){
			case JPCalendar.AT_SPOINTAGE:
				jl1.setHorizontalAlignment(JLabel.RIGHT);
				jl3.setHorizontalAlignment(JLabel.LEFT);
				jl4.setHorizontalAlignment(JLabel.RIGHT);
				Object value[][]=(Object [][]) cellule;
				if (value!=null){
					jl1.setText((String)value[0][0]);{
						jl1.setForeground((Color)value[0][1]);
					}
					jl2.setText((String)value[1][0]);{
						jl2.setForeground((Color)value[1][1]);
					}
					jl3.setText(" "+(String)value[2][0]);{
						jl3.setForeground((Color)value[2][1]);
					}
					jl4.setText(" "+(String)value[3][0]);{
						jl4.setForeground((Color)value[3][1]);
					}
				}
				jpl3l4.add(jl3,BorderLayout.WEST);
				jpl3l4.add(jl4,BorderLayout.EAST);
				
				jp.add(jl1,BorderLayout.NORTH);
				jp.add(jl2,BorderLayout.CENTER);
				jp.add(jpl3l4,BorderLayout.SOUTH);
				break;
			default:{
				jp.add(jl1,BorderLayout.CENTER);
				jl1.setText((String) cellule);
				//jl1.setText(dayHere.getSDay());
				if (dayHere.isCurrent()) {
					jp.setBackground(Gp.UPDATE_BG_JAUNE);
				}
			}
			}
			break;
		case JPCalendar.MONTH:
			jp.add(jl1,BorderLayout.CENTER);
			jl1.setText((String) cellule);
			if (dayHere.isCurrentMonth()) {
				jp.setBackground(Gp.UPDATE_BG_JAUNE);
			}
			break;
		}

		// cas particulier
		// hors priode
		if (dayHere.isInNeighbourMonth()) {
			jl1.setForeground(Gp.FILIGRANE_LGRAY);
			jl2.setForeground(jl1.getForeground());
			jl3.setForeground(jl1.getForeground());
			jl4.setForeground(jl1.getForeground());
		}

		// Date selectionne
		if (listDate!=null){
			if (listDate.contains(dayHere.getDateOnly())) {
				jl1.setForeground(jt.getSelectionForeground());
				jl2.setForeground(jl1.getForeground());
				jl3.setForeground(jl1.getForeground());
				jl4.setForeground(jl1.getForeground());
				jp.setBackground(jt.getSelectionBackground());
			}
		}
		return jp;
	}
}
