package composant_saisie.wComposant;

import java.awt.Component;
import java.awt.Container;
import java.awt.FocusTraversalPolicy;
import java.util.ArrayList;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class ComposantFocusTraversalPolicy extends FocusTraversalPolicy {
	ArrayList <Component> list=null;
	Component defaultc=null;
	public ComposantFocusTraversalPolicy(Component c){
		super();
		defaultc=c;
		list = new ArrayList <Component>(Gp.MAXFIELDS);
	}
	public Component getComponentAfter(Container container, Component component) {
		Component ret=null;
		int i=list.indexOf(component);
		if (i+1<=list.size()-1){
			ret=list.get(i+1);
		} else {
			ret=getFirstComponent(container);
		}
		return ret;
	}
	public Component getComponentBefore(Container container, Component component) {
		Component ret=null;
		int i=list.indexOf(component);
		if (i-1>=0){
			ret=list.get(i-1);
		} else {
			ret=getLastComponent(container);
		}
		return ret;
	}
	public Component getDefaultComponent(Container container) {
		Component ret=null;
		if (defaultc==null){
			ret=getFirstComponent(container);
		} else {
			ret=defaultc;
		}
			
		return ret;
	}
	public Component getFirstComponent(Container container) {
		return list.get(0);
	}
	public Component getLastComponent(Container container) {
		return list.get(list.size()-1);
	}
	public void add(Component c){
		list.add(c);
	}
	public void remove(Component c){
		list.remove(c);
	}
	public void setDefaultComponent(Component c){
		defaultc=c;
	}
	public void dispose() {
		if (list!=null){
			list.clear();
			list=null;
		}
		defaultc=null;
	}
	protected void finalize()  {
//		Gp.af("finalize : "+this.getClass().getSimpleName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
