package composant_saisie.wComposant;

import java.awt.KeyboardFocusManager;
import java.awt.Point;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;

import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JPanel;

import persistance.wGlobalParam.Gp;
import template_applicatif.wListe.AbstractDbListe;
import a_doc.doc.Licence;
import fenetre_menu.wConteneur.MainFrame;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class JPopup extends JDialog implements PropertyChangeListener {
	private static final long serialVersionUID = 1L;
	public AbstractDbListe liste=null;
	JPanel jp=null;
	JPopupIClicked jcpopup=null;
	JComponent jc=null;
	public static String T_RETURN="t_return";
	public static String ESCAPE="escape";
	public static String PACK="pack";
	public boolean userUpdateValue=true;
	public boolean isTrigger=false;
	private KeyboardFocusManager fkm=null;
	MainFrame mf=null;
	public JPopup (){
		super();
		adapte();
	}
	private void adapte(){
		this.fkm=KeyboardFocusManager.getCurrentKeyboardFocusManager();
		this.setFocusable(false);
		fkm.addPropertyChangeListener("activeWindow",this);
		this.setUndecorated(true);
	}
	public void addComposant(JPanel jp,JPopupIClicked jcpopup){
		this.jp=jp;
		this.jcpopup=jcpopup;
		this.jc=(JComponent)jcpopup;
		this.add(jp);
		this.mf=(MainFrame) jcpopup.getMainFrame();
		mf.gpAbc.setIcon(this);
	}
	public void validateDebut(){
		jp.addPropertyChangeListener(T_RETURN,this);
		jp.addPropertyChangeListener(ESCAPE,this);
		jp.addPropertyChangeListener(PACK,this);
	}

	//--- Gestion de la cration de la fenetre ---------------------------------
	public void openPopup(){
		if (jc.isEnabled()){
			if (!isTrigger){
				isTrigger=true;
				userUpdateValue=false;
				jp.putClientProperty(JPopup.ESCAPE, "escape");
				jp.putClientProperty(JPopup.T_RETURN, "t_return");
				jp.putClientProperty(JPopup.PACK, "pack");
				userUpdateValue=true;
				jcpopup.setValueChild(); //Rcupere la valeur de l'appelant
				this.pack();
				setVisible(true);
				// ajoute ce popup  la liste des popups ouvert
				// a la fin de l'affichage de ce popup
				addPopup(this);
			} else {
				isTrigger=false;
			}
		}
	}
	private void addPopup(JPopup jpopup){
		if (mf.jpopup==null){
			mf.jpopup=new ArrayList< JPopup >();
		}
		mf.jpopup.add(jpopup);
	}
	//--- Gestion de la cration de la fenetre ---------------------------------

	//--- Gestion de la position  l'ecran ---------------------------------
	public void setVisible(boolean enable){
		if (enable) {
			setRelativeLocation();
		}
		super.setVisible(enable);
	}
	public void pack(){
		super.pack();
		setRelativeLocation();
	}
	//--- Gestion de la position  l'ecran ---------------------------------
	public void setRelativeLocation(){
		Point p=null;
		if (jc.isShowing()){
			p= jc.getLocationOnScreen();
			p.y=p.y+jc.getHeight();
		} else {
			p=new Point(0,0);
		}
		Gp.setRelativeLocation(this,p,jp.getSize());
	}
	//--- Gestion du dispose de la fenetre ---------------------------------
	private void hidePopup(){ // Quitte par F2 ou Esc 
		// la souris ne joue plus sont role pour le trigger
		// Force le trigger  false
		// Au prochain appel on affichera la fenetre
		if (isVisible()){
			removeAndDispose(this);{
				isTrigger=false;
			}
		}
	}
	private void removeAndDispose(JPopup jpopup){ // Quitte par click de souris Ailleurs
		for (int i=0;i<mf.jpopup.size();i++){
			if (mf.jpopup.get(i)==jpopup){
				mf.jpopup.set(i,null);
				mf.jpopup.remove(i);
				jpopup.setTriggerOnDispose();
				jpopup.setVisible(false);
				jpopup.dispose();
				break;
			}
		}
		// ractive le dernier
		if (mf.jpopup.size()>0){
			jc.requestFocus();
		} else {
			mf.jpopup=null;
		}
	}
	private void setTriggerOnDispose(){
		if (jc.getMousePosition()==null)// la souris n'est pas dans le component jc
			isTrigger=false;
		else
			if(!jcpopup.clickedInFleche(jc.getMousePosition().getLocation()))
				isTrigger=false;
			else
				isTrigger=true;
	}
	public void propertyChange(PropertyChangeEvent arg0) {
		if (userUpdateValue){
			if (arg0.getPropertyName().equals(T_RETURN)){
				jcpopup.setValueFromChild(arg0.getNewValue());
				hidePopup();
			} else if (arg0.getPropertyName().equals(ESCAPE)){
				hidePopup();
			} else if (arg0.getPropertyName().equals(PACK)){
				pack();
			}
		}
		if (arg0.getPropertyName().equals("activeWindow")){ // Notification active Window
			Object newValue=arg0.getNewValue();
			if (isVisible() && newValue!=null && !(newValue instanceof JDialog)){
				if (newValue.getClass()!=this.getClass()){
					// fenetre autre qu'un POPUP on ferme ce POPUP
					removeAndDispose(this);
				} else {
					if (newValue!=this ){
						if ( getNum((JPopup) newValue) < getNum(this) ){
							// ferme le dernier de la liste qui est l'avant dernier
							if (mf.jpopup.size()>0){
								JPopup jpp=(JPopup) mf.jpopup.get(mf.jpopup.size()-1);
								jpp.removeAndDispose(jpp);
							}
						}
					}
				}
			}
		}
	}
	private int  getNum(JPopup jpopup){
		int ret=-1;
		for (int i=0;i<mf.jpopup.size();i++){
			if (mf.jpopup.get(i)==jpopup){
				ret=i;
				break;
			}
		}
		return ret;
	}
	public void disposePopup(){
		if (mf!=null){
			if (mf.jpopup!=null){
				for (int i=0;i<mf.jpopup.size();i++){
					if (mf.jpopup.get(i)==this){
						mf.jpopup.set(i,null);
						mf.jpopup.remove(i);
					}
				}
				if (mf.jpopup.size()==0){
					mf.jpopup=null;
				}
			}
			mf=null;
		}
		if (liste!=null){
			liste.dispose();
			liste=null;
		}
		//		liste=null;
		if (jp!=null){
			jp.removePropertyChangeListener(T_RETURN,this);
			jp.removePropertyChangeListener(ESCAPE,this);
			jp.removePropertyChangeListener(PACK,this);
			jp.remove(this);
			jp=null;
		}
		jcpopup=null;
		jc=null;
		if (fkm!=null){
			fkm.removePropertyChangeListener("activeWindow",this);
			fkm=null;
		}
		dispose();
	}
	protected void finalize()  {
		//		Gp.af("finalize : "+this.getClass().getSimpleName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
