package composant_saisie.wComposant;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyListener;
import java.util.ArrayList;

import javax.swing.ButtonGroup;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.Ccs;
import composant_saisie.wSaisieFormat.UserUpdate;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JRadio extends JPanel implements ItemListener {
	private static final long serialVersionUID = 1L;
	UserUpdate userUpdate=null;
	ButtonGroup bg=null;
	public JPanel jpGroup=null;
	ArrayList <JRadioButton> jbr=null;
	boolean userUpdated=true;
	public JRadio() {
		// Rien pour le moment  juste pour le cellRenderer de la table
		adapte();
	}
	public void setEnabled(boolean enabled){
		super.setEnabled(enabled);
		for (int i=0;i<jpGroup.getComponentCount();i++)
			jpGroup.getComponent(i).setEnabled(enabled);
	}
	public void setKeyListener(KeyListener kl){
		for (int i=0;i<jpGroup.getComponentCount();i++)
			jpGroup.getComponent(i).addKeyListener(kl);
	}
	private void adapte() {
		userUpdate=new UserUpdate(this);
		this.setLayout(new BorderLayout(0,0));{
			jpGroup=new JPanel(new FlowLayout(0,0,0));
			bg= new ButtonGroup();
			jbr=new ArrayList<JRadioButton>();
			add(jpGroup,BorderLayout.CENTER);
		}
	}
	public void addLibe(String libe) {
		remove(jpGroup);
		setLayout(new BorderLayout(5,5));
		add(jpGroup,BorderLayout.CENTER);
		JTextDb jlLibe=null;
		jlLibe = new JTextDb(libe);{
			Ccs.TexttoLibe(jlLibe);
			jlLibe.setHorizontalAlignment(JTextDb.CENTER);
		}
		this.add(jlLibe,BorderLayout.NORTH);
	}
	public void addButton(String text,boolean selected){
		JRadioButton jb=new JRadioButton(text,selected);{
			jbr.add(jb);
			bg.add(jb);
			jpGroup.add(jb);
			jb.addItemListener(this);
		}
	}
	public void setButton(String rb,boolean selected){
		setButton(Gp.parseInt(rb),selected);
	}
	public void setButton(int rb,boolean selected){
		userUpdated=false;
		if (rb<jbr.size()){
			jbr.get(rb).setSelected(selected);
		}
		userUpdated=true;
	}
	public int getButton(){
		int ret=-1;
		for (int i=0;i<jbr.size();i++) {
			if (jbr.get(i).isSelected()){
				ret=i;
				break;
			}
		}
		return ret;
	}
	public JRadioButton getRadioButton(){
		JRadioButton ret=null;
		for (int i=0;i<jbr.size();i++) {
			if (jbr.get(i).isSelected()){
				ret=jbr.get(i);
				break;
			}
		}
		return ret;
	}
	public int getWidthChar(){
		int ret=0;
		for (int i=0;i<jbr.size();i++) {
			ret=ret+2+2+jbr.get(i).getText().length();
		}
		return ret;
	}
	public void itemStateChanged(ItemEvent arg0) {
		if (userUpdated){
			Object source=arg0.getSource();
			for (int i=0;i<jbr.size();i++) {
				if (jbr.get(i)==source){
					if (jbr.get(i).isSelected()){
						userUpdate();
						i=jbr.size();
					}
				}
			}
		}
	}
	private void userUpdate(){
		userUpdate.userUpdate();
	}
	public void dispose() {
		if (jbr!=null){
			jbr.clear();
			jbr=null;
		}
		if (bg!=null){
			bg=null;
		}
		userUpdate=null;
	}
}
