package composant_saisie.wComposant;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Scrollbar;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.SwingConstants;

import template_applicatif.wVue.VueIMoveListener;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JSb extends JPanel implements AdjustmentListener, MouseWheelListener, ActionListener {
	private static final long serialVersionUID = 1L;

	VueIMoveListener vueMoveListener=null;

	public static final int MIN=0;
	public static final int MAX=90;
	public static final int MIL=45;
	private static final int PAGE=10;
	private static final int STEP=1;
	public JPanel jptopbottom=null;
	public JPanel jpprecedentsuivant=null;
	public JPanel jpprecedentesuivante=null;
	public JPanel jpscroll=null;
	public JScrollBar scrollbar=null;
	private int orientation=0;
	private boolean userSetValue=false;
	JButtonArrow jbtop=null;
	String buttontop="top";
	JButtonArrow jbbottom=null;
	String buttonbottom="bottom";
	JButtonArrow jbprecedent=null;
	String buttonprecedent="precedent";
	JButtonArrow jbsuivant=null;
	String buttonsuivant="suivant";
	JButtonArrow jbprecedente=null;
	String buttonprecedente="precedente";
	JButtonArrow jbsuivante=null;
	String buttonsuivante="suivante";
	JButtonArrow jbsuivantemil=null;
	String buttonsuivantemil="suivantmile";
	JLabel jlmil=null;
	public JSb (int orientation) {
		this.orientation=orientation;
		adapte();
	}
	public JSb (VueIMoveListener tableMoveListener,int orientation) {
		this.vueMoveListener=tableMoveListener;
		this.orientation=orientation;
		adapte();
	}
	public void setEnabled(boolean enable){
		super.setEnabled(enable);
		scrollbar.setEnabled(enable);
		if (jbtop!=null){
			jbtop.setEnabled(enable);
			jbbottom.setEnabled(enable);
			jbsuivant.setEnabled(enable);
			jbprecedent.setEnabled(enable);
			jbsuivante.setEnabled(enable);
			jbprecedente.setEnabled(enable);
			jbsuivantemil.setEnabled(enable);
		}
	}
	public void addTableMoveListener(VueIMoveListener tableMoveListener){
		this.vueMoveListener=tableMoveListener;
		setVisible(true);
	}
	public void adapte(){
		setLayout(new BorderLayout());{
			setBorder(BorderFactory.createEtchedBorder());
			jptopbottom=new JPanel(new BorderLayout(0,0));{
				jpprecedentesuivante=new JPanel(new BorderLayout(0,0));{
					jpprecedentsuivant=new JPanel(new BorderLayout(0,0));{
					}
					jpscroll=new JPanel(new BorderLayout(0,0));{
						scrollbar=new JScrollBar(orientation,MIL,PAGE,MIN,MAX+PAGE);{
							scrollbar.setUnitIncrement(STEP);
							scrollbar.addAdjustmentListener(this);
							scrollbar.addMouseWheelListener(this);
						}
						jpscroll.add(scrollbar,BorderLayout.CENTER);
					}
					jpprecedentesuivante.add(jpscroll,BorderLayout.CENTER);
				}
				jptopbottom.add(jpprecedentesuivante,BorderLayout.CENTER);
			}
			add(jptopbottom,BorderLayout.CENTER);
		}
	}
	public void setOrientation(int orientation){
		scrollbar.setOrientation(orientation);
	}
	public void setPlayButton(){
		jbtop=new JButtonArrow();{
			jbtop.setActionCommand(buttontop);
			jbtop.addActionListener(this);
			jbtop.addMouseWheelListener(this);
			jbtop.setFocusable(false);
		}
		jbbottom=new JButtonArrow();{
			jbbottom.setActionCommand(buttonbottom);
			jbbottom.addActionListener(this);
			jbbottom.addMouseWheelListener(this);
			jbbottom.setFocusable(false);
		}
		jbprecedente=new JButtonArrow();{
			jbprecedente.setActionCommand(buttonprecedente);
			jbprecedente.addActionListener(this);
			jbprecedente.addMouseWheelListener(this);
			jbprecedente.setFocusable(false);
		}
		jbsuivante=new JButtonArrow();{
			jbsuivante.setActionCommand(buttonsuivante);
			jbsuivante.addActionListener(this);
			jbsuivante.addMouseWheelListener(this);
			jbsuivante.setFocusable(false);
		}
		jbprecedent=new JButtonArrow();{
			jbprecedent.setActionCommand(buttonprecedent);
			jbprecedent.addActionListener(this);
			jbprecedent.addMouseWheelListener(this);
			jbprecedent.setFocusable(false);
		}
		jbsuivant=new JButtonArrow();{
			jbsuivant.setActionCommand(buttonsuivant);
			jbsuivant.addActionListener(this);
			jbsuivant.addMouseWheelListener(this);
			jbsuivant.setFocusable(false);
		}
		jbsuivantemil=new JButtonArrow();{
			jbsuivantemil.setActionCommand(buttonsuivantemil);
			jbsuivantemil.addActionListener(this);
			jbsuivantemil.addMouseWheelListener(this);
			jbsuivantemil.setFocusable(false);
		}
		//		jlmil=new JLabel();{
		//			jlmil.addMouseWheelListener(this);
		//			jlmil.setFocusable(false);
		//		}

		Dimension dim=null;
		Dimension dimmil=null;
		String debut=null;
		String fin=null;
		int idebut;
		int ifin;
		if (scrollbar.getOrientation()==Scrollbar.HORIZONTAL){
			dim=new Dimension(scrollbar.getPreferredSize().height,scrollbar.getPreferredSize().height);
			debut=BorderLayout.WEST;
			fin=BorderLayout.EAST;
			idebut=SwingConstants.WEST;
			ifin=SwingConstants.EAST;
		} else {
			dim=new Dimension(scrollbar.getPreferredSize().width,scrollbar.getPreferredSize().width);
			debut=BorderLayout.NORTH;
			fin=BorderLayout.SOUTH;
			idebut=SwingConstants.NORTH;
			ifin=SwingConstants.SOUTH;
		}
		jptopbottom.add(jbtop,debut);
		jptopbottom.add(jbbottom,fin);
		jpprecedentesuivante.add(jbprecedente,debut);
		jpprecedentesuivante.add(jbsuivante,fin);
		jpprecedentsuivant.add(jbprecedent,debut);
		jpprecedentsuivant.add(jbsuivant,fin);


		jbtop.setPreferredSize(dim);
		jbbottom.setPreferredSize(dim);
		jbprecedente.setPreferredSize(dim);
		jbsuivante.setPreferredSize(dim);
		jbprecedent.setPreferredSize(dim);
		jbsuivant.setPreferredSize(dim);

		jbtop.setFleche(idebut,JButtonArrow.END);
		jbbottom.setFleche(ifin,JButtonArrow.END);
		jbprecedente.setFleche(idebut,JButtonArrow.PAGE);
		jbsuivante.setFleche(ifin,JButtonArrow.PAGE);
		jbprecedent.setFleche(idebut,JButtonArrow.NEXT);
		jbsuivant.setFleche(ifin,JButtonArrow.NEXT);

		dimmil=new Dimension(0,0);
		jbsuivantemil.setPreferredSize(dimmil);
		//jlmil.setPreferredSize(dimmil);
		jpprecedentsuivant.add(jbsuivantemil,BorderLayout.CENTER);
		jpscroll.add(jpprecedentsuivant,BorderLayout.CENTER);

	}
	public void setValue(int value){
		userSetValue=true;
		scrollbar.setValue(value);
		userSetValue=false;
	}
	public void setWidth(int width){
		Dimension dim=new Dimension(width,scrollbar.getPreferredSize().height);
		setFixeSize(dim);
	}
	public void setHeight(int height){
		Dimension dim=new Dimension(scrollbar.getPreferredSize().width,height);
		setFixeSize(dim);
	}
	private void setFixeSize(Dimension dim){
		if (jbtop!=null){
			boolean milVisible=true;
			if (scrollbar.getOrientation()==Scrollbar.HORIZONTAL){
				dim.width=dim.width-(6*dim.height);
				if (dim.width<dim.height)
					milVisible=false;
			} else {
				dim.height=dim.height-(6*dim.width);
				if (dim.height<dim.width)
					milVisible=false;
			}
			Dimension dimmil=new Dimension(0,0);
			jbsuivantemil.setPreferredSize(dimmil);
			jbsuivantemil.setMaximumSize(dim);
			jbsuivantemil.setMinimumSize(dim);

			jbsuivantemil.setBorderPainted(milVisible);
			jbsuivantemil.setFocusPainted(milVisible);
			//jbsuivantmil.setVisible(milVisible);


			//			jlmil.setPreferredSize(dimmil);
			//			jlmil.setMaximumSize(dim);
			//			jlmil.setMinimumSize(dim);
			//			//jlmil.setVisible(!milVisible);
			//			if (milVisible)
			//				jpprecedentsuivant.add(jbsuivantmil,BorderLayout.CENTER);
			//			else
			//				jpprecedentsuivant.add(jlmil,BorderLayout.CENTER);
			//			jpprecedentsuivant.revalidate();
		}
		scrollbar.setPreferredSize(dim);
		scrollbar.setMaximumSize(dim);
		scrollbar.setMinimumSize(dim);
		scrollbar.revalidate();
		this.revalidate();
	}
	public void mouseWheelMoved(MouseWheelEvent arg0) {
		if (isEnabled()){
			if (vueMoveListener!=null){
				if (vueMoveListener.isMovable()){
					if (arg0.getWheelRotation()>0){
						vueMoveListener.suivant(arg0.getWheelRotation());
					} else { 
						vueMoveListener.precedent(arg0.getWheelRotation()*-1); }
				}
			}
		}
	}
	public void adjustmentValueChanged(AdjustmentEvent arg0) {
		if (!userSetValue && vueMoveListener!=null){
			if (vueMoveListener.isMovable()){
				switch (arg0.getValue()) {
				// depuis MIN
				case (STEP): vueMoveListener.suivant(1) ; break;
				case (PAGE): vueMoveListener.pageSuivante(); break;
				// depuis MIL
				case (MIL - STEP): vueMoveListener.precedent(1) ; break;
				case (MIL + STEP): vueMoveListener.suivant(1); break;
				case (MIL - PAGE): vueMoveListener.pagePrecedente(); break;
				case (MIL + PAGE): vueMoveListener.pageSuivante(); break;
				case MAX: vueMoveListener.dbFin(); break;
				case MIN: vueMoveListener.debut(); break; 
				// depuis MAX
				case (MAX - STEP): vueMoveListener.precedent(1) ; break;
				case (MAX - PAGE): vueMoveListener.pagePrecedente(); break;
				}
				if (scrollbar.getValue()!=MIN &&scrollbar.getValue()!=MAX){
					setValue(MIL);
				}
			}
		}
		if (jbtop!=null){
			if (scrollbar.getValue()==MIN){
				jbtop.setEnabled(false);
				jbprecedente.setEnabled(false);
				jbprecedent.setEnabled(false);
			} else {
				jbtop.setEnabled(true);
				jbprecedente.setEnabled(true);
				jbprecedent.setEnabled(true);
			}
			if (scrollbar.getValue()==MAX){
				jbbottom.setEnabled(false);
				jbsuivante.setEnabled(false);
				jbsuivant.setEnabled(false);
				jbsuivantemil.setEnabled(false);
			} else {
				jbbottom.setEnabled(true);
				jbsuivante.setEnabled(true);
				jbsuivant.setEnabled(true);
				jbsuivantemil.setEnabled(true);
			}
		}
	}
	public void actionPerformed(ActionEvent arg0) {
		if (vueMoveListener!=null){
			if (vueMoveListener.isMovable()){
				if (arg0.getActionCommand().equals(buttontop)){
					scrollbar.setValue(MIN);
				} else if ( arg0.getActionCommand().equals(buttonbottom)){
					scrollbar.setValue(MAX);
				} else if ( arg0.getActionCommand().equals(buttonprecedent)){
					scrollbar.setValue(MIL - STEP);
				} else if ( arg0.getActionCommand().equals(buttonsuivant)){
					scrollbar.setValue(MIL + STEP);
				} else if ( arg0.getActionCommand().equals(buttonprecedente)){
					scrollbar.setValue(MIL - PAGE);
				} else if ( arg0.getActionCommand().equals(buttonsuivante)){
					scrollbar.setValue(MIL + PAGE);
				} else if ( arg0.getActionCommand().equals(buttonsuivantemil)){
					scrollbar.setValue(MIL + PAGE);
				}
			}
		}
	}
	public void dispose() {
		vueMoveListener=null;
		jptopbottom=null;
		jpprecedentsuivant=null;
		jpprecedentesuivante=null;
		jpscroll=null;
		scrollbar=null;
		jbtop=null;
		jbbottom=null;
		jbprecedent=null;
		jbsuivant=null;
		jbprecedente=null;
		jbsuivante=null;
		jbsuivantemil=null;
		jlmil=null;
	}
}
