package composant_saisie.wComposant;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JFrame;
import javax.swing.SwingUtilities;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Edit;
import persistance.wSql.Sql;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JTextDbSpin extends JTextDb implements MouseListener, JPopupIClicked, KeyListener   {
	private static final long serialVersionUID = 1L;
	Sql sql=null;
	Color colorfondfleche=null;
	Color colorfondflechesave=new Color(230,230,230);
	Color colortraitgauche=null;
	Color colorcadrefond=null;
	int x=0;
	int y=0;
	int width=0;
	int height=0;
	
	
	//TODO COMPOSANT INUTILISABLE SIMPLE SQUELETTE
	//TODO COMPOSANT INUTILISABLE SIMPLE SQUELETTE
	//TODO COMPOSANT INUTILISABLE SIMPLE SQUELETTE
	//TODO COMPOSANT INUTILISABLE SIMPLE SQUELETTE
	
	
	
	public int calctable=0;
	public JTextDbSpin() {
		// Rien pour le moment juste pour le cellRenderer de la table
		colortraitgauche=Color.GRAY;
		colorfondfleche=colorfondflechesave;
		colorcadrefond=Color.GRAY;
		calctable=0;
	}
	public JTextDbSpin(Sql sql) {
		putClientProperty(Edit.TYPE_FIELD,Edit.INT);
		this.sql=sql;
		calctable=1;
		adapte();
	}
	private void adapte(){
		addMouseListener(this);
		addKeyListener(this);
		this.setDisabledTextColor(Gp.VERTFONCE_FG);
//		setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
		setCursor(Cursor.getPredefinedCursor(Cursor.TEXT_CURSOR));

		colortraitgauche=Color.LIGHT_GRAY;
		colorfondfleche=colorfondflechesave;
		colorcadrefond=Color.DARK_GRAY;
	}
	/*/////////////////////////
	// INTERFACE UTILISATEUR //
	/////////////////////////*/
	public void keyReleased(KeyEvent e) {}
	public void keyTyped(KeyEvent e) {}
	public void keyPressed(KeyEvent arg0) {
		if (arg0.getKeyCode()==KeyEvent.VK_F2){
			arg0.consume();
		}
	}
	public void mouseClicked(MouseEvent arg0) {
		if ( SwingUtilities.isLeftMouseButton(arg0) ){ 
			if (arg0.getClickCount()==2) {
				;
			} else if (arg0.getClickCount()==1){ 				
				if (clickedInFleche(getMousePosition())){
					;
				}
			}

		}
	}
	// Interface JPopupIClicked
	public boolean clickedInFleche(Point point){
		boolean ret=false;
		int xmin=0;
		int xmax=getHeight()-1;
		int ymin=0;
		int ymax=getHeight()-1;
		if (point!=null){
			int x=point.x;
			int y=point.y;
			if ((xmin<x && x<xmax) && (ymin < y && y < ymax) )
				ret=true;
		}
		return ret;
	}
	public void setValueChild() {
	}
	public void setValueFromChild(Object obj) {
		setText((String)obj);
	}
	public JFrame getMainFrame() {
		return sql.getMf();
	}
	// Interface JPopupIClicked

	/*/////////////////////////
	// INTERFACE UTILISATEUR //
	/////////////////////////*/
	public void mouseExited(MouseEvent arg0) {}
	public void mouseEntered(MouseEvent arg0) {}
	public void mousePressed(MouseEvent arg0) {
		if (this.isEnabled()){
			if (clickedInFleche(getMousePosition())){
				colorfondfleche=getSelectionColor();
				repaint();
			}
		}
	}
	public void mouseReleased(MouseEvent arg0) {
		if (this.isEnabled()){
			if (clickedInFleche(getMousePosition())){
				colorfondfleche=colorfondflechesave;
				repaint();
			}
		}
	}
	public void paint(Graphics g){
		super.paint(g);
		flechePaint(g);
		//this.setHorizontalAlignment(SwingConstants.LEFT);
		//g.drawString(getText(), getInsets().left+1, getInsets().top+g.getFont().getSize());
		super.surPaint(g,getText(),JTextDb.RIGHT, JTextDb.CENTER);
		paintBorder(g); // le text deborde sur le cadre
	}
	private void flechePaint(Graphics g) {
		int xx=getWidth ()-(getHeight ());
		xx=2;
		Color saveColor=g.getColor();
		// Trait Verticale gauche
		g.setColor(colortraitgauche);
		x=xx;
		y=0;
		width=1;
		height=getHeight ();
		g.fillRect(x, y, width,height );

		// carr gris
		g.setColor(colorfondfleche);
		x=xx;
		y=2;
		width=getHeight ()-3;
		height=getHeight ()-4;
		g.fillRect(x, y, width,height );

		// Ombre Cadre du carr gris
		x=xx;
		y=2;
		width=getHeight ()-2;
		height=getHeight ()-4;
		g.setColor(Color.GRAY);
		g.drawRect(x, y, width,height );
		// Cadre du carr gris
		x=xx;
		y=2;
		width=getHeight ()-3;
		height=getHeight ()-5;
		g.setColor(Gp.VERTFONCE_FG);
		g.drawRect(x, y, width,height );


		if (calctable==1) {
			// Cadre pav numrique
			x=xx;
			y=2;
			int inset=3;
			x=x+inset;
			y=y+inset+4;
			width=5;
			height=7;
			g.setColor(Color.DARK_GRAY);
			g.fillRect(x, y, width,height );

			// Cadre pav operateur
			x=x+width+2;
			y=y+2;
			height=5;
			g.fillRect(x, y, width,height );

			// Cadre rsultat
			x=xx;
			y=2;
			width=getHeight ()-3;
			height=getHeight ()-5;
			x=x+inset;
			y=y+inset;
			width=width-(2*inset)+1;
			height=3;
			g.setColor(colortraitgauche);
			g.fillRect(x, y, width,height );

			// dcoupe les touches
			g.setColor(colorfondfleche);
			x=xx;
			y=13;
			g.drawLine(x+1, y,x+1+14,y);

			x=xx;
			y=2;

			x=x+5;
			y=y+inset+4;
			g.drawLine(x, y,x,y+6);

			x=x+7;
			y=y+2;
			g.drawLine(x, y,x,y+4);

		} else {
			/*			// Triangle noir
			int nbPoints = 3 ;
			int[] xPoints = new int [nbPoints] ;
			int[] yPoints = new int [nbPoints] ;

			//g.setColor(Color.LIGHT_GRAY);
			g.setColor(Color.DARK_GRAY);
			// Point Gauche
			xPoints [1] = getWidth () - 13 ;
			yPoints [1] = 5 ;

			// Point Droit
			xPoints [0] = getWidth ()-4;
			yPoints [0] = 5 ;

			//Pointe en bas
			xPoints [2] =  getWidth () - 9;
			yPoints [2] = getHeight () - 5 ;

			g.fillPolygon (xPoints, yPoints, 3) ;
			 */
		}
		g.setColor(saveColor);
	}
	public void dispose(){
		sql=null;
		super.dispose();
	}
	protected void finalize()  {
//		Gp.af("finalize : "+this.getName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
