package composant_saisie.wComposant;

import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;

import javax.swing.JPasswordField;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Edit;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */

public class JTextPassword extends JPasswordField implements FocusListener {
	private static final long serialVersionUID = 1L;
	public JTextPassword(){
		adapte();
	}
	public JTextPassword(String txt){
		super(txt);
		adapte();
	}
	private void adapte(){
		putClientProperty(Edit.TYPE_FIELD,Edit.TEXT);
		this.setDisabledTextColor(Gp.VERTFONCE_FG);
		this.addFocusListener(this);
	}
	public String getText(){
		String ret="";
		if (getPassword()!=null){
			char[] pass=getPassword();
			for (int i=0;i<pass.length;i++){
				 ret=ret+pass[i];
			}
		}
		return ret;
	}
	public void setEnabled(boolean enable){
		if (!this.isEditable()){
			enable=false;
		}
		super.setEnabled(enable);
	}
	public void setEditable(boolean enable){
		super.setEditable(enable);
		setFocusable(enable);
		this.setEnabled(enable);
	}
	public void focusGained(FocusEvent e) {
		this.selectAll();
	}
	public void focusLost(FocusEvent e) {
		this.setSelectionStart(0);
		this.setSelectionEnd(0);
	}

}
