package composant_saisie.wComposant;

import java.awt.Color;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.border.Border;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.Document;
import javax.swing.text.JTextComponent;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Edit;
import persistance.wSql.Sql;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.Ccs;
import composant_saisie.wSaisieFormat.CcsFmt;
import composant_saisie.wSaisieFormat.Fmt;
import composant_saisie.wSaisieFormat.UserUpdate;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JTimeDelay extends JPanel implements DocumentListener,KeyListener, FocusListener {
	private static final long serialVersionUID = 1L;
	ComposantFocusTraversalPolicy cftp=null;
	Ccs ccs=null;
	JTextDbTime deb=null;
	JTextDb espace=null;
	JTextDbTime fin=null;
	JTextDb egale=null;
	JTextDbTime tot=null;
	String ancdeb="";
	String ancfin="";
	String anctot="";
	boolean updatableValue=true;
	boolean valueChanged=false;
	JTextDbTime lastFocus=null;
	Sql sql=null;
	UserUpdate userupdate=null;
	private boolean jtimedelayrequestfocusenter=false;
	private boolean jtimedelayrequestfocuscancel=false;
	public JTimeDelay(Sql sql, String sdeb, String sfin){
		this.sql=sql;
		adapte(sdeb,sfin);		
	}
	private void adapte(String sdeb, String sfin) {
		this.userupdate=new UserUpdate(this);
		putClientProperty(Edit.TYPE_FIELD,Edit.TIMEDELAY);
		deb=new JTextDbTime(sql);{
			deb.setOrientation(SwingConstants.VERTICAL);
		}
		espace = new JTextDb("   ");{
			espace.adapteTextLibe();
			espace.setOpaque(false);
			espace.setBorder(null);
			espace.setForeground(Color.BLACK);
			espace.setFocusable(false);
		}
		fin=new JTextDbTime(sql);{
			fin.setOrientation(SwingConstants.VERTICAL);
		}
		egale = new JTextDb("  = ");{
			egale.adapteTextLibe();
			egale.setOpaque(false);
			egale.setBorder(null);
			egale.setForeground(Color.BLACK);
			egale.setFocusable(false);
		}
		tot=new JTextDbTime(sql);{
			tot.setOrientation(SwingConstants.HORIZONTAL);
		}
		ccs=new Ccs(sql);
		ccs.adapteT(this,deb,"deb", Fmt.TIME);
		ccs.adapteT(this,fin,"fin", Fmt.TIME);
		ccs.adapteT(this,tot,"plag",Fmt.TIME);

		deb.setSTime(sdeb);
		fin.setSTime(sfin);
		tot.setDEA(sdeb, sfin);

		ccs.addEditListener(deb,Ccs.TIME);
		ccs.addEditListener(fin,Ccs.TIME);
		ccs.addEditListener(tot,Ccs.TIME);
		this.setLayout(new FlowLayout(0,0,0));{
			this.add(deb);
			this.add(espace);
			this.add(fin);
			this.add(egale);
			this.add(tot);
		}
		this.setOpaque(false);
		this.setFocusable(false);{
			this.setRequestFocusEnabled(true);
			this.addFocusListener(this);
		}
	}
	public void setBorder(Border border){
		if (deb!=null){
			deb.setBorder(border);
			fin.setBorder(border);
			tot.setBorder(border);
		}
	}
	public void setBackground(Color color){
		super.setBackground(color);
		if (deb!=null){
			deb.setBackground(color);
			fin.setBackground(color);
			tot.setBackground(color);
		}
	}
	public void setForeground(Color color){
		super.setForeground(color);
		if (deb!=null){
			deb.setForeground(color);
			fin.setForeground(color);
			tot.setForeground(color);
		}
	}
	public void setFont(Font font){
		super.setFont(font);
		if (deb!=null){
			deb.setFont(font);
			fin.setFont(font);
			tot.setFont(font);
		}
	}
	public void setEnabled(boolean enable){
		super.setEnabled(enable);
		if (deb!=null){
			deb.setEnabled(enable);
			fin.setEnabled(enable);
			tot.setEnabled(enable);
		}
	}	
	public void setOk(JComponent jc){
		if (jc!=null){
			jc.setForeground(Gp.LABEL_FG_BLACK);
			jc.setBorder(Gp.getBorder(Gp.LABEL_BORDER));
		}
	}	
	public void setOk(){
		userActionRecordFocusListe();
		//		setOk(deb);
		//		setOk(fin);
		//		setOk(tot);
	}

	public void focusGained(FocusEvent e) {}
	public void focusLost(FocusEvent e) {
		setFocusable(false);
	}
	public void requestFocus(){

		if (jtimedelayrequestfocusenter){
			jtimedelayrequestfocusenter=false;
			setFocusable(true);
			super.requestFocus();
			valueChanged=false;
			setOk(deb);
			setOk(fin);
			setOk(tot);
		} else if (jtimedelayrequestfocuscancel){
			jtimedelayrequestfocuscancel=false;
			setFocusable(true);
			super.requestFocus();
			valueChanged=false;
			setOk(deb);
			setOk(fin);
			setOk(tot);
		} else {
			deb.requestFocus();
			deb.selectAll();
			ancdeb=deb.getSTime();
			ancfin=fin.getSTime();
			anctot=tot.getSTime();
		}
	}

	public void keyReleased(KeyEvent e) {}
	public void keyTyped(KeyEvent e) {}
	public void keyPressed(KeyEvent e) { // ATTENTION MEME RACCOURCI QUE ABSTRACTDBFICHE
		if (e.isControlDown()){
			switch (e.getKeyCode()) {
			case KeyEvent.VK_M:
				e.consume();
				setFocusable(true);
				super.requestFocus();
				Gp.dispatchEvent(this,e);
				break;
			default:
				break; }
		} else {
			switch (e.getKeyCode()) {
			case KeyEvent.VK_F5:
				e.consume();
				this.setFocusable(true);
				super.requestFocus();
				Gp.dispatchEvent(this,e);
				break;
			case KeyEvent.VK_F3:
				e.consume();
				this.setFocusable(true);
				super.requestFocus();
				Gp.dispatchEvent(this,e);
				break;
			case KeyEvent.VK_ESCAPE:
				e.consume();
				userActionCancelFocusSaisie();
				Gp.dispatchEvent(this,e);
				break;
			case KeyEvent.VK_ENTER: 
				e.consume();
				userActionRecordFocusListe();
				if (e.getSource()==tot){
					Gp.dispatchEvent(this,e);
				} 
				break;
			default:
				break; }
		}
	}
	private void userActionCancelFocusSaisie() {
		jtimedelayrequestfocuscancel=true;{
			this.requestFocus();
		}
	}
	private void userActionRecordFocusListe() {
		if (deb.isFocusOwner()||lastFocus==deb){
			fin.requestFocus();
			updatableValue=false;
			deb.setSTime(CcsFmt.formatStrTime(deb.getText(),true));
			tot.setDEA(deb.getText(),fin.getText());
			updatableValue=true;

			setOk(deb);

			if (valueChanged){
				ccs.fireT(deb,Ccs.TIME);
				userUpdateParent();
			}
		}
		if (fin.isFocusOwner()||lastFocus==fin){
			tot.requestFocus();
			updatableValue=false;
			fin.setSTime(CcsFmt.formatStrTime(fin.getText(),true));
			tot.setDEA(deb.getText(),fin.getText());
			updatableValue=true;

			setOk(fin);

			if (valueChanged){
				ccs.fireT(fin,Ccs.TIME);
				userUpdateParent();
			}
		}
		if (tot.isFocusOwner()||lastFocus==fin){
			updatableValue=false;
			tot.setPlage(CcsFmt.formatStrTime(tot.getText(),true));
			deb.setSTime(tot.getDebSTime());
			fin.setSTime(tot.getFinStime());
			updatableValue=true;

			setOk(tot);

			if (valueChanged){
				ccs.fireT(tot,Ccs.TIME);
				jtimedelayrequestfocusenter=true;{
					this.requestFocus();
				}
				userUpdateParent();
			} else {
				deb.requestFocus();
			}
		}
	}
	public String getTimeDelay() {
		return tot.getTimeDelay();
	}
	public String getSTimeDelay() {
		return tot.getSTimeDelay();
	}
	public void setTimeDelay(String timedelay) {
		if (timedelay.length()!=15){
			timedelay="00:0000:0000:00";
		} 
		updatableValue=false;
		tot.setDEA(timedelay.substring(0,5),timedelay.substring(5,10));
		deb.setSTime(tot.getDebSTime());
		fin.setSTime(tot.getFinStime());
		updatableValue=true;
	}
	public int getTimeDelayMinutes() {
		return tot.getTimeDelayMinutes();
	}
	public String getSTime(){
		return tot.getSTime();
	}
	public void changedUpdate(DocumentEvent de) {}
	public void removeUpdate(DocumentEvent de) {
		userUpdateTextField(de.getDocument());
	}
	public void insertUpdate(DocumentEvent de) {
		userUpdateTextField(de.getDocument());
	}
	private void userUpdateTextField(Document jctd) {
		JTextComponent jc=(JTextComponent) jctd.getProperty(Ccs.JTPARENTDOC);
		if (jc.isValid()){
			if (this.isEnabled()){
				if (updatableValue) {
					updatableValue=false;
					if (jc==deb){
						if (deb.userUpdate){
							userUpdateParent();
							valueChanged=true;
							ccs.fireT(jc,Ccs.TIME);
							lastFocus=deb;	
						}
					}
					if (jc==fin){
						if (fin.userUpdate){
							userUpdateParent();
							valueChanged=true;
							ccs.fireT(jc,Ccs.TIME);
							lastFocus=fin;	
						}
					}
					if (jc==tot){
						if (tot.userUpdate){
							userUpdateParent();
							valueChanged=true;
							ccs.fireT(jc,Ccs.TIME);
							lastFocus=tot;	
						}
					}
					updatableValue=true;
				}
			}
		}
	}
	private void userUpdateParent(){
		userupdate.userUpdate();
	}
	public void setComposentFocusTraversalPolicy(Container container) {
		cftp=new ComposantFocusTraversalPolicy(deb); 
		cftp.add(deb);
		cftp.add(fin);
		cftp.add(tot);
		container.setFocusable(true);
		container.setFocusTraversalPolicy(cftp);

	}
	public void dispose() {
		if (cftp!=null){
			cftp.dispose();
			cftp=null;
		}
		if (ccs!=null){
			ccs.dispose();
			ccs=null;
		}
		if (deb!=null){
			deb.dispose();
			deb=null;
		}
		if (espace!=null){
			espace.dispose();
			espace=null;
		}
		if (fin!=null){
			fin.dispose();
			fin=null;
		}
		if (egale!=null){
			egale.dispose();
			egale=null;
		}
		if (tot!=null){
			tot.dispose();
			tot=null;
		}
		if (lastFocus!=null){
			lastFocus.dispose();
			lastFocus=null;
		}
		if (userupdate!=null){
			userupdate=null;
		}
		sql=null;
	}
	protected void finalize()  {
		//Gp.af("finalize : "+getClass().getSimpleName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
