package composant_saisie.wComposant;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Insets;

import javax.swing.border.AbstractBorder;

import a_doc.doc.Licence;



/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class RoundBorder extends AbstractBorder
{
	private static final long serialVersionUID = 1L;
	private int roundSize = 9;
	private Insets insets=null;
	public RoundBorder() { 
		adapte();
	}
	private void adapte() {
		insets=new Insets(7, 10,7,10);
	}
	public RoundBorder(int roundSize) { 
		this.roundSize = roundSize;
		adapte();
	}
	public void paintBorder(Component c, Graphics g, int x, int y, int width, int height) {
		g.setColor(Color.BLACK);
		g.drawRoundRect(x, y, width-1, height-1, roundSize, roundSize);
		g.setColor(Color.WHITE);
		g.drawRoundRect(x+1, y+1, width-3, height-3, roundSize-1, roundSize-1);
	}
	public void setInsets(Insets insets){
		this.insets=insets;
	}
	public Insets getBorderInsets(Component c) {
		return insets; 
	}
	public Insets getBorderInsets(Component c, Insets i) {
		i.left = i.right = i.bottom = i.top = 4;
		return i;
	}
	public boolean isBorderOpaque() { 
		return true; 
	}
}
