package composant_saisie.wPtime;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.KeyStroke;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JFocus;
import composant_saisie.wComposant.JPopup;
import composant_saisie.wComposant.JTextButton;
import composant_saisie.wComposant.JTextDb;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JPTime extends JPanel implements ActionListener, MouseWheelListener, MouseListener, KeyListener {
	private static final long serialVersionUID = 1L;
	JTime jtime=null;
	JPanel jpCtrl=null;
	JTextButton jbF2=null;
	JTextButton jbHV=null;
	JTextButton jbEsc=null;
	JPanel jpbutton=null;
	JTextDb jtdeb=null;
	JTextDb jtfin=null;
	JLabel jldeb=null;
	JLabel jlfin=null;
	JPanel jpdeb=null;
	JPanel jpfin=null;
	JPanel jplabel=null;
	JFocus jfocus=null;
	public JPTime(){
		adapte();
	}
	private void adapte() {
		jfocus=new JFocus();{
			jfocus.addKeyListener(this);
		}
		this.add(jfocus);

		jtime=new JTime();{
			jtime.setPanelToNotify(this);
			jpCtrl=new JPanel(new BorderLayout());{
				jpbutton=new JPanel();{
					jbF2=new JTextButton("F2",KeyEvent.VK_F2);{
						jbF2.addActionListener(this);
						jbF2.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER,0), "F2");
					}
					jbHV=new JTextButton("F4",KeyEvent.VK_F4);{
						jbHV.addActionListener(this);
					}
					jbEsc=new JTextButton("Esc",27);{
						jbEsc.addActionListener(this);
					}
				}
				jplabel=new JPanel();{
					jpdeb=new JPanel(new BorderLayout(0,0));{
						jldeb=new JLabel("H.Deb");{
							jldeb.setBorder(BorderFactory.createLineBorder(Color.GRAY));
							jldeb.setPreferredSize(new Dimension(0,12));
							jldeb.setHorizontalAlignment(SwingConstants.CENTER);
						}
						jtdeb=new JTextDb("deb");{
							jtdeb.adapteTextLibe();
							jtdeb.addMouseWheelListener(this);
							jtdeb.addMouseListener(this);
						}
						jpdeb.add(jldeb,BorderLayout.NORTH);
						jpdeb.add(jtdeb,BorderLayout.SOUTH);
					}
					jpfin=new JPanel(new BorderLayout(0,0));{
						jlfin=new JLabel("H.Fin");{
							jlfin.setBorder(BorderFactory.createLineBorder(Color.GRAY));
							jlfin.setPreferredSize(new Dimension(0,12));
							jlfin.setHorizontalAlignment(SwingConstants.CENTER);
						}
						jtfin=new JTextDb("fin");{
							jtfin.adapteTextLibe();
							jtfin.addMouseWheelListener(this);
							jtfin.addMouseListener(this);
						}
						jpfin.add(jlfin,BorderLayout.NORTH);
						jpfin.add(jtfin,BorderLayout.SOUTH);
					}
				}
			}
		}
		this.setLayout(new BorderLayout());
		this.add(jtime,BorderLayout.CENTER);
		jtime.setBorder(Gp.getBorder(BorderFactory.createRaisedBevelBorder(),Gp.LABEL_FG_BLACK));
		this.setBorder(BorderFactory.createLineBorder(Color.BLACK));
	}
	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==jbF2){
			setF2();
		} else if (e.getSource()==jbEsc){
			setESCAPE();
		} else if (e.getSource()==jbHV){
			setToggleOrientation();
		}
	}

	private void setToggleOrientation() {
		if (jtime.isVertical()){
			setOrientation(SwingConstants.HORIZONTAL);
		} else {
			setOrientation(SwingConstants.VERTICAL);
		}
		if (jtime.isPlage()){
			setPlageLabel();
		}
		if (this.getClientProperty(JPopup.PACK).equals("pack")) {
			this.putClientProperty(JPopup.PACK, "repack");
		} else {
			this.putClientProperty(JPopup.PACK, "pack");
		}
	}
	private void setPlageLabel(){
		if (jtime.isVertical()){
			jpCtrl.add(jplabel,BorderLayout.SOUTH);
		} else {
			jpCtrl.add(jplabel,BorderLayout.EAST);
		}
	}
	private void setF2() {
		this.putClientProperty(JPopup.T_RETURN, getTimeValue());
	}
	private void setESCAPE() {
		this.putClientProperty(JPopup.ESCAPE, "ok");
	}
	public void setOrientation(int orientation) {
		if (orientation==SwingConstants.VERTICAL){
			jpbutton.setLayout(new GridLayout(1,4));
			jplabel.setLayout(new GridLayout(1,2));
			this.add(jpCtrl,BorderLayout.NORTH);
			this.add(jpbutton,BorderLayout.SOUTH);
		} else {
			jpbutton.setLayout(new GridLayout(4,1));
			jplabel.setLayout(new GridLayout(2,1));
			this.add(jpCtrl,BorderLayout.WEST);
			this.add(jpbutton,BorderLayout.EAST);
		}
		jpbutton.add(jbF2);
		jpbutton.add(jbEsc);
		jpbutton.add(jfocus);
		jpbutton.add(jbHV);
		jplabel.add(jpdeb);
		jplabel.add(jpfin);
		jtime.setOrientation(orientation);
	}
	public void incrValue() {
		jtime.incrValue();
	}
	public void decrValue() {
		jtime.decrValue();
	}
	public void setPTime(Point point) {
		jtime.setPTime(point);
	}
	public String getSTime(){
		return jtime.getSTime();
	}
	public void setTimeValue(Time time) {
		jtime.setTimeValue(time);
	}
	public Time getTimeValue(){
		return jtime.getTimeValue();
	}
	public void setPlage(String timedeb, String timefin) {
		jtime.setPlage(timedeb,timefin);
		jtdeb.setText(jtime.getDebSTime());
		jtfin.setText(jtime.getFinSTime());
		setPlageLabel();
	}
	public void setPlage(String timetot) {
		jtime.setPlage(timetot);
		jtdeb.setText(jtime.getDebSTime());
		jtfin.setText(jtime.getFinSTime());
		setPlageLabel();
	}
	public String getTimeDelay() {
		return jtime.getTimeDelay();
	}
	public String getSTimeDelay() {
		return jtime.getSTimeDelay();
	}
	public int getTimeDelayMinutes() {
		return jtime.getTimeDelayMinutes();
	}
	public String getDebSTime() {
		return jtime.getDebSTime();
	}
	public String getFinSTime() {
		return jtime.getFinSTime();
	}
	public boolean isPlage(){
		return jtime.isPlage();
	}
	public void mouseWheelMoved(MouseWheelEvent e) {
		if (isEnabled()){
			if (e.getWheelRotation()>0){
				if (e.getSource()==jtdeb){
					jtime.incrMinDebut();
				} else {
					jtime.incrMinFin();
				}
			} else {
				if (e.getSource()==jtdeb){
					jtime.decrMinDebut();
				} else {
					jtime.decrMinFin();
				}
			}
			jtime.repaint();
		}
	}
	public void mouseClicked(MouseEvent e) {
		if ( SwingUtilities.isLeftMouseButton(e) ){ 
			if (e.getClickCount()==2) {
				jtime.setF2();
			} 
		}
	}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
	public void keyReleased(KeyEvent e) {}
	public void keyTyped(KeyEvent e) {}
	public void keyPressed(KeyEvent e) {
		switch (e.getKeyCode()){
		case KeyEvent.VK_UP:
			if (isPlage()){
				if (jtime.isVertical()){
					jtime.decrMinFin();
				} else {
					jtime.decrMinDebut();
				}
				jtime.repaint();
			} else {
				if (jtime.isVertical()){
					jtime.decrValue();
				}
			}
			e.consume();
			break;
		case KeyEvent.VK_DOWN:
			if (isPlage()){
				if (jtime.isVertical()){
					jtime.incrMinFin();
				} else {
					jtime.incrMinDebut();
				}
				jtime.repaint();
			} else {
				if (jtime.isVertical()){
					jtime.incrValue();
				}
			}
			e.consume();
			break;
		case KeyEvent.VK_LEFT:
			if (isPlage()){
				if (jtime.isVertical()){
					jtime.decrMinDebut();
				} else {
					jtime.decrMinFin();
				}
				jtime.repaint();
			} else {
				if (!jtime.isVertical()){
					jtime.decrValue();
				}
			}
			e.consume();
			break;
		case KeyEvent.VK_RIGHT:
			if (isPlage()){
				if (jtime.isVertical()){
					jtime.incrMinDebut();
				} else {
					jtime.incrMinFin();
				}
				jtime.repaint();
			} else {
				if (!jtime.isVertical()){
					jtime.incrValue();
				}
			}
			e.consume();
			break;
		}
	}
	public void setClickable(boolean clickable) {
		jtime.setClickable(clickable);
	}
	public void clearPlage() {
		jtime.clearPlage();
	}
	public void addPlage(Time time) {
		jtime.addPlage(time);
	}
	public void dispose(){
		if (jtime!=null){
			jtime.dispose();
			jtime=null;
		}
		jpCtrl=null;
		jbF2=null;
		jbHV=null;
		jbEsc=null;
		jpbutton=null;
		jtdeb=null;
		jtfin=null;
		jldeb=null;
		jlfin=null;
		jpdeb=null;
		jpfin=null;
		jplabel=null;
		jfocus=null;
	}
	protected void finalize()  {
		//		Gp.af("finalize : "+this.getClass().getSimpleName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
