package composant_saisie.wSaisieFormat;

import a_doc.doc.Licence;

/**
 * Identifiant du type d'affichage des Edits
 * @author William
 *
<br>{@link A_doc}
 <br>{@link Licence}.
  */
public enum Fma {
	// static de Mise en forme
	FIELD 	(0),
	CHECK 	(2),
	F2    	(3),
	NUM   	(4),
	INTERO 	(5),
	GRAS   	(6),
	NORMAL   	(7),
	NUMGRAS  	(8),
	LIBEMAX 		(9),
	INVISIBLE 	(10),
	NUMSPACE 	(11),
	NUMGRASSPACE	(12),
	RADIO			(13),
	DATE		(14),
	MONTH     (15),
	YEAR      (16),
	TIME		(17),
	PHONE     (18),
	SECU      (19),
	URSS      (20),
	POSTAL    (21),
	TIMEDELAY (22),
	PLAGETIMES (23),
	CACHE 	(24),

	// Impression
	PRINTSPACE	(50),
	PRINTLIBE 	(51),
	PRINTCHAMP 	(52),
	PRINTRUPTURE 	(53),
	PRINTSOMME    (54),
	PRINTCOUNT 	(55),
	PRINTRUPTUREINVISIBLE (56);
	int fma;
	Fma(int fma){
		this.fma=fma;
	}
	public int value(){
		return fma;
	}

}
