package composant_saisie.wSaisieFormat;

import persistance.wSql.Edit;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public enum Fmt {
	DATE("##/##/####"),
	TIME("##:##"),
	TIMEDELAY("##:##-##:##=##:##"),
	PHONE("##-##-##-##-##"),
	SECU("#-##-##-##-###-###-##"),
	URSS("###-###############"), 
	POSTAL("#####"), 
	MONTH("##/####"),
	YEAR("####"), 
	PLAGETIMES("##:##"),

	CHECK("K"),
	IMPCHECK("KKKKK");
	
	String masque="#";
	String fmt;
	Fmt(String fmt){
		this.fmt=fmt;
	}
	public String getFmt(){
		return fmt;
	}
	public int length(){
		return fmt.length();
	}
	public String splitter(){
		String ret="";
		for (int i=0; i<fmt.length();i++){
			if (!fmt.substring(i,i+1).equals(masque)){
				ret=fmt.substring(i,i+1);
				break;
			}
		}
		return ret;
	}
	public int nbPart(){
		int ret=0;
		for (int i=0; i<fmt.length();i++){
			if (!fmt.substring(i,i+1).equals(masque)){
				if (ret==0)
					ret++;
				ret++;
			}
		}
		return ret;
	}
	public Fma fma(){
		Fma ret=null;
		if (this==Fmt.DATE){
			ret=Fma.DATE;
		} else if (this==Fmt.TIME){
			ret=Fma.TIME;
		} else if (this==Fmt.TIMEDELAY){
			ret=Fma.TIMEDELAY;
		} else if (this==Fmt.PHONE){
			ret=Fma.PHONE;
		} else if (this==Fmt.SECU){
			ret=Fma.SECU;
		} else if (this==Fmt.URSS){
			ret=Fma.URSS;
		} else if (this==Fmt.POSTAL){
			ret=Fma.POSTAL;
		} else if (this==Fmt.MONTH){
			ret=Fma.MONTH;
		} else if (this==Fmt.YEAR){
			ret=Fma.YEAR;
		} else if (this==Fmt.PLAGETIMES){
			ret=Fma.PLAGETIMES;
			
		} else if (this==Fmt.CHECK || this==Fmt.IMPCHECK){
			ret=Fma.CHECK;
		}
		return ret;
	}
	public Edit getTypeEdit(){
		Edit ret=null;
		if (this==Fmt.DATE){
			ret=Edit.DATE;
		} else if (this==Fmt.TIME){
			ret=Edit.TIME;
		} else if (this==Fmt.TIMEDELAY){
			ret=Edit.TIMEDELAY;
		} else if (this==Fmt.PHONE){
			ret=Edit.PHONE;
		} else if (this==Fmt.SECU){
			ret=Edit.SECU;
		} else if (this==Fmt.URSS){
			ret=Edit.URSS;
		} else if (this==Fmt.POSTAL){
			ret=Edit.POSTAL;
		} else if (this==Fmt.MONTH){
			ret=Edit.MONTH;
		} else if (this==Fmt.YEAR){
			ret=Edit.YEAR;
		} else if (this==Fmt.PLAGETIMES){
			ret=Edit.PLAGETIMES;
			
		} else if (this==Fmt.CHECK || this==Fmt.IMPCHECK){
			ret=Edit.CHECK;
		}
		return ret;
	}
}
