package composant_saisie.wSaisieFormat;

import java.beans.PropertyChangeListener;

import javax.swing.JComponent;

import a_doc.doc.Licence;



/**
 * Notifieur de modification
*
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class UserUpdate  {
	public static String COL_LISTECELLEDITOR 	= "editcolchange";
	public static String COL_LISTECELLRENDERER 	= "focuscolchange";
	public static String COL_LISTESELECTION 	= "replaceselected";
	public static String RELOADTWIN 			= "updatef2";
	public static String CELLEDIT 				= "celledit";
	public static String PLUS_RIGHT 				= "plus_right";
	
	public static final String UPDATE = "userupdate_update";
	JComponent jc;
	String property=UPDATE;
	public UserUpdate(String property){
		this.property=property;
	}
	public UserUpdate(JComponent jc,String property){
		this.property=property;
		this.jc=jc;
		jc.putClientProperty(property,"ok");
	}
	public UserUpdate(JComponent jc){
		this.jc=jc;
		this.property=UPDATE;
		jc.putClientProperty(property,"ok");
	}
	/**
	 * Modification de l'utilisateur, on Notifie le changement  l'couteur<br>
	 * un Edit notifie une Fiche<br>
	 * une Fiche notifie une Vue<br>
	 */
	public void userUpdate(){
		if (jc.getClientProperty(this.property)!=null){
			if (jc.getClientProperty(this.property).equals("ok"))
				jc.putClientProperty(this.property,"nook");
			else
				jc.putClientProperty(this.property,"ok");
		}
	}
	public void removePropertyChangeListener(String propertie, PropertyChangeListener pcl) {
		jc.removePropertyChangeListener(property,pcl);
	}
	public void addPropertyChangeListener(String propertie, PropertyChangeListener pcl) {
		jc=(JComponent) pcl;
		jc.putClientProperty(property,"ok");
		jc.addPropertyChangeListener(property,pcl);
	}
}
