package fenetre_menu.wConteneur;
import java.awt.BorderLayout;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.ArrayList;

import javax.swing.JFrame;
import javax.swing.JPanel;

import module_standard.wFeedback.JDialogFeedBack;
import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JPanelImage;
import composant_saisie.wComposant.JPopup;
import composant_saisie.wComposant.JScrollPaneAuto;
import composant_saisie.wComposant.JStatusBar;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class MainFrame extends JFrame implements WindowListener  {
	private static final long serialVersionUID = 1L;
	public Gp gpAbc = null; // pour JPopup
	JPanel jpFrame = null;
	JPanelImage jpCenter = null;
	JStatusBar jstatusbar = null;
	JScrollPaneAuto jscrollpane=null;
	public ArrayList< JPopup > jpopup=null;
	public MainFrame(Gp gpAbc) {
		//Gp.debugSpyFocus();
		this.gpAbc = gpAbc;
		gpAbc.f_mf = this;
		if (Gp.isFileExists(Gp.DEVFILE)){
			gpAbc.ISDEVFILE=true;
		} else {
			Gp.setConsoleErr(true);
			Gp.setConsoleDebug(true);			
		}
		adapte();
	}

	public void adapte() {
		gpAbc.applyPreferences(gpAbc.m_user);
		jpFrame = new JPanel(new BorderLayout(5,0));{
			jpFrame.setFocusable(false);
			jpCenter = new JPanelImage();{
				gpAbc.f_mjpc = this.jpCenter;
				gpAbc.setFrameTexture();
				jpFrame.add(jpCenter, BorderLayout.CENTER);
			}
			jstatusbar = new JStatusBar();{
				gpAbc.f_mjStatusBar=jstatusbar;
				jpFrame.add(jstatusbar, BorderLayout.SOUTH);
			}
		}
		jscrollpane=new JScrollPaneAuto(jpFrame);

		// Set de la fenetre
		this.gpAbc.setIcon(this);
		this.gpAbc.setMainTitle();
		this.setSize(this.gpAbc.f_mfWidth, this.gpAbc.f_mfHeight);
		if (gpAbc.ISDEVFILE){
			this.setLocation(200,0);
		} else {
			this.setLocationRelativeTo(null);
		}
		this.setContentPane(jscrollpane);
		this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		this.addWindowListener(this);
		setVisible(true);
		///////////////////
		gpAbc.catchKeyboard();
		gpAbc.mapUser();
	}
	public void windowActivated(WindowEvent e) {}
	public void windowClosed(WindowEvent e) {}
	public void windowDeactivated(WindowEvent e) {}
	public void windowDeiconified(WindowEvent e) {}
	public void windowIconified(WindowEvent e) {}
	public void windowOpened(WindowEvent e) {}
	public void windowClosing(WindowEvent e) {
		gpAbc.closeCodeBarre();
		gpAbc.closeImpdot();
		if (!gpAbc.ISDEVFILE){
			gpAbc.clearMainFrame(true);
			gpAbc.clearContainer(this.getContentPane(),true);
			gpAbc.zoomIn(this,6);
			setVisible(false);
			if (gpAbc.appliParam.VERSIONEVAL && gpAbc.appliParam.CONTACT!=null ){
				gpAbc.m_menu="Votre avis nous intresse";
				gpAbc.m_optionText="Merci d'valuer ce logiciel";
				new JDialogFeedBack(this,new Sql(gpAbc.sqlAbc));
			}
		}
		System.exit(0);
	}
}
