package module_standard.wAide;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.JButton;
import javax.swing.JEditorPane;
import javax.swing.JFileChooser;
import javax.swing.JLabel;

import module_standard.wBackup.JDialogBackup;
import module_standard.wBackup.JFileChooserDb;
import module_standard.wBackup.JFileChooserExtensionFilter;
import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import a_doc.doc.Licence;
import fenetre_menu.wConteneur.JDialogDlg;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class JDialogAide extends JDialogDlg implements ActionListener,PropertyChangeListener {
	private static final long serialVersionUID = 1L;
	public static final int READ_AIDE=0;
	public static final int SET_AIDE=1;
	String annuler="Annuler l'affectation du bouton aide";
	JFileChooserDb jfc=null;
	JButton annul=null;
	Aide jpAide=null;
	String html="";
	String t_fileslash="file:////";
	String t_repAide="C:\\Documents and Settings\\William\\Mes documents";
	String t_pipefile="\\";
	int t_opt;
	public JDialogAide(Window wdn, Sql sql, int t_opt){
		super(wdn, sql);
		this.t_opt=t_opt;
		adapte();
	}
	private void adapte() {
		this.t_repAide=sql.getAppliParam().getPathHelp();
		this.html=Aide.getHtml(sql);
		switch (t_opt){
		case READ_AIDE:
			jpAide=new Aide(this);
			jpAide.loadPage(t_fileslash,t_repAide+t_pipefile,html);
			valide();
			break;
		case SET_AIDE:
			setAide();
			dispose();
			break;
		}
	}
	private void valide() {
		this.getContentPane().remove(jpTitre);
		this.setTitle("Aide : "+html);
		validateDebut(JDialogDlg.CENTER_ALIGNMENT);
	}
	public void dispose(){
		jpAide=null;
		super.dispose();
	}
	private boolean setAide(){
		boolean ret=false;
		File fExport=null;

		jfc = new JFileChooserDb(JDialogBackup.RESTORE);{
			jfc.addSelectedFileChanged(this);
			jfc.setNotChangeDirectory(this);
			String path=t_repAide+t_pipefile+"*.html";
			if (html.trim().length()!=0){
				annul=new JButton(annuler);
				annul.addActionListener(this);
				jfc.addSouth(annul);
				path=t_repAide+t_pipefile+html;
			}
			jfc.add(new JLabel(t_repAide+t_pipefile),BorderLayout.NORTH);
			fExport=new File(path);
			jfc.setSelectedFile(fExport);
			jfc.addChoosableFileFilter(new JFileChooserExtensionFilter("Fichier web ("+"htm"+")",new String []{ ".html",".htm"}));
		}
		String choisir="Choisir ce fichier d'aide";
		int returnVal = jfc.showDialog(this,choisir);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			fExport = jfc.getSelectedFile();
			Sql sqlAbc=new Sql(sql.getSqlAbc());
			sqlAbc.setTable("s_aide");
			
			html=fExport.getName();
			sqlAbc.writeValue(sqlAbc.t_table,"c_html='"+html+"'","c_code='"+sql.t_moduleIdAide+"'");
			sqlAbc=null;
			fExport=null;
			ret=true;
		}
		return ret;	
	}
	public void actionPerformed(ActionEvent e) {
		if (e.getActionCommand().equals(annuler)){
			Sql sqlAbc=new Sql(sql.getSqlAbc());
			sqlAbc.setTable("s_aide");
			html="";
			sqlAbc.writeValue(sqlAbc.t_table,"c_html='"+html+"'","c_code='"+sql.t_moduleIdAide+"'");
			sqlAbc=null;
			jfc.cancelSelection();
		}
	}
	public void propertyChange(PropertyChangeEvent arg0) {
		if (arg0.getPropertyName().equals(JFileChooser.SELECTED_FILE_CHANGED_PROPERTY)){
			JEditorPane jeAide  = new JEditorPane ();{
				jeAide.setPreferredSize(new Dimension(400, 400));
				jeAide.setEditable (false);
				jeAide.setBorder(Gp.getBorder(Gp.FILIGRANE_LGRAY));
			}
			if (jfc.getSelectedFile()!=null){
				if (jfc.getSelectedFile().isFile()){
					String url=t_fileslash+t_repAide+t_pipefile+jfc.getSelectedFile().getName();
					try {
						jeAide.setPage (new URL (url));
					} catch (MalformedURLException arg01) {
					} catch (IOException arg01) {
						File fExport=null;
						fExport=new File(t_repAide+t_pipefile+"*.html");
						jfc.setSelectedFile(fExport);
					}
				}
			} 
			jfc.setAccessory(jeAide);
		} else if (arg0.getPropertyName().equals(JFileChooser.DIRECTORY_CHANGED_PROPERTY)){
			File fExport=null;
			fExport=new File(t_repAide+t_pipefile+"*.html");
			jfc.setSelectedFile(fExport);
		}
		super.propertyChange(arg0);
	}
}
