package module_standard.wArborescence;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JPanel;
import javax.swing.JScrollPane;

import persistance.wSql.Sql;
import a_doc.doc.A_doc;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextButton;
import composant_saisie.wTree.JTreeDb;

import fenetre_menu.wConteneur.AbstractJDialogDb;
import fenetre_menu.wConteneur.AbstractJPanelDlg;
import fenetre_menu.wConteneur.JDialogDlg;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class Arborescence extends AbstractJPanelDlg implements ActionListener  {
	private static final long serialVersionUID = 1L;
	JTreeDb jtArbo = null;
	JTextButton jbQuitter=null;
	JTextButton jbExpand=null;
	JTextButton jbCollapse=null;
	String Quitter="Quitter";
	String Expand="+ Tous";
	String Collapse="- Tous";
	Sql sql=null;
	public Arborescence(JDialogDlg jd,Sql sql){
		super(jd);
		this.sql=sql;
		adapte();
	}
	private void adapte(){
		JPanel jpsouth=new JPanel(new FlowLayout());{
			jbCollapse= new JTextButton(Collapse);{
				jbCollapse.addActionListener(this);
			}
			jbExpand= new JTextButton(Expand);{
				jbExpand.addActionListener(this);
			}
			jbQuitter= new JTextButton(Quitter);{
				jbQuitter.addActionListener(this);
			}
			jpsouth.add(jbCollapse);
			jpsouth.add(jbExpand);
			jpsouth.add(jbQuitter);
			jd.setPreferredSize(new Dimension(800, 600));
			jd.getContentPane().add (jpsouth, BorderLayout.SOUTH);
		}
		JScrollPane jpaide = new JScrollPane ();{
			jtArbo = new JTreeDb (sql);{
				expand();
			}
			jpaide.setViewportView(jtArbo);
			jd.getContentPane().add (jpaide, BorderLayout.CENTER);
		}
	}
	public void actionPerformed(ActionEvent e) {
		if (e.getActionCommand().equals(Quitter)){
			quitter();
		} else if (e.getActionCommand().equals(Expand)){
			expand();
		} else if (e.getActionCommand().equals(Collapse)){
			collapse();
		}
	}
	private void collapse() {
		jtArbo.collapseAll();
		jbCollapse.setEnabled(false);
		jbExpand.setEnabled(true);
	}
	private void expand() {
		jtArbo.expandAll();
		jbCollapse.setEnabled(true);
		jbExpand.setEnabled(false);
	}
	private void quitter(){
		this.putClientProperty(AbstractJDialogDb.action,AbstractJDialogDb.closedialog);
	}

}
