package module_standard.wImprime;

import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics2D;

import javax.swing.JPanel;

import persistance.wGlobalParam.Gp;
import template_applicatif.wFiltre.JPdeA;
import template_applicatif.wVue.AbstractVue;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JPEntete extends JPanel {
	private static final long serialVersionUID = 1L;
	public static final int APPLI = 0;
	public static final int TITRE = 1;
	public static final int VERSION = 2;
	public static final int DATE = 3;
	public static final int HEURE = 4;
	public static final int PAGE = 5;
	public static final int IMP_BORNE = 6;
	public static final int IMP_CADREENTETE = 7;
	public static final int BORNEABORNE = 8;
	
	
	public String entete[]=null;
	public int numpage=0;
	public int numlist=0;
	public double enteteWidth=0;
	Graphics2D g2d=null;
	int charWidth=Gp.WIDTHCHAR+4;
	JPdeA jpdea=null;
	public JPEntete(AbstractVue vue,JPdeA jpdea){
		this.jpdea=jpdea;
		entete=vue.getImpEntete();
	}
	public int  drawEntete(Graphics2D g2d,double enteteWidth,int charHeight,double panelHeight,int numpage,int numlist){
		int ret=0;
		if (entete!=null){
			int yy=0;
			int xx=0;
			this.enteteWidth=enteteWidth;
			this.numpage=numpage;
			this.numlist=numlist;
			this.g2d=g2d;
			if (entete[APPLI].length()+entete[TITRE].length()+entete[VERSION].length()>0){
				if (numlist==0){
					xx=2;
					yy=2+(ret+1)*charHeight;
					// nom du logiciel EN HAUT A GAUCHE
					g2d.setFont(g2d.getFont().deriveFont(Font.PLAIN|Font.ITALIC));
					g2d.drawString(entete[APPLI],xx+charWidth,((int)panelHeight)+yy);
					// Titre de la liste~ EN HAUT AU MILIEUX
					String titre="";{
						titre="~ ";
						if (entete[TITRE].contains(")")) {
							boolean isOk=false;
							for (int i=0;i<entete[TITRE].length();i++){
								if (isOk){
									titre=titre+entete[TITRE].charAt(i);
								} else if (entete[TITRE].charAt(i)==')')
									isOk=true;
							}
							titre=titre+" ~";
						} else {
							titre="~ "+entete[TITRE]+" ~";
						}
						int sizeFont=g2d.getFont().getSize();
						g2d.setFont(g2d.getFont().deriveFont(Font.BOLD|Font.ITALIC,sizeFont+4));
						g2d.drawString(titre,xx+getXCenter((int)enteteWidth-(charWidth*2),titre),((int)panelHeight)+yy);
						g2d.setFont(g2d.getFont().deriveFont(Font.BOLD,sizeFont));
					}
					// Version du logiciel EN HAUT A DROITE
					g2d.setFont(g2d.getFont().deriveFont(Font.PLAIN|Font.ITALIC));
					g2d.drawString(entete[VERSION],xx+getXRight((int)enteteWidth-(charWidth*2),entete[VERSION]),((int)panelHeight)+yy);
				}
				ret++;
			}
			if (jpdea.isValid && entete[IMP_BORNE].equals("true")){
				if (numlist==0){
					yy=2+(ret+1)*charHeight+3;
					String de="De : "+jpdea.indexDebut;{
						String a="A : "+jpdea.indexFin;
						// Du code EN BAS CENTRE GAUCHE
						g2d.setFont(g2d.getFont().deriveFont(Font.BOLD));
						int rx=xx+getXLeftDeA((int)enteteWidth-(charWidth*2),de,a);
						int ry=((int)panelHeight)+yy;
						g2d.drawString(de,rx,ry);
						g2d.drawLine(rx,ry+3 , rx+getLen(de),ry+3 );
						// Au code EN BAS CENTRE DROITE
						rx=xx+getXRightDeA((int)enteteWidth-(charWidth*2),de,a);
						ry=((int)panelHeight)+yy;
						g2d.drawString(a,rx,ry);
						g2d.drawLine(rx,ry+3 , rx+getLen(a),ry+3 );
					}
				}
				ret++;
			} else {
				if (entete[BORNEABORNE].trim().length()>0){
					if (numlist==0){
						//yy=2+(ret+1)*charHeight+3+charHeight/2;
						yy=2+(ret+1)*charHeight+3;
						// Titre de la liste~ EN HAUT AU MILIEUX
						int sizeFont=g2d.getFont().getSize();
						g2d.setFont(g2d.getFont().deriveFont(Font.BOLD|Font.ITALIC,sizeFont+4));
						g2d.drawString(entete[BORNEABORNE].trim(),xx+getXCenter((int)enteteWidth-(charWidth*2),entete[BORNEABORNE].trim()),((int)panelHeight)+yy);
						g2d.setFont(g2d.getFont().deriveFont(Font.BOLD,sizeFont));
					}
					ret++;
				}
			}
			if (entete[DATE].length()+entete[HEURE].length()+entete[PAGE].length()>0){
				if (numlist==0){
					yy=2+(ret+1)*charHeight;
					int sizeFont=g2d.getFont().getSize();
					g2d.setFont(g2d.getFont().deriveFont(Font.PLAIN,sizeFont-4));
					// Date ddition EN BAS A GAUCHE
					// Edite  heure
					g2d.drawString(entete[DATE]+entete[HEURE],xx+charWidth,((int)panelHeight)+yy);
					// Num Page EN BAS A DROITE
					g2d.setFont(g2d.getFont().deriveFont(Font.PLAIN,sizeFont));
					g2d.drawString(entete[PAGE]+numpage,xx+getXRight((int)enteteWidth-(charWidth*2),entete[PAGE]+numpage),((int)panelHeight)+yy);
				}
				ret++;
			}

			if (entete[IMP_CADREENTETE].equals("true")){
				if (numlist==0){
					// Rectangle de la ligne
					int rx=charWidth/2;
					int ry=0;
					int rwidth=(int) enteteWidth-charWidth-charWidth/2;
					int rheight=ret*charHeight+charHeight/3;
					// Bidouille la premiere ligne pour cr un espace entre 2 pages
					g2d.drawRect(rx,((int) panelHeight)+ ry , rwidth,rheight );
				}
				ret++;
			}
			if (ret==1) // Pacth pour decoler le titre du cadre de l'dition
				ret++;
		}
		return ret;
	}

	public int getXCenter(int enteteWidth,String str){
		int ret=0;
		int lenstr=getLen(str);
		ret=(enteteWidth-lenstr)/2;
		return ret;
	}
	public int getXRight(int enteteWidth,String str){
		int ret=0;
		int lenstr=getLen(str);
		ret=(enteteWidth-lenstr);
		return ret;
	}

	public int getXRightDeA(int enteteWidth,String de,String a){
		int ret=0;
		int lende=getLen(de);
		int lena=getLen(a);
		int tiers=(enteteWidth-(lende+lena))/3;
		ret=tiers+lende+tiers;
		return ret;
	}
	public int getXLeftDeA(int enteteWidth,String de, String a){
		int ret=0;
		int lende=getLen(de);
		int lena=getLen(a);
		int tiers=(int) (enteteWidth-(lende+lena))/3;
		ret=tiers;
		return ret;
	}
	public int getLen(String str){
		FontMetrics fontMetrics = g2d.getFontMetrics();
		return fontMetrics.stringWidth(str);
	}
}
