package module_standard.wParamMenus;

import persistance.wSql.AbstractFieldsDef;
import persistance.wSql.Sql;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.Fma;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class S_menusParamLISTE extends AbstractFieldsDef {
	public S_menusParamLISTE(Sql sql,Vue vue) {
		super(sql,vue);
	}
	public Object adapteField(Vue vue){
		t_table="s_menus";
		t_nbLigne=6;
		t_filtre=null;
		v_filtre=null;
		t_index=new String[]{"c_code","c_cle2"};
		t_height=3;
		switch (vue){
		case F2:{
			t_height=1;
			t_index=new String[]{"c_smen"};
			addSqlField("c_smen" , 8,Fma.FIELD," Option   ");
			addSqlField("c_aide" ,60,Fma.FIELD,"Aide barre de Status");
			break;}
		case F3:
		default:{
			addSqlField("c_code" , 8,Fma.NORMAL,"  Menu    ");
			addSqlField("c_smen" , 8,Fma.NORMAL,"Sous menus");
			addSqlField("c_cle2" , 2,Fma.NORMAL,"Cle 2");
			addSqlField("c_menu" ,40,Fma.GRAS," Option              ");
			addSqlField("c_racc" , 1,Fma.GRAS," R ");
//			addSqlField("c_opt1" ,10,Fma.GRAS,"Fichier");
			addSqlField("c_aide" ,50,Fma.LIBEMAX,"Aide barre de Status");
			addSqlField("c_opt2" ,5,Fma.INVISIBLE," ");
			addSqlField("c_opt3" ,5,Fma.INVISIBLE," ");
			break;}
		}
		return this;
	}
	public void validateFields(){
		Vue vue=sql.vue;
		switch (vue){
		case F2:{
			t_nbLigne=4;
			addGroupby();
			break;}
		}
		super.validateFields();
	}
	public void addGroupby(){
		sql.clauseFilter="c_smen<> ''";
		sql.clauseGroupBy="c_smen";
	}
}
