package module_standard.wParamMenus;

import persistance.wGlobalParam.Gp;
import persistance.wSql.AbstractFieldsDef;
import persistance.wSql.Sql;
import table_standard.wS_menus.S_menusFICHE;
import template_applicatif.wFiche.AbstractDbFiche;
import template_applicatif.wListe.AbstractDbListe;
import template_applicatif.wListe.ListeRecno;
import template_applicatif.wVue.AbstractVue;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class S_menusParamVUE extends AbstractVue {
	private static final long serialVersionUID = 1L;
	public S_menusParamVUE(Sql sql, String t_seek, Vue vue) {
		super(sql.getSqlAbc(), t_seek, vue);
	}
	public AbstractDbListe getDbListe() {
		AbstractDbListe ret=null;
		adapteJoin(sqlListe);
		ret=new ListeRecno(sqlListe);
		sqlListe.clauseFilter="(substr(c_code,1,4)<>substr('"+Gp.DEVNUMM+"',1,4) AND substr(c_smen,1,4)<>substr('"+Gp.DEVNUMM+"',1,4))";
		return ret;
	}
	public AbstractDbFiche getDbFiche(Vue vue) {
		AbstractDbFiche ret=null;
		sqlFiche.t_AccesMode=Sql.t_AccesModeRecno;
		adapteJoin(sqlFiche);
		ret=new S_menusParamSAISIE(sqlFiche);
		sqlFiche.clauseFilter="(substr(c_code,1,4)<>substr('"+Gp.DEVNUMM+"',1,4) AND substr(c_smen,1,4)<>substr('"+Gp.DEVNUMM+"',1,4))";
		return ret;
	}
	
	public AbstractFieldsDef getFieldsDefEcran(Vue vue) {
		return new S_menusFICHE(sqlFiche,vue);
	}
	public AbstractFieldsDef getFieldsDefListe(Vue vue) {
		return new S_menusParamLISTE(sqlListe,vue);
	}
	public AbstractFieldsDef getFieldsDefPrint(Vue vue) { return null; }
	public AbstractFieldsDef getFieldsDefRupture(Vue vue) { return null; }
	public void adapteJoin(Sql sql) {}
}
