package module_standard.wPointageHeure;

import persistance.wSql.AbstractFieldsDef;
import persistance.wSql.Sql;
import template_applicatif.wFiche.AbstractDbFiche;
import template_applicatif.wListe.AbstractDbListe;
import template_applicatif.wListe.ListeRecno;
import template_applicatif.wVue.AbstractVue;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class S_pointageHeureVUE extends AbstractVue {
	private static final long serialVersionUID = 1L;
	public S_pointageHeureVUE(Sql sql, String t_seek, Vue vue) {
		super(sql, t_seek, vue);
	}
	public AbstractDbListe getDbListe() {
		AbstractDbListe ret=null;
		adapteJoin(sqlListe);
		sqlListe.v_filtre[0]=t_seek.substring(0,30);
		sqlListe.v_filtre[1]=t_seek.substring(30,40);
		sqlListe.t_seek="";
		ret=new ListeRecno(sqlListe);
		return ret;
	}
	public AbstractDbFiche getDbFiche(Vue vue) {
		AbstractDbFiche ret=null;
		sqlFiche.t_AccesMode=Sql.t_AccesModeRecno;
		adapteJoin(sqlFiche);
		sqlFiche.v_filtre[0]=t_seek.substring(0,30);
		sqlFiche.v_filtre[1]=t_seek.substring(30,40);
		sqlFiche.t_seek="";
		ret=new S_pointageHeureSAISIE(sqlFiche);
		return ret;
	}

	public AbstractFieldsDef getFieldsDefEcran(Vue vue) {
		AbstractFieldsDef ret=null;
		ret=new S_pointageHeureFICHE(sqlFiche,vue);
		return ret; 
	}
	public AbstractFieldsDef getFieldsDefListe(Vue vue) {
		AbstractFieldsDef ret=null;
		ret=new S_pointageHeureLISTE(sqlListe,vue);
		return ret;
	}

	public AbstractFieldsDef getFieldsDefPrint(Vue vue) {
		AbstractFieldsDef ret=null;
		return ret;
	}
	public AbstractFieldsDef getFieldsDefRupture(Vue vue) {
		AbstractFieldsDef ret=null;
		return ret;
	}
	public void adapteJoin(Sql sql) {}
}
