package module_standard.wRaz;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.swing.JOptionPane;
import javax.swing.JPanel;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextButton;
import composant_saisie.wComposant.JTextDb;
import composant_saisie.wSaisieFormat.Ccs;

import fenetre_menu.wConteneur.AbstractJDialogDb;
import fenetre_menu.wConteneur.AbstractJPanelDlg;
import fenetre_menu.wConteneur.JDialogDlg;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class Raz extends AbstractJPanelDlg implements ActionListener {
	private static final long serialVersionUID = 1L;
	Sql sql=null;
	JTextDb lfile=null;
	JTextDb lcount=null;
	JTextDb laver=null;

	JTextDb jtfile=null;
	JTextDb jtcoun=null;
	JTextDb jtaver=null;
	
	JTextDb jlSouth=null;
	JPanel jpLibe=null;
	JPanel jpText=null;
	JTextButton jbValid=null;
	String buttonValid="Remise  zro du fichier ";
	int count=0;
	String table=null;
	public Raz(JDialogDlg jd,Sql sql,String table){
		super(jd);
		this.sql=sql;
		this.table=table;
		adapte();
	}
	private void adapte() {
		buttonValid=buttonValid+table;

		lfile=new JTextDb("Table  remettre  zro");{
			Ccs.TexttoLibe(lfile);
		}
		lcount=new JTextDb("Nombre de fiches  supprimer");{
			Ccs.TexttoLibe(lcount);
		}
		laver=new JTextDb("Avertissement");{
			Ccs.TexttoLibe(laver);
		}

		jtfile=new JTextDb();{
			jtfile.setText(table);
			jtfile.adapteTextLibe();
		}
		jtcoun=new JTextDb();{
			count=getCount();
			jtcoun.setText(""+count);
			jtcoun.adapteTextLibe();
		}

		jtaver=new JTextDb();{
			if (isTtableVide()){
				jtaver.setText("Ce fichier est vide !");
			} else {
				jtaver.setText("Pensez  faire une sauvegarde. Au cas ou vous changeriez d'avis  ");
			}
			jtaver.adapteTextLibe();
		}

		jpLibe=new JPanel(Gp.adaptePanelL());{
			jpLibe.add(lfile,Gp.gety());
			jpLibe.add(lcount,Gp.gety());
			jpLibe.add(laver,Gp.gety());}		
		jpText=new JPanel(Gp.adaptePanelE());{
			jpText.add(jtfile,Gp.gety());
			jpText.add(jtcoun,Gp.gety());
			jpText.add(jtaver,Gp.gety());}

		jbValid=new JTextButton(buttonValid);{
			if (isTtableVide()){
				jbValid.setEnabled(false);
			} else {
				jbValid.addActionListener(this);
			}
		}
		this.add(jbValid,BorderLayout.PAGE_END);
		this.add(jpLibe,BorderLayout.WEST);
		this.add(jpText,BorderLayout.CENTER);
	}
	private boolean isTtableVide(){
		boolean ret=false;
		if (count==0)
			ret=true;
		return ret;
	}
	private int getCount(){
		int ret=0;
		try {
			Sql sqlTable=new Sql(sql);
			ResultSet rs=sqlTable.dBExecuteQueryOpen("SELECT sum(rowid/rowid ) as count FROM "+table);
			ret=rs.getInt("COUNT");
			sqlTable.dBExecuteQuerryClose(rs);
		} catch (SQLException e) { e.printStackTrace(); }
		return ret;
	}
	private void videTable(){
		int retour = JOptionPane.showConfirmDialog(sql.getMf(),"\n\nMettre  zro le fichier, Etes vous sre ???", "Attention !!!",JOptionPane.OK_CANCEL_OPTION);
		if (retour==JOptionPane.OK_OPTION){
			if (count!=0){
				Sql sqlTable=new Sql(sql);
				sqlTable.setTable(table);
				sql.setTextStatus("Purge des articles existant","","");
				sqlTable.dBTruncate();
				JOptionPane.showMessageDialog(sql.getMf(), "\n\nLe fichier ["+table+"] a t vid","Remise  zro Termine", JOptionPane.INFORMATION_MESSAGE);
			}
		} else {
			JOptionPane.showMessageDialog(sql.getMf(), "\n\nLe fichier ["+table+"] n'a pas t vid","Remise  zro ABANDONNEE", JOptionPane.INFORMATION_MESSAGE);
		}
	}
	public void actionPerformed(ActionEvent arg0) {
		if (arg0.getSource()==jbValid){
			jbValid.setEnabled(false);
			videTable();
			this.putClientProperty(AbstractJDialogDb.action,AbstractJDialogDb.closedialog);
		}

	}
}
