package module_standard.wSerial;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;

import composant_saisie.wPtime.Day;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public abstract class AbstractImpDot extends Thread {
	private static final long serialVersionUID = 1L;
	public static final int DIRECT=0;
	public static final int FORMAT=1;
	public static final int FDATA=2;
	public static final int BOUCLE_1=0;
	public static final int BOUCLE_FOR=1;
	public static final String LASER="LASER HP";
	public static final double coef8=203.2;
	public static final double coef12=304.8;
	public static final int PAGI_UN=0;
	public static final int PAGI_SUR=1;
	public static final int PAGI_DATE=2;
	public static final int PAGI_HEURE=3;
	public String [] data;
	public String [] pagi;
	boolean trace=false;
	Serial serial=null;
	int type=0;
	String t_fonti="";
	double t_size=0;
	String t_style="";
	double hp_margv=-3;
	double hp_margh=1.5;
	String nbDot="";
	protected int un=1;
	protected int sur=1;
	protected int nbre=1;
	protected int boucle=BOUCLE_1;
	int nbFields;
	Gp gpAbc;
	String name;
	String s_prn=null;
	public AbstractImpDot(Gp gpAbc,int num, String name, int type,int nbFields){
		this.gpAbc=gpAbc;
		this.s_prn=gpAbc.getImpDotDriver(num);
		this.serial=gpAbc.getImpDotSerial(num);
		this.name=name;
		this.type=type;
		this.nbFields=nbFields;
		if (gpAbc.m_user.equals("9000DEVE")){
			this.trace=true;
		}
		nbDot=getNbDot();
		if (type==FORMAT){
			startImp();
		}
	}
	private String getNbDot() {
		String ret="";
		if (this.s_prn.equals(LASER)){
			// OK pas de controle du nombre de dot
			// RESTE A DEVELOPPER
		} else {
			String tmp="";
			if (this.s_prn.length()>=2){
				tmp=this.s_prn.substring(this.s_prn.length()-2,this.s_prn.length());
			}
			if (!(tmp.equals(" 8")||tmp.equals("12"))){
				tmp=" 8";
			}
			if (tmp.equals(" 8")||tmp.equals("12")){
				ret=tmp;
			} else {	
				if (trace){
					Gp.ad("USER : '"+gpAbc.m_user+"' Prfrence DRIVER(' 8' ou '12' Dots), Incorrecte :"+s_prn+":");
				}
			}
		}
		return ret;
	}
	private void impDirect(){
		sendInitDot();
		print(un,sur,nbre);
	}
	private void impFormat(){
		sendInitDot();
		data=getData();
		pagi=getPagi();
		for (int i=0;i<data.length;i++){
			data[i]="VAR"+(i+1)+"$"; // Attention L'ubi ne prends pas les variables avec des 0 !!!
		}
		for (int i=0;i<pagi.length;i++){
			pagi[i]="VAR"+(data.length+i+1)+"$"; // Attention L'ubi ne prends pas les variables avec des 0 !!!
		}
		sendInitFormat();
	}
	private void impFData(){
		print(un,sur,nbre);
	}
	private void sendInitDot(){
		if (s_prn.equals(LASER)){
			//
		} else {
			imp("COMSET ON");
			imp("IMMEDIATE ON");
			//		imp("SETUP","SERVICE,MEMORY ALLOC,TRANS BUF UART1,30000"); 
			//		imp("SETUP","SERVICE,MEMORY ALLOC,REC BUF UART1,30000");
			imp ("VERBOFF");
			//imp ("VERBON");
			imp("SETUP","DETECTION,FEEDADJ,STOPADJ,0"); 
			imp("SETUP","SERVICE,PERFORMANCE,NORMAL");
			if (nbDot.equals("12")){
				imp("SETUP","DETECTION,FEEDADJ,STARTADJ,-160"); 
				imp("SETUP","SERVICE,MEDIA SIZE,LENGTH,2000"); 
				imp("SETUP","SERVICE,MEDIA SIZE,WIDTH,1200");
			} else if (nbDot.equals(" 8")){
				imp("SETUP","DETECTION,FEEDADJ,STARTADJ,-80"); 
				imp("SETUP","SERVICE,MEDIA SIZE,LENGTH,1227"); 
				imp("SETUP","SERVICE,MEDIA SIZE,WIDTH,800");
			}
			imp("SETUP","CONTRAST,4"); 
			imp("LTS& OFF");
			imp("CLL");
		}
	}
	public void print(int un, int sur,int nbre){
		boolean first=true;
		switch (boucle) {
		case BOUCLE_1:
			switch (type){
			case DIRECT:
				imp("NEW");
				imp("IMMEDIATE OFF");
				etiq();
				impPF(nbre);
				break;
			case FDATA:
				sendData(first);
				impPF(nbre);
				break;
			}
			break;
		case BOUCLE_FOR:
			for (int i=un;i<=nbre;i++){
				switch (type){
				case DIRECT:
					imp("NEW");
					imp("IMMEDIATE OFF");
					pagi[PAGI_UN]=""+i;
					etiq();
					impPF(0);
					break;
				case FDATA:
					pagi[PAGI_UN]=""+i;
					sendData(first);
					first=false;
					impPF(0);
					break;
				}
			}
			break;
		}
	}
	public void setDataPagi(String[] data, int un, int sur,int nbre,int boucle) {
		this.un=un;
		this.sur=sur;
		this.nbre=nbre;
		pagi=getPagi();
		pagi[PAGI_UN]=""+un;
		pagi[PAGI_SUR]=""+sur;
		pagi[PAGI_DATE]	=Day.getCurrentSDate();
		pagi[PAGI_HEURE]=Day.getCurrentSTime();
		this.data=data;
		this.boucle=boucle;
		startImp();
	}

	public abstract void etiq();
	public String [] getData(){
		String [] ret=new String [nbFields];
		for (int i=0;i<ret.length;i++){
			ret[i]="*-SAFE-*";
		}
		return ret;
	}

	private String [] getPagi(){
		String [] ret=new String [4];
		return ret;
	}

	private void sendInitFormat() {
		if (s_prn.equals(LASER)){
			//
		} else {
			imp("INPUT ON"); // Passe en direct protocol
			imp("LAYOUT INPUT "+'"'+name+'"');
			etiq();
			imp("LAYOUT END");
		}		
	}
	private void sendData(boolean first) {
		if (s_prn.equals(LASER)){
			//
		} else {
			char stx='@';
			char ttx=13;
			char etx='#';
			int istx=stx;
			int ittx=ttx;
			int ietx=etx;
			if (first){
				imp("INPUT ON"); // Passe en direct protocol
				imp("LAYOUT RUN "+'"'+name+'"');
				imp("FORMAT INPUT chr$("+istx+"),chr$("+ietx+"),chr$("+ittx+")"); // Passe en direct protocol
			}
			serial.write(stx);
			//
			for (int i=0;i<data.length;i++){
				serial.write(data[i]);
				serial.write(ttx);
			}
			for (int i=0;i<pagi.length;i++){
				serial.write(pagi[i]);
				serial.write(ttx);
			}
			//
			serial.write(etx);
			//
			serial.write(ttx);
		}
	}
	private void impPF(int nbre){
		if ( nbre>0 ){
			imp("PF "+nbre);
		} else {
			imp("PF ");
		}
		switch (type){
		case DIRECT:
			serial.setAckPF(false);
			imp("OPEN ","UART1:"," FOR OUTPUT AS #1");
			imp ("PRINT# 1,",Serial.ACKPF);
			imp("CLOSE# 1");
			imp("OPEN ","CONSOLE:"," FOR OUTPUT AS #1");
			imp("IMMEDIATE ON");
			imp("RUN");

			while (serial.isAckPF()==false){
				try {  
					Thread.sleep(50);
				} catch (InterruptedException arg0) { arg0.printStackTrace(); } 

			}
			break;
		case FORMAT:
			break;
		case FDATA:
			break;
		}
	}
	public void setDebug(boolean enable){
		serial.setDebug(enable);
	}
	protected void box(double t_posy, double t_posx, double t_haut, double t_long, double t_larg){
		lig(t_posy,t_posx,t_long,t_larg);
		lig(t_posy+t_haut,t_posx,t_long+t_larg,t_larg);
		lig(t_posy,t_posx,t_larg,t_haut);
		lig(t_posy,t_posx+t_long,t_larg,t_haut);
	}
	protected void txt(double t_posx, double t_posy, String t_font, String t_style, double t_size, String t_text){
		t_fonti=t_font;
		if (s_prn.equals(LASER)){
			// Univers
			if (t_fonti.trim().length()==0){
				t_fonti="4148";
			}
			// 0 droit,1 italique,4 condens,5 condens italique,8 ultra condensed
			// suffixe "s"
			if (t_style.length()==0){
				t_style="0";
			}
			// 0 moyen,1 semi-gras,3 gras,4 extra-gras
			// suffixe "b"
			String graisse="3";
			// 0 fixe,1 proportionnel
			// suffixe "p"
			String espacem="1";
			// suffixe font "t"
			// suffixe pointx "x"
			// suffixe pointy "y"
			// suffixe size "v"
			t_size=t_size*(50/12);
			serial.write(27);
			serial.write("(s"+espacem+"p"+t_size+"v"+t_style+"s"+graisse+"b"+t_fonti+"T");
			pos(t_posx,t_posy);
			serial.write(t_text);
		} else {
			if (t_fonti.trim().length()==0){
				t_fonti="Dutch 801 Bold BT";
			} else {
				font();
			}
			// 0 droit,1  360 italique
			if (t_style.length()==0){
				t_style="0";
			}
			// attention c'est la taille du corps
			// compter 1 tiers pour les accents
			// compter 1 tiers pour les cedilles
			t_size=t_size*(50/12);
			imp("FT ",t_fonti,","+(int)t_size+","+t_style);
			pos(t_posx,t_posy);
			imp("PT ",t_text);
		}
	}
	private void font(){
		if (t_fonti.equals("#1")){
			t_fonti = "Swiss 721 BT";
			t_size=6/(50/12);
		} else if (t_fonti.equals("#2")){
			t_fonti = "Swiss 721 BT";
			t_size=8/(50/12);
		} else if (t_fonti.equals("#3")){
			t_fonti = "Swiss 721 Bold BT";
			t_size=15/(50/12);
		} else if (t_fonti.equals("#4")){
			t_fonti = "Swiss 721 Bold BT";
			t_size=26/(50/12);
		} else if (t_fonti.equals("#5")){
			t_fonti = "Swiss 721 Bold BT";
			t_size=18/(50/12);
		} else if (t_fonti.equals("#6")){
			t_fonti = "Swiss 721 Bold BT";
			t_size=30/(50/12);
		} 
	}
	protected void cba(double t_posx, double t_posy,String ti_type,String ti_larb,double ti_haub,String ti_codb){
		int iti_larb=Integer.parseInt(ti_larb);
		String v_type,v_haum,v_larm;
		pos(t_posx,t_posy);
		if (s_prn.equals(LASER)){
			// type de code  barre
			v_type="";
			if (ti_type.equals("EAN-13")){
				v_type="24630T";	
			} else if (ti_type.equals("CODE128")){
				// ean128 type autoswitch
				v_type="24700T";
			}
			// hauteur du code barre
			if (ti_haub!=0) {
				v_haum=""+(int)(ti_haub*(50/17.8));
			} else {
				v_haum="40";
			}
			if (iti_larb==0){
				v_larm="4,"+(int)(4*2.25);
			} else {
				v_larm=ti_larb+","+(int)(iti_larb*2.25);
			}
			String v_txtuserno="0";
			serial.write(27);
			serial.write("(s"+v_txtuserno+"p003h"+v_haum+"v"+v_larm+"s"+v_larm+"b"+v_type);
			serial.write(ti_codb);
			serial.write(27);
			serial.write("(10U");
			serial.write(27);
			serial.write("(sp10hsb4099T");
		} else {
			// driver UBI 8 & 12 dots
			// type du code barres
			// barmag de 1  8
			ti_haub=(int) (ti_haub*getCoef());
			imp("BT ",ti_type);
			if (ti_type.equals("INT2OF5")){
				imp("BM 1");
				if (nbDot.equals("12")){
					imp("BARRATIO "+(int)(1+(3*iti_larb/2*3))+","+(int)(1+(1*iti_larb/2*3)));
				} else if (nbDot.equals(" 8")){
					imp("BARRATIO "+(int)(3*iti_larb)+","+(int)(1*iti_larb));
				}
			} else {
				if (iti_larb!=0) {
					imp("BM "+ti_larb);
				}
			}
			imp("BH "+(int)ti_haub);
			imp("PB ",ti_codb);
			if (iti_larb!=0) {
				imp("BM 2");
			}
		}
	}
	private void pos(double t_posx, double t_posy){
		t_posx=(t_posx+hp_margv)*getCoef();
		t_posy=(t_posy+hp_margh)*getCoef();
		if (s_prn.equals(LASER)){
			serial.write(27);
			serial.write("*p"+(int)t_posx+"x"+(int)t_posy+"Y");
		} else {
			imp("PP "+(int)t_posy+","+(int)t_posx);
		}		
	}
	protected void lig(double t_posx, double t_posy, double t_long, double t_larg){
		pos(t_posx,t_posy);
		t_long=t_long*getCoef();
		t_larg=t_larg*getCoef();
		if (s_prn.equals(LASER)){
			serial.write(27);
			serial.write("*c"+(int)t_long+"a"+(int)t_larg+"b0P");
		} else {
			imp("PL "+(int)t_long+","+(int)t_larg);
		}
	}
	private double getCoef(){
		double ret=0;
		if (s_prn.equals(LASER)){
			ret=coef12/25.4;
		} else if (nbDot.equals("12")){
			ret=coef12/25.4; // 12 soit 12Dots au mm
		} else if (nbDot.equals(" 8")){
			ret=coef8/25.4; // 8 soit 8Dots au mm
		}
		return ret;
	}
	protected void dir(int dir){
		if (s_prn.equals(LASER)){
			serial.write(27);
			switch (dir){
			case 1:
				serial.write("&a90P");
				break;
			case 2:
				serial.write("&a180P");
				break;
			case 3:
				serial.write("&a270P");
				break;
			default:
				serial.write("&a360");
			break;
			}
		} else {
			imp("DIR "+dir);
			if (dir==3){
				imp("ALIGN 7");
			} else if (dir==1){
				imp("ALIGN 1");
			} else if (dir==2){
				imp("ALIGN 1");
			}
		}
	}
	private void imp(String command,String txt,String param){
		serial.write(command);
		serial.write(getTxtFmt(txt));
		imp(param);
	}
	private void imp(String command,String txt){
		serial.write(command);
		imp(getTxtFmt(txt));
	}
	private String getTxtFmt(String txt){
		String ret="";
		ret='"'+txt+'"';
		switch (type){
		case DIRECT:
			break;
		case FORMAT:
			if (txt.charAt(txt.length()-1)=='$'){
				ret=txt;
			}
			break;
		case FDATA:
			break;
		}
		return ret;
	}
	protected void imp(String command){
		serial.write(command);
		serial.write(13);
	}
	public void run(){
		serial.setBusy(true);
		gpAbc.setCursorWait(true);
		switch (type){
		case FORMAT:
			impFormat();
			break;
		case FDATA:
			impFData();
			break;
		case DIRECT:
			impDirect();
			break;
		}
		gpAbc.setCursorWait(false);
		serial.setBusy(false);
	}
	public void startImp() {
		while(serial.isBusy()){
			try {
				Thread.sleep(50);
			} catch (InterruptedException arg0) { arg0.printStackTrace();	}
		}
		if (serial.isOpen()){
			start();
		}
	}
}


