package module_standard.wSerial;

import a_doc.doc.Licence;

/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class Ms1204 extends AbstractMS1204 {
	private static final long serialVersionUID = 1L;
	boolean beepInit=false;
	public Ms1204(Serial serial, boolean beepInit) {
		super(serial);
		this.beepInit=beepInit;
	}
	protected boolean initCB() {
		boolean ret=true;
		boolean beep=false;
		if (ret){
			ret=setCbOff(beep);
		}
		if (ret){
			ret=enable2TO5(beep);
		}
		if (ret){
			if (beepInit){
				ret=cbBeep();
			}
		}
		return ret;
	}	
	public void end(){
		setCbOff(true);
		close();
	}
}
