package module_standard.wToolTip;
import java.util.HashMap;
import java.util.Map;

import a_doc.doc.Licence;



/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class ParserHtml {
	private static HashMap<String, String> parser;
	private static boolean initialise = false;
	private static String rdu="";

	private static void ParserHTML(){
		// initialisation des vecteurs...
		parser = new HashMap<String, String>();           
		parser.put("","&aacute;"); parser.put("","&acirc;");  
		parser.put("","&aelig;");  parser.put("","&agrave;"); 
		parser.put("","&aring;");  parser.put("","&atilde;"); 
		parser.put("","&auml;");   parser.put("","&ccedil;"); 
		parser.put("","&eacute;"); parser.put("","&ecirc;");  
		parser.put("","&egrave;"); parser.put("","&euml;");   
		parser.put("","&yuml;");   parser.put("\"","&quot;");  
//		parser.put("<","&lt;");     parser.put(">","&gt;");     
		parser.put("","&iacute;"); parser.put("","&icirc;");  
		parser.put("","&igrave;"); parser.put("","&iuml;");   
		parser.put("","&ntilde;"); parser.put("","&oacute;"); 
		parser.put("","&ocirc;");  parser.put("","&ograve;"); 
		parser.put("","&oslash;"); parser.put("","&otilde;"); 
		parser.put("","&ouml;");   parser.put("","&szlig;");  
		parser.put("","&thorn;");  parser.put("","&uacute;"); 
		parser.put("","&ucirc;");  parser.put("","&ugrave;"); 
		parser.put("","&uuml;");   parser.put("","&yacute;"); 
		parser.put("","&euro;");   parser.put("","&yen;");    
		parser.put("","&oelig;");  parser.put("","&cent;");   
		parser.put("","&deg;");    parser.put("","&sup2;");
		parser.put("","&sup3;");   parser.put("","&divide;");
		parser.put("\n","<br>");
	}
	public static String stringToHtml(String src){
		if(!initialise){
			ParserHTML();
			initialise = true;        
		}
		rdu = src.replace("&", "&amp");
		src = rdu;
		for(Map.Entry<String,String> entry : parser.entrySet()){
			// remplace le caractere par son code HTML.
			rdu = src.replace(entry.getKey(),entry.getValue());
			// Le rendu devient la source.
			src = rdu;
		}
		return rdu;
	}
	public static String htmlToString(String src){
		if(!initialise){
			ParserHTML();
			initialise = true;        
		}
		rdu = src.replace("&amp", "&");
		src = rdu;
		for(Map.Entry<String,String> entry : parser.entrySet()){
			// remplce le code HTML par son caractre.
			rdu = src.replace(entry.getValue(), entry.getKey());
			src = rdu;
		}
		return rdu;
	}
}

