package module_standard.wToolTip;

import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.swing.JPanel;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JArea;
import composant_saisie.wComposant.JTextButton;
import composant_saisie.wComposant.JTextDb;
import composant_saisie.wSaisieFormat.Ccs;
import composant_saisie.wSaisieFormat.CcsFmt;

import fenetre_menu.wConteneur.AbstractJDialogDb;
import fenetre_menu.wConteneur.AbstractJPanelDlg;
import fenetre_menu.wConteneur.JDialogDlg;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class Tooltip extends AbstractJPanelDlg implements ActionListener, KeyListener {
	private static final long serialVersionUID = 1L;
	Sql sql=null;
	JTextDb ltabl=null;
	JTextDb lfiel=null;
	JTextDb ltitr=null;
	JTextDb laaid=null;
	JTextDb lnaid=null;

	JTextDb tabl=null;
	JTextDb fiel=null;
	JTextDb titr=null;
	JArea aaid=null;
	JArea naid=null;

	JTextDb jlSouth=null;
	JPanel jpText=null;
	JTextButton jbValid=null;
	JTextDb jt=null;
	int maxCar=0;

	public Tooltip(JDialogDlg jd,Sql sql, JTextDb jt){
		super(jd);
		this.sql=sql;
		this.jt=jt;
		adapte();
	}
	private void adapte() {
		ltabl=new JTextDb("Fichier ");{
			Ccs.TexttoLibe(ltabl);
		}
		lfiel=new JTextDb("Nom de la Zone ");{
			Ccs.TexttoLibe(lfiel);
		}
		ltitr=new JTextDb("Titre de la Zone ");{
			Ccs.TexttoLibe(ltitr);
		}
		laaid=new JTextDb("ToolTip actuel ");{
			Ccs.TexttoLibe(laaid);
		}
		lnaid=new JTextDb("Nouveau ToolTip ");{
			Ccs.TexttoLibe(lnaid);
		}

		tabl=new JTextDb();{
			tabl.setText(sql.t_table);
			tabl.adapteTextLibe();
		}
		fiel=new JTextDb();{
			fiel.setText(jt.getName());
			fiel.adapteTextLibe();
		}
		titr=new JTextDb();{
			titr.setText(sql.getFieldDef(jt.getName()).t_lib);
			titr.adapteTextLibe();
		}

		aaid=new JArea();{
			aaid.setBorder(Gp.getBorder(Gp.LABEL_BORDER));
			aaid.setText(ParserHtml.htmlToString(jt.getLibelleHelpText()));
			aaid.setDimChar(80,6);
			aaid.setEditable(false);
			aaid.setBackground(Gp.MOVE_BG_LVERT);
		}
		naid=new JArea();{
			naid.setBorder(Gp.getBorder(Gp.LABEL_BORDER));
			ResultSet rs=sql.getSqlAbc().dBExecuteQueryOpen("SELECT c_aide FROM s_field WHERE c_fiel='"+jt.getName()+"' AND c_tvue='"+sql.vue+"' AND c_code='"+sql.t_table+"' LIMIT 1;");
			try {
				if (rs.next()){
					naid.setText(ParserHtml.htmlToString(rs.getString("c_aide")));
				} else {
					naid.setText(ParserHtml.htmlToString(aaid.getText()));
				}
				naid.setSelectedAll();
			} catch (SQLException e) {e.printStackTrace();}
			sql.dBExecuteQuerryClose(rs);
			naid.addKeyListener(this);
			maxCar=120;
			naid.setDimChar(80,6);
			naid.requestFocus();
		}


		jpText=new JPanel(Gp.adaptePanelE());{
			Gp.setxy(0,0);
			Gp.gbc.anchor=GridBagConstraints.NORTHEAST;
			if (sql.isDevFile()){
				jpText.add(ltabl,Gp.gety());
				jpText.add(lfiel,Gp.gety());
			}
			jpText.add(ltitr,Gp.gety());
			jpText.add(laaid,Gp.gety());
			jpText.add(lnaid,Gp.gety());
			Gp.setxy(1,0);
			Gp.gbc.anchor=GridBagConstraints.NORTHWEST;
			if (sql.isDevFile()){
				jpText.add(tabl,Gp.gety());
				jpText.add(fiel,Gp.gety());
			}
			jpText.add(titr,Gp.gety());
			jpText.add(aaid,Gp.gety());
			jpText.add(naid,Gp.gety());}

		jbValid=new JTextButton("Enregistrer ce nouveau ToolTip",'E');{
			jbValid.setFont(Gp.FONTTEXT18);
			jbValid.addActionListener(this);
		}
		this.add(jpText,BorderLayout.CENTER);
		this.add(jbValid,BorderLayout.PAGE_END);
	}
	public void actionPerformed(ActionEvent arg0) {
		if (arg0.getSource()==jbValid){
			if (naid.getText()!= null){
				if (naid.getText().trim().length()>=0){
					if (!naid.getText().equals(aaid.getText())){
						jt.setLibelleHelpText(ParserHtml.stringToHtml(naid.getText()));
						String query="";
						String ordr="";
						try {
							for (int i=0;i<sql.fields.size();i++){
								if (sql.fields.get(i).t_field.equals(jt.getName())){
									ordr=Integer.toString(i).trim();
									ordr=CcsFmt.ligLig(ordr,2);
									break;
								}
							}
							ResultSet rs=sql.getSqlAbc().dBExecuteQueryOpen("SELECT rowid,c_aide FROM s_field WHERE c_fiel='"+jt.getName()+"' AND c_tvue='"+sql.vue+"' AND c_code='"+sql.t_table+"' LIMIT 1;");
							if (!naid.getText().isEmpty()){
								String value=ParserHtml.stringToHtml(sql.setQuerydoubleCote(naid.getText()));
								if (value.length()>maxCar){
									value=value.substring(0,maxCar);
								}
								if (rs.next()){
									String rowid=rs.getString("rowid");
									query="UPDATE s_field set c_aide='"+value+"'  WHERE rowid='"+rowid+"';";
								} else {
									query="INSERT INTO s_field (c_code,c_tvue,c_ordr,c_fiel,c_aide) VALUES ('"+sql.t_table+"','"+sql.vue+"','"+ordr+"','"+jt.getName()+"','"+value+"');";
								}
							} else {
								if (rs.next()){
									String rowid=rs.getString("rowid");
									query="DELETE FROM s_field WHERE rowid='"+rowid+"';";
								}
							}
							sql.getSqlAbc().dBExecuteQuerryClose(rs);
						} catch (SQLException e) {e.printStackTrace();}
						if (query.trim().length()>0){
							sql.getGpAbc().sqlAbc=new Sql(sql.getSqlAbc());
							sql.getSqlAbc().dBExecuteUpdate(query);
						}

						int lenf=0;
						String taff="";
						String libe="";
						String tfie="";
						String defa="";
						for (int i=0;i<sql.fields.size();i++){
							if (sql.fields.get(i).t_field.equals(jt.getName())){
								lenf=sql.fields.get(i).t_fieldLength;
								taff=Integer.toString(sql.fields.get(i).t_Fma.value());
								taff=CcsFmt.ligLig(taff,3);
								libe=sql.fields.get(i).t_lib;
								tfie=sql.fields.get(i).t_EditType.toString();
								defa=sql.fields.get(i).t_fieldDefaultValue;
								break;
							}
						}
						try {
							ResultSet rs=sql.getSqlAbc().dBExecuteQueryOpen("SELECT rowid FROM s_field WHERE c_fiel='"+jt.getName()+"' AND c_tvue='"+sql.vue+"' AND c_code='"+sql.t_table+"' LIMIT 1;");
							if (rs.next()){
								String rowid=rs.getString("rowid");
								String setUpdate="c_lenf='"+lenf+"',c_taff='"+taff+"',c_libe='"+libe+"',c_tfie='"+tfie+"',c_defa='"+defa+"'";
								query="UPDATE s_field set "+setUpdate+"  WHERE rowid='"+rowid+"';";
								sql.getSqlAbc().dBExecuteUpdate(query);
							}
						} catch (SQLException e) { e.printStackTrace(); }
					}
				}
				this.putClientProperty(AbstractJDialogDb.action,AbstractJDialogDb.closedialog);

			} else {
				//JOptionPane.showMessageDialog(null, "L'aide est Vide, Pas d'enregistrement","Attention !!!", JOptionPane.INFORMATION_MESSAGE);
				sql.notify("Attention !!!", "L'aide est Vide, Pas d'enregistrement", new String[]{"Je vrifie"}, sql.getAppliParam().JBCANCEL,0);
			}
		}
	}
	public void keyPressed(KeyEvent e) {}
	public void keyReleased(KeyEvent e) {}
	public void keyTyped(KeyEvent e) {
		if (e.getKeyChar()!=0){
		if (maxCar!=0){
			if (naid.getText().length()>maxCar-1){
				naid.setForeground(Gp.INVALIDE_FG_RED);
			} else {
				naid.setForeground(Gp.VERTFONCE_FG);
			}
		}
		}
	} 
}
