package persistance.wNet;

import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.ServerSocket;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;

import javax.swing.JOptionPane;

import a_doc.doc.Licence;



/**
sera le gestionnaire d'acces rseau<br>
On l'utilise pour tester l'unicit d'excution de l'appli via l'ouverture et le test du port local 1234<br>  
__________________________________________________________________________________
 <br>{@link A_doc}
 <br>{@link Licence}.*/
public class Net {
	// --- Multi instance -----------------------
	private static int PORT = 1234;
	@SuppressWarnings("unused")
	private static ServerSocket ss;
	public static boolean checkUniqueInstance(boolean nbinstance,boolean quit){
		boolean ret=false;
		try { 

			if (nbinstance) {
				ss=new ServerSocket(PORT);
			}
			ret=true;
		} catch(Exception e){
			//System.out.println("Il y a deja une instance du programme active"); 
			JOptionPane.showMessageDialog(null, "Ce programme est dj lanc sur votre machine","Attention !!!", JOptionPane.INFORMATION_MESSAGE);
			ret=false;
			if (quit)
				System.exit(0); 
		}
		return ret;
	}
	// --- Multi instance -----------------------


	public static List<String> getIps(){
		List<String> ips = new ArrayList<String>();

		try{
			Enumeration<NetworkInterface> interfaces = NetworkInterface.getNetworkInterfaces();

			while (interfaces.hasMoreElements()) {  // carte reseau trouvee
				NetworkInterface interfaceN = (NetworkInterface)interfaces.nextElement(); 
				Enumeration<InetAddress> ienum = interfaceN.getInetAddresses();
				while (ienum.hasMoreElements()) {  // retourne l adresse IPv4 et IPv6
					InetAddress ia = ienum.nextElement();
					String adress = ia.getHostAddress().toString();

					if( adress.length() < 16){          //On s'assure ainsi que l'adresse IP est bien IPv4
						if(adress.startsWith("127")){  //Ce n'est pas l'adresse IP Local' 
							System.out.println(ia.getHostAddress());
						} else if(adress.indexOf(":") > 0){
							System.out.println(ia.getHostAddress()); // les ":" indique que c'est une IPv6"
						} else {
							System.out.println(ia.getHostAddress());
						}
					} 

					ips.add(adress);        
				}
			}
		}
		catch(Exception e){
			System.out.println("pas de carte reseau");
			e.printStackTrace();
		}
		return ips;
	}
	public static String getIp(){
		String ret="";
		try { ret=InetAddress.getLocalHost ().getHostAddress ();
		} catch (UnknownHostException arg0) { arg0.printStackTrace(); }
		return ret;
	}
}
