package persistance.wNet;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.UnknownHostException;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;
/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
@Deprecated
public class Serveur  extends Thread {
	int port = 8080;
	int max_connexion=50;
	ServerSocket serversocket=null;
	Socket socket=null;
	BufferedReader pLec=null;
	PrintWriter pEcr=null; 
	boolean run=false;
	String serveur="";
	Gp gp=null;
	public Serveur(Gp gp,int port, int max_connexion){
		this.gp=gp;
		this.max_connexion=max_connexion;
		this.port=port;
		init();
		if (run){
			start();
		}
	}
	private void init(){
		try { serveur = InetAddress.getLocalHost().getHostName(); } catch (UnknownHostException arg0) { arg0.printStackTrace(); }
		try {
			serversocket = new ServerSocket(port,max_connexion,InetAddress.getLocalHost ());
			System.out.println("SERVEUR = " + serversocket);
			socket = serversocket.accept();
			pLec = new BufferedReader(new InputStreamReader(socket.getInputStream()));
			pEcr = new PrintWriter(new BufferedWriter(new OutputStreamWriter(socket.getOutputStream())));
			run=true;
		} catch (IOException arg0) { arg0.printStackTrace(); }
	}
	public void run(){
		String str="";
		while (run) {
			str=listen();
			// lecture du message
			System.out.println("ECHO = " + str );   // trace locale
			if (str.equals("END")) break;
			say("Echo from "+serveur+" "+str);
		}
	}
	public void say(String str){
		if (str!=null){
			if (str.length()>0){
				gp.gpAbc.f_mjStatusBar.setTextStatusFicheEdit(str);
			}
		}
		pEcr.println(str);
		System.out.println(str);
	}
	public String listen(){
		String ret="";
		try { ret = pLec.readLine(); } catch (IOException arg0) { arg0.printStackTrace(); }
		if (ret!=null){
			if (ret.length()>0){
				gp.gpAbc.f_mjStatusBar.setTextStatusFiche("SOCKET", ret);
			}
		}
		return ret;
	}
	public void stopRun(){
		run=false;
		try {
			socket.close();
			pLec.close();
			pEcr.close();
		} catch (IOException arg0) { arg0.printStackTrace(); }
	}
}
