package persistance.wTmp;

import java.awt.Color;
import java.util.ArrayList;

import persistance.wSql.Sql;
import a_doc.doc.Licence;
/**
Tmp est un mini sgb interne qui permet de travailler en collaboration de {@link Sql}<br>
lors des calcule de sous totaux.<br>
Il conomise des ressources et travail en mmoire.<br>
<br>
__________________________________________________________________________________
<br>{@link A_doc}
 <br>{@link Licence}.*/
public class Tmp {
	public static final int STRING=0;
	public static final int INTEGER=1;
	public static final int DOUBLE=2;
	public static final int BOOLEAN=3;
	public static final int COLOR=4;
	public static final int OBJECT=9;

	ArrayList< FieldTmp > r_=null;
	String [] fields=null;
	String [] fieldi=null;
	String [] fieldd=null;
	String [] fieldb=null;
	String [] fieldc=null;
	String [] fieldo=null;
	int nbs=0;
	int nbi=0;
	int nbd=0;
	int nbb=0;
	int nbc=0;
	int nbo=0;
	FieldTmp tmpfield=null;

	public Tmp(String [] fields){
		if (fields!=null){
			this.nbs=fields.length;
			this.fields=fields;
		}
		r_=new ArrayList<FieldTmp>();
	}
	public Tmp(){
		r_=new ArrayList<FieldTmp>();
	}
	public void setString(String [] fields){
		this.nbs=fields.length;
		this.fields=fields;
	}
	public void setDouble(String [] fields){
		this.nbd=fields.length;
		this.fieldd=fields;
	}
	public void setInteger(String [] fields){
		this.nbi=fields.length;
		this.fieldi=fields;
	}
	public void setBoolean(String [] fields){
		this.nbb=fields.length;
		this.fieldb=fields;
	}
	public void setColor(String [] fields){
		this.nbc=fields.length;
		this.fieldc=fields;
	}
	public void setObject(String [] fields){
		this.nbo=fields.length;
		this.fieldo=fields;
	}

	// Recno
	public void appendBlank(){
		tmpfield=new FieldTmp(nbs,nbi,nbd,nbb,nbc,nbo);
		r_.add(tmpfield);
	}
	public void remove(int index){
		tmpfield=r_.get(index);
		tmpfield.clear();
		r_.remove(index);
	}
	public int size(){
		return r_.size();
	}
	public void go(int index){
		tmpfield=r_.get(index);
	}
	public void goTop(){
		if (r_.isEmpty()){
			tmpfield=null;
		} else {
			tmpfield=r_.get(0);
		}
	}
	public void goBottom(){
		if (r_.isEmpty()){
			tmpfield=null;
		} else {
			tmpfield=r_.get(r_.size()-1);
		}
	}
	public void skip(int sens){
		for (int i=0;i<r_.size();i++){
			if (tmpfield==r_.get(i)){
				if (i+sens>=0 || i+sens<r_.size()) {
					tmpfield=r_.get(i+sens);
				} else {
					tmpfield=null;
				}
			}
		}
	}
	public boolean seek(String name, String seek){
		boolean ret=false;
		if (r_!=null){
			for (int i=0;i<r_.size();i++){
				tmpfield=r_.get(i);
				if (tmpfield.readS(getIndexS(name)).equals(seek)){
					ret=true;
					break;
				}
			}
		}
		return ret;
	}
	public void close(){
		while (r_.size()!=0){
			remove(0);
		}
		r_=null;
	}
	public void afList(){
		for (int i=0;i<r_.size();i++){
			tmpfield=r_.get(i);
			tmpfield.afField();
		}
	}

	//Field
	public void repl(String name,Object obj){
		repl(getIndex(name,obj),obj);
	}
	public void repl(int index,Object obj){
		if (tmpfield!=null){
			tmpfield.repl(index,obj);
		}
	}

	public void replAdd(String name,Object obj){
		replAdd(getIndex(name,obj),obj);
	}
	public void replAdd(int index,Object obj){
		if (tmpfield!=null){
			tmpfield.replAdd(index,obj);
		}
	}
	public Integer readI(String name){
		return readI(getIndexI(name));
	}
	public Integer readI(int index){
		Integer ret=null;
		if (tmpfield!=null){
			ret=tmpfield.readI(index);
		}
		return ret;
	}
	public String readS(String name){
		return readS(getIndexS(name));
	}
	public String readS(int index){
		String ret=null;
		if (tmpfield!=null){
			ret=tmpfield.readS(index);
		}
		return ret;
	}
	public Double readD(String name){
		return readD(getIndexD(name));
	}
	public Double readD(int index){
		Double ret=null;
		if (tmpfield!=null){
			ret=tmpfield.readD(index);
		}
		return ret;
	}
	public Boolean readB(String name){
		return readB(getIndexB(name));
	}
	public Boolean readB(int index){
		Boolean ret=null;
		if (tmpfield!=null){
			ret=tmpfield.readB(index);
		}
		return ret;
	}
	public Color readC(String name){
		return readC(getIndexC(name));
	}
	public Color readC(int index){
		Color ret=null;
		if (tmpfield!=null){
			ret=tmpfield.readC(index);
		}
		return ret;
	}
	public Object readO(String name){
		return readO(getIndexO(name));
	}
	public Object readO(int index){
		Object ret=null;
		if (tmpfield!=null){
			ret=tmpfield.readO(index);
		}
		return ret;
	}
	public void remove(String name, Object obj) {
		int index=getIndex(name,obj);
		if (index!=-1){
			tmpfield=r_.get(index);
			tmpfield.clear();
			r_.remove(index);
		}
	}

	public int getIndex(String name,Object obj){
		int ret=-1;
		if (obj instanceof Integer){
			ret=getIndexI(name);
		} else if (obj instanceof String){
			ret=getIndexS(name);
		} else if (obj instanceof Double){
			ret=getIndexD(name);
		} else if (obj instanceof Boolean){
			ret=getIndexB(name);
		} else if (obj instanceof Color){
			ret=getIndexC(name);
		} else if (obj instanceof Object){
			ret=getIndexO(name);
		}
		return ret;
	}
	public int getIndexS(String name){
		int ret=-1;
		for (int i=0;i<fields.length;i++){
			if (fields[i].equals(name)){
				ret=i;
				break;
			}
		}
		return ret;
	}
	public int getIndexI(String name){
		int ret=-1;
		for (int i=0;i<fieldi.length;i++){
			if (fieldi[i].equals(name)){
				ret=i;
				break;
			}
		}
		return ret;
	}
	public int getIndexD(String name){
		int ret=-1;
		for (int i=0;i<fieldd.length;i++){
			if (fieldd[i].equals(name)){
				ret=i;
				break;
			}
		}
		return ret;
	}
	public int getIndexB(String name){
		int ret=-1;
		for (int i=0;i<fieldb.length;i++){
			if (fieldb[i].equals(name)){
				ret=i;
				break;
			}
		}
		return ret;
	}
	public int getIndexC(String name){
		int ret=-1;
		for (int i=0;i<fieldc.length;i++){
			if (fieldc[i].equals(name)){
				ret=i;
				break;
			}
		}
		return ret;
	}
	public int getIndexO(String name){
		int ret=-1;
		for (int i=0;i<fieldo.length;i++){
			if (fieldo[i].equals(name)){
				ret=i;
				break;
			}
		}
		return ret;
	}
}
