package table_standard.wS_aide;


import javax.swing.JComponent;

import persistance.wSql.Sql;
import template_applicatif.wFiche.AbstractDbFiche;
import template_applicatif.wFiche.FicheIEditableColumns;
import template_applicatif.wListe.ListeIEditableColumn;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextDb;
import composant_saisie.wComposant.JTextDbF2;
import composant_saisie.wSaisieFormat.Ccs;
/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class S_aideSAISIE extends AbstractDbFiche {
	private static final long serialVersionUID = 1L;
	JTextDb lcode,lhtml;
	JTextDbF2 	code=null;
	JTextDb 	html=null;
	public S_aideSAISIE(Sql sql) {
		super(sql);
		initStart();
	}
	public void initCreateLE() {
		lcode	=new JTextDb();
		lhtml	=new JTextDb();
		code	=new JTextDbF2(new S_aideVUE(sql,"",Vue.F2UNIQUE1));
		html	=new JTextDb();
	}
	public void initMapLE() {
		ccs.mapL(this,lcode,0);
		ccs.mapL(this,lhtml,1);
		ccs.mapE(this,code,0);
		ccs.mapE(this,html,1);
	}
	public void initFocus() {
		setDefFocus(code);
	}
	public void setBaseListener() {
		ccs.addF2Listener(code,Ccs.NEWCODEF2);
		ccs.addF2Listener(code,Ccs.CODEINF2);
	}
	public void setEditableColumns(FicheIEditableColumns fe, ListeIEditableColumn fl) {}
	public void fireEditableColumnUpdate(String nameField, Object value) {}
	public void loadEAdapteGuiLE() {}
	public void fireBaseListener(JComponent jc){
		// La cl d'index
		// La fiche
		if (jc==code){
			if (sql.isModeAppendUpdated()||sql.isModeAppend()){
				ccs.fireT(jc,Ccs.NEWCODEF2);
			} else {
				ccs.fireT(jc,Ccs.CODEINF2);
			}
		}
	}
	protected void fireContextualRange(JComponent jc) {}
	protected void updateDependant(JComponent jc) {}
	protected void updateContextualRangeAndEnable(JComponent jc) {}
	public void setDependants() {}
}
