package table_standard.wS_field;

import persistance.wSql.AbstractFieldsDef;
import persistance.wSql.FieldsJoin;
import persistance.wSql.Sql;
import template_applicatif.wFiche.AbstractDbFiche;
import template_applicatif.wListe.AbstractDbListe;
import template_applicatif.wListe.ListeRecno;
import template_applicatif.wVue.AbstractVue;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class S_fieldVUE extends AbstractVue {
	private static final long serialVersionUID = 1L;
	public S_fieldVUE(Sql sql, String t_seek, Vue vue) {
		super(sql.getSqlAbc(), t_seek, vue);
	}
	public AbstractDbListe getDbListe() {
		AbstractDbListe ret=null;
		adapteJoin(sqlListe);
		ret=new ListeRecno(sqlListe);
		return ret;
	}
	public AbstractDbFiche getDbFiche(Vue vue) {
		AbstractDbFiche ret=null;
		sqlFiche.t_AccesMode=Sql.t_AccesModeRecno;
		adapteJoin(sqlFiche);
		ret=new S_fieldSAISIE(sqlFiche);
		return ret;
	}

	public AbstractFieldsDef getFieldsDefEcran(Vue vue) {
		return new S_fieldFICHE(sqlFiche,vue);
	}
	public AbstractFieldsDef getFieldsDefListe(Vue vue) {
		AbstractFieldsDef ret=null;
		ret=new S_fieldLISTE(sqlListe,vue);
		return ret;
	}

	public AbstractFieldsDef getFieldsDefPrint(Vue vue) {
		AbstractFieldsDef ret=null;
		return ret;
	}
	public AbstractFieldsDef getFieldsDefRupture(Vue vue) {
		AbstractFieldsDef ret=null;
		return ret;
	}
	public void adapteJoin(Sql sql) {
		FieldsJoin joinTvue=new FieldsJoin(
				new String[]{"c_tvue"},
				sql.getGp(), 					
				"s_fieldTvue", 					  
				"", 						      
				new String[]{"c_code"},				
				new String[]{"c_libe"}			
				);   		
		sql.addJoin(joinTvue);
		FieldsJoin joinTfiel=new FieldsJoin(
				new String[]{"c_tfie"},
				sql.getGp(), 					
				"s_fieldType", 					  
				"", 						      
				new String[]{"c_code"},				
				new String[]{"c_libe"}			
				);   		
		sql.addJoin(joinTfiel);
		FieldsJoin joinTaffi=new FieldsJoin(
				new String[]{"c_taff"},
				sql.getGp(), 					
				"s_fieldTaff", 					  
				"", 						      
				new String[]{"c_code"},				
				new String[]{"c_libe"}			
				);   		
		sql.addJoin(joinTaffi);
	}
}
