package table_standard.wS_intero;

import persistance.wSql.AbstractFieldsDef;
import persistance.wSql.Sql;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.Fma;
/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class S_interoLISTE extends AbstractFieldsDef {
	public S_interoLISTE(Sql sql,Vue vue) {
		super(sql,vue);
	}

	public Object adapteField(Vue vue){
		t_table="s_intero";
		t_nbLigne=5;
		t_filtre=null;
		v_filtre=null;
		t_index=new String[]{"c_code","c_repo"};
		switch (vue){
		case F2:{ // Liste d'ajout d'une fiche le code doit etre unique la deuxieme pour ce code
			t_filtre=new String[]{"c_code"};
			v_filtre=new String[]{"intero"};
			t_index=new String[]{"c_repo"};
			addSqlField("c_repo" , 1,Fma.FIELD,"Choix");
			addSqlField("c_mess" ,20,Fma.FIELD,"Message");
			break;}
		case F2UNIQUE1:{ // Liste d'ajout d'une fiche le code doit etre unique
			t_index=new String[]{"c_code"};
			addSqlField("c_code" , 6,Fma.FIELD,"Code");
			break;}
		case F3:
		default:{
			addSqlField("c_code" , 6,Fma.FIELD,"Code");
			addSqlField("c_repo" , 1,Fma.FIELD,"Choix");
			addSqlField("c_mess" ,20,Fma.FIELD,"Message");
			break;}
		}
		return this;
	}
	public void validateFields(){
		Vue vue=sql.vue;
		switch (vue){
		case F2UNIQUE1:{
			t_nbLigne=4;
			addGroupby();
			break;}
		}
		super.validateFields();
	}
	private void addGroupby() {
		sql.clauseGroupBy="c_code";
	}
}
