package table_standard.wS_menus;

import persistance.wSql.AbstractFieldsDef;
import persistance.wSql.Sql;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.Fma;
/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class S_menusLISTE extends AbstractFieldsDef {
	public S_menusLISTE(Sql sql,Vue vue) {
		super(sql,vue);
	}

	public Object adapteField(Vue vue){
		t_table="s_menus";
		t_nbLigne=20;
		t_filtre=null;
		v_filtre=null;
		t_index=new String[]{"c_code","c_cle2"};
		t_height=3;
		switch (vue){
		case F2UNIQUE1:
			t_height=1;
			t_index=new String[]{"c_smen"};
			addSqlField("c_code" , 10,Fma.GRAS ,"Menu");
			addSqlField("c_smen" , 10,Fma.FIELD,"Sous menus");
			addSqlField("c_menu" ,40,Fma.FIELD," Option");
			addSqlField("c_aide" ,60,Fma.FIELD,"Aide barre de Status");
			break;
		case F2UNIQUE2:
			t_height=1;
			t_index=new String[]{"c_opt1"};
			addSqlField("c_opt1" , 10,Fma.GRAS ,"Menu");
			addSqlField("c_aide" ,60,Fma.FIELD,"Aide barre de Status");
			break;
		case F2:
			t_height=1;
			t_index=new String[]{"c_cle2"};
			t_filtre=new String[]{"c_code"};
			v_filtre=new String[]{""};
			addSqlField("c_cle2" , 2,Fma.FIELD,"Cle 2");
			addSqlField("c_menu" ,40,Fma.FIELD,"Option");
			addSqlField("c_smen" ,10,Fma.FIELD,"Sous menus");
			addSqlField("c_aide" ,60,Fma.FIELD,"Aide barre de Status");
			break;
		case F3:
		default:
			t_nbLigne=16;
			t_height=1;
			addSqlField("c_code" , 10,Fma.GRAS ,"Menu");
		addSqlField("c_smen" , 10,Fma.FIELD,"Sous menus");
		addSqlField("c_cle2" , 2,Fma.GRAS ,"Cle 2");
		addSqlField("c_menu" ,40,Fma.GRAS ,"Option");
		addSqlField("c_racc" , 1,Fma.GRAS ,"R");
		addSqlField("c_opt1" ,10,Fma.GRAS ,"Fichier");
		addSqlField("c_opt2" , 5,Fma.FIELD,"Detail");
		addSqlField("c_opt3" , 5,Fma.INVISIBLE,"Param");
		addSqlField("c_aide" ,50,Fma.LIBEMAX  ,"Aide barre de Status");
		break;
		}
		return this;
	}
	public void validateFields(){
		Vue vue=sql.vue;
		switch (vue){
		case F2UNIQUE1:{
			t_nbLigne=8;
			addGroupbyOption1();
			break;}
		case F2UNIQUE2:{
			t_nbLigne=8;
			addGroupbyOption2();
			break;}
		}
		super.validateFields();
	}
	public void addGroupbyOption1(){
		sql.clauseFilter="c_smen<> ''";
		sql.clauseGroupBy="c_smen";
	}
	public void addGroupbyOption2(){
		sql.clauseFilter="c_opt1<> ''";
		sql.clauseGroupBy="c_opt1";
	}
}
