package table_standard.wS_menus;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.SwingConstants;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import template_applicatif.wFiche.AbstractDbFiche;
import template_applicatif.wFiche.FicheIEditableColumns;
import template_applicatif.wListe.ListeIEditableColumn;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JArea;
import composant_saisie.wComposant.JTextDb;
import composant_saisie.wComposant.JTextDbF2;
import composant_saisie.wSaisieFormat.Ccs;
/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class S_menusSAISIE extends AbstractDbFiche {
	private static final long serialVersionUID = 1L;
	JTextDb lcode,lcle2,lsmen,lopt1,lmenu,lracc,laide;
	//
	JTextDb lopt2, lopt3;
	//
	JTextDbF2	code=null;
	JTextDbF2	cle2=null;
	JTextDb  	smen=null;
	JTextDb   	opt1=null;
	JTextDb		menu=null;
	JTextDb   	racc=null;
	JArea		aide=null;
	//
	JTextDb   	opt2=null;
	JTextDb   	opt3=null;
	// 
	String insert="Insrer";

	public S_menusSAISIE(Sql sql) {
		super(sql);
		initStart();
	}
	public void initCreateLE() {
		lcode	=new JTextDb();
		lcle2	=new JTextDb();
		lsmen	=new JTextDb();
		lopt1	=new JTextDb();
		lmenu	=new JTextDb();
		lracc	=new JTextDb();
		laide	=new JTextDb();
		//
		lopt2	=new JTextDb();
		lopt3	=new JTextDb();
		////
		code	=new JTextDbF2(new S_menusVUE(sql,"",Vue.F2UNIQUE1));
		cle2	=new JTextDbF2(new S_menusVUE(sql,"",Vue.F2));
		smen	=new JTextDb();
		opt1	=new JTextDb();
		menu	=new JTextDb();
		racc	=new JTextDb();
		aide	=new JArea();
		//
		opt2	=new JTextDb();
		opt3	=new JTextDb();
	}
	public void initMapLE() {
		ccs.mapL(this,lcode,0);
		ccs.mapL(this,lcle2,1);
		ccs.mapL(this,lsmen,2);
		ccs.mapL(this,lopt1,3);
		ccs.mapL(this,lmenu,4);
		ccs.mapL(this,lracc,5);
		ccs.mapL(this,laide,6);
		ccs.mapL(this,lopt2,7);
		ccs.mapL(this,lopt3,8);

		ccs.mapE(this,code,0);
		ccs.mapE(this,cle2,1);
		ccs.mapE(this,smen,2);
		ccs.mapE(this,opt1,3);
		ccs.mapE(this,menu,4);
		ccs.mapE(this,racc,5);
		ccs.mapE(this,aide,6);{
			aide.setDimChar(sql.fields.get(6).t_fieldLength/2,3);
		}
		//
		ccs.mapE(this,opt2,7);
		ccs.mapE(this,opt3,8);
	}
	public void initGuiLE(){
		ccs.alignL(SwingConstants.LEFT);
		jpDbE=new JPanel(Gp.adaptePanelE());
		Gp.setx(0);
		jpDbE.add(lcode,Gp.gety());
		jpDbE.add(lcle2,Gp.getx());
		jpDbE.add(lsmen,Gp.getx());
		jpDbE.add(lopt1,Gp.getx());
		jpDbE.add(lopt2,Gp.getx());
		//
		Gp.setx(0);
		jpDbE.add(code,Gp.gety());
		jpDbE.add(cle2,Gp.getx());
		jpDbE.add(smen,Gp.getx());
		jpDbE.add(opt1,Gp.getx());
		jpDbE.add(opt2,Gp.getx());
		////
		Gp.setx(0);
		Gp.setWidth(3);
		jpDbE.add(lmenu,Gp.gety());
		Gp.setWidth(1);
		Gp.getx();
		Gp.getx();
		jpDbE.add(lracc,Gp.getx());
		//
		Gp.setx(0);
		Gp.setWidth(3);
		jpDbE.add(menu,Gp.gety());
		Gp.setWidth(1);
		Gp.getx();
		Gp.getx();
		jpDbE.add(racc,Gp.getx());
		////
		Gp.setx(0);
		jpDbE.add(laide,Gp.gety());
		//
		Gp.setx(0);
		Gp.setHeight(2);
		Gp.setWidth(4);
		jpDbE.add(aide,Gp.gety());
		Gp.gety();
		Gp.setHeight(1);
		Gp.setWidth(1);
		////
		//jpDbT.add(lopt2,Gp.gety());
		//jpDbT.add(lopt3,Gp.gety());
		//jpDbT.add(opt2,Gp.gety());
		//jpDbT.add(opt3,Gp.gety());
	}
	public void validateAdapteFicheCrud(){
		userOptionAdd(insert, null);	
	}

	public void setRemoveForParam() {
		if (setCrudOnlyUpdate()){
			code.setEnabled(false);
			smen.setEnabled(false);
			setCrudOptionEnabled(insert, false);
		}
		jpDbE.remove(lsmen);
		jpDbE.remove(lopt1);
		jpDbE.remove(lopt2);
		jpDbE.remove(lopt3);

		jpDbE.remove(smen);
		jpDbE.remove(opt1);
		jpDbE.remove(opt2);
		jpDbE.remove(opt3);

		opt1.enableEditableColumn(false);
		smen.removeEditableColumn();
		opt2.enableEditableColumn(false);
		opt3.enableEditableColumn(false);
	}
	public void initFocus() {
		setDefFocus(code);
	}
	public void setEditableColumns(FicheIEditableColumns fe,ListeIEditableColumn fl) {
		menu.setEditableColumns(fe,fl);
		racc.setEditableColumns(fe,fl);
		opt1.setEditableColumns(fe,fl);
		aide.setEditableColumns(fe,fl);
		smen.setEditableColumns(fe,fl);
	}
	public void fireEditableColumnUpdate(String nameField,Object value){
		menu.fireEditableColumnUpdate(nameField,value);
		racc.fireEditableColumnUpdate(nameField,value);
		opt1.fireEditableColumnUpdate(nameField,value);
		aide.fireEditableColumnUpdate(nameField,value);
		smen.fireEditableColumnUpdate(nameField,value);
	}
	public void loadEAdapteGuiLE() {
		//updateZoneListenerHighLevel(code);
		computeDependant(code);
		computeDependant(smen);
		computeDependant(opt1);
	}

	public void setBaseListener() {
		ccs.addF2Listener(code,Ccs.CONSULTF2);
		ccs.addF2Listener(cle2,Ccs.CONSULTF2);
		ccs.addF2Listener(cle2,Ccs.NEWCODEF2);
	}
	public void fireBaseListener(JComponent jc){
		// La cl d'index
		// La fiche
		if (jc==code){
			ccs.fireT(jc,Ccs.CONSULTF2);
			updateContextualRangeAndEnable(code);
		}
		if (jc==cle2){
			if (sql.isModeAppendUpdated()||sql.isModeAppend()){
				ccs.fireT(jc,Ccs.NEWCODEF2);
			} else {
				ccs.fireT(jc,Ccs.CONSULTF2);
			}
		}
	}
	public void updateDependant(JComponent jc){
		///////////////////////
		if (jc==smen){
			if (opt1.getText().trim().length()>0){
				smen.setText("");
			}
		}
		if (jc==opt1){
			if (smen.getText().trim().length()>0){
				opt1.setText("");
			}
		}
	}
	public void updateContextualRangeAndEnable(JComponent jc) {
		if (jc==code){
			cle2.sqlF2.v_filtre[0]=code.getText();
		}
	}
	public void fireContextualRange(JComponent jc){
		if (jc==smen){
			if (opt1.getText().trim().length()>0){
				ccs.setEEnabled(jc,false);
			} else {
				ccs.setEEnabled(jc,true);
			}
		}
		if (jc==opt1){
			if (smen.getText().trim().length()>0){
				ccs.setEEnabled(jc,false);
			} else {
				ccs.setEEnabled(jc,true);
			}
		}
	}
	public void setDependants(){
		ccs.addDependant(smen, opt1);
		ccs.addDependant(opt1 ,smen);
	}
	/////////////////////
	// Saisie en Ligne //
	/////////////////////
	//	S_menusDetailVUE	mend=null;
	//	public void dispose(){
	//		if (mend!=null){
	//			mend.dispose();
	//			mend  =null;
	//		}
	//		super.dispose();
	//	}
	//	public void validateInitSaisieEnLigne(){
	//		mend  =new S_menusDetailVUE(sql,"",Vue.F3DETAIL);{
	//			mend.validateInitSaisieEnLigneDetail(vue,"Option","Modifier menu");
	//		}
	//	}
	//	public void loadfAdapteSaisieEnLigne(){
	//		mend.sqlFiche.v_filtre[0]=mend.sqlListe.v_filtre[0]=code.getText();
	//		mend.loadfAdapteSaisieEnLigneDetail(code.getText());
	//	}
	public boolean dbUpdateBeforeOtherTable(){
		dbReplaceCode();
		dbReplaceSmen();
		return true;
	}
	public boolean dbUpdateAfterOtherTable(){
		updateMenu();
		return true;
	}
	public void dbDeleteAfterOtherTable(){
		updateMenu();
	}
	private void dbReplaceCode() {
		String ancCode=sql.getDataString(code.getName());
		String newCode=code.getText();
		if (!ancCode.equals(newCode) && ancCode.trim().length()>0 && newCode.trim().length()>0){
			sql.writeValue(sql.t_table, " c_code='"+newCode+"'","c_code='"+ancCode+"'");
		}

	}
	private void dbReplaceSmen() {
		String ancSmen=sql.getDataString(smen.getName());
		String newSmen=smen.getText();
		if (!ancSmen.equals(newSmen) && ancSmen.trim().length()>0 && newSmen.trim().length()>0){
			sql.writeValue(sql.t_table, " c_code='"+newSmen+"'","c_code='"+ancSmen+"'");
		}
	}
	private void updateMenu(){
		sql.loadMenu();
	}
	public void userOptionDo(String actionCommandOption){
		if (actionCommandOption.equals(insert)){
			sql.createTemporaryTable(false);
			sql.insertTemporarySinceTable("c_code='"+code.getText()+"' AND c_cle2='"+cle2.getText()+"'");
			String tmp="";
			for (int i=1;i<99;i++){
				tmp=""+(cle2.getInt()+i);
				if (!sql.readSeek(sql.t_table, "c_code+c_cle2", code.getText()+tmp)){
					break;
				}
			}
			sql.updateTemporarySinceTable("c_cle2='"+tmp+"',c_smen='',c_opt1='',c_menu='',c_aide='',c_racc='' ", "c_code='"+code.getText()+"' AND c_cle2='"+cle2.getText()+"'");
			sql.insertFromTemporaryTable("c_cle2='"+tmp+"'");
			sql.dropTemporaryTable(false);
			load(code.getText()+tmp);
			reloadAfterDb();
			updateMenu();
		}
	}
	public Object devSpe1(Object obj){
		if (sql.isShiftMask()){
			// Remonte
			if (sql.readSeek(sql.t_table,"c_smen",code.getText())){
				// Remonte dans le menu
				String tmpcode=sql.readStringValue(sql.t_table, "c_smen",code.getText(), "c_code");
				String tmpcle2=sql.readStringValue(sql.t_table, "c_smen",code.getText(), "c_cle2");
				load(tmpcode+tmpcle2);
				loadTwin(Sql.t_LoadAllField);
				reloadAfterDb();
			} else {
				Gp.MB("Vous tes, au plus haut de l'arborescence, Relacher le Shift pour Descendre, Merci");
			}
		} else {
			// Descend
			if (sql.readSeek(sql.t_table,"c_code",smen.getText())){
				// Descend dans le menu
				load(smen.getText());
				loadTwin(Sql.t_LoadAllField);
				reloadAfterDb();
			} else {
				Gp.MB("Vous tes, au plus bas de l'arborescence, Faite Shift pour remonter, Merci");
			}
		}
		return obj;
	}
}
