package table_standard.wS_menus;

import persistance.wSql.AbstractFieldsDef;
import persistance.wSql.Sql;
import template_applicatif.wFiche.AbstractDbFiche;
import template_applicatif.wListe.AbstractDbListe;
import template_applicatif.wListe.ListeRecno;
import template_applicatif.wVue.AbstractVue;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;
/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class S_menusVUE extends AbstractVue {
	private static final long serialVersionUID = 1L;
	public S_menusVUE(Sql sql, String t_seek, Vue vue) {
		super(sql.getSqlAbc(), t_seek, vue);
	}
	public AbstractDbListe getDbListe() {
		adapteJoin(sqlListe);
		return new ListeRecno(sqlListe);
	}
	public AbstractDbFiche getDbFiche(Vue vue) {
		sqlFiche.t_AccesMode=Sql.t_AccesModeRecno;
		adapteJoin(sqlFiche);
		return new S_menusSAISIE(sqlFiche);
	}

	public AbstractFieldsDef getFieldsDefEcran(Vue vue) {
		return new S_menusFICHE(sqlFiche,vue); 
	}
	public AbstractFieldsDef getFieldsDefListe(Vue vue) {
		return new S_menusLISTE(sqlListe,vue);
	}

	public AbstractFieldsDef getFieldsDefPrint(Vue vue) {
		return null;
	}
	public AbstractFieldsDef getFieldsDefRupture(Vue vue) {
		return null;
	}
	public void adapteJoin(Sql sql) {}
	public void userEnterLigne(String nameField,Object value){
		if (nameField==null){
			dbFiche.devSpe1(null);
		}
		super.userEnterLigne(nameField, value);
	}
}
