package table_standard.wS_prefs;

import persistance.wSql.AbstractFieldsDef;
import persistance.wSql.Sql;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.Fma;
/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class S_prefsLISTE extends AbstractFieldsDef {
	public S_prefsLISTE(Sql sql,Vue vue) {
		super(sql,vue);
	}
	public Object adapteField(Vue vue){
		t_table="s_prefs";
		t_nbLigne=6;
		t_filtre=null;
		v_filtre=null;
		t_index=new String[]{"c_code"};
		this.t_height=1;
		switch (vue){
		case F2:
			addSqlField("c_code" ,15,Fma.FIELD,"Utilisateur");
			break;
		case F3:
		default:{
			addSqlField("c_code" ,15,Fma.FIELD,"Utilisateur");
			addSqlField("c_them" ,15,Fma.FIELD,"Thme");
			addSqlField("c_atit" , 1,Fma.CHECK,"titre");
			addSqlField("c_titr" , 2,Fma.NUM,"Titre");
			addSqlField("c_tota" , 2,Fma.NUM,"Totaux");
			addSqlField("c_gras" , 1,Fma.CHECK,"Gras");
			addSqlField("c_mgra" , 1,Fma.CHECK,"Menus");
			addSqlField("c_tool" , 1,Fma.CHECK,"Tooltip");
			addSqlField("c_dela" , 6,Fma.NUM,"Tps.apparition","##.##");
			addSqlField("c_time" , 6,Fma.NUM,"Tps.affichage","##.##");
			addSqlField("c_fond" , 1,Fma.CHECK,"Fond");
			addSqlField("c_butt" , 1,Fma.CHECK,"Boutton");
			addSqlField("c_vpro" , 1,Fma.CHECK,"Pro");
			addSqlField("c_idot" , 8,Fma.NUM,"Etiq.");
			addSqlField("c_1204" , 8,Fma.NUM,"C.Barre");
			break;}
		}
		return this;
	}
}
