package table_standard.wS_slcol;

import persistance.wSql.AbstractFieldsDef;
import persistance.wSql.Sql;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.Fma;
/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class S_slcolLISTE extends AbstractFieldsDef {
	public S_slcolLISTE(Sql sql,Vue vue) {
		super(sql,vue);
	}

	public Object adapteField(Vue vue){
		t_table="s_slcol";
		t_nbLigne=5;
		t_filtre=null;
		v_filtre=null;
		t_index=new String[]{"c_code","c_cle2","c_wari"};
		t_height=1;
		switch (vue){
		case F2UNIQUE1:
			t_index=new String[]{"c_code"};
			addSqlField("c_code" , 10,Fma.GRAS ,"Option");
			addSqlField("c_wari" ,50,Fma.FIELD," Champs");
			break;
		case F2:
			t_index=new String[]{"c_cle2","c_wari"};
			t_filtre=new String[]{"c_code"};
			v_filtre=new String[]{""};
			addSqlField("c_cle2" ,30,Fma.FIELD,"Valeur");
			addSqlField("c_wari" ,50,Fma.FIELD,"Champs");
			addSqlField("c_colo" ,3,Fma.FIELD,"couleur");
			addSqlField("c_fond" ,3,Fma.FIELD,"Fond");
			break;
		case F3:
		default:
			t_nbLigne=23;
		//t_option="slcol";
		addSqlField("c_code" , 10,Fma.GRAS ,"Menu");
		addSqlField("c_cle2" ,30,Fma.INVISIBLE ,"Valeur");
		addSqlField("c_wari" ,50,Fma.GRAS ,"Champs");
		addSqlField("c_colo" ,3,Fma.INVISIBLE ,"Couleur");
		addSqlField("c_fond" ,3,Fma.INVISIBLE,"Fond");
		break;
		}
		return this;
	}
	public void validateFields(){
		Vue vue=sql.vue;
		switch (vue){
		case F3:
		case F2UNIQUE1:{
			t_nbLigne=6;
			addGroupbyOption();
			break;}
		}
		super.validateFields();
	}
	public void addGroupbyOption(){
		sql.clauseGroupBy="c_code";
	}
}
