package table_standard.wS_slcol;
import javax.swing.JComponent;

import persistance.wSql.Sql;
import table_standard.wS_menus.S_menusVUE;
import table_standard.wS_slcolDetail.S_slcolDetailVUEDETAIL;
import template_applicatif.wFiche.AbstractDbFiche;
import template_applicatif.wFiche.FicheIEditableColumns;
import template_applicatif.wListe.ListeIEditableColumn;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextDb;
import composant_saisie.wComposant.JTextDbF2;
import composant_saisie.wSaisieFormat.Ccs;
/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class S_slcolSAISIE extends AbstractDbFiche {
	private static final long serialVersionUID = 1L;
	JTextDb lcode;
	JTextDb lwari;

	JTextDbF2	code=null;
	JTextDb		wari=null;
	public S_slcolSAISIE(Sql sql) {
		super(sql);
		initStart();
	}
	public void initCreateLE() {
		lcode	=new JTextDb();
		lwari	=new JTextDb();
		code	=new JTextDbF2(new S_menusVUE(sql,"",Vue.F2UNIQUE2));
		wari	=new JTextDb();
	}
	public void initMapLE() {
		ccs.mapL(this,lcode,0);
		ccs.mapL(this,lwari,2);
		ccs.mapE(this,code,0);
		ccs.mapE(this,wari,2);
	}
	public void initFocus() {
		setDefFocus(code);
	}
	public void setBaseListener() {
		ccs.addF2Listener(code,Ccs.CONSULTF2);
		ccs.addEditListener(wari,Ccs.NOTEMPTY );
	}
	public void setEditableColumns(FicheIEditableColumns fe,ListeIEditableColumn fl) {}
	public void fireEditableColumnUpdate(String nameField,Object value){}
	public void loadEAdapteGuiLE() {
		updateContextualRangeAndEnable(code);
	}
	public void fireBaseListener(JComponent jc){
		// La cl d'index
		// La fiche
		if (jc==code){
			ccs.fireT(jc,Ccs.CONSULTF2);
			updateContextualRangeAndEnable(code);
		}
		if (jc==wari){
			ccs.fireT(jc,Ccs.NOTEMPTY);
		}
	}
	protected void fireContextualRange(JComponent jc) {}
	protected void updateDependant(JComponent jc) {}
	protected void updateContextualRangeAndEnable(JComponent jc) {}
	public void setDependants() {}
	public boolean dbUpdateBeforeOtherTable(){
		dbReplaceCode();
		return true;
	}
	private void dbReplaceCode() {
		String ancCode=sql.getDataString(code.getName());
		String newCode=code.getText();
		if (!ancCode.equals(newCode) && ancCode.trim().length()>0 && newCode.trim().length()>0){
			sql.writeValue(sql.t_table, " c_code='"+newCode+"'","c_code='"+ancCode+"'");
		}
	}
	/////////////////////
	// Saisie en Ligne //
	/////////////////////
	S_slcolDetailVUEDETAIL	dcol=null;
	public void dispose(){
		if (dcol!=null){
			dcol.dispose();
			dcol  =null;
		}
		super.dispose();
	}
	public void validateInitSaisieEnLigne(){
		dcol  =new S_slcolDetailVUEDETAIL(sql,"",Vue.F3DETAIL);{
			dcol.validateInitSaisieEnLigneDetail(vue,"Liste","Modifier couleur");
		}
	}
	public void loadEAdapteGuiSaisieEnLigne(){
		dcol.sqlFiche.v_filtre[0]=dcol.sqlListe.v_filtre[0]=code.getText();
		dcol.loadfAdapteSaisieEnLigneDetail(code.getText());
	}
	public void dbDeleteAfterOtherTable(){
		String ancCode=sql.getDataString(code.getName());
		sql.dBExecuteUpdate("DELETE FROM "+sql.t_table+" WHERE c_code='"+ancCode+"';");
		sql.dBTopByIndex();
		load(Sql.t_LoadAllField);
		loadTwin(Sql.t_LoadAllField);
	}
}
