package table_standard.wS_slcol;

import persistance.wSql.AbstractFieldsDef;
import persistance.wSql.FieldsJoin;
import persistance.wSql.Sql;
import template_applicatif.wFiche.AbstractDbFiche;
import template_applicatif.wListe.AbstractDbListe;
import template_applicatif.wListe.ListeRecno;
import template_applicatif.wVue.AbstractVue;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;
/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class S_slcolVUE extends AbstractVue {
	private static final long serialVersionUID = 1L;
	public S_slcolVUE(Sql sql, String t_seek, Vue vue) {
		super(sql.getSqlAbc(), t_seek, vue);
	}
	public AbstractDbListe getDbListe() {
		adapteJoin(sqlListe);
		return new ListeRecno(sqlListe);
	}
	public AbstractDbFiche getDbFiche(Vue vue) {
		sqlFiche.t_AccesMode=Sql.t_AccesModeRecno;
		adapteJoin(sqlFiche);
		return new S_slcolSAISIE(sqlFiche);
	}
	
	public AbstractFieldsDef getFieldsDefEcran(Vue vue) {
		return new S_slcolFICHE(sqlFiche,vue); 
	}
	public AbstractFieldsDef getFieldsDefListe(Vue vue) {
		return new S_slcolLISTE(sqlListe,vue);
	}
	
	public AbstractFieldsDef getFieldsDefPrint(Vue vue) {
		return null;
	}
	public AbstractFieldsDef getFieldsDefRupture(Vue vue) {
		return null;
	}
	public void adapteJoin(Sql sql) {
		FieldsJoin joinOptm=new FieldsJoin(
				new String[]{"c_code"},
				sql.getGp(), 					
				"s_menus", 						  
				"", 						      
				new String[]{"c_opt1"},				
				new String[]{"c_menu"}			
				);   		
		sql.addJoin(joinOptm);
		FieldsJoin joinColo=new FieldsJoin(
				new String[]{"c_colo"},
				sql.getGp(), 					
				"s_color", 						  
				"s_colorColo", 					  
				new String[]{"c_code"},				
				new String[]{"c_libe","c_colo"}
				);   		
		sql.addJoin(joinColo);
		FieldsJoin joinFond=new FieldsJoin(
				new String[]{"c_fond"},
				sql.getGp(), 					
				"s_color", 						  
				"s_colorFond", 					  
				new String[]{"c_code"},				
				new String[]{"c_libe","c_colo"}
				);   		
		sql.addJoin(joinFond);
	}
}
