package table_standard.wS_slcolDetail;

import java.awt.event.KeyEvent;

import javax.swing.JComponent;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import table_standard.wS_color.S_colorVUE;
import template_applicatif.wFiche.AbstractDbFiche;
import template_applicatif.wFiche.FicheIEditableColumns;
import template_applicatif.wListe.ListeIEditableColumn;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextDb;
import composant_saisie.wComposant.JTextDbF2;
import composant_saisie.wSaisieFormat.Ccs;
/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class S_slcolDetailSAISIE extends AbstractDbFiche {
	private static final long serialVersionUID = 1L;
	JTextDb		code=null;
	JTextDbF2	cle2=null;
	JTextDb		wari=null;
	JTextDbF2  	colo=null;
	JTextDbF2  	fond=null;
	public S_slcolDetailSAISIE(Sql sql) {
		super(sql);
		initStart();
	}
	public void initCreateLE() {
		code	=new JTextDb();
		cle2	=new JTextDbF2(new S_slcolDetailVUEDETAIL(sql,"",Vue.F2));
		wari	=new JTextDb();
		colo	=new JTextDbF2(new S_colorVUE(sql,"",Vue.F2));
		fond	=new JTextDbF2(new S_colorVUE(sql,"",Vue.F2));
	}
	public void initMapLE() {
		ccs.mapE(this,code,0);
		ccs.mapE(this,cle2,1);
		ccs.mapE(this,wari,2);
		ccs.mapE(this,colo,3);
		ccs.mapE(this,fond,4);
	}
	public void initGuiLE(){
		initGuiEDetail();
		jpDbE.remove(code);
	}
	public void initFocus() {
		setDefFocus(cle2);
	}
	public void loadEAdapteGuiLE() {
		code.setText(sql.v_filtre[0]);
		ccs.setEEnabled(code,false);
	}
	public void loadEAdapteGuiFicheOnAppend(){
		wari.setText(sql.readStringValue("s_slcol","c_code", code.getText(),"c_wari"));
	}
	public void setBaseListener() {
		ccs.addF2Listener(cle2,Ccs.CONSULTF2);
		ccs.addF2Listener(colo,Ccs.CONSULTF2);
		ccs.addEditListener(wari,Ccs.NOTEMPTY );
		ccs.addF2Listener(fond,Ccs.CONSULTF2);
	}
	public void setEditableColumns(FicheIEditableColumns fe,ListeIEditableColumn fl) {}
	public void fireEditableColumnUpdate(String nameField,Object value){}
	public void fireBaseListener(JComponent jc){
		// La cl d'index
		// La fiche
		if (jc==wari){
			ccs.fireT(jc,Ccs.NOTEMPTY);
		}
		if (jc==cle2){
			ccs.fireT(jc,Ccs.CONSULTF2);
		}
		if (jc==colo){
			ccs.fireT(jc,Ccs.CONSULTF2);
		}
		if (jc==fond){
			ccs.fireT(jc,Ccs.CONSULTF2);
		}
	}
	protected void fireContextualRange(JComponent jc) {}
	protected void updateDependant(JComponent jc) {}
	protected void updateContextualRangeAndEnable(JComponent jc) {}
	public void setDependants() {}
	public void reloadAfterDbOperationFinal(){ 
		// Quitte automatique lorsqu'il n'y a plus de ligne
		// Raffraichi la liste d'entte.
		if (!sql.readSeek("s_slcol","c_code",code.getText())){
			sql.taParent.load(Sql.t_LoadAllField);
			sql.taParent.loadTwin(Sql.t_LoadAllField);
			Gp.keyb(new int[]{KeyEvent.VK_ESCAPE});
		}
	}
}
