package template_applicatif.wFiche;

import javax.swing.JComponent;

import template_applicatif.wListe.AbstractDbListe;
import template_applicatif.wVue.AbstractVue;
import template_applicatif.wVue.VueIAide;
import a_doc.doc.Licence;

/**
 * Interface d'actions utilisateur <br>
 * Assure la liaison avec le trio {@link AbstractVue} {@link AbstractDbFiche} {@link AbstractDbListe}
__________________________________________________________________________________
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public interface FicheIAction extends VueIAide {
	/**
	 * Utilisateur  fait Effecer <br>
	 */
	public void userDelete();
	/**
	 * Utilisateur  fait Option <br>
	 */
	public void userOption(String actionCommandOption);
	/**
	 * Utilisateur  fait Nouveau <br>
	 */
	public void userAppend();
	/**
	 * Utilisateur  fait Abandon <br>
	 */
	public void userCancel();
	/**
	 * Utilisateur  fait Enregistrer <br>
	 */
	public void userRecord();
	public void userOptionAdd(String option, String fileIcon);
	public void userOptionAdd(JComponent jcOption);
	
	public void setModeMovable();
	public void setModeUpdated();
	public void setModeAppend();
	public void setModeAppendUpdated();
}
