package template_applicatif.wFiltre;


import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JTextField;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import template_applicatif.wFiche.AbstractDbFiche;
import template_applicatif.wFiche.FicheIEditableColumns;
import template_applicatif.wListe.ListeIEditableColumn;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextDb;
import composant_saisie.wComposant.JTextDbF2;
import composant_saisie.wSaisieFormat.Ccs;
/**
 * Fabrique de borne  borne sur une table <br>
 * borne DE sur le dbut de la table<br>
 * borne A  sur la fin de la table<br>
__________________________________________________________________________________
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public abstract class AbstractVueDEA extends AbstractDbFiche  {
	private static final long serialVersionUID = 1L;
	JTextDb lcode1,lcode0,lcode2;
	public JTextDbF2   code1=null;
	public JTextDbF2   code2=null;
	public AbstractVueDEA(Sql sql) {
		super(sql);
		initStart();
	}
	public abstract String getLibeDe();
	public abstract String getLibeA();
	public abstract JTextDbF2 getNewF2();
	public void initCreateLE() {
		lcode1	=new JTextDb();
		lcode0	=new JTextDb();
		lcode2	=new JTextDb();
		lcode1.setText(getLibeDe());{
			Ccs.TexttoLibe(lcode1);
			lcode1.setHorizontalAlignment(JTextField.LEADING);
		}
		lcode0.setText(" ");
		lcode2.setText(getLibeA());{
			Ccs.TexttoLibe(lcode2);
			lcode2.setHorizontalAlignment(JTextField.LEADING);
		}
		code1	=getNewF2();
		code2	=getNewF2();
	}
	protected void initMapLE() {
		//ccs.mapL(this,lcode0,0);
		//ccs.mapL(this,lcode1,0);
		//ccs.mapL(this,lcode2,0);
		
		// Retrouve la longueur de la cl d'index du F2 par rapport a la STRUCTURE de la fiche;
		int lenIndex=0;
		for (int index=0;index<code1.sqlF2.t_index.length;index++){
			for (int field=0;field<sql.fields.size();field++){
				if (code1.sqlF2.t_index[index].equals(sql.fields.get(field).t_field)){
					lenIndex=lenIndex+sql.fields.get(field).t_fieldLength;
				}
			}
		}
		ccs.mapE(this,code1, "",lenIndex,"c_code");
		ccs.mapE(this,code2, "",lenIndex,"c_code");
	}
	public void initGuiLE(){
		jpDbE=new JPanel(Gp.adaptePanelE());
		jpDbE.add(lcode1,Gp.gety());
		jpDbE.add(lcode2,Gp.getx());		
		//
		Gp.setx(0);
		jpDbE.add(code1,Gp.gety());
		jpDbE.add(code2,Gp.getx());
	}
	public void setSpace(String space){
		lcode0.setText(space);
	}
	public void initFocus() {
		setDefFocus(code1);
	}
	public void setBaseListener() {
		// La cl d'index
		ccs.addF2Listener(code1,Ccs.CODEINF2);
		ccs.addF2Listener(code2,Ccs.CODEINF2);
	}
	public void setEditableColumns(FicheIEditableColumns fe, ListeIEditableColumn fl) {}
	public void fireEditableColumnUpdate(String nameField, Object value) {}
	public void validateAdapteFicheCrud(){
		load(Sql.t_LoadAllField);
	}
	public void load(int load){
		if (sql.isModeMovable()||sql.isModeSauve()){
			setCcsEnable(false);
			code1.sqlF2.clauseFilter=vue.dbFiche.vue.sql.clauseFilter;
			code2.sqlF2.clauseFilter=vue.dbFiche.vue.sql.clauseFilter;
			code1.debut();
			code2.dbFin();
			setCcsEnable(true);
			initFocus();
			setModeUpdated();
		}
	}
	public void setDe(boolean enable){
		lcode0.setVisible(!enable);
		lcode2.setVisible(!enable);
		code2.setVisible(!enable);
	}

	public void fireBaseListener(JComponent jc){
		// La cl d'index
		if (jc==code1||jc==code2){
			ccs.fireT(jc,Ccs.CODEINF2);
		}
	}
	protected void fireContextualRange(JComponent jc) {}
	public void loadEAdapteGuiLE() {}
	public void setDependants() {}
	protected void updateDependant(JComponent jc) {}
	protected void updateContextualRangeAndEnable(JComponent jc) {}
	public void setTextLibeDe(String string) {
		lcode1.setWidthChar(string.length());
		lcode1.setText(string);
	}
	public void setTextLibeA(String string) {
		lcode2.setWidthChar(string.length());
		lcode2.setText(string);
	}
}
