package template_applicatif.wFiltre;

import java.awt.GridBagConstraints;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSeparator;

import persistance.wGlobalParam.Gp;

public class FiltreTotaux extends JPanel{
	private static final long serialVersionUID = 1L;
	public ArrayList< JLabel > label;
	public ArrayList< JLabel > value;
	int nbLabel=0;
	public void dispose(){
		label.clear();
		label=null;
		value.clear();
		value=null;
	}
	public FiltreTotaux(){
		adapte();
	}
	private void adapte() {
		label = new ArrayList< JLabel > ();
		value = new ArrayList< JLabel > ();
		init();
		finInit();
	}
	private void init() {
		setLayout(Gp.adaptePanelC());

		Gp.setFill(GridBagConstraints.VERTICAL);  
		Gp.setHeight(99);
		add(new JSeparator(JSeparator.VERTICAL),Gp.gety());
		Gp.setHeight(1);
		Gp.setFill(GridBagConstraints.NONE);
	}
	private void finInit() {
		setBorder(BorderFactory.createEtchedBorder());
	}
	private void adapteLabelText(JLabel jl){
		jl.setFont(Gp.FONTTEXT12);
	}
	private void adapteLabelValue(JLabel jl){
		jl.setFont(Gp.FONTTEXT.deriveFont(Gp.FONTTEXTTYPE,Gp.TOTAUXSIZE));
		jl.setForeground(Gp.VERTFONCE_FG);
		jl.setBackground(Gp.MOVE_BG_LVERT);
	}
	public void addLabel(String txt,String val){
		nbLabel=nbLabel+1;
		JLabel tmpLabel=new JLabel(txt);
		label.add(tmpLabel);
		JLabel tmpValue=new JLabel(val);
		value.add(tmpValue);
		//
		adapteLabelText(tmpLabel);
		adapteLabelValue(tmpValue);
		//
		Gp.setx(nbLabel*2);
		add(tmpLabel,Gp.getx());
		Gp.setFill(GridBagConstraints.VERTICAL);  
		Gp.setHeight(99);
		add(new JSeparator(JSeparator.VERTICAL),Gp.getx());
		Gp.setHeight(1);
		Gp.setFill(GridBagConstraints.NONE);  
		//
		Gp.setx(nbLabel*2);
		int y=Gp.gbc.gridy;
		Gp.sety(y+1);
		add(tmpValue,Gp.getx());
		Gp.sety(y);
	}
	public void setValue(int index, String val){
		value.get(index).setText(val);
	}
	public void setValue(String val) {
		for (int i=0;i<value.size();i++){
			value.get(i).setText(val);
		}
	}
}
