package template_applicatif.wFiltre;

import java.awt.FlowLayout;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextDb;
import composant_saisie.wComposant.JTextDbDate;
import composant_saisie.wPtime.Day;
import composant_saisie.wSaisieFormat.Ccs;
import composant_saisie.wSaisieFormat.UserUpdate;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JPDeADate extends JPanel implements DocumentListener  {
	private static final long serialVersionUID = 1L;
	UserUpdate userupdate=null;
	Sql sql=null;
	JTextDb jlspace=null;
	public JTextDb jlDebut=null;
	public JTextDb jlFin=null;
	JPanel jpDebutFin=null;
	public JTextDbDate debut=null;
	public JTextDbDate fin=null;
	public JPDeADate (Sql sql){
		super(new FlowLayout(0,0,0));
		this.sql=sql;
		userupdate=new UserUpdate(this);
		adapte();
	}
	public void adapte(){
		initLT();
		initFiche();
		this.add(jpDebutFin);
		this.setBorder(BorderFactory.createEtchedBorder());
	}
	public void initLT() {
		jlspace=new JTextDb("  ");{
			Ccs.TexttoLibe(jlspace);
			jlspace.setHorizontalAlignment(JTextDb.LEFT);
		}
		jlDebut=new JTextDb("Du ");{
			Ccs.TexttoLibe(jlDebut);
			jlDebut.setHorizontalAlignment(JTextDb.LEFT);
		}
		jlFin=new JTextDb("Au ");{
			Ccs.TexttoLibe(jlFin);
			jlFin.setHorizontalAlignment(JTextDb.LEFT);
		}

		debut =new JTextDbDate(sql);{
			debut.setSDate(Day.getCurrentSDate());
			debut.getDocument().addDocumentListener(this);
			debut.setFont(Gp.FONTTEXT12);
			debut.setBorder(Gp.getBorder(Gp.LABEL_BORDER));
			debut.setBackground(Gp.UPDATE_BG_JAUNE);

		}
		fin =new JTextDbDate(sql);{
			fin.setSDate(Day.getCurrentSDate());
			fin.getDocument().addDocumentListener(this);
			fin.setFont(Gp.FONTTEXT12);
			fin.setBorder(Gp.getBorder(Gp.LABEL_BORDER));
			fin.setBackground(Gp.UPDATE_BG_JAUNE);
		}
	}
	public void setEntireCurrentMonth(){
		debut.setSDate("01"+Day.getCurrentSDate().subSequence(2,10));
		Day tmp=new Day();
		tmp.setSDate(debut.getSDate());
		while (debut.getSMonthSYear().equals(tmp.getSMonthSYear())){
			fin.setSDate(tmp.getSDate());
			tmp.addDay(1);
		}
	}
	public void setEntireCurrentYear(){
		debut.setSDate(Day.getDebYearSDate(0));
		fin.setSDate(Day.getFinYearSDate(0));
	}
	public void setEntireCurrentWeek(){
		debut.setSDate(Day.getDebWeekSDate(0));
		fin.setSDate(Day.getFinWeekSDate(0));
	}
	public void setSpace(String space) {
		jlspace.setText(space);
	}
	public void initFiche(){
		jpDebutFin=new JPanel(Gp.adaptePanelE());
		jpDebutFin.add(jlDebut,Gp.gety());
		jpDebutFin.add(jlFin,Gp.getx());		
		//
		Gp.setx(0);
		jpDebutFin.add(debut,Gp.gety());
		jpDebutFin.add(fin,Gp.getx());
	}
	public void setDe(boolean enable){
		jlspace.setVisible(!enable);
		jlFin.setVisible(!enable);
		fin.setVisible(!enable);
	}
	public void setTextLibeDe(String string) {
		jlDebut.setWidthChar(string.length());
		jlDebut.setText(string);
	}
	public void setTextLibeA(String string) {
		jlFin.setWidthChar(string.length());
		jlFin.setText(string);
	}
	public void changedUpdate(DocumentEvent e) {}
	public void insertUpdate(DocumentEvent e) {
		userUpdate();
	}
	public void removeUpdate(DocumentEvent e) {
		userUpdate();
	}
	private void userUpdate() {
		debut.setValueChild();
		fin.setValueChild();
		userupdate.userUpdate();
	}
	public void dispose() {
		userupdate=null;
		debut.getDocument().removeDocumentListener(this);
		fin.getDocument().removeDocumentListener(this);
		debut=null;
		fin=null;
	}
}
