package template_applicatif.wListe;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JPanel;

import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextButton;
import composant_saisie.wSaisieFormat.UserUpdate;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class ListeButtonPlus extends JPanel implements ActionListener{
	private static final long serialVersionUID = 1L;
	private JTextButton jbPlus=null;
	private UserUpdate userupdate=null;
	private UserUpdate userupdateRight=null;
	public ListeButtonPlus(){
		this.userupdate=new UserUpdate(this);
		this.userupdateRight=new UserUpdate(this,UserUpdate.PLUS_RIGHT);
		this.setLayout(new BorderLayout(0,0));{
			JPanel jpb=new JPanel(new BorderLayout());{
				jpb.setBorder(BorderFactory.createEtchedBorder());	
				jbPlus=new JTextButton("+"); {
					jbPlus.setFocusable(false);
					jbPlus.addActionListener(this);
					jpb.add(jbPlus,BorderLayout.CENTER);
				}
			}
			add(jpb,BorderLayout.CENTER);	
		}
	}
	public void setVisible(boolean enable){
		super.setVisible(enable);
		jbPlus.setVisible(enable);
	}
	public void setEnabled(boolean enable){
		super.setEnabled(enable);
		jbPlus.setEnabled(enable);
	}
	public void actionPerformed(ActionEvent arg0) {
		if (arg0.getSource()==jbPlus){
			if (arg0.getActionCommand().contains(JTextButton.CLICK_RIGHT)){
				userPlusRight();
			} else {
				userPlus();
			}
		}
	}
	public void userPlus() {
		userupdate.userUpdate();
	}
	public void userPlusRight() {
		userupdateRight.userUpdate();
	}
	public void setPlus(){
		jbPlus.setMnemonic(java.awt.event.KeyEvent.VK_PLUS);
		jbPlus.setText("+");
	}
	public void setMoins(){
		jbPlus.setMnemonic(java.awt.event.KeyEvent.VK_MINUS);
		jbPlus.setText("-");
	}
	public void dispose() {
		userupdate=null;
		userupdateRight=null;
		jbPlus=null;
	}
}
