package template_applicatif.wListe;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.beans.PropertyChangeListener;

import javax.swing.AbstractCellEditor;
import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.table.TableCellEditor;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Edit;
import persistance.wSql.Sql;
import template_applicatif.wVue.AbstractVue;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextCheck;
import composant_saisie.wComposant.JTextDb;
import composant_saisie.wComposant.JTextDbF2;
import composant_saisie.wSaisieFormat.Ccs;
import composant_saisie.wSaisieFormat.UserIUpdate;
import composant_saisie.wSaisieFormat.UserUpdate;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class ListeCellEditor extends AbstractCellEditor implements TableCellEditor, KeyListener,DocumentListener, ActionListener,UserIUpdate  {
	private static final long serialVersionUID = 1L;
	private JComponent jc=null;
	private JTextCheck jtc=null;
	private JTextDbF2 jf2=null;
	private JTextDb jtext=null;
	private Ccs ccs=null;
	private String cancel="";
	private Sql sql=null;
	private JTable jt=null;
	private boolean isEnclencheEdit=false;
	private boolean isInEdit=false;
	private int rowHasEdit=-1;
	private int colHasEdit=-1;
	private ListeFastEdit fastedit=null;
	private String validEditing="validediting";
	private UserUpdate userupdate=null;
	private UserUpdate userupdate2=null;
	public ListeCellEditor(Sql sql){
		super();
		this.sql=sql;
		this.userupdate=new UserUpdate(UserUpdate.COL_LISTECELLEDITOR);
		this.userupdate2=new UserUpdate(UserUpdate.CELLEDIT);

		// String int double
		jtext=new JTextDb();{
			jtext.setSelectAllOnFocus(false);
		}

		// checkbox
		jtc=new JTextCheck("");{
			jtc.setFont(Gp.FONTTEXT12);
			if (sql.t_height!=1){
				jtc.setVerticalAlignment(SwingConstants.TOP);
			}
			jtc.setHorizontalAlignment(SwingConstants.CENTER);
		}

	}
	public void addPropertyChangeListener(String propertie,PropertyChangeListener pcl) {
		if (propertie.equals(UserUpdate.COL_LISTECELLEDITOR)) {
			userupdate.addPropertyChangeListener(propertie,pcl);
		} else {
			userupdate2.addPropertyChangeListener(propertie,pcl);
		}
	}
	public void removePropertyChangeListener(String propertie,PropertyChangeListener pcl) {
		if (propertie.equals(UserUpdate.COL_LISTECELLEDITOR)) {
			userupdate.removePropertyChangeListener(propertie,pcl);
		} else {
			userupdate2.removePropertyChangeListener(propertie,pcl);
		}
	}
	public Component getTableCellEditorComponent(JTable jt, Object value,boolean isSelected, int row, int column) {
		this.fastedit=((ListeModele)jt.getModel()).getFastedit();
		this.jt=jt;
		this.rowHasEdit=row;
		this.colHasEdit=column;

		// alerte la table que la cellule n'est plus la mme
		userupdate.userUpdate();
//		if (jt.getClientProperty(UserUpdate.COL_LISTECELLEDITOR).equals("basculeOn")){
//			jt.putClientProperty(UserUpdate.COL_LISTECELLEDITOR,"basculeOff" );
//		} else {
//			jt.putClientProperty(UserUpdate.COL_LISTECELLEDITOR,"basculeOn" );
//		}

		if (value!=null){
			if (fastedit.isFastListeEnable(column)){
				if (isInEdit()){
					stopCellEditing();
				} else {
					isEnclencheEdit=true;
					isInEdit=true;
					cancel=(String) value;
				}
			}
			jc=activateCtf((String) value);
		}
		return jc;
	}
	private JComponent activateCtf(String value){
		JComponent ret=null;
		if (fastedit.getTypeEdit(colHasEdit).equals(Edit.CHECK)){
			if (value.equals("0")) {
				jtc.setSelected(false);
			} else {
				jtc.setSelected(true);
			}
			jtc.setActionCommand(validEditing);
			jtc.addActionListener(this);
			ret=jtc;
		} else if (fastedit.getTypeEdit(colHasEdit).equals(Edit.INT)||fastedit.getTypeEdit(colHasEdit).equals(Edit.DOUBLE)){
			this.ccs=new Ccs(sql.sqlTwin); {
				String def_value=sql.sqlTwin.getFieldDef(fastedit.getName(colHasEdit)).t_fieldDefaultValue;
				String format=sql.sqlTwin.getFieldDef(fastedit.getName(colHasEdit)).t_fieldFormat;
				if (format==null){
					if (fastedit.getTypeEdit(colHasEdit).equals(Edit.INT))
						format="####";
					else
						format="####.##";
				}
				String name=fastedit.getName(colHasEdit);
				ccs.adapteE(this,jtext,def_value,format,name);
			}
			if (isEnclencheEdit){
				isEnclencheEdit=false;
			} else {
				jtext.setText((String) value);
			}
			ret=jtext;
		} else if (fastedit.getTypeEdit(colHasEdit).equals(Edit.TEXT)){
			ret=setJText((String) value);
		} else if (fastedit.getTypeEdit(colHasEdit).equals(Edit.F2)){
			if(fastedit.getComponent(colHasEdit).getClass()==JTextDbF2.class){
				// Recupere le composant qui  t ajout en fastedit
				jf2=(JTextDbF2) fastedit.getComponent(colHasEdit);
				// Cre une nouvelle instance de Vue  partir du composant
				AbstractVue fic=AbstractVue.getVue(jf2.jpVueF2,jf2.sqlF2.vue);
				// Cr un nouveau F2
				jf2=new JTextDbF2(fic);
				this.ccs=new Ccs(sql.sqlTwin);{
					String def_value=sql.sqlTwin.getFieldDef(fastedit.getName(colHasEdit)).t_fieldDefaultValue;
					int len= sql.sqlTwin.getFieldDef(fastedit.getName(colHasEdit)).t_fieldLength;
					String name= fastedit.getName(colHasEdit);
					ccs.mapE(this, jf2,def_value,len,name);
				}
				jf2.setValueFromChild((String) value);
				ret=jf2;
			} else {
				ret=setJText((String) value);
			}

		}
		if (ret!=null){
			ret.setBorder(BorderFactory.createMatteBorder(1, 2, 2, 1,Color.BLACK));
		}
		return ret;
	}
	private JTextDb setJText(String value){
		this.ccs=new Ccs(sql.sqlTwin); {
			int numField=sql.sqlTwin.getNumField(fastedit.getName(colHasEdit));
			ccs.mapE(this,jtext,numField);
		}
		if (isEnclencheEdit){
			isEnclencheEdit=false;
		} else {
			jtext.setText( value);
		}
		return jtext;
	}
	public Object getCellEditorValue() {
		Object ret=null;
		Edit type_field=(Edit) jc.getClientProperty(Edit.TYPE_FIELD);
		switch(type_field){
			case TEXT:
				ret =  ((JTextDb)jc).getText();
				break;
			case F2:
				ret =  ((JTextDbF2)jc).getText();
				break;
			case CHECK:
				String value="0";
				if (((JTextCheck)jc).isSelected())
					value="1";
				ret =  value;
				break;
		}
		return ret;
	}

	private void validEditing(){
		if (isInEdit){
			//Gp.af(2,"LCE validEditing VK_ENTER");
			// 1  stop l'dition
			stopCellEditing();
			// 2 met  jour la table
			jt.setValueAt((String) getCellEditorValue(), rowHasEdit, colHasEdit);
			// 3 reselectionne la ligne
			jt.setRowSelectionInterval(rowHasEdit,rowHasEdit);
			// 4 alerte la table quelle  change et doit mettre  jour la twin
			userupdate2.userUpdate();
//			if (jt.getClientProperty(UserUpdate.CELLEDIT).equals("basculeOn"))
//				jt.putClientProperty(UserUpdate.CELLEDIT,"basculeOff" );
//			else
//				jt.putClientProperty(UserUpdate.CELLEDIT,"basculeOn" );
		}
	}

	public void cancelCellEditing(){
		if (isInEdit){
			super.cancelCellEditing();
			// remet  jour les datas du modele sans passer par setValueAt sinon bug du escape
			sql.datas.get(rowHasEdit)[colHasEdit]=(String) cancel;
			isInEdit=false;
		}
	}
	public boolean stopCellEditing(){
		boolean ret=super.stopCellEditing();
		if (isInEdit){
			isInEdit=false;
		}
		return ret;
	}
	public boolean isInEdit(){
		return isInEdit;
	}
	public int getColHasEdit() {
		return colHasEdit;
	}

	// Necessaite au Ctf (Controle de la saisie) mais non utilis
	public void changedUpdate(DocumentEvent arg0) {}
	public void insertUpdate(DocumentEvent arg0) {}
	public void removeUpdate(DocumentEvent arg0) {}
	public void keyReleased(KeyEvent arg0) {}
	public void keyTyped(KeyEvent arg0) {}
	public void keyPressed(KeyEvent arg0) {
		if (arg0.isControlDown()){

		} else {
			// Valididation des TextField numrique, caractre, des checkBox et F2
			switch (arg0.getKeyCode()) {
			case KeyEvent.VK_UP:
			case KeyEvent.VK_DOWN:
				cancelCellEditing();
				arg0.consume(); 
				break;
			case KeyEvent.VK_ENTER:
				validEditing();
				arg0.consume(); 
				break;
			default:
				break; }
		}
	}
	public void actionPerformed(ActionEvent arg0) {
		// Valididation checkBox 
		if (arg0.getActionCommand().equals(validEditing))
			validEditing();
	}
	public void dispose() {
		jc=null;
		jtc=null;
		jf2=null;
		jtext=null;
		userupdate=null;
		userupdate2=null;
		if (ccs!=null){
			ccs.dispose();
			ccs=null;
		}
		cancel=null;
		jt=null;
		if (fastedit!=null){
			fastedit.dispose();
			fastedit=null;
		}
		sql=null;
	}
	protected void finalize()  {
//		Gp.af("finalize : "+"ListeCellEditor");
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
